# README

## 所属学校与比赛方向

- **所属学校**：华东师范大学
- **比赛方向**：操作系统原理赛道（模块实验创新）

## 队伍信息

- **队伍编号**：T202410269994253
- **队伍名**：V我50队

## 队伍成员与指导老师

- **队伍成员**：
  - 葛佳誉（队长）
- **指导老师**：石亮

## 项目完成情况介绍

本项目主要对xv6操作系统的原有round-robin（rr）调度算法进行了测试，并在此基础上进行了改进，引入了优先级队列调度算法。以下是项目的详细完成情况：

### 测试与验证

- **原有rr调度算法测试**：
  - 对xv6自带的rr调度算法进行了详尽的测试,我发现因此，原有的调度算法可能导致某些长时间运行的进程被频繁地中断，降低了系统的整体性能和用户体验。

- **新优先级队列调度算法实现**：
  - 在深入理解原有调度算法的基础上，设计并实现了一种基于优先级队列的调度算法。
  - 该算法能够根据不同进程的优先级进行调度，以提高系统的整体性能。

- **新算法测试**：
  - 通过xv6自带的usertests对新实现的优先级队列调度算法进行了全面的测试。
  - 测试结果表明，新算法能够成功运行，且系统未出现任何问题。
  - 并且解决了上述rr的问题

## 创新性与难度

### 创新性

- **全新调度算法引入**：本项目在经典的xv6操作系统上，创造性地引入了优先级队列调度算法。这一改变不仅为操作系统调度策略带来了新的视角，还显著提升了系统在处理多任务、多优先级进程时的效率和响应速度。

- **算法优化与扩展**：我们不仅仅实现了基本的优先级队列调度，还进一步对算法进行了优化，如引入了动态优先级调整机制。这一机制使系统能够根据进程的实际运行情况动态调整其优先级，从而更加灵活地适应不同的应用场景。

- **用户体验提升**：通过引入优先级队列调度，我们使得用户进程能够更加公平、高效地获取系统资源，从而显著提高了系统的整体性能和用户体验。

### 难度

- **深入理解操作系统调度机制**：实现优先级队列调度算法的前提是对操作系统的调度机制有深入的理解和掌握。这包括对进程状态管理、时间片分配、进程切换等核心概念的深刻理解，以及对xv6操作系统内部工作原理的熟悉。

- **优先级队列的维护**：优先级队列的维护是本项目的一大难点。我们需要确保队列的插入、删除和更新操作都能够在较短的时间内完成，同时保持队列的有序性。此外，还需要考虑在进程优先级发生变化时，如何高效地调整队列中的位置，以确保调度算法的准确性和效率。

- **进程切换的复杂性**：在操作系统中实现进程切换是一个复杂的过程，涉及CPU状态的保存和恢复、内存管理的调整、进程上下文的切换等多个方面。在引入优先级队列调度后，进程切换的频率和模式可能会发生变化，因此我们需要对原有的进程切换机制进行深入的改造和优化，以确保系统的稳定性和效率。

- **系统兼容性与稳定性**：在引入新的调度算法时，我们需要确保系统的兼容性不受影响，即原有的进程和应用程序仍然能够在新的调度策略下正常运行。同时，我们还需要对系统的稳定性进行严格的测试，以确保新的调度算法不会引入新的漏洞或错误，从而保障系统的可靠性和稳定性。


## 文档与材料

- **PDF文档**：
  - 项目详细报告及实验过程记录，请[点击这里](https://gitlab.eduxiji.net/T202410269994253/project2608132-271815/-/blob/main/final_report.pdf)。

- **其他过程性材料**：
  - 提交记录，请[点击这里](https://gitlab.eduxiji.net/T202410269994253/project2608132-271815/-/blob/main/experimentation.png)。




希望本项目能够得到评委的认可和支持！
