#!/usr/bin/env python3

import re
import matplotlib.pyplot as plt
from collections import Counter

# 步骤 1: 读取文件内容
with open('xv6.out', 'r') as file:
    content = file.read()

# 步骤 2: 应用正则表达式
pattern = r"ticket_time now is (\d+)"
matches = re.findall(pattern, content)
 
# 步骤 3: 统计数量（同时得到具体的数字，并过滤掉超过100的记录）
numbers = [int(match) for match in matches ]  # 将匹配到的数字字符串转换为整数，并过滤掉超过100的数字
start_time = numbers[0]

# 从所有时间中减去起始时间
numbers = [num - start_time for num in numbers]
count = Counter(numbers)           # 使用 Counter 来统计每个数字出现的次数

# 步骤 4: 制作图表
# 由于我们想要显示每个数字及其出现的次数，我们可以使用条形图
plt.bar(count.keys(), count.values())
plt.xlabel('ticket_time now is number')
plt.ylabel('Frequency')
plt.title('Frequency of "ticket_time now is \d+" in xv6.OUT')
plt.xticks(rotation=45)  # 旋转 x 轴标签，以便更好地显示
plt.tight_layout()       # 自动调整子图参数, 使之填充整个图像区域

# 显示图表
plt.savefig("my_schedule")
# my_schedule
# original_schedule