
kernel/kernel:     file format elf64-littleriscv


Disassembly of section .text:

0000000080000000 <_entry>:
    80000000:	0000a117          	auipc	sp,0xa
    80000004:	83010113          	addi	sp,sp,-2000 # 80009830 <stack0>
    80000008:	6505                	lui	a0,0x1
    8000000a:	f14025f3          	csrr	a1,mhartid
    8000000e:	0585                	addi	a1,a1,1
    80000010:	02b50533          	mul	a0,a0,a1
    80000014:	912a                	add	sp,sp,a0
    80000016:	070000ef          	jal	ra,80000086 <start>

000000008000001a <spin>:
    8000001a:	a001                	j	8000001a <spin>

000000008000001c <timerinit>:
// which arrive at timervec in kernelvec.S,
// which turns them into software interrupts for
// devintr() in trap.c.
void
timerinit()
{
    8000001c:	1141                	addi	sp,sp,-16
    8000001e:	e422                	sd	s0,8(sp)
    80000020:	0800                	addi	s0,sp,16
// which hart (core) is this?
static inline uint64
r_mhartid()
{
  uint64 x;
  asm volatile("csrr %0, mhartid" : "=r" (x) );
    80000022:	f14027f3          	csrr	a5,mhartid
  // each CPU has a separate source of timer interrupts.
  int id = r_mhartid();

  // ask the CLINT for a timer interrupt.
  int interval = 1000000; // cycles; about 1/10th second in qemu.
  *(uint64*)CLINT_MTIMECMP(id) = *(uint64*)CLINT_MTIME + interval;
    80000026:	0037969b          	slliw	a3,a5,0x3
    8000002a:	02004737          	lui	a4,0x2004
    8000002e:	96ba                	add	a3,a3,a4
    80000030:	0200c737          	lui	a4,0x200c
    80000034:	ff873603          	ld	a2,-8(a4) # 200bff8 <_entry-0x7dff4008>
    80000038:	000f4737          	lui	a4,0xf4
    8000003c:	24070713          	addi	a4,a4,576 # f4240 <_entry-0x7ff0bdc0>
    80000040:	963a                	add	a2,a2,a4
    80000042:	e290                	sd	a2,0(a3)

  // prepare information in scratch[] for timervec.
  // scratch[0..3] : space for timervec to save registers.
  // scratch[4] : address of CLINT MTIMECMP register.
  // scratch[5] : desired interval (in cycles) between timer interrupts.
  uint64 *scratch = &mscratch0[32 * id];
    80000044:	0057979b          	slliw	a5,a5,0x5
    80000048:	078e                	slli	a5,a5,0x3
    8000004a:	00009617          	auipc	a2,0x9
    8000004e:	fe660613          	addi	a2,a2,-26 # 80009030 <mscratch0>
    80000052:	97b2                	add	a5,a5,a2
  scratch[4] = CLINT_MTIMECMP(id);
    80000054:	f394                	sd	a3,32(a5)
  scratch[5] = interval;
    80000056:	f798                	sd	a4,40(a5)
}

static inline void 
w_mscratch(uint64 x)
{
  asm volatile("csrw mscratch, %0" : : "r" (x));
    80000058:	34079073          	csrw	mscratch,a5
  asm volatile("csrw mtvec, %0" : : "r" (x));
    8000005c:	00006797          	auipc	a5,0x6
    80000060:	17478793          	addi	a5,a5,372 # 800061d0 <timervec>
    80000064:	30579073          	csrw	mtvec,a5
  asm volatile("csrr %0, mstatus" : "=r" (x) );
    80000068:	300027f3          	csrr	a5,mstatus

  // set the machine-mode trap handler.
  w_mtvec((uint64)timervec);

  // enable machine-mode interrupts.
  w_mstatus(r_mstatus() | MSTATUS_MIE);
    8000006c:	0087e793          	ori	a5,a5,8
  asm volatile("csrw mstatus, %0" : : "r" (x));
    80000070:	30079073          	csrw	mstatus,a5
  asm volatile("csrr %0, mie" : "=r" (x) );
    80000074:	304027f3          	csrr	a5,mie

  // enable machine-mode timer interrupts.
  w_mie(r_mie() | MIE_MTIE);
    80000078:	0807e793          	ori	a5,a5,128
  asm volatile("csrw mie, %0" : : "r" (x));
    8000007c:	30479073          	csrw	mie,a5
}
    80000080:	6422                	ld	s0,8(sp)
    80000082:	0141                	addi	sp,sp,16
    80000084:	8082                	ret

0000000080000086 <start>:
{
    80000086:	1141                	addi	sp,sp,-16
    80000088:	e406                	sd	ra,8(sp)
    8000008a:	e022                	sd	s0,0(sp)
    8000008c:	0800                	addi	s0,sp,16
  asm volatile("csrr %0, mstatus" : "=r" (x) );
    8000008e:	300027f3          	csrr	a5,mstatus
  x &= ~MSTATUS_MPP_MASK;
    80000092:	7779                	lui	a4,0xffffe
    80000094:	7ff70713          	addi	a4,a4,2047 # ffffffffffffe7ff <end+0xffffffff7ffd27ff>
    80000098:	8ff9                	and	a5,a5,a4
  x |= MSTATUS_MPP_S;
    8000009a:	6705                	lui	a4,0x1
    8000009c:	80070713          	addi	a4,a4,-2048 # 800 <_entry-0x7ffff800>
    800000a0:	8fd9                	or	a5,a5,a4
  asm volatile("csrw mstatus, %0" : : "r" (x));
    800000a2:	30079073          	csrw	mstatus,a5
  asm volatile("csrw mepc, %0" : : "r" (x));
    800000a6:	00001797          	auipc	a5,0x1
    800000aa:	e6678793          	addi	a5,a5,-410 # 80000f0c <main>
    800000ae:	34179073          	csrw	mepc,a5
  asm volatile("csrw satp, %0" : : "r" (x));
    800000b2:	4781                	li	a5,0
    800000b4:	18079073          	csrw	satp,a5
  asm volatile("csrw medeleg, %0" : : "r" (x));
    800000b8:	67c1                	lui	a5,0x10
    800000ba:	17fd                	addi	a5,a5,-1 # ffff <_entry-0x7fff0001>
    800000bc:	30279073          	csrw	medeleg,a5
  asm volatile("csrw mideleg, %0" : : "r" (x));
    800000c0:	30379073          	csrw	mideleg,a5
  asm volatile("csrr %0, sie" : "=r" (x) );
    800000c4:	104027f3          	csrr	a5,sie
  w_sie(r_sie() | SIE_SEIE | SIE_STIE | SIE_SSIE);
    800000c8:	2227e793          	ori	a5,a5,546
  asm volatile("csrw sie, %0" : : "r" (x));
    800000cc:	10479073          	csrw	sie,a5
  timerinit();
    800000d0:	00000097          	auipc	ra,0x0
    800000d4:	f4c080e7          	jalr	-180(ra) # 8000001c <timerinit>
  asm volatile("csrr %0, mhartid" : "=r" (x) );
    800000d8:	f14027f3          	csrr	a5,mhartid
  w_tp(id);
    800000dc:	2781                	sext.w	a5,a5
}

static inline void 
w_tp(uint64 x)
{
  asm volatile("mv tp, %0" : : "r" (x));
    800000de:	823e                	mv	tp,a5
  asm volatile("mret");
    800000e0:	30200073          	mret
}
    800000e4:	60a2                	ld	ra,8(sp)
    800000e6:	6402                	ld	s0,0(sp)
    800000e8:	0141                	addi	sp,sp,16
    800000ea:	8082                	ret

00000000800000ec <consolewrite>:
//
// user write()s to the console go here.
//
int
consolewrite(int user_src, uint64 src, int n)
{
    800000ec:	715d                	addi	sp,sp,-80
    800000ee:	e486                	sd	ra,72(sp)
    800000f0:	e0a2                	sd	s0,64(sp)
    800000f2:	fc26                	sd	s1,56(sp)
    800000f4:	f84a                	sd	s2,48(sp)
    800000f6:	f44e                	sd	s3,40(sp)
    800000f8:	f052                	sd	s4,32(sp)
    800000fa:	ec56                	sd	s5,24(sp)
    800000fc:	0880                	addi	s0,sp,80
    800000fe:	8a2a                	mv	s4,a0
    80000100:	84ae                	mv	s1,a1
    80000102:	89b2                	mv	s3,a2
  int i;

  acquire(&cons.lock);
    80000104:	00011517          	auipc	a0,0x11
    80000108:	72c50513          	addi	a0,a0,1836 # 80011830 <cons>
    8000010c:	00001097          	auipc	ra,0x1
    80000110:	b56080e7          	jalr	-1194(ra) # 80000c62 <acquire>
  for(i = 0; i < n; i++){
    80000114:	05305b63          	blez	s3,8000016a <consolewrite+0x7e>
    80000118:	4901                	li	s2,0
    char c;
    if(either_copyin(&c, user_src, src+i, 1) == -1)
    8000011a:	5afd                	li	s5,-1
    8000011c:	4685                	li	a3,1
    8000011e:	8626                	mv	a2,s1
    80000120:	85d2                	mv	a1,s4
    80000122:	fbf40513          	addi	a0,s0,-65
    80000126:	00002097          	auipc	ra,0x2
    8000012a:	794080e7          	jalr	1940(ra) # 800028ba <either_copyin>
    8000012e:	01550c63          	beq	a0,s5,80000146 <consolewrite+0x5a>
      break;
    uartputc(c);
    80000132:	fbf44503          	lbu	a0,-65(s0)
    80000136:	00000097          	auipc	ra,0x0
    8000013a:	7fa080e7          	jalr	2042(ra) # 80000930 <uartputc>
  for(i = 0; i < n; i++){
    8000013e:	2905                	addiw	s2,s2,1
    80000140:	0485                	addi	s1,s1,1
    80000142:	fd299de3          	bne	s3,s2,8000011c <consolewrite+0x30>
  }
  release(&cons.lock);
    80000146:	00011517          	auipc	a0,0x11
    8000014a:	6ea50513          	addi	a0,a0,1770 # 80011830 <cons>
    8000014e:	00001097          	auipc	ra,0x1
    80000152:	bc8080e7          	jalr	-1080(ra) # 80000d16 <release>

  return i;
}
    80000156:	854a                	mv	a0,s2
    80000158:	60a6                	ld	ra,72(sp)
    8000015a:	6406                	ld	s0,64(sp)
    8000015c:	74e2                	ld	s1,56(sp)
    8000015e:	7942                	ld	s2,48(sp)
    80000160:	79a2                	ld	s3,40(sp)
    80000162:	7a02                	ld	s4,32(sp)
    80000164:	6ae2                	ld	s5,24(sp)
    80000166:	6161                	addi	sp,sp,80
    80000168:	8082                	ret
  for(i = 0; i < n; i++){
    8000016a:	4901                	li	s2,0
    8000016c:	bfe9                	j	80000146 <consolewrite+0x5a>

000000008000016e <consoleread>:
// user_dist indicates whether dst is a user
// or kernel address.
//
int
consoleread(int user_dst, uint64 dst, int n)
{
    8000016e:	7159                	addi	sp,sp,-112
    80000170:	f486                	sd	ra,104(sp)
    80000172:	f0a2                	sd	s0,96(sp)
    80000174:	eca6                	sd	s1,88(sp)
    80000176:	e8ca                	sd	s2,80(sp)
    80000178:	e4ce                	sd	s3,72(sp)
    8000017a:	e0d2                	sd	s4,64(sp)
    8000017c:	fc56                	sd	s5,56(sp)
    8000017e:	f85a                	sd	s6,48(sp)
    80000180:	f45e                	sd	s7,40(sp)
    80000182:	f062                	sd	s8,32(sp)
    80000184:	ec66                	sd	s9,24(sp)
    80000186:	e86a                	sd	s10,16(sp)
    80000188:	1880                	addi	s0,sp,112
    8000018a:	8aaa                	mv	s5,a0
    8000018c:	8a2e                	mv	s4,a1
    8000018e:	89b2                	mv	s3,a2
  uint target;
  int c;
  char cbuf;

  target = n;
    80000190:	00060b1b          	sext.w	s6,a2
  acquire(&cons.lock);
    80000194:	00011517          	auipc	a0,0x11
    80000198:	69c50513          	addi	a0,a0,1692 # 80011830 <cons>
    8000019c:	00001097          	auipc	ra,0x1
    800001a0:	ac6080e7          	jalr	-1338(ra) # 80000c62 <acquire>
  while(n > 0){
    // wait until interrupt handler has put some
    // input into cons.buffer.
    while(cons.r == cons.w){
    800001a4:	00011497          	auipc	s1,0x11
    800001a8:	68c48493          	addi	s1,s1,1676 # 80011830 <cons>
      if(myproc()->killed){
        release(&cons.lock);
        return -1;
      }
      sleep(&cons.r, &cons.lock);
    800001ac:	00011917          	auipc	s2,0x11
    800001b0:	71c90913          	addi	s2,s2,1820 # 800118c8 <cons+0x98>
    }

    c = cons.buf[cons.r++ % INPUT_BUF];

    if(c == C('D')){  // end-of-file
    800001b4:	4b91                	li	s7,4
      break;
    }

    // copy the input byte to the user-space buffer.
    cbuf = c;
    if(either_copyout(user_dst, dst, &cbuf, 1) == -1)
    800001b6:	5c7d                	li	s8,-1
      break;

    dst++;
    --n;

    if(c == '\n'){
    800001b8:	4ca9                	li	s9,10
  while(n > 0){
    800001ba:	07305863          	blez	s3,8000022a <consoleread+0xbc>
    while(cons.r == cons.w){
    800001be:	0984a783          	lw	a5,152(s1)
    800001c2:	09c4a703          	lw	a4,156(s1)
    800001c6:	02f71463          	bne	a4,a5,800001ee <consoleread+0x80>
      if(myproc()->killed){
    800001ca:	00002097          	auipc	ra,0x2
    800001ce:	b80080e7          	jalr	-1152(ra) # 80001d4a <myproc>
    800001d2:	591c                	lw	a5,48(a0)
    800001d4:	e7b5                	bnez	a5,80000240 <consoleread+0xd2>
      sleep(&cons.r, &cons.lock);
    800001d6:	85a6                	mv	a1,s1
    800001d8:	854a                	mv	a0,s2
    800001da:	00002097          	auipc	ra,0x2
    800001de:	430080e7          	jalr	1072(ra) # 8000260a <sleep>
    while(cons.r == cons.w){
    800001e2:	0984a783          	lw	a5,152(s1)
    800001e6:	09c4a703          	lw	a4,156(s1)
    800001ea:	fef700e3          	beq	a4,a5,800001ca <consoleread+0x5c>
    c = cons.buf[cons.r++ % INPUT_BUF];
    800001ee:	0017871b          	addiw	a4,a5,1
    800001f2:	08e4ac23          	sw	a4,152(s1)
    800001f6:	07f7f713          	andi	a4,a5,127
    800001fa:	9726                	add	a4,a4,s1
    800001fc:	01874703          	lbu	a4,24(a4)
    80000200:	00070d1b          	sext.w	s10,a4
    if(c == C('D')){  // end-of-file
    80000204:	077d0563          	beq	s10,s7,8000026e <consoleread+0x100>
    cbuf = c;
    80000208:	f8e40fa3          	sb	a4,-97(s0)
    if(either_copyout(user_dst, dst, &cbuf, 1) == -1)
    8000020c:	4685                	li	a3,1
    8000020e:	f9f40613          	addi	a2,s0,-97
    80000212:	85d2                	mv	a1,s4
    80000214:	8556                	mv	a0,s5
    80000216:	00002097          	auipc	ra,0x2
    8000021a:	64e080e7          	jalr	1614(ra) # 80002864 <either_copyout>
    8000021e:	01850663          	beq	a0,s8,8000022a <consoleread+0xbc>
    dst++;
    80000222:	0a05                	addi	s4,s4,1
    --n;
    80000224:	39fd                	addiw	s3,s3,-1
    if(c == '\n'){
    80000226:	f99d1ae3          	bne	s10,s9,800001ba <consoleread+0x4c>
      // a whole line has arrived, return to
      // the user-level read().
      break;
    }
  }
  release(&cons.lock);
    8000022a:	00011517          	auipc	a0,0x11
    8000022e:	60650513          	addi	a0,a0,1542 # 80011830 <cons>
    80000232:	00001097          	auipc	ra,0x1
    80000236:	ae4080e7          	jalr	-1308(ra) # 80000d16 <release>

  return target - n;
    8000023a:	413b053b          	subw	a0,s6,s3
    8000023e:	a811                	j	80000252 <consoleread+0xe4>
        release(&cons.lock);
    80000240:	00011517          	auipc	a0,0x11
    80000244:	5f050513          	addi	a0,a0,1520 # 80011830 <cons>
    80000248:	00001097          	auipc	ra,0x1
    8000024c:	ace080e7          	jalr	-1330(ra) # 80000d16 <release>
        return -1;
    80000250:	557d                	li	a0,-1
}
    80000252:	70a6                	ld	ra,104(sp)
    80000254:	7406                	ld	s0,96(sp)
    80000256:	64e6                	ld	s1,88(sp)
    80000258:	6946                	ld	s2,80(sp)
    8000025a:	69a6                	ld	s3,72(sp)
    8000025c:	6a06                	ld	s4,64(sp)
    8000025e:	7ae2                	ld	s5,56(sp)
    80000260:	7b42                	ld	s6,48(sp)
    80000262:	7ba2                	ld	s7,40(sp)
    80000264:	7c02                	ld	s8,32(sp)
    80000266:	6ce2                	ld	s9,24(sp)
    80000268:	6d42                	ld	s10,16(sp)
    8000026a:	6165                	addi	sp,sp,112
    8000026c:	8082                	ret
      if(n < target){
    8000026e:	0009871b          	sext.w	a4,s3
    80000272:	fb677ce3          	bgeu	a4,s6,8000022a <consoleread+0xbc>
        cons.r--;
    80000276:	00011717          	auipc	a4,0x11
    8000027a:	64f72923          	sw	a5,1618(a4) # 800118c8 <cons+0x98>
    8000027e:	b775                	j	8000022a <consoleread+0xbc>

0000000080000280 <consputc>:
{
    80000280:	1141                	addi	sp,sp,-16
    80000282:	e406                	sd	ra,8(sp)
    80000284:	e022                	sd	s0,0(sp)
    80000286:	0800                	addi	s0,sp,16
  if(c == BACKSPACE){
    80000288:	10000793          	li	a5,256
    8000028c:	00f50a63          	beq	a0,a5,800002a0 <consputc+0x20>
    uartputc_sync(c);
    80000290:	00000097          	auipc	ra,0x0
    80000294:	5c2080e7          	jalr	1474(ra) # 80000852 <uartputc_sync>
}
    80000298:	60a2                	ld	ra,8(sp)
    8000029a:	6402                	ld	s0,0(sp)
    8000029c:	0141                	addi	sp,sp,16
    8000029e:	8082                	ret
    uartputc_sync('\b'); uartputc_sync(' '); uartputc_sync('\b');
    800002a0:	4521                	li	a0,8
    800002a2:	00000097          	auipc	ra,0x0
    800002a6:	5b0080e7          	jalr	1456(ra) # 80000852 <uartputc_sync>
    800002aa:	02000513          	li	a0,32
    800002ae:	00000097          	auipc	ra,0x0
    800002b2:	5a4080e7          	jalr	1444(ra) # 80000852 <uartputc_sync>
    800002b6:	4521                	li	a0,8
    800002b8:	00000097          	auipc	ra,0x0
    800002bc:	59a080e7          	jalr	1434(ra) # 80000852 <uartputc_sync>
    800002c0:	bfe1                	j	80000298 <consputc+0x18>

00000000800002c2 <consoleintr>:
// do erase/kill processing, append to cons.buf,
// wake up consoleread() if a whole line has arrived.
//
void
consoleintr(int c)
{
    800002c2:	1101                	addi	sp,sp,-32
    800002c4:	ec06                	sd	ra,24(sp)
    800002c6:	e822                	sd	s0,16(sp)
    800002c8:	e426                	sd	s1,8(sp)
    800002ca:	e04a                	sd	s2,0(sp)
    800002cc:	1000                	addi	s0,sp,32
    800002ce:	84aa                	mv	s1,a0
  acquire(&cons.lock);
    800002d0:	00011517          	auipc	a0,0x11
    800002d4:	56050513          	addi	a0,a0,1376 # 80011830 <cons>
    800002d8:	00001097          	auipc	ra,0x1
    800002dc:	98a080e7          	jalr	-1654(ra) # 80000c62 <acquire>

  switch(c){
    800002e0:	47d5                	li	a5,21
    800002e2:	0af48663          	beq	s1,a5,8000038e <consoleintr+0xcc>
    800002e6:	0297ca63          	blt	a5,s1,8000031a <consoleintr+0x58>
    800002ea:	47a1                	li	a5,8
    800002ec:	0ef48763          	beq	s1,a5,800003da <consoleintr+0x118>
    800002f0:	47c1                	li	a5,16
    800002f2:	10f49a63          	bne	s1,a5,80000406 <consoleintr+0x144>
  case C('P'):  // Print process list.
    procdump();
    800002f6:	00002097          	auipc	ra,0x2
    800002fa:	61a080e7          	jalr	1562(ra) # 80002910 <procdump>
      }
    }
    break;
  }
  
  release(&cons.lock);
    800002fe:	00011517          	auipc	a0,0x11
    80000302:	53250513          	addi	a0,a0,1330 # 80011830 <cons>
    80000306:	00001097          	auipc	ra,0x1
    8000030a:	a10080e7          	jalr	-1520(ra) # 80000d16 <release>
}
    8000030e:	60e2                	ld	ra,24(sp)
    80000310:	6442                	ld	s0,16(sp)
    80000312:	64a2                	ld	s1,8(sp)
    80000314:	6902                	ld	s2,0(sp)
    80000316:	6105                	addi	sp,sp,32
    80000318:	8082                	ret
  switch(c){
    8000031a:	07f00793          	li	a5,127
    8000031e:	0af48e63          	beq	s1,a5,800003da <consoleintr+0x118>
    if(c != 0 && cons.e-cons.r < INPUT_BUF){
    80000322:	00011717          	auipc	a4,0x11
    80000326:	50e70713          	addi	a4,a4,1294 # 80011830 <cons>
    8000032a:	0a072783          	lw	a5,160(a4)
    8000032e:	09872703          	lw	a4,152(a4)
    80000332:	9f99                	subw	a5,a5,a4
    80000334:	07f00713          	li	a4,127
    80000338:	fcf763e3          	bltu	a4,a5,800002fe <consoleintr+0x3c>
      c = (c == '\r') ? '\n' : c;
    8000033c:	47b5                	li	a5,13
    8000033e:	0cf48763          	beq	s1,a5,8000040c <consoleintr+0x14a>
      consputc(c);
    80000342:	8526                	mv	a0,s1
    80000344:	00000097          	auipc	ra,0x0
    80000348:	f3c080e7          	jalr	-196(ra) # 80000280 <consputc>
      cons.buf[cons.e++ % INPUT_BUF] = c;
    8000034c:	00011797          	auipc	a5,0x11
    80000350:	4e478793          	addi	a5,a5,1252 # 80011830 <cons>
    80000354:	0a07a703          	lw	a4,160(a5)
    80000358:	0017069b          	addiw	a3,a4,1
    8000035c:	0006861b          	sext.w	a2,a3
    80000360:	0ad7a023          	sw	a3,160(a5)
    80000364:	07f77713          	andi	a4,a4,127
    80000368:	97ba                	add	a5,a5,a4
    8000036a:	00978c23          	sb	s1,24(a5)
      if(c == '\n' || c == C('D') || cons.e == cons.r+INPUT_BUF){
    8000036e:	47a9                	li	a5,10
    80000370:	0cf48563          	beq	s1,a5,8000043a <consoleintr+0x178>
    80000374:	4791                	li	a5,4
    80000376:	0cf48263          	beq	s1,a5,8000043a <consoleintr+0x178>
    8000037a:	00011797          	auipc	a5,0x11
    8000037e:	54e7a783          	lw	a5,1358(a5) # 800118c8 <cons+0x98>
    80000382:	0807879b          	addiw	a5,a5,128
    80000386:	f6f61ce3          	bne	a2,a5,800002fe <consoleintr+0x3c>
      cons.buf[cons.e++ % INPUT_BUF] = c;
    8000038a:	863e                	mv	a2,a5
    8000038c:	a07d                	j	8000043a <consoleintr+0x178>
    while(cons.e != cons.w &&
    8000038e:	00011717          	auipc	a4,0x11
    80000392:	4a270713          	addi	a4,a4,1186 # 80011830 <cons>
    80000396:	0a072783          	lw	a5,160(a4)
    8000039a:	09c72703          	lw	a4,156(a4)
          cons.buf[(cons.e-1) % INPUT_BUF] != '\n'){
    8000039e:	00011497          	auipc	s1,0x11
    800003a2:	49248493          	addi	s1,s1,1170 # 80011830 <cons>
    while(cons.e != cons.w &&
    800003a6:	4929                	li	s2,10
    800003a8:	f4f70be3          	beq	a4,a5,800002fe <consoleintr+0x3c>
          cons.buf[(cons.e-1) % INPUT_BUF] != '\n'){
    800003ac:	37fd                	addiw	a5,a5,-1
    800003ae:	07f7f713          	andi	a4,a5,127
    800003b2:	9726                	add	a4,a4,s1
    while(cons.e != cons.w &&
    800003b4:	01874703          	lbu	a4,24(a4)
    800003b8:	f52703e3          	beq	a4,s2,800002fe <consoleintr+0x3c>
      cons.e--;
    800003bc:	0af4a023          	sw	a5,160(s1)
      consputc(BACKSPACE);
    800003c0:	10000513          	li	a0,256
    800003c4:	00000097          	auipc	ra,0x0
    800003c8:	ebc080e7          	jalr	-324(ra) # 80000280 <consputc>
    while(cons.e != cons.w &&
    800003cc:	0a04a783          	lw	a5,160(s1)
    800003d0:	09c4a703          	lw	a4,156(s1)
    800003d4:	fcf71ce3          	bne	a4,a5,800003ac <consoleintr+0xea>
    800003d8:	b71d                	j	800002fe <consoleintr+0x3c>
    if(cons.e != cons.w){
    800003da:	00011717          	auipc	a4,0x11
    800003de:	45670713          	addi	a4,a4,1110 # 80011830 <cons>
    800003e2:	0a072783          	lw	a5,160(a4)
    800003e6:	09c72703          	lw	a4,156(a4)
    800003ea:	f0f70ae3          	beq	a4,a5,800002fe <consoleintr+0x3c>
      cons.e--;
    800003ee:	37fd                	addiw	a5,a5,-1
    800003f0:	00011717          	auipc	a4,0x11
    800003f4:	4ef72023          	sw	a5,1248(a4) # 800118d0 <cons+0xa0>
      consputc(BACKSPACE);
    800003f8:	10000513          	li	a0,256
    800003fc:	00000097          	auipc	ra,0x0
    80000400:	e84080e7          	jalr	-380(ra) # 80000280 <consputc>
    80000404:	bded                	j	800002fe <consoleintr+0x3c>
    if(c != 0 && cons.e-cons.r < INPUT_BUF){
    80000406:	ee048ce3          	beqz	s1,800002fe <consoleintr+0x3c>
    8000040a:	bf21                	j	80000322 <consoleintr+0x60>
      consputc(c);
    8000040c:	4529                	li	a0,10
    8000040e:	00000097          	auipc	ra,0x0
    80000412:	e72080e7          	jalr	-398(ra) # 80000280 <consputc>
      cons.buf[cons.e++ % INPUT_BUF] = c;
    80000416:	00011797          	auipc	a5,0x11
    8000041a:	41a78793          	addi	a5,a5,1050 # 80011830 <cons>
    8000041e:	0a07a703          	lw	a4,160(a5)
    80000422:	0017069b          	addiw	a3,a4,1
    80000426:	0006861b          	sext.w	a2,a3
    8000042a:	0ad7a023          	sw	a3,160(a5)
    8000042e:	07f77713          	andi	a4,a4,127
    80000432:	97ba                	add	a5,a5,a4
    80000434:	4729                	li	a4,10
    80000436:	00e78c23          	sb	a4,24(a5)
        cons.w = cons.e;
    8000043a:	00011797          	auipc	a5,0x11
    8000043e:	48c7a923          	sw	a2,1170(a5) # 800118cc <cons+0x9c>
        wakeup(&cons.r);
    80000442:	00011517          	auipc	a0,0x11
    80000446:	48650513          	addi	a0,a0,1158 # 800118c8 <cons+0x98>
    8000044a:	00002097          	auipc	ra,0x2
    8000044e:	340080e7          	jalr	832(ra) # 8000278a <wakeup>
    80000452:	b575                	j	800002fe <consoleintr+0x3c>

0000000080000454 <consoleinit>:

void
consoleinit(void)
{
    80000454:	1141                	addi	sp,sp,-16
    80000456:	e406                	sd	ra,8(sp)
    80000458:	e022                	sd	s0,0(sp)
    8000045a:	0800                	addi	s0,sp,16
  initlock(&cons.lock, "cons");
    8000045c:	00008597          	auipc	a1,0x8
    80000460:	bb458593          	addi	a1,a1,-1100 # 80008010 <etext+0x10>
    80000464:	00011517          	auipc	a0,0x11
    80000468:	3cc50513          	addi	a0,a0,972 # 80011830 <cons>
    8000046c:	00000097          	auipc	ra,0x0
    80000470:	766080e7          	jalr	1894(ra) # 80000bd2 <initlock>

  uartinit();
    80000474:	00000097          	auipc	ra,0x0
    80000478:	38e080e7          	jalr	910(ra) # 80000802 <uartinit>

  // connect read and write system calls
  // to consoleread and consolewrite.
  devsw[CONSOLE].read = consoleread;
    8000047c:	00027797          	auipc	a5,0x27
    80000480:	fac78793          	addi	a5,a5,-84 # 80027428 <devsw>
    80000484:	00000717          	auipc	a4,0x0
    80000488:	cea70713          	addi	a4,a4,-790 # 8000016e <consoleread>
    8000048c:	eb98                	sd	a4,16(a5)
  devsw[CONSOLE].write = consolewrite;
    8000048e:	00000717          	auipc	a4,0x0
    80000492:	c5e70713          	addi	a4,a4,-930 # 800000ec <consolewrite>
    80000496:	ef98                	sd	a4,24(a5)
}
    80000498:	60a2                	ld	ra,8(sp)
    8000049a:	6402                	ld	s0,0(sp)
    8000049c:	0141                	addi	sp,sp,16
    8000049e:	8082                	ret

00000000800004a0 <printint>:

static char digits[] = "0123456789abcdef";

static void
printint(int xx, int base, int sign)
{
    800004a0:	7179                	addi	sp,sp,-48
    800004a2:	f406                	sd	ra,40(sp)
    800004a4:	f022                	sd	s0,32(sp)
    800004a6:	ec26                	sd	s1,24(sp)
    800004a8:	e84a                	sd	s2,16(sp)
    800004aa:	1800                	addi	s0,sp,48
  char buf[16];
  int i;
  uint x;

  if (sign && (sign = xx < 0))
    800004ac:	c219                	beqz	a2,800004b2 <printint+0x12>
    800004ae:	08054663          	bltz	a0,8000053a <printint+0x9a>
    x = -xx;
  else
    x = xx;
    800004b2:	2501                	sext.w	a0,a0
    800004b4:	4881                	li	a7,0
    800004b6:	fd040693          	addi	a3,s0,-48

  i = 0;
    800004ba:	4701                	li	a4,0
  do
  {
    buf[i++] = digits[x % base];
    800004bc:	2581                	sext.w	a1,a1
    800004be:	00008617          	auipc	a2,0x8
    800004c2:	b9a60613          	addi	a2,a2,-1126 # 80008058 <digits>
    800004c6:	883a                	mv	a6,a4
    800004c8:	2705                	addiw	a4,a4,1
    800004ca:	02b577bb          	remuw	a5,a0,a1
    800004ce:	1782                	slli	a5,a5,0x20
    800004d0:	9381                	srli	a5,a5,0x20
    800004d2:	97b2                	add	a5,a5,a2
    800004d4:	0007c783          	lbu	a5,0(a5)
    800004d8:	00f68023          	sb	a5,0(a3)
  } while ((x /= base) != 0);
    800004dc:	0005079b          	sext.w	a5,a0
    800004e0:	02b5553b          	divuw	a0,a0,a1
    800004e4:	0685                	addi	a3,a3,1
    800004e6:	feb7f0e3          	bgeu	a5,a1,800004c6 <printint+0x26>

  if (sign)
    800004ea:	00088b63          	beqz	a7,80000500 <printint+0x60>
    buf[i++] = '-';
    800004ee:	fe040793          	addi	a5,s0,-32
    800004f2:	973e                	add	a4,a4,a5
    800004f4:	02d00793          	li	a5,45
    800004f8:	fef70823          	sb	a5,-16(a4)
    800004fc:	0028071b          	addiw	a4,a6,2

  while (--i >= 0)
    80000500:	02e05763          	blez	a4,8000052e <printint+0x8e>
    80000504:	fd040793          	addi	a5,s0,-48
    80000508:	00e784b3          	add	s1,a5,a4
    8000050c:	fff78913          	addi	s2,a5,-1
    80000510:	993a                	add	s2,s2,a4
    80000512:	377d                	addiw	a4,a4,-1
    80000514:	1702                	slli	a4,a4,0x20
    80000516:	9301                	srli	a4,a4,0x20
    80000518:	40e90933          	sub	s2,s2,a4
    consputc(buf[i]);
    8000051c:	fff4c503          	lbu	a0,-1(s1)
    80000520:	00000097          	auipc	ra,0x0
    80000524:	d60080e7          	jalr	-672(ra) # 80000280 <consputc>
  while (--i >= 0)
    80000528:	14fd                	addi	s1,s1,-1
    8000052a:	ff2499e3          	bne	s1,s2,8000051c <printint+0x7c>
}
    8000052e:	70a2                	ld	ra,40(sp)
    80000530:	7402                	ld	s0,32(sp)
    80000532:	64e2                	ld	s1,24(sp)
    80000534:	6942                	ld	s2,16(sp)
    80000536:	6145                	addi	sp,sp,48
    80000538:	8082                	ret
    x = -xx;
    8000053a:	40a0053b          	negw	a0,a0
  if (sign && (sign = xx < 0))
    8000053e:	4885                	li	a7,1
    x = -xx;
    80000540:	bf9d                	j	800004b6 <printint+0x16>

0000000080000542 <printfinit>:
  for (;;)
    ;
}

void printfinit(void)
{
    80000542:	1101                	addi	sp,sp,-32
    80000544:	ec06                	sd	ra,24(sp)
    80000546:	e822                	sd	s0,16(sp)
    80000548:	e426                	sd	s1,8(sp)
    8000054a:	1000                	addi	s0,sp,32
  initlock(&pr.lock, "pr");
    8000054c:	00011497          	auipc	s1,0x11
    80000550:	38c48493          	addi	s1,s1,908 # 800118d8 <pr>
    80000554:	00008597          	auipc	a1,0x8
    80000558:	ac458593          	addi	a1,a1,-1340 # 80008018 <etext+0x18>
    8000055c:	8526                	mv	a0,s1
    8000055e:	00000097          	auipc	ra,0x0
    80000562:	674080e7          	jalr	1652(ra) # 80000bd2 <initlock>
  pr.locking = 1;
    80000566:	4785                	li	a5,1
    80000568:	cc9c                	sw	a5,24(s1)
}
    8000056a:	60e2                	ld	ra,24(sp)
    8000056c:	6442                	ld	s0,16(sp)
    8000056e:	64a2                	ld	s1,8(sp)
    80000570:	6105                	addi	sp,sp,32
    80000572:	8082                	ret

0000000080000574 <backtrace>:
void backtrace(void)
{
    80000574:	7179                	addi	sp,sp,-48
    80000576:	f406                	sd	ra,40(sp)
    80000578:	f022                	sd	s0,32(sp)
    8000057a:	ec26                	sd	s1,24(sp)
    8000057c:	e84a                	sd	s2,16(sp)
    8000057e:	e44e                	sd	s3,8(sp)
    80000580:	1800                	addi	s0,sp,48

static inline uint64
r_fp()
{
uint64 x;
asm volatile("mv %0, s0" : "=r" (x) );
    80000582:	84a2                	mv	s1,s0
  uint64 fp = r_fp();
  uint64 top = PGROUNDUP(fp);
    80000584:	6905                	lui	s2,0x1
    80000586:	197d                	addi	s2,s2,-1 # fff <_entry-0x7ffff001>
    80000588:	9926                	add	s2,s2,s1
    8000058a:	77fd                	lui	a5,0xfffff
    8000058c:	00f97933          	and	s2,s2,a5
  printf("backtrace:\n");
    80000590:	00008517          	auipc	a0,0x8
    80000594:	a9050513          	addi	a0,a0,-1392 # 80008020 <etext+0x20>
    80000598:	00000097          	auipc	ra,0x0
    8000059c:	08a080e7          	jalr	138(ra) # 80000622 <printf>
  while (fp < top)
    800005a0:	0324f163          	bgeu	s1,s2,800005c2 <backtrace+0x4e>
  {
    uint64 retaddr = fp - 8;
    printf("%p\n", *(uint64 *)retaddr);
    800005a4:	00008997          	auipc	s3,0x8
    800005a8:	a8c98993          	addi	s3,s3,-1396 # 80008030 <etext+0x30>
    800005ac:	ff84b583          	ld	a1,-8(s1)
    800005b0:	854e                	mv	a0,s3
    800005b2:	00000097          	auipc	ra,0x0
    800005b6:	070080e7          	jalr	112(ra) # 80000622 <printf>
    fp = *((uint64 *)(fp - 16));
    800005ba:	ff04b483          	ld	s1,-16(s1)
  while (fp < top)
    800005be:	ff24e7e3          	bltu	s1,s2,800005ac <backtrace+0x38>
  }
}
    800005c2:	70a2                	ld	ra,40(sp)
    800005c4:	7402                	ld	s0,32(sp)
    800005c6:	64e2                	ld	s1,24(sp)
    800005c8:	6942                	ld	s2,16(sp)
    800005ca:	69a2                	ld	s3,8(sp)
    800005cc:	6145                	addi	sp,sp,48
    800005ce:	8082                	ret

00000000800005d0 <panic>:
{
    800005d0:	1101                	addi	sp,sp,-32
    800005d2:	ec06                	sd	ra,24(sp)
    800005d4:	e822                	sd	s0,16(sp)
    800005d6:	e426                	sd	s1,8(sp)
    800005d8:	1000                	addi	s0,sp,32
    800005da:	84aa                	mv	s1,a0
  pr.locking = 0;
    800005dc:	00011797          	auipc	a5,0x11
    800005e0:	3007aa23          	sw	zero,788(a5) # 800118f0 <pr+0x18>
  printf("panic: ");
    800005e4:	00008517          	auipc	a0,0x8
    800005e8:	a5450513          	addi	a0,a0,-1452 # 80008038 <etext+0x38>
    800005ec:	00000097          	auipc	ra,0x0
    800005f0:	036080e7          	jalr	54(ra) # 80000622 <printf>
  printf(s);
    800005f4:	8526                	mv	a0,s1
    800005f6:	00000097          	auipc	ra,0x0
    800005fa:	02c080e7          	jalr	44(ra) # 80000622 <printf>
  printf("\n");
    800005fe:	00008517          	auipc	a0,0x8
    80000602:	ae250513          	addi	a0,a0,-1310 # 800080e0 <digits+0x88>
    80000606:	00000097          	auipc	ra,0x0
    8000060a:	01c080e7          	jalr	28(ra) # 80000622 <printf>
  backtrace();
    8000060e:	00000097          	auipc	ra,0x0
    80000612:	f66080e7          	jalr	-154(ra) # 80000574 <backtrace>
  panicked = 1; // freeze uart output from other CPUs
    80000616:	4785                	li	a5,1
    80000618:	00009717          	auipc	a4,0x9
    8000061c:	9ef72423          	sw	a5,-1560(a4) # 80009000 <panicked>
  for (;;)
    80000620:	a001                	j	80000620 <panic+0x50>

0000000080000622 <printf>:
{
    80000622:	7131                	addi	sp,sp,-192
    80000624:	fc86                	sd	ra,120(sp)
    80000626:	f8a2                	sd	s0,112(sp)
    80000628:	f4a6                	sd	s1,104(sp)
    8000062a:	f0ca                	sd	s2,96(sp)
    8000062c:	ecce                	sd	s3,88(sp)
    8000062e:	e8d2                	sd	s4,80(sp)
    80000630:	e4d6                	sd	s5,72(sp)
    80000632:	e0da                	sd	s6,64(sp)
    80000634:	fc5e                	sd	s7,56(sp)
    80000636:	f862                	sd	s8,48(sp)
    80000638:	f466                	sd	s9,40(sp)
    8000063a:	f06a                	sd	s10,32(sp)
    8000063c:	ec6e                	sd	s11,24(sp)
    8000063e:	0100                	addi	s0,sp,128
    80000640:	8a2a                	mv	s4,a0
    80000642:	e40c                	sd	a1,8(s0)
    80000644:	e810                	sd	a2,16(s0)
    80000646:	ec14                	sd	a3,24(s0)
    80000648:	f018                	sd	a4,32(s0)
    8000064a:	f41c                	sd	a5,40(s0)
    8000064c:	03043823          	sd	a6,48(s0)
    80000650:	03143c23          	sd	a7,56(s0)
  locking = pr.locking;
    80000654:	00011d97          	auipc	s11,0x11
    80000658:	29cdad83          	lw	s11,668(s11) # 800118f0 <pr+0x18>
  if (locking)
    8000065c:	020d9b63          	bnez	s11,80000692 <printf+0x70>
  if (fmt == 0)
    80000660:	040a0263          	beqz	s4,800006a4 <printf+0x82>
  va_start(ap, fmt);
    80000664:	00840793          	addi	a5,s0,8
    80000668:	f8f43423          	sd	a5,-120(s0)
  for (i = 0; (c = fmt[i] & 0xff) != 0; i++)
    8000066c:	000a4503          	lbu	a0,0(s4)
    80000670:	14050f63          	beqz	a0,800007ce <printf+0x1ac>
    80000674:	4981                	li	s3,0
    if (c != '%')
    80000676:	02500a93          	li	s5,37
    switch (c)
    8000067a:	07000b93          	li	s7,112
  consputc('x');
    8000067e:	4d41                	li	s10,16
    consputc(digits[x >> (sizeof(uint64) * 8 - 4)]);
    80000680:	00008b17          	auipc	s6,0x8
    80000684:	9d8b0b13          	addi	s6,s6,-1576 # 80008058 <digits>
    switch (c)
    80000688:	07300c93          	li	s9,115
    8000068c:	06400c13          	li	s8,100
    80000690:	a82d                	j	800006ca <printf+0xa8>
    acquire(&pr.lock);
    80000692:	00011517          	auipc	a0,0x11
    80000696:	24650513          	addi	a0,a0,582 # 800118d8 <pr>
    8000069a:	00000097          	auipc	ra,0x0
    8000069e:	5c8080e7          	jalr	1480(ra) # 80000c62 <acquire>
    800006a2:	bf7d                	j	80000660 <printf+0x3e>
    panic("null fmt");
    800006a4:	00008517          	auipc	a0,0x8
    800006a8:	9a450513          	addi	a0,a0,-1628 # 80008048 <etext+0x48>
    800006ac:	00000097          	auipc	ra,0x0
    800006b0:	f24080e7          	jalr	-220(ra) # 800005d0 <panic>
      consputc(c);
    800006b4:	00000097          	auipc	ra,0x0
    800006b8:	bcc080e7          	jalr	-1076(ra) # 80000280 <consputc>
  for (i = 0; (c = fmt[i] & 0xff) != 0; i++)
    800006bc:	2985                	addiw	s3,s3,1
    800006be:	013a07b3          	add	a5,s4,s3
    800006c2:	0007c503          	lbu	a0,0(a5)
    800006c6:	10050463          	beqz	a0,800007ce <printf+0x1ac>
    if (c != '%')
    800006ca:	ff5515e3          	bne	a0,s5,800006b4 <printf+0x92>
    c = fmt[++i] & 0xff;
    800006ce:	2985                	addiw	s3,s3,1
    800006d0:	013a07b3          	add	a5,s4,s3
    800006d4:	0007c783          	lbu	a5,0(a5)
    800006d8:	0007849b          	sext.w	s1,a5
    if (c == 0)
    800006dc:	cbed                	beqz	a5,800007ce <printf+0x1ac>
    switch (c)
    800006de:	05778a63          	beq	a5,s7,80000732 <printf+0x110>
    800006e2:	02fbf663          	bgeu	s7,a5,8000070e <printf+0xec>
    800006e6:	09978863          	beq	a5,s9,80000776 <printf+0x154>
    800006ea:	07800713          	li	a4,120
    800006ee:	0ce79563          	bne	a5,a4,800007b8 <printf+0x196>
      printint(va_arg(ap, int), 16, 1);
    800006f2:	f8843783          	ld	a5,-120(s0)
    800006f6:	00878713          	addi	a4,a5,8
    800006fa:	f8e43423          	sd	a4,-120(s0)
    800006fe:	4605                	li	a2,1
    80000700:	85ea                	mv	a1,s10
    80000702:	4388                	lw	a0,0(a5)
    80000704:	00000097          	auipc	ra,0x0
    80000708:	d9c080e7          	jalr	-612(ra) # 800004a0 <printint>
      break;
    8000070c:	bf45                	j	800006bc <printf+0x9a>
    switch (c)
    8000070e:	09578f63          	beq	a5,s5,800007ac <printf+0x18a>
    80000712:	0b879363          	bne	a5,s8,800007b8 <printf+0x196>
      printint(va_arg(ap, int), 10, 1);
    80000716:	f8843783          	ld	a5,-120(s0)
    8000071a:	00878713          	addi	a4,a5,8
    8000071e:	f8e43423          	sd	a4,-120(s0)
    80000722:	4605                	li	a2,1
    80000724:	45a9                	li	a1,10
    80000726:	4388                	lw	a0,0(a5)
    80000728:	00000097          	auipc	ra,0x0
    8000072c:	d78080e7          	jalr	-648(ra) # 800004a0 <printint>
      break;
    80000730:	b771                	j	800006bc <printf+0x9a>
      printptr(va_arg(ap, uint64));
    80000732:	f8843783          	ld	a5,-120(s0)
    80000736:	00878713          	addi	a4,a5,8
    8000073a:	f8e43423          	sd	a4,-120(s0)
    8000073e:	0007b903          	ld	s2,0(a5)
  consputc('0');
    80000742:	03000513          	li	a0,48
    80000746:	00000097          	auipc	ra,0x0
    8000074a:	b3a080e7          	jalr	-1222(ra) # 80000280 <consputc>
  consputc('x');
    8000074e:	07800513          	li	a0,120
    80000752:	00000097          	auipc	ra,0x0
    80000756:	b2e080e7          	jalr	-1234(ra) # 80000280 <consputc>
    8000075a:	84ea                	mv	s1,s10
    consputc(digits[x >> (sizeof(uint64) * 8 - 4)]);
    8000075c:	03c95793          	srli	a5,s2,0x3c
    80000760:	97da                	add	a5,a5,s6
    80000762:	0007c503          	lbu	a0,0(a5)
    80000766:	00000097          	auipc	ra,0x0
    8000076a:	b1a080e7          	jalr	-1254(ra) # 80000280 <consputc>
  for (i = 0; i < (sizeof(uint64) * 2); i++, x <<= 4)
    8000076e:	0912                	slli	s2,s2,0x4
    80000770:	34fd                	addiw	s1,s1,-1
    80000772:	f4ed                	bnez	s1,8000075c <printf+0x13a>
    80000774:	b7a1                	j	800006bc <printf+0x9a>
      if ((s = va_arg(ap, char *)) == 0)
    80000776:	f8843783          	ld	a5,-120(s0)
    8000077a:	00878713          	addi	a4,a5,8
    8000077e:	f8e43423          	sd	a4,-120(s0)
    80000782:	6384                	ld	s1,0(a5)
    80000784:	cc89                	beqz	s1,8000079e <printf+0x17c>
      for (; *s; s++)
    80000786:	0004c503          	lbu	a0,0(s1)
    8000078a:	d90d                	beqz	a0,800006bc <printf+0x9a>
        consputc(*s);
    8000078c:	00000097          	auipc	ra,0x0
    80000790:	af4080e7          	jalr	-1292(ra) # 80000280 <consputc>
      for (; *s; s++)
    80000794:	0485                	addi	s1,s1,1
    80000796:	0004c503          	lbu	a0,0(s1)
    8000079a:	f96d                	bnez	a0,8000078c <printf+0x16a>
    8000079c:	b705                	j	800006bc <printf+0x9a>
        s = "(null)";
    8000079e:	00008497          	auipc	s1,0x8
    800007a2:	8a248493          	addi	s1,s1,-1886 # 80008040 <etext+0x40>
      for (; *s; s++)
    800007a6:	02800513          	li	a0,40
    800007aa:	b7cd                	j	8000078c <printf+0x16a>
      consputc('%');
    800007ac:	8556                	mv	a0,s5
    800007ae:	00000097          	auipc	ra,0x0
    800007b2:	ad2080e7          	jalr	-1326(ra) # 80000280 <consputc>
      break;
    800007b6:	b719                	j	800006bc <printf+0x9a>
      consputc('%');
    800007b8:	8556                	mv	a0,s5
    800007ba:	00000097          	auipc	ra,0x0
    800007be:	ac6080e7          	jalr	-1338(ra) # 80000280 <consputc>
      consputc(c);
    800007c2:	8526                	mv	a0,s1
    800007c4:	00000097          	auipc	ra,0x0
    800007c8:	abc080e7          	jalr	-1348(ra) # 80000280 <consputc>
      break;
    800007cc:	bdc5                	j	800006bc <printf+0x9a>
  if (locking)
    800007ce:	020d9163          	bnez	s11,800007f0 <printf+0x1ce>
}
    800007d2:	70e6                	ld	ra,120(sp)
    800007d4:	7446                	ld	s0,112(sp)
    800007d6:	74a6                	ld	s1,104(sp)
    800007d8:	7906                	ld	s2,96(sp)
    800007da:	69e6                	ld	s3,88(sp)
    800007dc:	6a46                	ld	s4,80(sp)
    800007de:	6aa6                	ld	s5,72(sp)
    800007e0:	6b06                	ld	s6,64(sp)
    800007e2:	7be2                	ld	s7,56(sp)
    800007e4:	7c42                	ld	s8,48(sp)
    800007e6:	7ca2                	ld	s9,40(sp)
    800007e8:	7d02                	ld	s10,32(sp)
    800007ea:	6de2                	ld	s11,24(sp)
    800007ec:	6129                	addi	sp,sp,192
    800007ee:	8082                	ret
    release(&pr.lock);
    800007f0:	00011517          	auipc	a0,0x11
    800007f4:	0e850513          	addi	a0,a0,232 # 800118d8 <pr>
    800007f8:	00000097          	auipc	ra,0x0
    800007fc:	51e080e7          	jalr	1310(ra) # 80000d16 <release>
}
    80000800:	bfc9                	j	800007d2 <printf+0x1b0>

0000000080000802 <uartinit>:

void uartstart();

void
uartinit(void)
{
    80000802:	1141                	addi	sp,sp,-16
    80000804:	e406                	sd	ra,8(sp)
    80000806:	e022                	sd	s0,0(sp)
    80000808:	0800                	addi	s0,sp,16
  // disable interrupts.
  WriteReg(IER, 0x00);
    8000080a:	100007b7          	lui	a5,0x10000
    8000080e:	000780a3          	sb	zero,1(a5) # 10000001 <_entry-0x6fffffff>

  // special mode to set baud rate.
  WriteReg(LCR, LCR_BAUD_LATCH);
    80000812:	f8000713          	li	a4,-128
    80000816:	00e781a3          	sb	a4,3(a5)

  // LSB for baud rate of 38.4K.
  WriteReg(0, 0x03);
    8000081a:	470d                	li	a4,3
    8000081c:	00e78023          	sb	a4,0(a5)

  // MSB for baud rate of 38.4K.
  WriteReg(1, 0x00);
    80000820:	000780a3          	sb	zero,1(a5)

  // leave set-baud mode,
  // and set word length to 8 bits, no parity.
  WriteReg(LCR, LCR_EIGHT_BITS);
    80000824:	00e781a3          	sb	a4,3(a5)

  // reset and enable FIFOs.
  WriteReg(FCR, FCR_FIFO_ENABLE | FCR_FIFO_CLEAR);
    80000828:	469d                	li	a3,7
    8000082a:	00d78123          	sb	a3,2(a5)

  // enable transmit and receive interrupts.
  WriteReg(IER, IER_TX_ENABLE | IER_RX_ENABLE);
    8000082e:	00e780a3          	sb	a4,1(a5)

  initlock(&uart_tx_lock, "uart");
    80000832:	00008597          	auipc	a1,0x8
    80000836:	83e58593          	addi	a1,a1,-1986 # 80008070 <digits+0x18>
    8000083a:	00011517          	auipc	a0,0x11
    8000083e:	0be50513          	addi	a0,a0,190 # 800118f8 <uart_tx_lock>
    80000842:	00000097          	auipc	ra,0x0
    80000846:	390080e7          	jalr	912(ra) # 80000bd2 <initlock>
}
    8000084a:	60a2                	ld	ra,8(sp)
    8000084c:	6402                	ld	s0,0(sp)
    8000084e:	0141                	addi	sp,sp,16
    80000850:	8082                	ret

0000000080000852 <uartputc_sync>:
// use interrupts, for use by kernel printf() and
// to echo characters. it spins waiting for the uart's
// output register to be empty.
void
uartputc_sync(int c)
{
    80000852:	1101                	addi	sp,sp,-32
    80000854:	ec06                	sd	ra,24(sp)
    80000856:	e822                	sd	s0,16(sp)
    80000858:	e426                	sd	s1,8(sp)
    8000085a:	1000                	addi	s0,sp,32
    8000085c:	84aa                	mv	s1,a0
  push_off();
    8000085e:	00000097          	auipc	ra,0x0
    80000862:	3b8080e7          	jalr	952(ra) # 80000c16 <push_off>

  if(panicked){
    80000866:	00008797          	auipc	a5,0x8
    8000086a:	79a7a783          	lw	a5,1946(a5) # 80009000 <panicked>
    for(;;)
      ;
  }

  // wait for Transmit Holding Empty to be set in LSR.
  while((ReadReg(LSR) & LSR_TX_IDLE) == 0)
    8000086e:	10000737          	lui	a4,0x10000
  if(panicked){
    80000872:	c391                	beqz	a5,80000876 <uartputc_sync+0x24>
    for(;;)
    80000874:	a001                	j	80000874 <uartputc_sync+0x22>
  while((ReadReg(LSR) & LSR_TX_IDLE) == 0)
    80000876:	00574783          	lbu	a5,5(a4) # 10000005 <_entry-0x6ffffffb>
    8000087a:	0207f793          	andi	a5,a5,32
    8000087e:	dfe5                	beqz	a5,80000876 <uartputc_sync+0x24>
    ;
  WriteReg(THR, c);
    80000880:	0ff4f513          	zext.b	a0,s1
    80000884:	100007b7          	lui	a5,0x10000
    80000888:	00a78023          	sb	a0,0(a5) # 10000000 <_entry-0x70000000>

  pop_off();
    8000088c:	00000097          	auipc	ra,0x0
    80000890:	42a080e7          	jalr	1066(ra) # 80000cb6 <pop_off>
}
    80000894:	60e2                	ld	ra,24(sp)
    80000896:	6442                	ld	s0,16(sp)
    80000898:	64a2                	ld	s1,8(sp)
    8000089a:	6105                	addi	sp,sp,32
    8000089c:	8082                	ret

000000008000089e <uartstart>:
// called from both the top- and bottom-half.
void
uartstart()
{
  while(1){
    if(uart_tx_w == uart_tx_r){
    8000089e:	00008797          	auipc	a5,0x8
    800008a2:	7667a783          	lw	a5,1894(a5) # 80009004 <uart_tx_r>
    800008a6:	00008717          	auipc	a4,0x8
    800008aa:	76272703          	lw	a4,1890(a4) # 80009008 <uart_tx_w>
    800008ae:	08f70063          	beq	a4,a5,8000092e <uartstart+0x90>
{
    800008b2:	7139                	addi	sp,sp,-64
    800008b4:	fc06                	sd	ra,56(sp)
    800008b6:	f822                	sd	s0,48(sp)
    800008b8:	f426                	sd	s1,40(sp)
    800008ba:	f04a                	sd	s2,32(sp)
    800008bc:	ec4e                	sd	s3,24(sp)
    800008be:	e852                	sd	s4,16(sp)
    800008c0:	e456                	sd	s5,8(sp)
    800008c2:	0080                	addi	s0,sp,64
      // transmit buffer is empty.
      return;
    }
    
    if((ReadReg(LSR) & LSR_TX_IDLE) == 0){
    800008c4:	10000937          	lui	s2,0x10000
      // so we cannot give it another byte.
      // it will interrupt when it's ready for a new byte.
      return;
    }
    
    int c = uart_tx_buf[uart_tx_r];
    800008c8:	00011a97          	auipc	s5,0x11
    800008cc:	030a8a93          	addi	s5,s5,48 # 800118f8 <uart_tx_lock>
    uart_tx_r = (uart_tx_r + 1) % UART_TX_BUF_SIZE;
    800008d0:	00008497          	auipc	s1,0x8
    800008d4:	73448493          	addi	s1,s1,1844 # 80009004 <uart_tx_r>
    if(uart_tx_w == uart_tx_r){
    800008d8:	00008a17          	auipc	s4,0x8
    800008dc:	730a0a13          	addi	s4,s4,1840 # 80009008 <uart_tx_w>
    if((ReadReg(LSR) & LSR_TX_IDLE) == 0){
    800008e0:	00594703          	lbu	a4,5(s2) # 10000005 <_entry-0x6ffffffb>
    800008e4:	02077713          	andi	a4,a4,32
    800008e8:	cb15                	beqz	a4,8000091c <uartstart+0x7e>
    int c = uart_tx_buf[uart_tx_r];
    800008ea:	00fa8733          	add	a4,s5,a5
    800008ee:	01874983          	lbu	s3,24(a4)
    uart_tx_r = (uart_tx_r + 1) % UART_TX_BUF_SIZE;
    800008f2:	2785                	addiw	a5,a5,1
    800008f4:	41f7d71b          	sraiw	a4,a5,0x1f
    800008f8:	01b7571b          	srliw	a4,a4,0x1b
    800008fc:	9fb9                	addw	a5,a5,a4
    800008fe:	8bfd                	andi	a5,a5,31
    80000900:	9f99                	subw	a5,a5,a4
    80000902:	c09c                	sw	a5,0(s1)
    
    // maybe uartputc() is waiting for space in the buffer.
    wakeup(&uart_tx_r);
    80000904:	8526                	mv	a0,s1
    80000906:	00002097          	auipc	ra,0x2
    8000090a:	e84080e7          	jalr	-380(ra) # 8000278a <wakeup>
    
    WriteReg(THR, c);
    8000090e:	01390023          	sb	s3,0(s2)
    if(uart_tx_w == uart_tx_r){
    80000912:	409c                	lw	a5,0(s1)
    80000914:	000a2703          	lw	a4,0(s4)
    80000918:	fcf714e3          	bne	a4,a5,800008e0 <uartstart+0x42>
  }
}
    8000091c:	70e2                	ld	ra,56(sp)
    8000091e:	7442                	ld	s0,48(sp)
    80000920:	74a2                	ld	s1,40(sp)
    80000922:	7902                	ld	s2,32(sp)
    80000924:	69e2                	ld	s3,24(sp)
    80000926:	6a42                	ld	s4,16(sp)
    80000928:	6aa2                	ld	s5,8(sp)
    8000092a:	6121                	addi	sp,sp,64
    8000092c:	8082                	ret
    8000092e:	8082                	ret

0000000080000930 <uartputc>:
{
    80000930:	7179                	addi	sp,sp,-48
    80000932:	f406                	sd	ra,40(sp)
    80000934:	f022                	sd	s0,32(sp)
    80000936:	ec26                	sd	s1,24(sp)
    80000938:	e84a                	sd	s2,16(sp)
    8000093a:	e44e                	sd	s3,8(sp)
    8000093c:	e052                	sd	s4,0(sp)
    8000093e:	1800                	addi	s0,sp,48
    80000940:	84aa                	mv	s1,a0
  acquire(&uart_tx_lock);
    80000942:	00011517          	auipc	a0,0x11
    80000946:	fb650513          	addi	a0,a0,-74 # 800118f8 <uart_tx_lock>
    8000094a:	00000097          	auipc	ra,0x0
    8000094e:	318080e7          	jalr	792(ra) # 80000c62 <acquire>
  if(panicked){
    80000952:	00008797          	auipc	a5,0x8
    80000956:	6ae7a783          	lw	a5,1710(a5) # 80009000 <panicked>
    8000095a:	c391                	beqz	a5,8000095e <uartputc+0x2e>
    for(;;)
    8000095c:	a001                	j	8000095c <uartputc+0x2c>
    if(((uart_tx_w + 1) % UART_TX_BUF_SIZE) == uart_tx_r){
    8000095e:	00008697          	auipc	a3,0x8
    80000962:	6aa6a683          	lw	a3,1706(a3) # 80009008 <uart_tx_w>
    80000966:	0016879b          	addiw	a5,a3,1
    8000096a:	41f7d71b          	sraiw	a4,a5,0x1f
    8000096e:	01b7571b          	srliw	a4,a4,0x1b
    80000972:	9fb9                	addw	a5,a5,a4
    80000974:	8bfd                	andi	a5,a5,31
    80000976:	9f99                	subw	a5,a5,a4
    80000978:	00008717          	auipc	a4,0x8
    8000097c:	68c72703          	lw	a4,1676(a4) # 80009004 <uart_tx_r>
    80000980:	04f71363          	bne	a4,a5,800009c6 <uartputc+0x96>
      sleep(&uart_tx_r, &uart_tx_lock);
    80000984:	00011a17          	auipc	s4,0x11
    80000988:	f74a0a13          	addi	s4,s4,-140 # 800118f8 <uart_tx_lock>
    8000098c:	00008917          	auipc	s2,0x8
    80000990:	67890913          	addi	s2,s2,1656 # 80009004 <uart_tx_r>
    if(((uart_tx_w + 1) % UART_TX_BUF_SIZE) == uart_tx_r){
    80000994:	00008997          	auipc	s3,0x8
    80000998:	67498993          	addi	s3,s3,1652 # 80009008 <uart_tx_w>
      sleep(&uart_tx_r, &uart_tx_lock);
    8000099c:	85d2                	mv	a1,s4
    8000099e:	854a                	mv	a0,s2
    800009a0:	00002097          	auipc	ra,0x2
    800009a4:	c6a080e7          	jalr	-918(ra) # 8000260a <sleep>
    if(((uart_tx_w + 1) % UART_TX_BUF_SIZE) == uart_tx_r){
    800009a8:	0009a683          	lw	a3,0(s3)
    800009ac:	0016879b          	addiw	a5,a3,1
    800009b0:	41f7d71b          	sraiw	a4,a5,0x1f
    800009b4:	01b7571b          	srliw	a4,a4,0x1b
    800009b8:	9fb9                	addw	a5,a5,a4
    800009ba:	8bfd                	andi	a5,a5,31
    800009bc:	9f99                	subw	a5,a5,a4
    800009be:	00092703          	lw	a4,0(s2)
    800009c2:	fcf70de3          	beq	a4,a5,8000099c <uartputc+0x6c>
      uart_tx_buf[uart_tx_w] = c;
    800009c6:	00011917          	auipc	s2,0x11
    800009ca:	f3290913          	addi	s2,s2,-206 # 800118f8 <uart_tx_lock>
    800009ce:	96ca                	add	a3,a3,s2
    800009d0:	00968c23          	sb	s1,24(a3)
      uart_tx_w = (uart_tx_w + 1) % UART_TX_BUF_SIZE;
    800009d4:	00008717          	auipc	a4,0x8
    800009d8:	62f72a23          	sw	a5,1588(a4) # 80009008 <uart_tx_w>
      uartstart();
    800009dc:	00000097          	auipc	ra,0x0
    800009e0:	ec2080e7          	jalr	-318(ra) # 8000089e <uartstart>
      release(&uart_tx_lock);
    800009e4:	854a                	mv	a0,s2
    800009e6:	00000097          	auipc	ra,0x0
    800009ea:	330080e7          	jalr	816(ra) # 80000d16 <release>
}
    800009ee:	70a2                	ld	ra,40(sp)
    800009f0:	7402                	ld	s0,32(sp)
    800009f2:	64e2                	ld	s1,24(sp)
    800009f4:	6942                	ld	s2,16(sp)
    800009f6:	69a2                	ld	s3,8(sp)
    800009f8:	6a02                	ld	s4,0(sp)
    800009fa:	6145                	addi	sp,sp,48
    800009fc:	8082                	ret

00000000800009fe <uartgetc>:

// read one input character from the UART.
// return -1 if none is waiting.
int
uartgetc(void)
{
    800009fe:	1141                	addi	sp,sp,-16
    80000a00:	e422                	sd	s0,8(sp)
    80000a02:	0800                	addi	s0,sp,16
  if(ReadReg(LSR) & 0x01){
    80000a04:	100007b7          	lui	a5,0x10000
    80000a08:	0057c783          	lbu	a5,5(a5) # 10000005 <_entry-0x6ffffffb>
    80000a0c:	8b85                	andi	a5,a5,1
    80000a0e:	cb91                	beqz	a5,80000a22 <uartgetc+0x24>
    // input data is ready.
    return ReadReg(RHR);
    80000a10:	100007b7          	lui	a5,0x10000
    80000a14:	0007c503          	lbu	a0,0(a5) # 10000000 <_entry-0x70000000>
    80000a18:	0ff57513          	zext.b	a0,a0
  } else {
    return -1;
  }
}
    80000a1c:	6422                	ld	s0,8(sp)
    80000a1e:	0141                	addi	sp,sp,16
    80000a20:	8082                	ret
    return -1;
    80000a22:	557d                	li	a0,-1
    80000a24:	bfe5                	j	80000a1c <uartgetc+0x1e>

0000000080000a26 <uartintr>:
// handle a uart interrupt, raised because input has
// arrived, or the uart is ready for more output, or
// both. called from trap.c.
void
uartintr(void)
{
    80000a26:	1101                	addi	sp,sp,-32
    80000a28:	ec06                	sd	ra,24(sp)
    80000a2a:	e822                	sd	s0,16(sp)
    80000a2c:	e426                	sd	s1,8(sp)
    80000a2e:	1000                	addi	s0,sp,32
  // read and process incoming characters.
  while(1){
    int c = uartgetc();
    if(c == -1)
    80000a30:	54fd                	li	s1,-1
    80000a32:	a029                	j	80000a3c <uartintr+0x16>
      break;
    consoleintr(c);
    80000a34:	00000097          	auipc	ra,0x0
    80000a38:	88e080e7          	jalr	-1906(ra) # 800002c2 <consoleintr>
    int c = uartgetc();
    80000a3c:	00000097          	auipc	ra,0x0
    80000a40:	fc2080e7          	jalr	-62(ra) # 800009fe <uartgetc>
    if(c == -1)
    80000a44:	fe9518e3          	bne	a0,s1,80000a34 <uartintr+0xe>
  }

  // send buffered characters.
  acquire(&uart_tx_lock);
    80000a48:	00011497          	auipc	s1,0x11
    80000a4c:	eb048493          	addi	s1,s1,-336 # 800118f8 <uart_tx_lock>
    80000a50:	8526                	mv	a0,s1
    80000a52:	00000097          	auipc	ra,0x0
    80000a56:	210080e7          	jalr	528(ra) # 80000c62 <acquire>
  uartstart();
    80000a5a:	00000097          	auipc	ra,0x0
    80000a5e:	e44080e7          	jalr	-444(ra) # 8000089e <uartstart>
  release(&uart_tx_lock);
    80000a62:	8526                	mv	a0,s1
    80000a64:	00000097          	auipc	ra,0x0
    80000a68:	2b2080e7          	jalr	690(ra) # 80000d16 <release>
}
    80000a6c:	60e2                	ld	ra,24(sp)
    80000a6e:	6442                	ld	s0,16(sp)
    80000a70:	64a2                	ld	s1,8(sp)
    80000a72:	6105                	addi	sp,sp,32
    80000a74:	8082                	ret

0000000080000a76 <kfree>:
// which normally should have been returned by a
// call to kalloc().  (The exception is when
// initializing the allocator; see kinit above.)
void
kfree(void *pa)
{
    80000a76:	1101                	addi	sp,sp,-32
    80000a78:	ec06                	sd	ra,24(sp)
    80000a7a:	e822                	sd	s0,16(sp)
    80000a7c:	e426                	sd	s1,8(sp)
    80000a7e:	e04a                	sd	s2,0(sp)
    80000a80:	1000                	addi	s0,sp,32
  struct run *r;

  if(((uint64)pa % PGSIZE) != 0 || (char*)pa < end || (uint64)pa >= PHYSTOP)
    80000a82:	03451793          	slli	a5,a0,0x34
    80000a86:	ebb9                	bnez	a5,80000adc <kfree+0x66>
    80000a88:	84aa                	mv	s1,a0
    80000a8a:	0002b797          	auipc	a5,0x2b
    80000a8e:	57678793          	addi	a5,a5,1398 # 8002c000 <end>
    80000a92:	04f56563          	bltu	a0,a5,80000adc <kfree+0x66>
    80000a96:	47c5                	li	a5,17
    80000a98:	07ee                	slli	a5,a5,0x1b
    80000a9a:	04f57163          	bgeu	a0,a5,80000adc <kfree+0x66>
    panic("kfree");

  // Fill with junk to catch dangling refs.
  memset(pa, 1, PGSIZE);
    80000a9e:	6605                	lui	a2,0x1
    80000aa0:	4585                	li	a1,1
    80000aa2:	00000097          	auipc	ra,0x0
    80000aa6:	2bc080e7          	jalr	700(ra) # 80000d5e <memset>

  r = (struct run*)pa;

  acquire(&kmem.lock);
    80000aaa:	00011917          	auipc	s2,0x11
    80000aae:	e8690913          	addi	s2,s2,-378 # 80011930 <kmem>
    80000ab2:	854a                	mv	a0,s2
    80000ab4:	00000097          	auipc	ra,0x0
    80000ab8:	1ae080e7          	jalr	430(ra) # 80000c62 <acquire>
  r->next = kmem.freelist;
    80000abc:	01893783          	ld	a5,24(s2)
    80000ac0:	e09c                	sd	a5,0(s1)
  kmem.freelist = r;
    80000ac2:	00993c23          	sd	s1,24(s2)
  release(&kmem.lock);
    80000ac6:	854a                	mv	a0,s2
    80000ac8:	00000097          	auipc	ra,0x0
    80000acc:	24e080e7          	jalr	590(ra) # 80000d16 <release>
}
    80000ad0:	60e2                	ld	ra,24(sp)
    80000ad2:	6442                	ld	s0,16(sp)
    80000ad4:	64a2                	ld	s1,8(sp)
    80000ad6:	6902                	ld	s2,0(sp)
    80000ad8:	6105                	addi	sp,sp,32
    80000ada:	8082                	ret
    panic("kfree");
    80000adc:	00007517          	auipc	a0,0x7
    80000ae0:	59c50513          	addi	a0,a0,1436 # 80008078 <digits+0x20>
    80000ae4:	00000097          	auipc	ra,0x0
    80000ae8:	aec080e7          	jalr	-1300(ra) # 800005d0 <panic>

0000000080000aec <freerange>:
{
    80000aec:	7179                	addi	sp,sp,-48
    80000aee:	f406                	sd	ra,40(sp)
    80000af0:	f022                	sd	s0,32(sp)
    80000af2:	ec26                	sd	s1,24(sp)
    80000af4:	e84a                	sd	s2,16(sp)
    80000af6:	e44e                	sd	s3,8(sp)
    80000af8:	e052                	sd	s4,0(sp)
    80000afa:	1800                	addi	s0,sp,48
  p = (char*)PGROUNDUP((uint64)pa_start);
    80000afc:	6785                	lui	a5,0x1
    80000afe:	fff78493          	addi	s1,a5,-1 # fff <_entry-0x7ffff001>
    80000b02:	94aa                	add	s1,s1,a0
    80000b04:	757d                	lui	a0,0xfffff
    80000b06:	8ce9                	and	s1,s1,a0
  for(; p + PGSIZE <= (char*)pa_end; p += PGSIZE)
    80000b08:	94be                	add	s1,s1,a5
    80000b0a:	0095ee63          	bltu	a1,s1,80000b26 <freerange+0x3a>
    80000b0e:	892e                	mv	s2,a1
    kfree(p);
    80000b10:	7a7d                	lui	s4,0xfffff
  for(; p + PGSIZE <= (char*)pa_end; p += PGSIZE)
    80000b12:	6985                	lui	s3,0x1
    kfree(p);
    80000b14:	01448533          	add	a0,s1,s4
    80000b18:	00000097          	auipc	ra,0x0
    80000b1c:	f5e080e7          	jalr	-162(ra) # 80000a76 <kfree>
  for(; p + PGSIZE <= (char*)pa_end; p += PGSIZE)
    80000b20:	94ce                	add	s1,s1,s3
    80000b22:	fe9979e3          	bgeu	s2,s1,80000b14 <freerange+0x28>
}
    80000b26:	70a2                	ld	ra,40(sp)
    80000b28:	7402                	ld	s0,32(sp)
    80000b2a:	64e2                	ld	s1,24(sp)
    80000b2c:	6942                	ld	s2,16(sp)
    80000b2e:	69a2                	ld	s3,8(sp)
    80000b30:	6a02                	ld	s4,0(sp)
    80000b32:	6145                	addi	sp,sp,48
    80000b34:	8082                	ret

0000000080000b36 <kinit>:
{
    80000b36:	1141                	addi	sp,sp,-16
    80000b38:	e406                	sd	ra,8(sp)
    80000b3a:	e022                	sd	s0,0(sp)
    80000b3c:	0800                	addi	s0,sp,16
  initlock(&kmem.lock, "kmem");
    80000b3e:	00007597          	auipc	a1,0x7
    80000b42:	54258593          	addi	a1,a1,1346 # 80008080 <digits+0x28>
    80000b46:	00011517          	auipc	a0,0x11
    80000b4a:	dea50513          	addi	a0,a0,-534 # 80011930 <kmem>
    80000b4e:	00000097          	auipc	ra,0x0
    80000b52:	084080e7          	jalr	132(ra) # 80000bd2 <initlock>
  freerange(end, (void*)PHYSTOP);
    80000b56:	45c5                	li	a1,17
    80000b58:	05ee                	slli	a1,a1,0x1b
    80000b5a:	0002b517          	auipc	a0,0x2b
    80000b5e:	4a650513          	addi	a0,a0,1190 # 8002c000 <end>
    80000b62:	00000097          	auipc	ra,0x0
    80000b66:	f8a080e7          	jalr	-118(ra) # 80000aec <freerange>
}
    80000b6a:	60a2                	ld	ra,8(sp)
    80000b6c:	6402                	ld	s0,0(sp)
    80000b6e:	0141                	addi	sp,sp,16
    80000b70:	8082                	ret

0000000080000b72 <kalloc>:
// Allocate one 4096-byte page of physical memory.
// Returns a pointer that the kernel can use.
// Returns 0 if the memory cannot be allocated.
void *
kalloc(void)
{
    80000b72:	1101                	addi	sp,sp,-32
    80000b74:	ec06                	sd	ra,24(sp)
    80000b76:	e822                	sd	s0,16(sp)
    80000b78:	e426                	sd	s1,8(sp)
    80000b7a:	1000                	addi	s0,sp,32
  struct run *r;

  acquire(&kmem.lock);
    80000b7c:	00011497          	auipc	s1,0x11
    80000b80:	db448493          	addi	s1,s1,-588 # 80011930 <kmem>
    80000b84:	8526                	mv	a0,s1
    80000b86:	00000097          	auipc	ra,0x0
    80000b8a:	0dc080e7          	jalr	220(ra) # 80000c62 <acquire>
  r = kmem.freelist;
    80000b8e:	6c84                	ld	s1,24(s1)
  if(r)
    80000b90:	c885                	beqz	s1,80000bc0 <kalloc+0x4e>
    kmem.freelist = r->next;
    80000b92:	609c                	ld	a5,0(s1)
    80000b94:	00011517          	auipc	a0,0x11
    80000b98:	d9c50513          	addi	a0,a0,-612 # 80011930 <kmem>
    80000b9c:	ed1c                	sd	a5,24(a0)
  release(&kmem.lock);
    80000b9e:	00000097          	auipc	ra,0x0
    80000ba2:	178080e7          	jalr	376(ra) # 80000d16 <release>

  if(r)
    memset((char*)r, 5, PGSIZE); // fill with junk
    80000ba6:	6605                	lui	a2,0x1
    80000ba8:	4595                	li	a1,5
    80000baa:	8526                	mv	a0,s1
    80000bac:	00000097          	auipc	ra,0x0
    80000bb0:	1b2080e7          	jalr	434(ra) # 80000d5e <memset>
  return (void*)r;
}
    80000bb4:	8526                	mv	a0,s1
    80000bb6:	60e2                	ld	ra,24(sp)
    80000bb8:	6442                	ld	s0,16(sp)
    80000bba:	64a2                	ld	s1,8(sp)
    80000bbc:	6105                	addi	sp,sp,32
    80000bbe:	8082                	ret
  release(&kmem.lock);
    80000bc0:	00011517          	auipc	a0,0x11
    80000bc4:	d7050513          	addi	a0,a0,-656 # 80011930 <kmem>
    80000bc8:	00000097          	auipc	ra,0x0
    80000bcc:	14e080e7          	jalr	334(ra) # 80000d16 <release>
  if(r)
    80000bd0:	b7d5                	j	80000bb4 <kalloc+0x42>

0000000080000bd2 <initlock>:
#include "proc.h"
#include "defs.h"

void
initlock(struct spinlock *lk, char *name)
{
    80000bd2:	1141                	addi	sp,sp,-16
    80000bd4:	e422                	sd	s0,8(sp)
    80000bd6:	0800                	addi	s0,sp,16
  lk->name = name;
    80000bd8:	e50c                	sd	a1,8(a0)
  lk->locked = 0;
    80000bda:	00052023          	sw	zero,0(a0)
  lk->cpu = 0;
    80000bde:	00053823          	sd	zero,16(a0)
}
    80000be2:	6422                	ld	s0,8(sp)
    80000be4:	0141                	addi	sp,sp,16
    80000be6:	8082                	ret

0000000080000be8 <holding>:
// Interrupts must be off.
int
holding(struct spinlock *lk)
{
  int r;
  r = (lk->locked && lk->cpu == mycpu());
    80000be8:	411c                	lw	a5,0(a0)
    80000bea:	e399                	bnez	a5,80000bf0 <holding+0x8>
    80000bec:	4501                	li	a0,0
  return r;
}
    80000bee:	8082                	ret
{
    80000bf0:	1101                	addi	sp,sp,-32
    80000bf2:	ec06                	sd	ra,24(sp)
    80000bf4:	e822                	sd	s0,16(sp)
    80000bf6:	e426                	sd	s1,8(sp)
    80000bf8:	1000                	addi	s0,sp,32
  r = (lk->locked && lk->cpu == mycpu());
    80000bfa:	6904                	ld	s1,16(a0)
    80000bfc:	00001097          	auipc	ra,0x1
    80000c00:	132080e7          	jalr	306(ra) # 80001d2e <mycpu>
    80000c04:	40a48533          	sub	a0,s1,a0
    80000c08:	00153513          	seqz	a0,a0
}
    80000c0c:	60e2                	ld	ra,24(sp)
    80000c0e:	6442                	ld	s0,16(sp)
    80000c10:	64a2                	ld	s1,8(sp)
    80000c12:	6105                	addi	sp,sp,32
    80000c14:	8082                	ret

0000000080000c16 <push_off>:
// it takes two pop_off()s to undo two push_off()s.  Also, if interrupts
// are initially off, then push_off, pop_off leaves them off.

void
push_off(void)
{
    80000c16:	1101                	addi	sp,sp,-32
    80000c18:	ec06                	sd	ra,24(sp)
    80000c1a:	e822                	sd	s0,16(sp)
    80000c1c:	e426                	sd	s1,8(sp)
    80000c1e:	1000                	addi	s0,sp,32
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80000c20:	100024f3          	csrr	s1,sstatus
    80000c24:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() & ~SSTATUS_SIE);
    80000c28:	9bf5                	andi	a5,a5,-3
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80000c2a:	10079073          	csrw	sstatus,a5
  int old = intr_get();

  intr_off();
  if(mycpu()->noff == 0)
    80000c2e:	00001097          	auipc	ra,0x1
    80000c32:	100080e7          	jalr	256(ra) # 80001d2e <mycpu>
    80000c36:	5d3c                	lw	a5,120(a0)
    80000c38:	cf89                	beqz	a5,80000c52 <push_off+0x3c>
    mycpu()->intena = old;
  mycpu()->noff += 1;
    80000c3a:	00001097          	auipc	ra,0x1
    80000c3e:	0f4080e7          	jalr	244(ra) # 80001d2e <mycpu>
    80000c42:	5d3c                	lw	a5,120(a0)
    80000c44:	2785                	addiw	a5,a5,1
    80000c46:	dd3c                	sw	a5,120(a0)
}
    80000c48:	60e2                	ld	ra,24(sp)
    80000c4a:	6442                	ld	s0,16(sp)
    80000c4c:	64a2                	ld	s1,8(sp)
    80000c4e:	6105                	addi	sp,sp,32
    80000c50:	8082                	ret
    mycpu()->intena = old;
    80000c52:	00001097          	auipc	ra,0x1
    80000c56:	0dc080e7          	jalr	220(ra) # 80001d2e <mycpu>
  return (x & SSTATUS_SIE) != 0;
    80000c5a:	8085                	srli	s1,s1,0x1
    80000c5c:	8885                	andi	s1,s1,1
    80000c5e:	dd64                	sw	s1,124(a0)
    80000c60:	bfe9                	j	80000c3a <push_off+0x24>

0000000080000c62 <acquire>:
{
    80000c62:	1101                	addi	sp,sp,-32
    80000c64:	ec06                	sd	ra,24(sp)
    80000c66:	e822                	sd	s0,16(sp)
    80000c68:	e426                	sd	s1,8(sp)
    80000c6a:	1000                	addi	s0,sp,32
    80000c6c:	84aa                	mv	s1,a0
  push_off(); // disable interrupts to avoid deadlock.
    80000c6e:	00000097          	auipc	ra,0x0
    80000c72:	fa8080e7          	jalr	-88(ra) # 80000c16 <push_off>
  if(holding(lk))
    80000c76:	8526                	mv	a0,s1
    80000c78:	00000097          	auipc	ra,0x0
    80000c7c:	f70080e7          	jalr	-144(ra) # 80000be8 <holding>
  while(__sync_lock_test_and_set(&lk->locked, 1) != 0)
    80000c80:	4705                	li	a4,1
  if(holding(lk))
    80000c82:	e115                	bnez	a0,80000ca6 <acquire+0x44>
  while(__sync_lock_test_and_set(&lk->locked, 1) != 0)
    80000c84:	87ba                	mv	a5,a4
    80000c86:	0cf4a7af          	amoswap.w.aq	a5,a5,(s1)
    80000c8a:	2781                	sext.w	a5,a5
    80000c8c:	ffe5                	bnez	a5,80000c84 <acquire+0x22>
  __sync_synchronize();
    80000c8e:	0ff0000f          	fence
  lk->cpu = mycpu();
    80000c92:	00001097          	auipc	ra,0x1
    80000c96:	09c080e7          	jalr	156(ra) # 80001d2e <mycpu>
    80000c9a:	e888                	sd	a0,16(s1)
}
    80000c9c:	60e2                	ld	ra,24(sp)
    80000c9e:	6442                	ld	s0,16(sp)
    80000ca0:	64a2                	ld	s1,8(sp)
    80000ca2:	6105                	addi	sp,sp,32
    80000ca4:	8082                	ret
    panic("acquire");
    80000ca6:	00007517          	auipc	a0,0x7
    80000caa:	3e250513          	addi	a0,a0,994 # 80008088 <digits+0x30>
    80000cae:	00000097          	auipc	ra,0x0
    80000cb2:	922080e7          	jalr	-1758(ra) # 800005d0 <panic>

0000000080000cb6 <pop_off>:

void
pop_off(void)
{
    80000cb6:	1141                	addi	sp,sp,-16
    80000cb8:	e406                	sd	ra,8(sp)
    80000cba:	e022                	sd	s0,0(sp)
    80000cbc:	0800                	addi	s0,sp,16
  struct cpu *c = mycpu();
    80000cbe:	00001097          	auipc	ra,0x1
    80000cc2:	070080e7          	jalr	112(ra) # 80001d2e <mycpu>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80000cc6:	100027f3          	csrr	a5,sstatus
  return (x & SSTATUS_SIE) != 0;
    80000cca:	8b89                	andi	a5,a5,2
  if(intr_get())
    80000ccc:	e78d                	bnez	a5,80000cf6 <pop_off+0x40>
    panic("pop_off - interruptible");
  if(c->noff < 1)
    80000cce:	5d3c                	lw	a5,120(a0)
    80000cd0:	02f05b63          	blez	a5,80000d06 <pop_off+0x50>
    panic("pop_off");
  c->noff -= 1;
    80000cd4:	37fd                	addiw	a5,a5,-1
    80000cd6:	0007871b          	sext.w	a4,a5
    80000cda:	dd3c                	sw	a5,120(a0)
  if(c->noff == 0 && c->intena)
    80000cdc:	eb09                	bnez	a4,80000cee <pop_off+0x38>
    80000cde:	5d7c                	lw	a5,124(a0)
    80000ce0:	c799                	beqz	a5,80000cee <pop_off+0x38>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80000ce2:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80000ce6:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80000cea:	10079073          	csrw	sstatus,a5
    intr_on();
}
    80000cee:	60a2                	ld	ra,8(sp)
    80000cf0:	6402                	ld	s0,0(sp)
    80000cf2:	0141                	addi	sp,sp,16
    80000cf4:	8082                	ret
    panic("pop_off - interruptible");
    80000cf6:	00007517          	auipc	a0,0x7
    80000cfa:	39a50513          	addi	a0,a0,922 # 80008090 <digits+0x38>
    80000cfe:	00000097          	auipc	ra,0x0
    80000d02:	8d2080e7          	jalr	-1838(ra) # 800005d0 <panic>
    panic("pop_off");
    80000d06:	00007517          	auipc	a0,0x7
    80000d0a:	3a250513          	addi	a0,a0,930 # 800080a8 <digits+0x50>
    80000d0e:	00000097          	auipc	ra,0x0
    80000d12:	8c2080e7          	jalr	-1854(ra) # 800005d0 <panic>

0000000080000d16 <release>:
{
    80000d16:	1101                	addi	sp,sp,-32
    80000d18:	ec06                	sd	ra,24(sp)
    80000d1a:	e822                	sd	s0,16(sp)
    80000d1c:	e426                	sd	s1,8(sp)
    80000d1e:	1000                	addi	s0,sp,32
    80000d20:	84aa                	mv	s1,a0
  if(!holding(lk))
    80000d22:	00000097          	auipc	ra,0x0
    80000d26:	ec6080e7          	jalr	-314(ra) # 80000be8 <holding>
    80000d2a:	c115                	beqz	a0,80000d4e <release+0x38>
  lk->cpu = 0;
    80000d2c:	0004b823          	sd	zero,16(s1)
  __sync_synchronize();
    80000d30:	0ff0000f          	fence
  __sync_lock_release(&lk->locked);
    80000d34:	0f50000f          	fence	iorw,ow
    80000d38:	0804a02f          	amoswap.w	zero,zero,(s1)
  pop_off();
    80000d3c:	00000097          	auipc	ra,0x0
    80000d40:	f7a080e7          	jalr	-134(ra) # 80000cb6 <pop_off>
}
    80000d44:	60e2                	ld	ra,24(sp)
    80000d46:	6442                	ld	s0,16(sp)
    80000d48:	64a2                	ld	s1,8(sp)
    80000d4a:	6105                	addi	sp,sp,32
    80000d4c:	8082                	ret
    panic("release");
    80000d4e:	00007517          	auipc	a0,0x7
    80000d52:	36250513          	addi	a0,a0,866 # 800080b0 <digits+0x58>
    80000d56:	00000097          	auipc	ra,0x0
    80000d5a:	87a080e7          	jalr	-1926(ra) # 800005d0 <panic>

0000000080000d5e <memset>:
    80000d5e:	1141                	addi	sp,sp,-16
    80000d60:	e422                	sd	s0,8(sp)
    80000d62:	0800                	addi	s0,sp,16
    80000d64:	ca19                	beqz	a2,80000d7a <memset+0x1c>
    80000d66:	87aa                	mv	a5,a0
    80000d68:	1602                	slli	a2,a2,0x20
    80000d6a:	9201                	srli	a2,a2,0x20
    80000d6c:	00a60733          	add	a4,a2,a0
    80000d70:	00b78023          	sb	a1,0(a5)
    80000d74:	0785                	addi	a5,a5,1
    80000d76:	fee79de3          	bne	a5,a4,80000d70 <memset+0x12>
    80000d7a:	6422                	ld	s0,8(sp)
    80000d7c:	0141                	addi	sp,sp,16
    80000d7e:	8082                	ret

0000000080000d80 <memcmp>:
    80000d80:	1141                	addi	sp,sp,-16
    80000d82:	e422                	sd	s0,8(sp)
    80000d84:	0800                	addi	s0,sp,16
    80000d86:	ca05                	beqz	a2,80000db6 <memcmp+0x36>
    80000d88:	fff6069b          	addiw	a3,a2,-1 # fff <_entry-0x7ffff001>
    80000d8c:	1682                	slli	a3,a3,0x20
    80000d8e:	9281                	srli	a3,a3,0x20
    80000d90:	0685                	addi	a3,a3,1
    80000d92:	96aa                	add	a3,a3,a0
    80000d94:	00054783          	lbu	a5,0(a0)
    80000d98:	0005c703          	lbu	a4,0(a1)
    80000d9c:	00e79863          	bne	a5,a4,80000dac <memcmp+0x2c>
    80000da0:	0505                	addi	a0,a0,1
    80000da2:	0585                	addi	a1,a1,1
    80000da4:	fed518e3          	bne	a0,a3,80000d94 <memcmp+0x14>
    80000da8:	4501                	li	a0,0
    80000daa:	a019                	j	80000db0 <memcmp+0x30>
    80000dac:	40e7853b          	subw	a0,a5,a4
    80000db0:	6422                	ld	s0,8(sp)
    80000db2:	0141                	addi	sp,sp,16
    80000db4:	8082                	ret
    80000db6:	4501                	li	a0,0
    80000db8:	bfe5                	j	80000db0 <memcmp+0x30>

0000000080000dba <memmove>:
    80000dba:	1141                	addi	sp,sp,-16
    80000dbc:	e422                	sd	s0,8(sp)
    80000dbe:	0800                	addi	s0,sp,16
    80000dc0:	02a5e563          	bltu	a1,a0,80000dea <memmove+0x30>
    80000dc4:	fff6069b          	addiw	a3,a2,-1
    80000dc8:	ce11                	beqz	a2,80000de4 <memmove+0x2a>
    80000dca:	1682                	slli	a3,a3,0x20
    80000dcc:	9281                	srli	a3,a3,0x20
    80000dce:	0685                	addi	a3,a3,1
    80000dd0:	96ae                	add	a3,a3,a1
    80000dd2:	87aa                	mv	a5,a0
    80000dd4:	0585                	addi	a1,a1,1
    80000dd6:	0785                	addi	a5,a5,1
    80000dd8:	fff5c703          	lbu	a4,-1(a1)
    80000ddc:	fee78fa3          	sb	a4,-1(a5)
    80000de0:	fed59ae3          	bne	a1,a3,80000dd4 <memmove+0x1a>
    80000de4:	6422                	ld	s0,8(sp)
    80000de6:	0141                	addi	sp,sp,16
    80000de8:	8082                	ret
    80000dea:	02061713          	slli	a4,a2,0x20
    80000dee:	9301                	srli	a4,a4,0x20
    80000df0:	00e587b3          	add	a5,a1,a4
    80000df4:	fcf578e3          	bgeu	a0,a5,80000dc4 <memmove+0xa>
    80000df8:	972a                	add	a4,a4,a0
    80000dfa:	fff6069b          	addiw	a3,a2,-1
    80000dfe:	d27d                	beqz	a2,80000de4 <memmove+0x2a>
    80000e00:	02069613          	slli	a2,a3,0x20
    80000e04:	9201                	srli	a2,a2,0x20
    80000e06:	fff64613          	not	a2,a2
    80000e0a:	963e                	add	a2,a2,a5
    80000e0c:	17fd                	addi	a5,a5,-1
    80000e0e:	177d                	addi	a4,a4,-1
    80000e10:	0007c683          	lbu	a3,0(a5)
    80000e14:	00d70023          	sb	a3,0(a4)
    80000e18:	fef61ae3          	bne	a2,a5,80000e0c <memmove+0x52>
    80000e1c:	b7e1                	j	80000de4 <memmove+0x2a>

0000000080000e1e <memcpy>:
    80000e1e:	1141                	addi	sp,sp,-16
    80000e20:	e406                	sd	ra,8(sp)
    80000e22:	e022                	sd	s0,0(sp)
    80000e24:	0800                	addi	s0,sp,16
    80000e26:	00000097          	auipc	ra,0x0
    80000e2a:	f94080e7          	jalr	-108(ra) # 80000dba <memmove>
    80000e2e:	60a2                	ld	ra,8(sp)
    80000e30:	6402                	ld	s0,0(sp)
    80000e32:	0141                	addi	sp,sp,16
    80000e34:	8082                	ret

0000000080000e36 <strncmp>:
    80000e36:	1141                	addi	sp,sp,-16
    80000e38:	e422                	sd	s0,8(sp)
    80000e3a:	0800                	addi	s0,sp,16
    80000e3c:	ce11                	beqz	a2,80000e58 <strncmp+0x22>
    80000e3e:	00054783          	lbu	a5,0(a0)
    80000e42:	cf89                	beqz	a5,80000e5c <strncmp+0x26>
    80000e44:	0005c703          	lbu	a4,0(a1)
    80000e48:	00f71a63          	bne	a4,a5,80000e5c <strncmp+0x26>
    80000e4c:	367d                	addiw	a2,a2,-1
    80000e4e:	0505                	addi	a0,a0,1
    80000e50:	0585                	addi	a1,a1,1
    80000e52:	f675                	bnez	a2,80000e3e <strncmp+0x8>
    80000e54:	4501                	li	a0,0
    80000e56:	a809                	j	80000e68 <strncmp+0x32>
    80000e58:	4501                	li	a0,0
    80000e5a:	a039                	j	80000e68 <strncmp+0x32>
    80000e5c:	ca09                	beqz	a2,80000e6e <strncmp+0x38>
    80000e5e:	00054503          	lbu	a0,0(a0)
    80000e62:	0005c783          	lbu	a5,0(a1)
    80000e66:	9d1d                	subw	a0,a0,a5
    80000e68:	6422                	ld	s0,8(sp)
    80000e6a:	0141                	addi	sp,sp,16
    80000e6c:	8082                	ret
    80000e6e:	4501                	li	a0,0
    80000e70:	bfe5                	j	80000e68 <strncmp+0x32>

0000000080000e72 <strncpy>:
    80000e72:	1141                	addi	sp,sp,-16
    80000e74:	e422                	sd	s0,8(sp)
    80000e76:	0800                	addi	s0,sp,16
    80000e78:	872a                	mv	a4,a0
    80000e7a:	8832                	mv	a6,a2
    80000e7c:	367d                	addiw	a2,a2,-1
    80000e7e:	01005963          	blez	a6,80000e90 <strncpy+0x1e>
    80000e82:	0705                	addi	a4,a4,1
    80000e84:	0005c783          	lbu	a5,0(a1)
    80000e88:	fef70fa3          	sb	a5,-1(a4)
    80000e8c:	0585                	addi	a1,a1,1
    80000e8e:	f7f5                	bnez	a5,80000e7a <strncpy+0x8>
    80000e90:	86ba                	mv	a3,a4
    80000e92:	00c05c63          	blez	a2,80000eaa <strncpy+0x38>
    80000e96:	0685                	addi	a3,a3,1
    80000e98:	fe068fa3          	sb	zero,-1(a3)
    80000e9c:	fff6c793          	not	a5,a3
    80000ea0:	9fb9                	addw	a5,a5,a4
    80000ea2:	010787bb          	addw	a5,a5,a6
    80000ea6:	fef048e3          	bgtz	a5,80000e96 <strncpy+0x24>
    80000eaa:	6422                	ld	s0,8(sp)
    80000eac:	0141                	addi	sp,sp,16
    80000eae:	8082                	ret

0000000080000eb0 <safestrcpy>:
    80000eb0:	1141                	addi	sp,sp,-16
    80000eb2:	e422                	sd	s0,8(sp)
    80000eb4:	0800                	addi	s0,sp,16
    80000eb6:	02c05363          	blez	a2,80000edc <safestrcpy+0x2c>
    80000eba:	fff6069b          	addiw	a3,a2,-1
    80000ebe:	1682                	slli	a3,a3,0x20
    80000ec0:	9281                	srli	a3,a3,0x20
    80000ec2:	96ae                	add	a3,a3,a1
    80000ec4:	87aa                	mv	a5,a0
    80000ec6:	00d58963          	beq	a1,a3,80000ed8 <safestrcpy+0x28>
    80000eca:	0585                	addi	a1,a1,1
    80000ecc:	0785                	addi	a5,a5,1
    80000ece:	fff5c703          	lbu	a4,-1(a1)
    80000ed2:	fee78fa3          	sb	a4,-1(a5)
    80000ed6:	fb65                	bnez	a4,80000ec6 <safestrcpy+0x16>
    80000ed8:	00078023          	sb	zero,0(a5)
    80000edc:	6422                	ld	s0,8(sp)
    80000ede:	0141                	addi	sp,sp,16
    80000ee0:	8082                	ret

0000000080000ee2 <strlen>:
    80000ee2:	1141                	addi	sp,sp,-16
    80000ee4:	e422                	sd	s0,8(sp)
    80000ee6:	0800                	addi	s0,sp,16
    80000ee8:	00054783          	lbu	a5,0(a0)
    80000eec:	cf91                	beqz	a5,80000f08 <strlen+0x26>
    80000eee:	0505                	addi	a0,a0,1
    80000ef0:	87aa                	mv	a5,a0
    80000ef2:	4685                	li	a3,1
    80000ef4:	9e89                	subw	a3,a3,a0
    80000ef6:	00f6853b          	addw	a0,a3,a5
    80000efa:	0785                	addi	a5,a5,1
    80000efc:	fff7c703          	lbu	a4,-1(a5)
    80000f00:	fb7d                	bnez	a4,80000ef6 <strlen+0x14>
    80000f02:	6422                	ld	s0,8(sp)
    80000f04:	0141                	addi	sp,sp,16
    80000f06:	8082                	ret
    80000f08:	4501                	li	a0,0
    80000f0a:	bfe5                	j	80000f02 <strlen+0x20>

0000000080000f0c <main>:
volatile static int started = 0;

// start() jumps here in supervisor mode on all CPUs.
void
main()
{
    80000f0c:	1141                	addi	sp,sp,-16
    80000f0e:	e406                	sd	ra,8(sp)
    80000f10:	e022                	sd	s0,0(sp)
    80000f12:	0800                	addi	s0,sp,16
  if(cpuid() == 0){
    80000f14:	00001097          	auipc	ra,0x1
    80000f18:	e0a080e7          	jalr	-502(ra) # 80001d1e <cpuid>
    virtio_disk_init(); // emulated hard disk
    userinit();      // first user process
    __sync_synchronize();
    started = 1;
  } else {
    while(started == 0)
    80000f1c:	00008717          	auipc	a4,0x8
    80000f20:	0f070713          	addi	a4,a4,240 # 8000900c <started>
  if(cpuid() == 0){
    80000f24:	c139                	beqz	a0,80000f6a <main+0x5e>
    while(started == 0)
    80000f26:	431c                	lw	a5,0(a4)
    80000f28:	2781                	sext.w	a5,a5
    80000f2a:	dff5                	beqz	a5,80000f26 <main+0x1a>
      ;
    __sync_synchronize();
    80000f2c:	0ff0000f          	fence
    printf("hart %d starting\n", cpuid());
    80000f30:	00001097          	auipc	ra,0x1
    80000f34:	dee080e7          	jalr	-530(ra) # 80001d1e <cpuid>
    80000f38:	85aa                	mv	a1,a0
    80000f3a:	00007517          	auipc	a0,0x7
    80000f3e:	19650513          	addi	a0,a0,406 # 800080d0 <digits+0x78>
    80000f42:	fffff097          	auipc	ra,0xfffff
    80000f46:	6e0080e7          	jalr	1760(ra) # 80000622 <printf>
    kvminithart();    // turn on paging
    80000f4a:	00000097          	auipc	ra,0x0
    80000f4e:	0e0080e7          	jalr	224(ra) # 8000102a <kvminithart>
    trapinithart();   // install kernel trap vector
    80000f52:	00002097          	auipc	ra,0x2
    80000f56:	b00080e7          	jalr	-1280(ra) # 80002a52 <trapinithart>
    plicinithart();   // ask PLIC for device interrupts
    80000f5a:	00005097          	auipc	ra,0x5
    80000f5e:	2b6080e7          	jalr	694(ra) # 80006210 <plicinithart>
  }

  scheduler();        
    80000f62:	00001097          	auipc	ra,0x1
    80000f66:	394080e7          	jalr	916(ra) # 800022f6 <scheduler>
    consoleinit();
    80000f6a:	fffff097          	auipc	ra,0xfffff
    80000f6e:	4ea080e7          	jalr	1258(ra) # 80000454 <consoleinit>
    printfinit();
    80000f72:	fffff097          	auipc	ra,0xfffff
    80000f76:	5d0080e7          	jalr	1488(ra) # 80000542 <printfinit>
    printf("\n");
    80000f7a:	00007517          	auipc	a0,0x7
    80000f7e:	16650513          	addi	a0,a0,358 # 800080e0 <digits+0x88>
    80000f82:	fffff097          	auipc	ra,0xfffff
    80000f86:	6a0080e7          	jalr	1696(ra) # 80000622 <printf>
    printf("xv6 kernel is booting\n");
    80000f8a:	00007517          	auipc	a0,0x7
    80000f8e:	12e50513          	addi	a0,a0,302 # 800080b8 <digits+0x60>
    80000f92:	fffff097          	auipc	ra,0xfffff
    80000f96:	690080e7          	jalr	1680(ra) # 80000622 <printf>
    printf("\n");
    80000f9a:	00007517          	auipc	a0,0x7
    80000f9e:	14650513          	addi	a0,a0,326 # 800080e0 <digits+0x88>
    80000fa2:	fffff097          	auipc	ra,0xfffff
    80000fa6:	680080e7          	jalr	1664(ra) # 80000622 <printf>
    kinit();         // physical page allocator
    80000faa:	00000097          	auipc	ra,0x0
    80000fae:	b8c080e7          	jalr	-1140(ra) # 80000b36 <kinit>
    kvminit();       // create kernel page table
    80000fb2:	00000097          	auipc	ra,0x0
    80000fb6:	2a8080e7          	jalr	680(ra) # 8000125a <kvminit>
    kvminithart();   // turn on paging
    80000fba:	00000097          	auipc	ra,0x0
    80000fbe:	070080e7          	jalr	112(ra) # 8000102a <kvminithart>
    procinit();      // process table
    80000fc2:	00001097          	auipc	ra,0x1
    80000fc6:	c74080e7          	jalr	-908(ra) # 80001c36 <procinit>
    my_init();
    80000fca:	00001097          	auipc	ra,0x1
    80000fce:	970080e7          	jalr	-1680(ra) # 8000193a <my_init>
    trapinit();      // trap vectors
    80000fd2:	00002097          	auipc	ra,0x2
    80000fd6:	a58080e7          	jalr	-1448(ra) # 80002a2a <trapinit>
    trapinithart();  // install kernel trap vector
    80000fda:	00002097          	auipc	ra,0x2
    80000fde:	a78080e7          	jalr	-1416(ra) # 80002a52 <trapinithart>
    plicinit();      // set up interrupt controller
    80000fe2:	00005097          	auipc	ra,0x5
    80000fe6:	218080e7          	jalr	536(ra) # 800061fa <plicinit>
    plicinithart();  // ask PLIC for device interrupts
    80000fea:	00005097          	auipc	ra,0x5
    80000fee:	226080e7          	jalr	550(ra) # 80006210 <plicinithart>
    binit();         // buffer cache
    80000ff2:	00002097          	auipc	ra,0x2
    80000ff6:	3ce080e7          	jalr	974(ra) # 800033c0 <binit>
    iinit();         // inode cache
    80000ffa:	00003097          	auipc	ra,0x3
    80000ffe:	a60080e7          	jalr	-1440(ra) # 80003a5a <iinit>
    fileinit();      // file table
    80001002:	00004097          	auipc	ra,0x4
    80001006:	9fe080e7          	jalr	-1538(ra) # 80004a00 <fileinit>
    virtio_disk_init(); // emulated hard disk
    8000100a:	00005097          	auipc	ra,0x5
    8000100e:	30e080e7          	jalr	782(ra) # 80006318 <virtio_disk_init>
    userinit();      // first user process
    80001012:	00001097          	auipc	ra,0x1
    80001016:	07a080e7          	jalr	122(ra) # 8000208c <userinit>
    __sync_synchronize();
    8000101a:	0ff0000f          	fence
    started = 1;
    8000101e:	4785                	li	a5,1
    80001020:	00008717          	auipc	a4,0x8
    80001024:	fef72623          	sw	a5,-20(a4) # 8000900c <started>
    80001028:	bf2d                	j	80000f62 <main+0x56>

000000008000102a <kvminithart>:

// Switch h/w page table register to the kernel's page table,
// and enable paging.
void
kvminithart()
{
    8000102a:	1141                	addi	sp,sp,-16
    8000102c:	e422                	sd	s0,8(sp)
    8000102e:	0800                	addi	s0,sp,16
  w_satp(MAKE_SATP(kernel_pagetable));
    80001030:	00008797          	auipc	a5,0x8
    80001034:	fe07b783          	ld	a5,-32(a5) # 80009010 <kernel_pagetable>
    80001038:	83b1                	srli	a5,a5,0xc
    8000103a:	577d                	li	a4,-1
    8000103c:	177e                	slli	a4,a4,0x3f
    8000103e:	8fd9                	or	a5,a5,a4
  asm volatile("csrw satp, %0" : : "r" (x));
    80001040:	18079073          	csrw	satp,a5
  asm volatile("sfence.vma zero, zero");
    80001044:	12000073          	sfence.vma
  sfence_vma();
}
    80001048:	6422                	ld	s0,8(sp)
    8000104a:	0141                	addi	sp,sp,16
    8000104c:	8082                	ret

000000008000104e <walk>:
//   21..29 -- 9 bits of level-1 index.
//   12..20 -- 9 bits of level-0 index.
//    0..11 -- 12 bits of byte offset within the page.
pte_t *
walk(pagetable_t pagetable, uint64 va, int alloc)
{
    8000104e:	7139                	addi	sp,sp,-64
    80001050:	fc06                	sd	ra,56(sp)
    80001052:	f822                	sd	s0,48(sp)
    80001054:	f426                	sd	s1,40(sp)
    80001056:	f04a                	sd	s2,32(sp)
    80001058:	ec4e                	sd	s3,24(sp)
    8000105a:	e852                	sd	s4,16(sp)
    8000105c:	e456                	sd	s5,8(sp)
    8000105e:	e05a                	sd	s6,0(sp)
    80001060:	0080                	addi	s0,sp,64
    80001062:	84aa                	mv	s1,a0
    80001064:	89ae                	mv	s3,a1
    80001066:	8ab2                	mv	s5,a2
  if(va >= MAXVA)
    80001068:	57fd                	li	a5,-1
    8000106a:	83e9                	srli	a5,a5,0x1a
    8000106c:	4a79                	li	s4,30
    panic("walk");

  for(int level = 2; level > 0; level--) {
    8000106e:	4b31                	li	s6,12
  if(va >= MAXVA)
    80001070:	04b7f263          	bgeu	a5,a1,800010b4 <walk+0x66>
    panic("walk");
    80001074:	00007517          	auipc	a0,0x7
    80001078:	07450513          	addi	a0,a0,116 # 800080e8 <digits+0x90>
    8000107c:	fffff097          	auipc	ra,0xfffff
    80001080:	554080e7          	jalr	1364(ra) # 800005d0 <panic>
    pte_t *pte = &pagetable[PX(level, va)];
    if(*pte & PTE_V) {
      pagetable = (pagetable_t)PTE2PA(*pte);
    } else {
      if(!alloc || (pagetable = (pde_t*)kalloc()) == 0)
    80001084:	060a8663          	beqz	s5,800010f0 <walk+0xa2>
    80001088:	00000097          	auipc	ra,0x0
    8000108c:	aea080e7          	jalr	-1302(ra) # 80000b72 <kalloc>
    80001090:	84aa                	mv	s1,a0
    80001092:	c529                	beqz	a0,800010dc <walk+0x8e>
        return 0;
      memset(pagetable, 0, PGSIZE);
    80001094:	6605                	lui	a2,0x1
    80001096:	4581                	li	a1,0
    80001098:	00000097          	auipc	ra,0x0
    8000109c:	cc6080e7          	jalr	-826(ra) # 80000d5e <memset>
      *pte = PA2PTE(pagetable) | PTE_V;
    800010a0:	00c4d793          	srli	a5,s1,0xc
    800010a4:	07aa                	slli	a5,a5,0xa
    800010a6:	0017e793          	ori	a5,a5,1
    800010aa:	00f93023          	sd	a5,0(s2)
  for(int level = 2; level > 0; level--) {
    800010ae:	3a5d                	addiw	s4,s4,-9 # ffffffffffffeff7 <end+0xffffffff7ffd2ff7>
    800010b0:	036a0063          	beq	s4,s6,800010d0 <walk+0x82>
    pte_t *pte = &pagetable[PX(level, va)];
    800010b4:	0149d933          	srl	s2,s3,s4
    800010b8:	1ff97913          	andi	s2,s2,511
    800010bc:	090e                	slli	s2,s2,0x3
    800010be:	9926                	add	s2,s2,s1
    if(*pte & PTE_V) {
    800010c0:	00093483          	ld	s1,0(s2)
    800010c4:	0014f793          	andi	a5,s1,1
    800010c8:	dfd5                	beqz	a5,80001084 <walk+0x36>
      pagetable = (pagetable_t)PTE2PA(*pte);
    800010ca:	80a9                	srli	s1,s1,0xa
    800010cc:	04b2                	slli	s1,s1,0xc
    800010ce:	b7c5                	j	800010ae <walk+0x60>
    }
  }
  return &pagetable[PX(0, va)];
    800010d0:	00c9d513          	srli	a0,s3,0xc
    800010d4:	1ff57513          	andi	a0,a0,511
    800010d8:	050e                	slli	a0,a0,0x3
    800010da:	9526                	add	a0,a0,s1
}
    800010dc:	70e2                	ld	ra,56(sp)
    800010de:	7442                	ld	s0,48(sp)
    800010e0:	74a2                	ld	s1,40(sp)
    800010e2:	7902                	ld	s2,32(sp)
    800010e4:	69e2                	ld	s3,24(sp)
    800010e6:	6a42                	ld	s4,16(sp)
    800010e8:	6aa2                	ld	s5,8(sp)
    800010ea:	6b02                	ld	s6,0(sp)
    800010ec:	6121                	addi	sp,sp,64
    800010ee:	8082                	ret
        return 0;
    800010f0:	4501                	li	a0,0
    800010f2:	b7ed                	j	800010dc <walk+0x8e>

00000000800010f4 <walkaddr>:
walkaddr(pagetable_t pagetable, uint64 va)
{
  pte_t *pte;
  uint64 pa;

  if(va >= MAXVA)
    800010f4:	57fd                	li	a5,-1
    800010f6:	83e9                	srli	a5,a5,0x1a
    800010f8:	00b7f463          	bgeu	a5,a1,80001100 <walkaddr+0xc>
    return 0;
    800010fc:	4501                	li	a0,0
    return 0;
  if((*pte & PTE_U) == 0)
    return 0;
  pa = PTE2PA(*pte);
  return pa;
}
    800010fe:	8082                	ret
{
    80001100:	1141                	addi	sp,sp,-16
    80001102:	e406                	sd	ra,8(sp)
    80001104:	e022                	sd	s0,0(sp)
    80001106:	0800                	addi	s0,sp,16
  pte = walk(pagetable, va, 0);
    80001108:	4601                	li	a2,0
    8000110a:	00000097          	auipc	ra,0x0
    8000110e:	f44080e7          	jalr	-188(ra) # 8000104e <walk>
  if(pte == 0)
    80001112:	c105                	beqz	a0,80001132 <walkaddr+0x3e>
  if((*pte & PTE_V) == 0)
    80001114:	611c                	ld	a5,0(a0)
  if((*pte & PTE_U) == 0)
    80001116:	0117f693          	andi	a3,a5,17
    8000111a:	4745                	li	a4,17
    return 0;
    8000111c:	4501                	li	a0,0
  if((*pte & PTE_U) == 0)
    8000111e:	00e68663          	beq	a3,a4,8000112a <walkaddr+0x36>
}
    80001122:	60a2                	ld	ra,8(sp)
    80001124:	6402                	ld	s0,0(sp)
    80001126:	0141                	addi	sp,sp,16
    80001128:	8082                	ret
  pa = PTE2PA(*pte);
    8000112a:	00a7d513          	srli	a0,a5,0xa
    8000112e:	0532                	slli	a0,a0,0xc
  return pa;
    80001130:	bfcd                	j	80001122 <walkaddr+0x2e>
    return 0;
    80001132:	4501                	li	a0,0
    80001134:	b7fd                	j	80001122 <walkaddr+0x2e>

0000000080001136 <kvmpa>:
// a physical address. only needed for
// addresses on the stack.
// assumes va is page aligned.
uint64
kvmpa(uint64 va)
{
    80001136:	1101                	addi	sp,sp,-32
    80001138:	ec06                	sd	ra,24(sp)
    8000113a:	e822                	sd	s0,16(sp)
    8000113c:	e426                	sd	s1,8(sp)
    8000113e:	1000                	addi	s0,sp,32
    80001140:	85aa                	mv	a1,a0
  uint64 off = va % PGSIZE;
    80001142:	1552                	slli	a0,a0,0x34
    80001144:	03455493          	srli	s1,a0,0x34
  pte_t *pte;
  uint64 pa;
  
  pte = walk(kernel_pagetable, va, 0);
    80001148:	4601                	li	a2,0
    8000114a:	00008517          	auipc	a0,0x8
    8000114e:	ec653503          	ld	a0,-314(a0) # 80009010 <kernel_pagetable>
    80001152:	00000097          	auipc	ra,0x0
    80001156:	efc080e7          	jalr	-260(ra) # 8000104e <walk>
  if(pte == 0)
    8000115a:	cd09                	beqz	a0,80001174 <kvmpa+0x3e>
    panic("kvmpa");
  if((*pte & PTE_V) == 0)
    8000115c:	6108                	ld	a0,0(a0)
    8000115e:	00157793          	andi	a5,a0,1
    80001162:	c38d                	beqz	a5,80001184 <kvmpa+0x4e>
    panic("kvmpa");
  pa = PTE2PA(*pte);
    80001164:	8129                	srli	a0,a0,0xa
    80001166:	0532                	slli	a0,a0,0xc
  return pa+off;
}
    80001168:	9526                	add	a0,a0,s1
    8000116a:	60e2                	ld	ra,24(sp)
    8000116c:	6442                	ld	s0,16(sp)
    8000116e:	64a2                	ld	s1,8(sp)
    80001170:	6105                	addi	sp,sp,32
    80001172:	8082                	ret
    panic("kvmpa");
    80001174:	00007517          	auipc	a0,0x7
    80001178:	f7c50513          	addi	a0,a0,-132 # 800080f0 <digits+0x98>
    8000117c:	fffff097          	auipc	ra,0xfffff
    80001180:	454080e7          	jalr	1108(ra) # 800005d0 <panic>
    panic("kvmpa");
    80001184:	00007517          	auipc	a0,0x7
    80001188:	f6c50513          	addi	a0,a0,-148 # 800080f0 <digits+0x98>
    8000118c:	fffff097          	auipc	ra,0xfffff
    80001190:	444080e7          	jalr	1092(ra) # 800005d0 <panic>

0000000080001194 <mappages>:
// physical addresses starting at pa. va and size might not
// be page-aligned. Returns 0 on success, -1 if walk() couldn't
// allocate a needed page-table page.
int
mappages(pagetable_t pagetable, uint64 va, uint64 size, uint64 pa, int perm)
{
    80001194:	715d                	addi	sp,sp,-80
    80001196:	e486                	sd	ra,72(sp)
    80001198:	e0a2                	sd	s0,64(sp)
    8000119a:	fc26                	sd	s1,56(sp)
    8000119c:	f84a                	sd	s2,48(sp)
    8000119e:	f44e                	sd	s3,40(sp)
    800011a0:	f052                	sd	s4,32(sp)
    800011a2:	ec56                	sd	s5,24(sp)
    800011a4:	e85a                	sd	s6,16(sp)
    800011a6:	e45e                	sd	s7,8(sp)
    800011a8:	0880                	addi	s0,sp,80
    800011aa:	8aaa                	mv	s5,a0
    800011ac:	8b3a                	mv	s6,a4
  uint64 a, last;
  pte_t *pte;

  a = PGROUNDDOWN(va);
    800011ae:	777d                	lui	a4,0xfffff
    800011b0:	00e5f7b3          	and	a5,a1,a4
  last = PGROUNDDOWN(va + size - 1);
    800011b4:	167d                	addi	a2,a2,-1 # fff <_entry-0x7ffff001>
    800011b6:	00b609b3          	add	s3,a2,a1
    800011ba:	00e9f9b3          	and	s3,s3,a4
  a = PGROUNDDOWN(va);
    800011be:	893e                	mv	s2,a5
    800011c0:	40f68a33          	sub	s4,a3,a5
    if(*pte & PTE_V)
      panic("remap");
    *pte = PA2PTE(pa) | perm | PTE_V;
    if(a == last)
      break;
    a += PGSIZE;
    800011c4:	6b85                	lui	s7,0x1
    800011c6:	012a04b3          	add	s1,s4,s2
    if((pte = walk(pagetable, a, 1)) == 0)
    800011ca:	4605                	li	a2,1
    800011cc:	85ca                	mv	a1,s2
    800011ce:	8556                	mv	a0,s5
    800011d0:	00000097          	auipc	ra,0x0
    800011d4:	e7e080e7          	jalr	-386(ra) # 8000104e <walk>
    800011d8:	c51d                	beqz	a0,80001206 <mappages+0x72>
    if(*pte & PTE_V)
    800011da:	611c                	ld	a5,0(a0)
    800011dc:	8b85                	andi	a5,a5,1
    800011de:	ef81                	bnez	a5,800011f6 <mappages+0x62>
    *pte = PA2PTE(pa) | perm | PTE_V;
    800011e0:	80b1                	srli	s1,s1,0xc
    800011e2:	04aa                	slli	s1,s1,0xa
    800011e4:	0164e4b3          	or	s1,s1,s6
    800011e8:	0014e493          	ori	s1,s1,1
    800011ec:	e104                	sd	s1,0(a0)
    if(a == last)
    800011ee:	03390863          	beq	s2,s3,8000121e <mappages+0x8a>
    a += PGSIZE;
    800011f2:	995e                	add	s2,s2,s7
    if((pte = walk(pagetable, a, 1)) == 0)
    800011f4:	bfc9                	j	800011c6 <mappages+0x32>
      panic("remap");
    800011f6:	00007517          	auipc	a0,0x7
    800011fa:	f0250513          	addi	a0,a0,-254 # 800080f8 <digits+0xa0>
    800011fe:	fffff097          	auipc	ra,0xfffff
    80001202:	3d2080e7          	jalr	978(ra) # 800005d0 <panic>
      return -1;
    80001206:	557d                	li	a0,-1
    pa += PGSIZE;
  }
  return 0;
}
    80001208:	60a6                	ld	ra,72(sp)
    8000120a:	6406                	ld	s0,64(sp)
    8000120c:	74e2                	ld	s1,56(sp)
    8000120e:	7942                	ld	s2,48(sp)
    80001210:	79a2                	ld	s3,40(sp)
    80001212:	7a02                	ld	s4,32(sp)
    80001214:	6ae2                	ld	s5,24(sp)
    80001216:	6b42                	ld	s6,16(sp)
    80001218:	6ba2                	ld	s7,8(sp)
    8000121a:	6161                	addi	sp,sp,80
    8000121c:	8082                	ret
  return 0;
    8000121e:	4501                	li	a0,0
    80001220:	b7e5                	j	80001208 <mappages+0x74>

0000000080001222 <kvmmap>:
{
    80001222:	1141                	addi	sp,sp,-16
    80001224:	e406                	sd	ra,8(sp)
    80001226:	e022                	sd	s0,0(sp)
    80001228:	0800                	addi	s0,sp,16
    8000122a:	8736                	mv	a4,a3
  if(mappages(kernel_pagetable, va, sz, pa, perm) != 0)
    8000122c:	86ae                	mv	a3,a1
    8000122e:	85aa                	mv	a1,a0
    80001230:	00008517          	auipc	a0,0x8
    80001234:	de053503          	ld	a0,-544(a0) # 80009010 <kernel_pagetable>
    80001238:	00000097          	auipc	ra,0x0
    8000123c:	f5c080e7          	jalr	-164(ra) # 80001194 <mappages>
    80001240:	e509                	bnez	a0,8000124a <kvmmap+0x28>
}
    80001242:	60a2                	ld	ra,8(sp)
    80001244:	6402                	ld	s0,0(sp)
    80001246:	0141                	addi	sp,sp,16
    80001248:	8082                	ret
    panic("kvmmap");
    8000124a:	00007517          	auipc	a0,0x7
    8000124e:	eb650513          	addi	a0,a0,-330 # 80008100 <digits+0xa8>
    80001252:	fffff097          	auipc	ra,0xfffff
    80001256:	37e080e7          	jalr	894(ra) # 800005d0 <panic>

000000008000125a <kvminit>:
{
    8000125a:	1101                	addi	sp,sp,-32
    8000125c:	ec06                	sd	ra,24(sp)
    8000125e:	e822                	sd	s0,16(sp)
    80001260:	e426                	sd	s1,8(sp)
    80001262:	1000                	addi	s0,sp,32
  kernel_pagetable = (pagetable_t) kalloc();
    80001264:	00000097          	auipc	ra,0x0
    80001268:	90e080e7          	jalr	-1778(ra) # 80000b72 <kalloc>
    8000126c:	00008797          	auipc	a5,0x8
    80001270:	daa7b223          	sd	a0,-604(a5) # 80009010 <kernel_pagetable>
  memset(kernel_pagetable, 0, PGSIZE);
    80001274:	6605                	lui	a2,0x1
    80001276:	4581                	li	a1,0
    80001278:	00000097          	auipc	ra,0x0
    8000127c:	ae6080e7          	jalr	-1306(ra) # 80000d5e <memset>
  kvmmap(UART0, UART0, PGSIZE, PTE_R | PTE_W);
    80001280:	4699                	li	a3,6
    80001282:	6605                	lui	a2,0x1
    80001284:	100005b7          	lui	a1,0x10000
    80001288:	10000537          	lui	a0,0x10000
    8000128c:	00000097          	auipc	ra,0x0
    80001290:	f96080e7          	jalr	-106(ra) # 80001222 <kvmmap>
  kvmmap(VIRTIO0, VIRTIO0, PGSIZE, PTE_R | PTE_W);
    80001294:	4699                	li	a3,6
    80001296:	6605                	lui	a2,0x1
    80001298:	100015b7          	lui	a1,0x10001
    8000129c:	10001537          	lui	a0,0x10001
    800012a0:	00000097          	auipc	ra,0x0
    800012a4:	f82080e7          	jalr	-126(ra) # 80001222 <kvmmap>
  kvmmap(CLINT, CLINT, 0x10000, PTE_R | PTE_W);
    800012a8:	4699                	li	a3,6
    800012aa:	6641                	lui	a2,0x10
    800012ac:	020005b7          	lui	a1,0x2000
    800012b0:	02000537          	lui	a0,0x2000
    800012b4:	00000097          	auipc	ra,0x0
    800012b8:	f6e080e7          	jalr	-146(ra) # 80001222 <kvmmap>
  kvmmap(PLIC, PLIC, 0x400000, PTE_R | PTE_W);
    800012bc:	4699                	li	a3,6
    800012be:	00400637          	lui	a2,0x400
    800012c2:	0c0005b7          	lui	a1,0xc000
    800012c6:	0c000537          	lui	a0,0xc000
    800012ca:	00000097          	auipc	ra,0x0
    800012ce:	f58080e7          	jalr	-168(ra) # 80001222 <kvmmap>
  kvmmap(KERNBASE, KERNBASE, (uint64)etext-KERNBASE, PTE_R | PTE_X);
    800012d2:	00007497          	auipc	s1,0x7
    800012d6:	d2e48493          	addi	s1,s1,-722 # 80008000 <etext>
    800012da:	46a9                	li	a3,10
    800012dc:	80007617          	auipc	a2,0x80007
    800012e0:	d2460613          	addi	a2,a2,-732 # 8000 <_entry-0x7fff8000>
    800012e4:	4585                	li	a1,1
    800012e6:	05fe                	slli	a1,a1,0x1f
    800012e8:	852e                	mv	a0,a1
    800012ea:	00000097          	auipc	ra,0x0
    800012ee:	f38080e7          	jalr	-200(ra) # 80001222 <kvmmap>
  kvmmap((uint64)etext, (uint64)etext, PHYSTOP-(uint64)etext, PTE_R | PTE_W);
    800012f2:	4699                	li	a3,6
    800012f4:	4645                	li	a2,17
    800012f6:	066e                	slli	a2,a2,0x1b
    800012f8:	8e05                	sub	a2,a2,s1
    800012fa:	85a6                	mv	a1,s1
    800012fc:	8526                	mv	a0,s1
    800012fe:	00000097          	auipc	ra,0x0
    80001302:	f24080e7          	jalr	-220(ra) # 80001222 <kvmmap>
  kvmmap(TRAMPOLINE, (uint64)trampoline, PGSIZE, PTE_R | PTE_X);
    80001306:	46a9                	li	a3,10
    80001308:	6605                	lui	a2,0x1
    8000130a:	00006597          	auipc	a1,0x6
    8000130e:	cf658593          	addi	a1,a1,-778 # 80007000 <_trampoline>
    80001312:	04000537          	lui	a0,0x4000
    80001316:	157d                	addi	a0,a0,-1 # 3ffffff <_entry-0x7c000001>
    80001318:	0532                	slli	a0,a0,0xc
    8000131a:	00000097          	auipc	ra,0x0
    8000131e:	f08080e7          	jalr	-248(ra) # 80001222 <kvmmap>
}
    80001322:	60e2                	ld	ra,24(sp)
    80001324:	6442                	ld	s0,16(sp)
    80001326:	64a2                	ld	s1,8(sp)
    80001328:	6105                	addi	sp,sp,32
    8000132a:	8082                	ret

000000008000132c <uvmunmap>:
// Remove npages of mappings starting from va. va must be
// page-aligned. The mappings must exist.
// Optionally free the physical memory.
void
uvmunmap(pagetable_t pagetable, uint64 va, uint64 npages, int do_free)
{
    8000132c:	715d                	addi	sp,sp,-80
    8000132e:	e486                	sd	ra,72(sp)
    80001330:	e0a2                	sd	s0,64(sp)
    80001332:	fc26                	sd	s1,56(sp)
    80001334:	f84a                	sd	s2,48(sp)
    80001336:	f44e                	sd	s3,40(sp)
    80001338:	f052                	sd	s4,32(sp)
    8000133a:	ec56                	sd	s5,24(sp)
    8000133c:	e85a                	sd	s6,16(sp)
    8000133e:	e45e                	sd	s7,8(sp)
    80001340:	0880                	addi	s0,sp,80
  uint64 a;
  pte_t *pte;

  if((va % PGSIZE) != 0)
    80001342:	03459793          	slli	a5,a1,0x34
    80001346:	e795                	bnez	a5,80001372 <uvmunmap+0x46>
    80001348:	8a2a                	mv	s4,a0
    8000134a:	892e                	mv	s2,a1
    8000134c:	8ab6                	mv	s5,a3
    panic("uvmunmap: not aligned");

  for(a = va; a < va + npages*PGSIZE; a += PGSIZE){
    8000134e:	0632                	slli	a2,a2,0xc
    80001350:	00b609b3          	add	s3,a2,a1
    if((pte = walk(pagetable, a, 0)) == 0)
      panic("uvmunmap: walk");
    if((*pte & PTE_V) == 0)
      panic("uvmunmap: not mapped");
    if(PTE_FLAGS(*pte) == PTE_V)
    80001354:	4b85                	li	s7,1
  for(a = va; a < va + npages*PGSIZE; a += PGSIZE){
    80001356:	6b05                	lui	s6,0x1
    80001358:	0735e263          	bltu	a1,s3,800013bc <uvmunmap+0x90>
      uint64 pa = PTE2PA(*pte);
      kfree((void*)pa);
    }
    *pte = 0;
  }
}
    8000135c:	60a6                	ld	ra,72(sp)
    8000135e:	6406                	ld	s0,64(sp)
    80001360:	74e2                	ld	s1,56(sp)
    80001362:	7942                	ld	s2,48(sp)
    80001364:	79a2                	ld	s3,40(sp)
    80001366:	7a02                	ld	s4,32(sp)
    80001368:	6ae2                	ld	s5,24(sp)
    8000136a:	6b42                	ld	s6,16(sp)
    8000136c:	6ba2                	ld	s7,8(sp)
    8000136e:	6161                	addi	sp,sp,80
    80001370:	8082                	ret
    panic("uvmunmap: not aligned");
    80001372:	00007517          	auipc	a0,0x7
    80001376:	d9650513          	addi	a0,a0,-618 # 80008108 <digits+0xb0>
    8000137a:	fffff097          	auipc	ra,0xfffff
    8000137e:	256080e7          	jalr	598(ra) # 800005d0 <panic>
      panic("uvmunmap: walk");
    80001382:	00007517          	auipc	a0,0x7
    80001386:	d9e50513          	addi	a0,a0,-610 # 80008120 <digits+0xc8>
    8000138a:	fffff097          	auipc	ra,0xfffff
    8000138e:	246080e7          	jalr	582(ra) # 800005d0 <panic>
      panic("uvmunmap: not mapped");
    80001392:	00007517          	auipc	a0,0x7
    80001396:	d9e50513          	addi	a0,a0,-610 # 80008130 <digits+0xd8>
    8000139a:	fffff097          	auipc	ra,0xfffff
    8000139e:	236080e7          	jalr	566(ra) # 800005d0 <panic>
      panic("uvmunmap: not a leaf");
    800013a2:	00007517          	auipc	a0,0x7
    800013a6:	da650513          	addi	a0,a0,-602 # 80008148 <digits+0xf0>
    800013aa:	fffff097          	auipc	ra,0xfffff
    800013ae:	226080e7          	jalr	550(ra) # 800005d0 <panic>
    *pte = 0;
    800013b2:	0004b023          	sd	zero,0(s1)
  for(a = va; a < va + npages*PGSIZE; a += PGSIZE){
    800013b6:	995a                	add	s2,s2,s6
    800013b8:	fb3972e3          	bgeu	s2,s3,8000135c <uvmunmap+0x30>
    if((pte = walk(pagetable, a, 0)) == 0)
    800013bc:	4601                	li	a2,0
    800013be:	85ca                	mv	a1,s2
    800013c0:	8552                	mv	a0,s4
    800013c2:	00000097          	auipc	ra,0x0
    800013c6:	c8c080e7          	jalr	-884(ra) # 8000104e <walk>
    800013ca:	84aa                	mv	s1,a0
    800013cc:	d95d                	beqz	a0,80001382 <uvmunmap+0x56>
    if((*pte & PTE_V) == 0)
    800013ce:	6108                	ld	a0,0(a0)
    800013d0:	00157793          	andi	a5,a0,1
    800013d4:	dfdd                	beqz	a5,80001392 <uvmunmap+0x66>
    if(PTE_FLAGS(*pte) == PTE_V)
    800013d6:	3ff57793          	andi	a5,a0,1023
    800013da:	fd7784e3          	beq	a5,s7,800013a2 <uvmunmap+0x76>
    if(do_free){
    800013de:	fc0a8ae3          	beqz	s5,800013b2 <uvmunmap+0x86>
      uint64 pa = PTE2PA(*pte);
    800013e2:	8129                	srli	a0,a0,0xa
      kfree((void*)pa);
    800013e4:	0532                	slli	a0,a0,0xc
    800013e6:	fffff097          	auipc	ra,0xfffff
    800013ea:	690080e7          	jalr	1680(ra) # 80000a76 <kfree>
    800013ee:	b7d1                	j	800013b2 <uvmunmap+0x86>

00000000800013f0 <uvmcreate>:

// create an empty user page table.
// returns 0 if out of memory.
pagetable_t
uvmcreate()
{
    800013f0:	1101                	addi	sp,sp,-32
    800013f2:	ec06                	sd	ra,24(sp)
    800013f4:	e822                	sd	s0,16(sp)
    800013f6:	e426                	sd	s1,8(sp)
    800013f8:	1000                	addi	s0,sp,32
  pagetable_t pagetable;
  pagetable = (pagetable_t) kalloc();
    800013fa:	fffff097          	auipc	ra,0xfffff
    800013fe:	778080e7          	jalr	1912(ra) # 80000b72 <kalloc>
    80001402:	84aa                	mv	s1,a0
  if(pagetable == 0)
    80001404:	c519                	beqz	a0,80001412 <uvmcreate+0x22>
    return 0;
  memset(pagetable, 0, PGSIZE);
    80001406:	6605                	lui	a2,0x1
    80001408:	4581                	li	a1,0
    8000140a:	00000097          	auipc	ra,0x0
    8000140e:	954080e7          	jalr	-1708(ra) # 80000d5e <memset>
  return pagetable;
}
    80001412:	8526                	mv	a0,s1
    80001414:	60e2                	ld	ra,24(sp)
    80001416:	6442                	ld	s0,16(sp)
    80001418:	64a2                	ld	s1,8(sp)
    8000141a:	6105                	addi	sp,sp,32
    8000141c:	8082                	ret

000000008000141e <uvminit>:
// Load the user initcode into address 0 of pagetable,
// for the very first process.
// sz must be less than a page.
void
uvminit(pagetable_t pagetable, uchar *src, uint sz)
{
    8000141e:	7179                	addi	sp,sp,-48
    80001420:	f406                	sd	ra,40(sp)
    80001422:	f022                	sd	s0,32(sp)
    80001424:	ec26                	sd	s1,24(sp)
    80001426:	e84a                	sd	s2,16(sp)
    80001428:	e44e                	sd	s3,8(sp)
    8000142a:	e052                	sd	s4,0(sp)
    8000142c:	1800                	addi	s0,sp,48
  char *mem;

  if(sz >= PGSIZE)
    8000142e:	6785                	lui	a5,0x1
    80001430:	04f67863          	bgeu	a2,a5,80001480 <uvminit+0x62>
    80001434:	8a2a                	mv	s4,a0
    80001436:	89ae                	mv	s3,a1
    80001438:	84b2                	mv	s1,a2
    panic("inituvm: more than a page");
  mem = kalloc();
    8000143a:	fffff097          	auipc	ra,0xfffff
    8000143e:	738080e7          	jalr	1848(ra) # 80000b72 <kalloc>
    80001442:	892a                	mv	s2,a0
  memset(mem, 0, PGSIZE);
    80001444:	6605                	lui	a2,0x1
    80001446:	4581                	li	a1,0
    80001448:	00000097          	auipc	ra,0x0
    8000144c:	916080e7          	jalr	-1770(ra) # 80000d5e <memset>
  mappages(pagetable, 0, PGSIZE, (uint64)mem, PTE_W|PTE_R|PTE_X|PTE_U);
    80001450:	4779                	li	a4,30
    80001452:	86ca                	mv	a3,s2
    80001454:	6605                	lui	a2,0x1
    80001456:	4581                	li	a1,0
    80001458:	8552                	mv	a0,s4
    8000145a:	00000097          	auipc	ra,0x0
    8000145e:	d3a080e7          	jalr	-710(ra) # 80001194 <mappages>
  memmove(mem, src, sz);
    80001462:	8626                	mv	a2,s1
    80001464:	85ce                	mv	a1,s3
    80001466:	854a                	mv	a0,s2
    80001468:	00000097          	auipc	ra,0x0
    8000146c:	952080e7          	jalr	-1710(ra) # 80000dba <memmove>
}
    80001470:	70a2                	ld	ra,40(sp)
    80001472:	7402                	ld	s0,32(sp)
    80001474:	64e2                	ld	s1,24(sp)
    80001476:	6942                	ld	s2,16(sp)
    80001478:	69a2                	ld	s3,8(sp)
    8000147a:	6a02                	ld	s4,0(sp)
    8000147c:	6145                	addi	sp,sp,48
    8000147e:	8082                	ret
    panic("inituvm: more than a page");
    80001480:	00007517          	auipc	a0,0x7
    80001484:	ce050513          	addi	a0,a0,-800 # 80008160 <digits+0x108>
    80001488:	fffff097          	auipc	ra,0xfffff
    8000148c:	148080e7          	jalr	328(ra) # 800005d0 <panic>

0000000080001490 <uvmdealloc>:
// newsz.  oldsz and newsz need not be page-aligned, nor does newsz
// need to be less than oldsz.  oldsz can be larger than the actual
// process size.  Returns the new process size.
uint64
uvmdealloc(pagetable_t pagetable, uint64 oldsz, uint64 newsz)
{
    80001490:	1101                	addi	sp,sp,-32
    80001492:	ec06                	sd	ra,24(sp)
    80001494:	e822                	sd	s0,16(sp)
    80001496:	e426                	sd	s1,8(sp)
    80001498:	1000                	addi	s0,sp,32
  if(newsz >= oldsz)
    return oldsz;
    8000149a:	84ae                	mv	s1,a1
  if(newsz >= oldsz)
    8000149c:	00b67d63          	bgeu	a2,a1,800014b6 <uvmdealloc+0x26>
    800014a0:	84b2                	mv	s1,a2

  if(PGROUNDUP(newsz) < PGROUNDUP(oldsz)){
    800014a2:	6785                	lui	a5,0x1
    800014a4:	17fd                	addi	a5,a5,-1 # fff <_entry-0x7ffff001>
    800014a6:	00f60733          	add	a4,a2,a5
    800014aa:	767d                	lui	a2,0xfffff
    800014ac:	8f71                	and	a4,a4,a2
    800014ae:	97ae                	add	a5,a5,a1
    800014b0:	8ff1                	and	a5,a5,a2
    800014b2:	00f76863          	bltu	a4,a5,800014c2 <uvmdealloc+0x32>
    int npages = (PGROUNDUP(oldsz) - PGROUNDUP(newsz)) / PGSIZE;
    uvmunmap(pagetable, PGROUNDUP(newsz), npages, 1);
  }

  return newsz;
}
    800014b6:	8526                	mv	a0,s1
    800014b8:	60e2                	ld	ra,24(sp)
    800014ba:	6442                	ld	s0,16(sp)
    800014bc:	64a2                	ld	s1,8(sp)
    800014be:	6105                	addi	sp,sp,32
    800014c0:	8082                	ret
    int npages = (PGROUNDUP(oldsz) - PGROUNDUP(newsz)) / PGSIZE;
    800014c2:	8f99                	sub	a5,a5,a4
    800014c4:	83b1                	srli	a5,a5,0xc
    uvmunmap(pagetable, PGROUNDUP(newsz), npages, 1);
    800014c6:	4685                	li	a3,1
    800014c8:	0007861b          	sext.w	a2,a5
    800014cc:	85ba                	mv	a1,a4
    800014ce:	00000097          	auipc	ra,0x0
    800014d2:	e5e080e7          	jalr	-418(ra) # 8000132c <uvmunmap>
    800014d6:	b7c5                	j	800014b6 <uvmdealloc+0x26>

00000000800014d8 <uvmalloc>:
  if(newsz < oldsz)
    800014d8:	0ab66163          	bltu	a2,a1,8000157a <uvmalloc+0xa2>
{
    800014dc:	7139                	addi	sp,sp,-64
    800014de:	fc06                	sd	ra,56(sp)
    800014e0:	f822                	sd	s0,48(sp)
    800014e2:	f426                	sd	s1,40(sp)
    800014e4:	f04a                	sd	s2,32(sp)
    800014e6:	ec4e                	sd	s3,24(sp)
    800014e8:	e852                	sd	s4,16(sp)
    800014ea:	e456                	sd	s5,8(sp)
    800014ec:	0080                	addi	s0,sp,64
    800014ee:	8aaa                	mv	s5,a0
    800014f0:	8a32                	mv	s4,a2
  oldsz = PGROUNDUP(oldsz);
    800014f2:	6985                	lui	s3,0x1
    800014f4:	19fd                	addi	s3,s3,-1 # fff <_entry-0x7ffff001>
    800014f6:	95ce                	add	a1,a1,s3
    800014f8:	79fd                	lui	s3,0xfffff
    800014fa:	0135f9b3          	and	s3,a1,s3
  for(a = oldsz; a < newsz; a += PGSIZE){
    800014fe:	08c9f063          	bgeu	s3,a2,8000157e <uvmalloc+0xa6>
    80001502:	894e                	mv	s2,s3
    mem = kalloc();
    80001504:	fffff097          	auipc	ra,0xfffff
    80001508:	66e080e7          	jalr	1646(ra) # 80000b72 <kalloc>
    8000150c:	84aa                	mv	s1,a0
    if(mem == 0){
    8000150e:	c51d                	beqz	a0,8000153c <uvmalloc+0x64>
    memset(mem, 0, PGSIZE);
    80001510:	6605                	lui	a2,0x1
    80001512:	4581                	li	a1,0
    80001514:	00000097          	auipc	ra,0x0
    80001518:	84a080e7          	jalr	-1974(ra) # 80000d5e <memset>
    if(mappages(pagetable, a, PGSIZE, (uint64)mem, PTE_W|PTE_X|PTE_R|PTE_U) != 0){
    8000151c:	4779                	li	a4,30
    8000151e:	86a6                	mv	a3,s1
    80001520:	6605                	lui	a2,0x1
    80001522:	85ca                	mv	a1,s2
    80001524:	8556                	mv	a0,s5
    80001526:	00000097          	auipc	ra,0x0
    8000152a:	c6e080e7          	jalr	-914(ra) # 80001194 <mappages>
    8000152e:	e905                	bnez	a0,8000155e <uvmalloc+0x86>
  for(a = oldsz; a < newsz; a += PGSIZE){
    80001530:	6785                	lui	a5,0x1
    80001532:	993e                	add	s2,s2,a5
    80001534:	fd4968e3          	bltu	s2,s4,80001504 <uvmalloc+0x2c>
  return newsz;
    80001538:	8552                	mv	a0,s4
    8000153a:	a809                	j	8000154c <uvmalloc+0x74>
      uvmdealloc(pagetable, a, oldsz);
    8000153c:	864e                	mv	a2,s3
    8000153e:	85ca                	mv	a1,s2
    80001540:	8556                	mv	a0,s5
    80001542:	00000097          	auipc	ra,0x0
    80001546:	f4e080e7          	jalr	-178(ra) # 80001490 <uvmdealloc>
      return 0;
    8000154a:	4501                	li	a0,0
}
    8000154c:	70e2                	ld	ra,56(sp)
    8000154e:	7442                	ld	s0,48(sp)
    80001550:	74a2                	ld	s1,40(sp)
    80001552:	7902                	ld	s2,32(sp)
    80001554:	69e2                	ld	s3,24(sp)
    80001556:	6a42                	ld	s4,16(sp)
    80001558:	6aa2                	ld	s5,8(sp)
    8000155a:	6121                	addi	sp,sp,64
    8000155c:	8082                	ret
      kfree(mem);
    8000155e:	8526                	mv	a0,s1
    80001560:	fffff097          	auipc	ra,0xfffff
    80001564:	516080e7          	jalr	1302(ra) # 80000a76 <kfree>
      uvmdealloc(pagetable, a, oldsz);
    80001568:	864e                	mv	a2,s3
    8000156a:	85ca                	mv	a1,s2
    8000156c:	8556                	mv	a0,s5
    8000156e:	00000097          	auipc	ra,0x0
    80001572:	f22080e7          	jalr	-222(ra) # 80001490 <uvmdealloc>
      return 0;
    80001576:	4501                	li	a0,0
    80001578:	bfd1                	j	8000154c <uvmalloc+0x74>
    return oldsz;
    8000157a:	852e                	mv	a0,a1
}
    8000157c:	8082                	ret
  return newsz;
    8000157e:	8532                	mv	a0,a2
    80001580:	b7f1                	j	8000154c <uvmalloc+0x74>

0000000080001582 <freewalk>:

// Recursively free page-table pages.
// All leaf mappings must already have been removed.
void
freewalk(pagetable_t pagetable)
{
    80001582:	7179                	addi	sp,sp,-48
    80001584:	f406                	sd	ra,40(sp)
    80001586:	f022                	sd	s0,32(sp)
    80001588:	ec26                	sd	s1,24(sp)
    8000158a:	e84a                	sd	s2,16(sp)
    8000158c:	e44e                	sd	s3,8(sp)
    8000158e:	e052                	sd	s4,0(sp)
    80001590:	1800                	addi	s0,sp,48
    80001592:	8a2a                	mv	s4,a0
  // there are 2^9 = 512 PTEs in a page table.
  for(int i = 0; i < 512; i++){
    80001594:	84aa                	mv	s1,a0
    80001596:	6905                	lui	s2,0x1
    80001598:	992a                	add	s2,s2,a0
    pte_t pte = pagetable[i];
    if((pte & PTE_V) && (pte & (PTE_R|PTE_W|PTE_X)) == 0){
    8000159a:	4985                	li	s3,1
    8000159c:	a821                	j	800015b4 <freewalk+0x32>
      // this PTE points to a lower-level page table.
      uint64 child = PTE2PA(pte);
    8000159e:	8129                	srli	a0,a0,0xa
      freewalk((pagetable_t)child);
    800015a0:	0532                	slli	a0,a0,0xc
    800015a2:	00000097          	auipc	ra,0x0
    800015a6:	fe0080e7          	jalr	-32(ra) # 80001582 <freewalk>
      pagetable[i] = 0;
    800015aa:	0004b023          	sd	zero,0(s1)
  for(int i = 0; i < 512; i++){
    800015ae:	04a1                	addi	s1,s1,8
    800015b0:	03248163          	beq	s1,s2,800015d2 <freewalk+0x50>
    pte_t pte = pagetable[i];
    800015b4:	6088                	ld	a0,0(s1)
    if((pte & PTE_V) && (pte & (PTE_R|PTE_W|PTE_X)) == 0){
    800015b6:	00f57793          	andi	a5,a0,15
    800015ba:	ff3782e3          	beq	a5,s3,8000159e <freewalk+0x1c>
    } else if(pte & PTE_V){
    800015be:	8905                	andi	a0,a0,1
    800015c0:	d57d                	beqz	a0,800015ae <freewalk+0x2c>
      panic("freewalk: leaf");
    800015c2:	00007517          	auipc	a0,0x7
    800015c6:	bbe50513          	addi	a0,a0,-1090 # 80008180 <digits+0x128>
    800015ca:	fffff097          	auipc	ra,0xfffff
    800015ce:	006080e7          	jalr	6(ra) # 800005d0 <panic>
    }
  }
  kfree((void*)pagetable);
    800015d2:	8552                	mv	a0,s4
    800015d4:	fffff097          	auipc	ra,0xfffff
    800015d8:	4a2080e7          	jalr	1186(ra) # 80000a76 <kfree>
}
    800015dc:	70a2                	ld	ra,40(sp)
    800015de:	7402                	ld	s0,32(sp)
    800015e0:	64e2                	ld	s1,24(sp)
    800015e2:	6942                	ld	s2,16(sp)
    800015e4:	69a2                	ld	s3,8(sp)
    800015e6:	6a02                	ld	s4,0(sp)
    800015e8:	6145                	addi	sp,sp,48
    800015ea:	8082                	ret

00000000800015ec <uvmfree>:

// Free user memory pages,
// then free page-table pages.
void
uvmfree(pagetable_t pagetable, uint64 sz)
{
    800015ec:	1101                	addi	sp,sp,-32
    800015ee:	ec06                	sd	ra,24(sp)
    800015f0:	e822                	sd	s0,16(sp)
    800015f2:	e426                	sd	s1,8(sp)
    800015f4:	1000                	addi	s0,sp,32
    800015f6:	84aa                	mv	s1,a0
  if(sz > 0)
    800015f8:	e999                	bnez	a1,8000160e <uvmfree+0x22>
    uvmunmap(pagetable, 0, PGROUNDUP(sz)/PGSIZE, 1);
  freewalk(pagetable);
    800015fa:	8526                	mv	a0,s1
    800015fc:	00000097          	auipc	ra,0x0
    80001600:	f86080e7          	jalr	-122(ra) # 80001582 <freewalk>
}
    80001604:	60e2                	ld	ra,24(sp)
    80001606:	6442                	ld	s0,16(sp)
    80001608:	64a2                	ld	s1,8(sp)
    8000160a:	6105                	addi	sp,sp,32
    8000160c:	8082                	ret
    uvmunmap(pagetable, 0, PGROUNDUP(sz)/PGSIZE, 1);
    8000160e:	6605                	lui	a2,0x1
    80001610:	167d                	addi	a2,a2,-1 # fff <_entry-0x7ffff001>
    80001612:	962e                	add	a2,a2,a1
    80001614:	4685                	li	a3,1
    80001616:	8231                	srli	a2,a2,0xc
    80001618:	4581                	li	a1,0
    8000161a:	00000097          	auipc	ra,0x0
    8000161e:	d12080e7          	jalr	-750(ra) # 8000132c <uvmunmap>
    80001622:	bfe1                	j	800015fa <uvmfree+0xe>

0000000080001624 <uvmcopy>:
  pte_t *pte;
  uint64 pa, i;
  uint flags;
  char *mem;

  for(i = 0; i < sz; i += PGSIZE){
    80001624:	c679                	beqz	a2,800016f2 <uvmcopy+0xce>
{
    80001626:	715d                	addi	sp,sp,-80
    80001628:	e486                	sd	ra,72(sp)
    8000162a:	e0a2                	sd	s0,64(sp)
    8000162c:	fc26                	sd	s1,56(sp)
    8000162e:	f84a                	sd	s2,48(sp)
    80001630:	f44e                	sd	s3,40(sp)
    80001632:	f052                	sd	s4,32(sp)
    80001634:	ec56                	sd	s5,24(sp)
    80001636:	e85a                	sd	s6,16(sp)
    80001638:	e45e                	sd	s7,8(sp)
    8000163a:	0880                	addi	s0,sp,80
    8000163c:	8b2a                	mv	s6,a0
    8000163e:	8aae                	mv	s5,a1
    80001640:	8a32                	mv	s4,a2
  for(i = 0; i < sz; i += PGSIZE){
    80001642:	4981                	li	s3,0
    if((pte = walk(old, i, 0)) == 0)
    80001644:	4601                	li	a2,0
    80001646:	85ce                	mv	a1,s3
    80001648:	855a                	mv	a0,s6
    8000164a:	00000097          	auipc	ra,0x0
    8000164e:	a04080e7          	jalr	-1532(ra) # 8000104e <walk>
    80001652:	c531                	beqz	a0,8000169e <uvmcopy+0x7a>
      panic("uvmcopy: pte should exist");
    if((*pte & PTE_V) == 0)
    80001654:	6118                	ld	a4,0(a0)
    80001656:	00177793          	andi	a5,a4,1
    8000165a:	cbb1                	beqz	a5,800016ae <uvmcopy+0x8a>
      panic("uvmcopy: page not present");
    pa = PTE2PA(*pte);
    8000165c:	00a75593          	srli	a1,a4,0xa
    80001660:	00c59b93          	slli	s7,a1,0xc
    flags = PTE_FLAGS(*pte);
    80001664:	3ff77493          	andi	s1,a4,1023
    if((mem = kalloc()) == 0)
    80001668:	fffff097          	auipc	ra,0xfffff
    8000166c:	50a080e7          	jalr	1290(ra) # 80000b72 <kalloc>
    80001670:	892a                	mv	s2,a0
    80001672:	c939                	beqz	a0,800016c8 <uvmcopy+0xa4>
      goto err;
    memmove(mem, (char*)pa, PGSIZE);
    80001674:	6605                	lui	a2,0x1
    80001676:	85de                	mv	a1,s7
    80001678:	fffff097          	auipc	ra,0xfffff
    8000167c:	742080e7          	jalr	1858(ra) # 80000dba <memmove>
    if(mappages(new, i, PGSIZE, (uint64)mem, flags) != 0){
    80001680:	8726                	mv	a4,s1
    80001682:	86ca                	mv	a3,s2
    80001684:	6605                	lui	a2,0x1
    80001686:	85ce                	mv	a1,s3
    80001688:	8556                	mv	a0,s5
    8000168a:	00000097          	auipc	ra,0x0
    8000168e:	b0a080e7          	jalr	-1270(ra) # 80001194 <mappages>
    80001692:	e515                	bnez	a0,800016be <uvmcopy+0x9a>
  for(i = 0; i < sz; i += PGSIZE){
    80001694:	6785                	lui	a5,0x1
    80001696:	99be                	add	s3,s3,a5
    80001698:	fb49e6e3          	bltu	s3,s4,80001644 <uvmcopy+0x20>
    8000169c:	a081                	j	800016dc <uvmcopy+0xb8>
      panic("uvmcopy: pte should exist");
    8000169e:	00007517          	auipc	a0,0x7
    800016a2:	af250513          	addi	a0,a0,-1294 # 80008190 <digits+0x138>
    800016a6:	fffff097          	auipc	ra,0xfffff
    800016aa:	f2a080e7          	jalr	-214(ra) # 800005d0 <panic>
      panic("uvmcopy: page not present");
    800016ae:	00007517          	auipc	a0,0x7
    800016b2:	b0250513          	addi	a0,a0,-1278 # 800081b0 <digits+0x158>
    800016b6:	fffff097          	auipc	ra,0xfffff
    800016ba:	f1a080e7          	jalr	-230(ra) # 800005d0 <panic>
      kfree(mem);
    800016be:	854a                	mv	a0,s2
    800016c0:	fffff097          	auipc	ra,0xfffff
    800016c4:	3b6080e7          	jalr	950(ra) # 80000a76 <kfree>
    }
  }
  return 0;

 err:
  uvmunmap(new, 0, i / PGSIZE, 1);
    800016c8:	4685                	li	a3,1
    800016ca:	00c9d613          	srli	a2,s3,0xc
    800016ce:	4581                	li	a1,0
    800016d0:	8556                	mv	a0,s5
    800016d2:	00000097          	auipc	ra,0x0
    800016d6:	c5a080e7          	jalr	-934(ra) # 8000132c <uvmunmap>
  return -1;
    800016da:	557d                	li	a0,-1
}
    800016dc:	60a6                	ld	ra,72(sp)
    800016de:	6406                	ld	s0,64(sp)
    800016e0:	74e2                	ld	s1,56(sp)
    800016e2:	7942                	ld	s2,48(sp)
    800016e4:	79a2                	ld	s3,40(sp)
    800016e6:	7a02                	ld	s4,32(sp)
    800016e8:	6ae2                	ld	s5,24(sp)
    800016ea:	6b42                	ld	s6,16(sp)
    800016ec:	6ba2                	ld	s7,8(sp)
    800016ee:	6161                	addi	sp,sp,80
    800016f0:	8082                	ret
  return 0;
    800016f2:	4501                	li	a0,0
}
    800016f4:	8082                	ret

00000000800016f6 <uvmclear>:

// mark a PTE invalid for user access.
// used by exec for the user stack guard page.
void
uvmclear(pagetable_t pagetable, uint64 va)
{
    800016f6:	1141                	addi	sp,sp,-16
    800016f8:	e406                	sd	ra,8(sp)
    800016fa:	e022                	sd	s0,0(sp)
    800016fc:	0800                	addi	s0,sp,16
  pte_t *pte;
  
  pte = walk(pagetable, va, 0);
    800016fe:	4601                	li	a2,0
    80001700:	00000097          	auipc	ra,0x0
    80001704:	94e080e7          	jalr	-1714(ra) # 8000104e <walk>
  if(pte == 0)
    80001708:	c901                	beqz	a0,80001718 <uvmclear+0x22>
    panic("uvmclear");
  *pte &= ~PTE_U;
    8000170a:	611c                	ld	a5,0(a0)
    8000170c:	9bbd                	andi	a5,a5,-17
    8000170e:	e11c                	sd	a5,0(a0)
}
    80001710:	60a2                	ld	ra,8(sp)
    80001712:	6402                	ld	s0,0(sp)
    80001714:	0141                	addi	sp,sp,16
    80001716:	8082                	ret
    panic("uvmclear");
    80001718:	00007517          	auipc	a0,0x7
    8000171c:	ab850513          	addi	a0,a0,-1352 # 800081d0 <digits+0x178>
    80001720:	fffff097          	auipc	ra,0xfffff
    80001724:	eb0080e7          	jalr	-336(ra) # 800005d0 <panic>

0000000080001728 <copyout>:
int
copyout(pagetable_t pagetable, uint64 dstva, char *src, uint64 len)
{
  uint64 n, va0, pa0;

  while(len > 0){
    80001728:	c6bd                	beqz	a3,80001796 <copyout+0x6e>
{
    8000172a:	715d                	addi	sp,sp,-80
    8000172c:	e486                	sd	ra,72(sp)
    8000172e:	e0a2                	sd	s0,64(sp)
    80001730:	fc26                	sd	s1,56(sp)
    80001732:	f84a                	sd	s2,48(sp)
    80001734:	f44e                	sd	s3,40(sp)
    80001736:	f052                	sd	s4,32(sp)
    80001738:	ec56                	sd	s5,24(sp)
    8000173a:	e85a                	sd	s6,16(sp)
    8000173c:	e45e                	sd	s7,8(sp)
    8000173e:	e062                	sd	s8,0(sp)
    80001740:	0880                	addi	s0,sp,80
    80001742:	8b2a                	mv	s6,a0
    80001744:	8c2e                	mv	s8,a1
    80001746:	8a32                	mv	s4,a2
    80001748:	89b6                	mv	s3,a3
    va0 = PGROUNDDOWN(dstva);
    8000174a:	7bfd                	lui	s7,0xfffff
    pa0 = walkaddr(pagetable, va0);
    if(pa0 == 0)
      return -1;
    n = PGSIZE - (dstva - va0);
    8000174c:	6a85                	lui	s5,0x1
    8000174e:	a015                	j	80001772 <copyout+0x4a>
    if(n > len)
      n = len;
    memmove((void *)(pa0 + (dstva - va0)), src, n);
    80001750:	9562                	add	a0,a0,s8
    80001752:	0004861b          	sext.w	a2,s1
    80001756:	85d2                	mv	a1,s4
    80001758:	41250533          	sub	a0,a0,s2
    8000175c:	fffff097          	auipc	ra,0xfffff
    80001760:	65e080e7          	jalr	1630(ra) # 80000dba <memmove>

    len -= n;
    80001764:	409989b3          	sub	s3,s3,s1
    src += n;
    80001768:	9a26                	add	s4,s4,s1
    dstva = va0 + PGSIZE;
    8000176a:	01590c33          	add	s8,s2,s5
  while(len > 0){
    8000176e:	02098263          	beqz	s3,80001792 <copyout+0x6a>
    va0 = PGROUNDDOWN(dstva);
    80001772:	017c7933          	and	s2,s8,s7
    pa0 = walkaddr(pagetable, va0);
    80001776:	85ca                	mv	a1,s2
    80001778:	855a                	mv	a0,s6
    8000177a:	00000097          	auipc	ra,0x0
    8000177e:	97a080e7          	jalr	-1670(ra) # 800010f4 <walkaddr>
    if(pa0 == 0)
    80001782:	cd01                	beqz	a0,8000179a <copyout+0x72>
    n = PGSIZE - (dstva - va0);
    80001784:	418904b3          	sub	s1,s2,s8
    80001788:	94d6                	add	s1,s1,s5
    if(n > len)
    8000178a:	fc99f3e3          	bgeu	s3,s1,80001750 <copyout+0x28>
    8000178e:	84ce                	mv	s1,s3
    80001790:	b7c1                	j	80001750 <copyout+0x28>
  }
  return 0;
    80001792:	4501                	li	a0,0
    80001794:	a021                	j	8000179c <copyout+0x74>
    80001796:	4501                	li	a0,0
}
    80001798:	8082                	ret
      return -1;
    8000179a:	557d                	li	a0,-1
}
    8000179c:	60a6                	ld	ra,72(sp)
    8000179e:	6406                	ld	s0,64(sp)
    800017a0:	74e2                	ld	s1,56(sp)
    800017a2:	7942                	ld	s2,48(sp)
    800017a4:	79a2                	ld	s3,40(sp)
    800017a6:	7a02                	ld	s4,32(sp)
    800017a8:	6ae2                	ld	s5,24(sp)
    800017aa:	6b42                	ld	s6,16(sp)
    800017ac:	6ba2                	ld	s7,8(sp)
    800017ae:	6c02                	ld	s8,0(sp)
    800017b0:	6161                	addi	sp,sp,80
    800017b2:	8082                	ret

00000000800017b4 <copyin>:
int
copyin(pagetable_t pagetable, char *dst, uint64 srcva, uint64 len)
{
  uint64 n, va0, pa0;

  while(len > 0){
    800017b4:	caa5                	beqz	a3,80001824 <copyin+0x70>
{
    800017b6:	715d                	addi	sp,sp,-80
    800017b8:	e486                	sd	ra,72(sp)
    800017ba:	e0a2                	sd	s0,64(sp)
    800017bc:	fc26                	sd	s1,56(sp)
    800017be:	f84a                	sd	s2,48(sp)
    800017c0:	f44e                	sd	s3,40(sp)
    800017c2:	f052                	sd	s4,32(sp)
    800017c4:	ec56                	sd	s5,24(sp)
    800017c6:	e85a                	sd	s6,16(sp)
    800017c8:	e45e                	sd	s7,8(sp)
    800017ca:	e062                	sd	s8,0(sp)
    800017cc:	0880                	addi	s0,sp,80
    800017ce:	8b2a                	mv	s6,a0
    800017d0:	8a2e                	mv	s4,a1
    800017d2:	8c32                	mv	s8,a2
    800017d4:	89b6                	mv	s3,a3
    va0 = PGROUNDDOWN(srcva);
    800017d6:	7bfd                	lui	s7,0xfffff
    pa0 = walkaddr(pagetable, va0);
    if(pa0 == 0)
      return -1;
    n = PGSIZE - (srcva - va0);
    800017d8:	6a85                	lui	s5,0x1
    800017da:	a01d                	j	80001800 <copyin+0x4c>
    if(n > len)
      n = len;
    memmove(dst, (void *)(pa0 + (srcva - va0)), n);
    800017dc:	018505b3          	add	a1,a0,s8
    800017e0:	0004861b          	sext.w	a2,s1
    800017e4:	412585b3          	sub	a1,a1,s2
    800017e8:	8552                	mv	a0,s4
    800017ea:	fffff097          	auipc	ra,0xfffff
    800017ee:	5d0080e7          	jalr	1488(ra) # 80000dba <memmove>

    len -= n;
    800017f2:	409989b3          	sub	s3,s3,s1
    dst += n;
    800017f6:	9a26                	add	s4,s4,s1
    srcva = va0 + PGSIZE;
    800017f8:	01590c33          	add	s8,s2,s5
  while(len > 0){
    800017fc:	02098263          	beqz	s3,80001820 <copyin+0x6c>
    va0 = PGROUNDDOWN(srcva);
    80001800:	017c7933          	and	s2,s8,s7
    pa0 = walkaddr(pagetable, va0);
    80001804:	85ca                	mv	a1,s2
    80001806:	855a                	mv	a0,s6
    80001808:	00000097          	auipc	ra,0x0
    8000180c:	8ec080e7          	jalr	-1812(ra) # 800010f4 <walkaddr>
    if(pa0 == 0)
    80001810:	cd01                	beqz	a0,80001828 <copyin+0x74>
    n = PGSIZE - (srcva - va0);
    80001812:	418904b3          	sub	s1,s2,s8
    80001816:	94d6                	add	s1,s1,s5
    if(n > len)
    80001818:	fc99f2e3          	bgeu	s3,s1,800017dc <copyin+0x28>
    8000181c:	84ce                	mv	s1,s3
    8000181e:	bf7d                	j	800017dc <copyin+0x28>
  }
  return 0;
    80001820:	4501                	li	a0,0
    80001822:	a021                	j	8000182a <copyin+0x76>
    80001824:	4501                	li	a0,0
}
    80001826:	8082                	ret
      return -1;
    80001828:	557d                	li	a0,-1
}
    8000182a:	60a6                	ld	ra,72(sp)
    8000182c:	6406                	ld	s0,64(sp)
    8000182e:	74e2                	ld	s1,56(sp)
    80001830:	7942                	ld	s2,48(sp)
    80001832:	79a2                	ld	s3,40(sp)
    80001834:	7a02                	ld	s4,32(sp)
    80001836:	6ae2                	ld	s5,24(sp)
    80001838:	6b42                	ld	s6,16(sp)
    8000183a:	6ba2                	ld	s7,8(sp)
    8000183c:	6c02                	ld	s8,0(sp)
    8000183e:	6161                	addi	sp,sp,80
    80001840:	8082                	ret

0000000080001842 <copyinstr>:
copyinstr(pagetable_t pagetable, char *dst, uint64 srcva, uint64 max)
{
  uint64 n, va0, pa0;
  int got_null = 0;

  while(got_null == 0 && max > 0){
    80001842:	c6c5                	beqz	a3,800018ea <copyinstr+0xa8>
{
    80001844:	715d                	addi	sp,sp,-80
    80001846:	e486                	sd	ra,72(sp)
    80001848:	e0a2                	sd	s0,64(sp)
    8000184a:	fc26                	sd	s1,56(sp)
    8000184c:	f84a                	sd	s2,48(sp)
    8000184e:	f44e                	sd	s3,40(sp)
    80001850:	f052                	sd	s4,32(sp)
    80001852:	ec56                	sd	s5,24(sp)
    80001854:	e85a                	sd	s6,16(sp)
    80001856:	e45e                	sd	s7,8(sp)
    80001858:	0880                	addi	s0,sp,80
    8000185a:	8a2a                	mv	s4,a0
    8000185c:	8b2e                	mv	s6,a1
    8000185e:	8bb2                	mv	s7,a2
    80001860:	84b6                	mv	s1,a3
    va0 = PGROUNDDOWN(srcva);
    80001862:	7afd                	lui	s5,0xfffff
    pa0 = walkaddr(pagetable, va0);
    if(pa0 == 0)
      return -1;
    n = PGSIZE - (srcva - va0);
    80001864:	6985                	lui	s3,0x1
    80001866:	a035                	j	80001892 <copyinstr+0x50>
      n = max;

    char *p = (char *) (pa0 + (srcva - va0));
    while(n > 0){
      if(*p == '\0'){
        *dst = '\0';
    80001868:	00078023          	sb	zero,0(a5) # 1000 <_entry-0x7ffff000>
    8000186c:	4785                	li	a5,1
      dst++;
    }

    srcva = va0 + PGSIZE;
  }
  if(got_null){
    8000186e:	0017b793          	seqz	a5,a5
    80001872:	40f00533          	neg	a0,a5
    return 0;
  } else {
    return -1;
  }
}
    80001876:	60a6                	ld	ra,72(sp)
    80001878:	6406                	ld	s0,64(sp)
    8000187a:	74e2                	ld	s1,56(sp)
    8000187c:	7942                	ld	s2,48(sp)
    8000187e:	79a2                	ld	s3,40(sp)
    80001880:	7a02                	ld	s4,32(sp)
    80001882:	6ae2                	ld	s5,24(sp)
    80001884:	6b42                	ld	s6,16(sp)
    80001886:	6ba2                	ld	s7,8(sp)
    80001888:	6161                	addi	sp,sp,80
    8000188a:	8082                	ret
    srcva = va0 + PGSIZE;
    8000188c:	01390bb3          	add	s7,s2,s3
  while(got_null == 0 && max > 0){
    80001890:	c8a9                	beqz	s1,800018e2 <copyinstr+0xa0>
    va0 = PGROUNDDOWN(srcva);
    80001892:	015bf933          	and	s2,s7,s5
    pa0 = walkaddr(pagetable, va0);
    80001896:	85ca                	mv	a1,s2
    80001898:	8552                	mv	a0,s4
    8000189a:	00000097          	auipc	ra,0x0
    8000189e:	85a080e7          	jalr	-1958(ra) # 800010f4 <walkaddr>
    if(pa0 == 0)
    800018a2:	c131                	beqz	a0,800018e6 <copyinstr+0xa4>
    n = PGSIZE - (srcva - va0);
    800018a4:	41790833          	sub	a6,s2,s7
    800018a8:	984e                	add	a6,a6,s3
    if(n > max)
    800018aa:	0104f363          	bgeu	s1,a6,800018b0 <copyinstr+0x6e>
    800018ae:	8826                	mv	a6,s1
    char *p = (char *) (pa0 + (srcva - va0));
    800018b0:	955e                	add	a0,a0,s7
    800018b2:	41250533          	sub	a0,a0,s2
    while(n > 0){
    800018b6:	fc080be3          	beqz	a6,8000188c <copyinstr+0x4a>
    800018ba:	985a                	add	a6,a6,s6
    800018bc:	87da                	mv	a5,s6
      if(*p == '\0'){
    800018be:	41650633          	sub	a2,a0,s6
    800018c2:	14fd                	addi	s1,s1,-1
    800018c4:	9b26                	add	s6,s6,s1
    800018c6:	00f60733          	add	a4,a2,a5
    800018ca:	00074703          	lbu	a4,0(a4) # fffffffffffff000 <end+0xffffffff7ffd3000>
    800018ce:	df49                	beqz	a4,80001868 <copyinstr+0x26>
        *dst = *p;
    800018d0:	00e78023          	sb	a4,0(a5)
      --max;
    800018d4:	40fb04b3          	sub	s1,s6,a5
      dst++;
    800018d8:	0785                	addi	a5,a5,1
    while(n > 0){
    800018da:	ff0796e3          	bne	a5,a6,800018c6 <copyinstr+0x84>
      dst++;
    800018de:	8b42                	mv	s6,a6
    800018e0:	b775                	j	8000188c <copyinstr+0x4a>
    800018e2:	4781                	li	a5,0
    800018e4:	b769                	j	8000186e <copyinstr+0x2c>
      return -1;
    800018e6:	557d                	li	a0,-1
    800018e8:	b779                	j	80001876 <copyinstr+0x34>
  int got_null = 0;
    800018ea:	4781                	li	a5,0
  if(got_null){
    800018ec:	0017b793          	seqz	a5,a5
    800018f0:	40f00533          	neg	a0,a5
}
    800018f4:	8082                	ret

00000000800018f6 <wakeup1>:

// Wake up p if it is sleeping in wait(); used by exit().
// Caller must hold p->lock.
static void
wakeup1(struct proc *p)
{
    800018f6:	1101                	addi	sp,sp,-32
    800018f8:	ec06                	sd	ra,24(sp)
    800018fa:	e822                	sd	s0,16(sp)
    800018fc:	e426                	sd	s1,8(sp)
    800018fe:	1000                	addi	s0,sp,32
    80001900:	84aa                	mv	s1,a0
  if (!holding(&p->lock))
    80001902:	fffff097          	auipc	ra,0xfffff
    80001906:	2e6080e7          	jalr	742(ra) # 80000be8 <holding>
    8000190a:	c909                	beqz	a0,8000191c <wakeup1+0x26>
    panic("wakeup1");
  if (p->chan == p && p->state == SLEEPING)
    8000190c:	749c                	ld	a5,40(s1)
    8000190e:	00978f63          	beq	a5,s1,8000192c <wakeup1+0x36>
  {
    p->state = RUNNABLE;
  }
}
    80001912:	60e2                	ld	ra,24(sp)
    80001914:	6442                	ld	s0,16(sp)
    80001916:	64a2                	ld	s1,8(sp)
    80001918:	6105                	addi	sp,sp,32
    8000191a:	8082                	ret
    panic("wakeup1");
    8000191c:	00007517          	auipc	a0,0x7
    80001920:	8c450513          	addi	a0,a0,-1852 # 800081e0 <digits+0x188>
    80001924:	fffff097          	auipc	ra,0xfffff
    80001928:	cac080e7          	jalr	-852(ra) # 800005d0 <panic>
  if (p->chan == p && p->state == SLEEPING)
    8000192c:	4c98                	lw	a4,24(s1)
    8000192e:	4785                	li	a5,1
    80001930:	fef711e3          	bne	a4,a5,80001912 <wakeup1+0x1c>
    p->state = RUNNABLE;
    80001934:	4789                	li	a5,2
    80001936:	cc9c                	sw	a5,24(s1)
}
    80001938:	bfe9                	j	80001912 <wakeup1+0x1c>

000000008000193a <my_init>:
{
    8000193a:	1141                	addi	sp,sp,-16
    8000193c:	e422                	sd	s0,8(sp)
    8000193e:	0800                	addi	s0,sp,16
  for (int i = 0; i < 6; i++)
    80001940:	00010797          	auipc	a5,0x10
    80001944:	01078793          	addi	a5,a5,16 # 80011950 <proc_linklist_list>
    80001948:	00010717          	auipc	a4,0x10
    8000194c:	06870713          	addi	a4,a4,104 # 800119b0 <link_list_lock>
    proc_linklist_list[i].header = 0;
    80001950:	0007b023          	sd	zero,0(a5)
    proc_linklist_list[i].tail = 0;
    80001954:	0007b423          	sd	zero,8(a5)
  for (int i = 0; i < 6; i++)
    80001958:	07c1                	addi	a5,a5,16
    8000195a:	fee79be3          	bne	a5,a4,80001950 <my_init+0x16>
}
    8000195e:	6422                	ld	s0,8(sp)
    80001960:	0141                	addi	sp,sp,16
    80001962:	8082                	ret

0000000080001964 <insert_node_at_tail>:
  if (offset < 0 || offset >= 6)
    80001964:	4715                	li	a4,5
    80001966:	02a76963          	bltu	a4,a0,80001998 <insert_node_at_tail+0x34>
  if (list->header == 0)
    8000196a:	00451693          	slli	a3,a0,0x4
    8000196e:	00010717          	auipc	a4,0x10
    80001972:	fe270713          	addi	a4,a4,-30 # 80011950 <proc_linklist_list>
    80001976:	9736                	add	a4,a4,a3
    80001978:	6318                	ld	a4,0(a4)
    8000197a:	cf1d                	beqz	a4,800019b8 <insert_node_at_tail+0x54>
    list->tail->nextproc = p;
    8000197c:	00451793          	slli	a5,a0,0x4
    80001980:	00010717          	auipc	a4,0x10
    80001984:	fd070713          	addi	a4,a4,-48 # 80011950 <proc_linklist_list>
    80001988:	97ba                	add	a5,a5,a4
    8000198a:	6798                	ld	a4,8(a5)
    8000198c:	2cb73423          	sd	a1,712(a4)
    list->tail = p;
    80001990:	e78c                	sd	a1,8(a5)
  p->nextproc = 0; // 确保新节点的 nextproc 为空
    80001992:	2c05b423          	sd	zero,712(a1)
    80001996:	8082                	ret
{
    80001998:	1141                	addi	sp,sp,-16
    8000199a:	e406                	sd	ra,8(sp)
    8000199c:	e022                	sd	s0,0(sp)
    8000199e:	0800                	addi	s0,sp,16
    printf("Invalid offset!\n");
    800019a0:	00007517          	auipc	a0,0x7
    800019a4:	84850513          	addi	a0,a0,-1976 # 800081e8 <digits+0x190>
    800019a8:	fffff097          	auipc	ra,0xfffff
    800019ac:	c7a080e7          	jalr	-902(ra) # 80000622 <printf>
}
    800019b0:	60a2                	ld	ra,8(sp)
    800019b2:	6402                	ld	s0,0(sp)
    800019b4:	0141                	addi	sp,sp,16
    800019b6:	8082                	ret
    list->header = p;
    800019b8:	00010717          	auipc	a4,0x10
    800019bc:	f9870713          	addi	a4,a4,-104 # 80011950 <proc_linklist_list>
    800019c0:	00d707b3          	add	a5,a4,a3
    800019c4:	e38c                	sd	a1,0(a5)
    list->tail = p;
    800019c6:	e78c                	sd	a1,8(a5)
    800019c8:	b7e9                	j	80001992 <insert_node_at_tail+0x2e>

00000000800019ca <move_proc_between_lists>:
{
    800019ca:	1141                	addi	sp,sp,-16
    800019cc:	e406                	sd	ra,8(sp)
    800019ce:	e022                	sd	s0,0(sp)
    800019d0:	0800                	addi	s0,sp,16
  if (src_offset < 0 || src_offset >= 6 || dest_offset < 0 || dest_offset >= 6)
    800019d2:	4795                	li	a5,5
    800019d4:	06a7ed63          	bltu	a5,a0,80001a4e <move_proc_between_lists+0x84>
    800019d8:	86aa                	mv	a3,a0
    800019da:	0005879b          	sext.w	a5,a1
    800019de:	4715                	li	a4,5
    800019e0:	06f76763          	bltu	a4,a5,80001a4e <move_proc_between_lists+0x84>
  struct proc *curr = src_list->header;
    800019e4:	00451713          	slli	a4,a0,0x4
    800019e8:	00010797          	auipc	a5,0x10
    800019ec:	f6878793          	addi	a5,a5,-152 # 80011950 <proc_linklist_list>
    800019f0:	97ba                	add	a5,a5,a4
    800019f2:	639c                	ld	a5,0(a5)
  while (curr != 0 && curr != p)
    800019f4:	cbad                	beqz	a5,80001a66 <move_proc_between_lists+0x9c>
    800019f6:	08c78163          	beq	a5,a2,80001a78 <move_proc_between_lists+0xae>
    curr = curr->nextproc;
    800019fa:	873e                	mv	a4,a5
    800019fc:	2c87b783          	ld	a5,712(a5)
  while (curr != 0 && curr != p)
    80001a00:	c3bd                	beqz	a5,80001a66 <move_proc_between_lists+0x9c>
    80001a02:	fef61ce3          	bne	a2,a5,800019fa <move_proc_between_lists+0x30>
    prev->nextproc = curr->nextproc;
    80001a06:	2c87b603          	ld	a2,712(a5)
    80001a0a:	2cc73423          	sd	a2,712(a4)
  if (curr == src_list->tail)
    80001a0e:	00469513          	slli	a0,a3,0x4
    80001a12:	00010617          	auipc	a2,0x10
    80001a16:	f3e60613          	addi	a2,a2,-194 # 80011950 <proc_linklist_list>
    80001a1a:	962a                	add	a2,a2,a0
    80001a1c:	6610                	ld	a2,8(a2)
    80001a1e:	06f60a63          	beq	a2,a5,80001a92 <move_proc_between_lists+0xc8>
  curr->nextproc = 0;
    80001a22:	2c07b423          	sd	zero,712(a5)
  if (dest_list->header == 0)
    80001a26:	00459693          	slli	a3,a1,0x4
    80001a2a:	00010717          	auipc	a4,0x10
    80001a2e:	f2670713          	addi	a4,a4,-218 # 80011950 <proc_linklist_list>
    80001a32:	9736                	add	a4,a4,a3
    80001a34:	6318                	ld	a4,0(a4)
    80001a36:	c735                	beqz	a4,80001aa2 <move_proc_between_lists+0xd8>
    dest_list->tail->nextproc = curr;
    80001a38:	0592                	slli	a1,a1,0x4
    80001a3a:	00010717          	auipc	a4,0x10
    80001a3e:	f1670713          	addi	a4,a4,-234 # 80011950 <proc_linklist_list>
    80001a42:	95ba                	add	a1,a1,a4
    80001a44:	6598                	ld	a4,8(a1)
    80001a46:	2cf73423          	sd	a5,712(a4)
    dest_list->tail = curr;
    80001a4a:	e59c                	sd	a5,8(a1)
    80001a4c:	a809                	j	80001a5e <move_proc_between_lists+0x94>
    printf("Invalid offset!\n");
    80001a4e:	00006517          	auipc	a0,0x6
    80001a52:	79a50513          	addi	a0,a0,1946 # 800081e8 <digits+0x190>
    80001a56:	fffff097          	auipc	ra,0xfffff
    80001a5a:	bcc080e7          	jalr	-1076(ra) # 80000622 <printf>
}
    80001a5e:	60a2                	ld	ra,8(sp)
    80001a60:	6402                	ld	s0,0(sp)
    80001a62:	0141                	addi	sp,sp,16
    80001a64:	8082                	ret
    printf("Proc not found in source list!\n");
    80001a66:	00006517          	auipc	a0,0x6
    80001a6a:	79a50513          	addi	a0,a0,1946 # 80008200 <digits+0x1a8>
    80001a6e:	fffff097          	auipc	ra,0xfffff
    80001a72:	bb4080e7          	jalr	-1100(ra) # 80000622 <printf>
    return;
    80001a76:	b7e5                	j	80001a5e <move_proc_between_lists+0x94>
    src_list->header = curr->nextproc;
    80001a78:	00451713          	slli	a4,a0,0x4
    80001a7c:	00010797          	auipc	a5,0x10
    80001a80:	ed478793          	addi	a5,a5,-300 # 80011950 <proc_linklist_list>
    80001a84:	97ba                	add	a5,a5,a4
    80001a86:	2c863703          	ld	a4,712(a2)
    80001a8a:	e398                	sd	a4,0(a5)
  struct proc *curr = src_list->header;
    80001a8c:	87b2                	mv	a5,a2
  struct proc *prev = 0;
    80001a8e:	4701                	li	a4,0
    80001a90:	bfbd                	j	80001a0e <move_proc_between_lists+0x44>
    src_list->tail = prev;
    80001a92:	00010617          	auipc	a2,0x10
    80001a96:	ebe60613          	addi	a2,a2,-322 # 80011950 <proc_linklist_list>
    80001a9a:	00a606b3          	add	a3,a2,a0
    80001a9e:	e698                	sd	a4,8(a3)
    80001aa0:	b749                	j	80001a22 <move_proc_between_lists+0x58>
    dest_list->header = curr;
    80001aa2:	00010717          	auipc	a4,0x10
    80001aa6:	eae70713          	addi	a4,a4,-338 # 80011950 <proc_linklist_list>
    80001aaa:	00d705b3          	add	a1,a4,a3
    80001aae:	e19c                	sd	a5,0(a1)
    dest_list->tail = curr;
    80001ab0:	e59c                	sd	a5,8(a1)
    80001ab2:	b775                	j	80001a5e <move_proc_between_lists+0x94>

0000000080001ab4 <move_to_trash>:
{
    80001ab4:	1141                	addi	sp,sp,-16
    80001ab6:	e406                	sd	ra,8(sp)
    80001ab8:	e022                	sd	s0,0(sp)
    80001aba:	0800                	addi	s0,sp,16
  if (src_offset < 0 || src_offset >= 6)
    80001abc:	4795                	li	a5,5
    80001abe:	04a7ea63          	bltu	a5,a0,80001b12 <move_to_trash+0x5e>
    80001ac2:	86aa                	mv	a3,a0
  struct proc *curr = src_list->header;
    80001ac4:	00451713          	slli	a4,a0,0x4
    80001ac8:	00010797          	auipc	a5,0x10
    80001acc:	e8878793          	addi	a5,a5,-376 # 80011950 <proc_linklist_list>
    80001ad0:	97ba                	add	a5,a5,a4
    80001ad2:	639c                	ld	a5,0(a5)
  while (curr != 0 && curr != p)
    80001ad4:	cba1                	beqz	a5,80001b24 <move_to_trash+0x70>
    80001ad6:	06b78063          	beq	a5,a1,80001b36 <move_to_trash+0x82>
    curr = curr->nextproc;
    80001ada:	873e                	mv	a4,a5
    80001adc:	2c87b783          	ld	a5,712(a5)
  while (curr != 0 && curr != p)
    80001ae0:	c3b1                	beqz	a5,80001b24 <move_to_trash+0x70>
    80001ae2:	fef59ce3          	bne	a1,a5,80001ada <move_to_trash+0x26>
    prev->nextproc = curr->nextproc;
    80001ae6:	2c87b603          	ld	a2,712(a5)
    80001aea:	2cc73423          	sd	a2,712(a4)
  if (curr == src_list->tail)
    80001aee:	00469593          	slli	a1,a3,0x4
    80001af2:	00010617          	auipc	a2,0x10
    80001af6:	e5e60613          	addi	a2,a2,-418 # 80011950 <proc_linklist_list>
    80001afa:	962e                	add	a2,a2,a1
    80001afc:	6610                	ld	a2,8(a2)
    80001afe:	04f60963          	beq	a2,a5,80001b50 <move_to_trash+0x9c>
  dest_list->header = curr;
    80001b02:	00010717          	auipc	a4,0x10
    80001b06:	e8f73f23          	sd	a5,-354(a4) # 800119a0 <proc_linklist_list+0x50>
}
    80001b0a:	60a2                	ld	ra,8(sp)
    80001b0c:	6402                	ld	s0,0(sp)
    80001b0e:	0141                	addi	sp,sp,16
    80001b10:	8082                	ret
    printf("Invalid offset!\n");
    80001b12:	00006517          	auipc	a0,0x6
    80001b16:	6d650513          	addi	a0,a0,1750 # 800081e8 <digits+0x190>
    80001b1a:	fffff097          	auipc	ra,0xfffff
    80001b1e:	b08080e7          	jalr	-1272(ra) # 80000622 <printf>
    return;
    80001b22:	b7e5                	j	80001b0a <move_to_trash+0x56>
    printf("Proc not found in source list!\n");
    80001b24:	00006517          	auipc	a0,0x6
    80001b28:	6dc50513          	addi	a0,a0,1756 # 80008200 <digits+0x1a8>
    80001b2c:	fffff097          	auipc	ra,0xfffff
    80001b30:	af6080e7          	jalr	-1290(ra) # 80000622 <printf>
    return;
    80001b34:	bfd9                	j	80001b0a <move_to_trash+0x56>
    src_list->header = curr->nextproc;
    80001b36:	00451713          	slli	a4,a0,0x4
    80001b3a:	00010797          	auipc	a5,0x10
    80001b3e:	e1678793          	addi	a5,a5,-490 # 80011950 <proc_linklist_list>
    80001b42:	97ba                	add	a5,a5,a4
    80001b44:	2c85b703          	ld	a4,712(a1)
    80001b48:	e398                	sd	a4,0(a5)
  struct proc *curr = src_list->header;
    80001b4a:	87ae                	mv	a5,a1
  struct proc *prev = 0;
    80001b4c:	4701                	li	a4,0
    80001b4e:	b745                	j	80001aee <move_to_trash+0x3a>
    src_list->tail = prev;
    80001b50:	00010617          	auipc	a2,0x10
    80001b54:	e0060613          	addi	a2,a2,-512 # 80011950 <proc_linklist_list>
    80001b58:	00b606b3          	add	a3,a2,a1
    80001b5c:	e698                	sd	a4,8(a3)
    80001b5e:	b755                	j	80001b02 <move_to_trash+0x4e>

0000000080001b60 <free_node>:
{
    80001b60:	1101                	addi	sp,sp,-32
    80001b62:	ec06                	sd	ra,24(sp)
    80001b64:	e822                	sd	s0,16(sp)
    80001b66:	e426                	sd	s1,8(sp)
    80001b68:	1000                	addi	s0,sp,32
    80001b6a:	84aa                	mv	s1,a0
  acquire(&link_list_lock);
    80001b6c:	00010517          	auipc	a0,0x10
    80001b70:	e4450513          	addi	a0,a0,-444 # 800119b0 <link_list_lock>
    80001b74:	fffff097          	auipc	ra,0xfffff
    80001b78:	0ee080e7          	jalr	238(ra) # 80000c62 <acquire>
  struct proc *curr = list->header;
    80001b7c:	00010517          	auipc	a0,0x10
    80001b80:	e2453503          	ld	a0,-476(a0) # 800119a0 <proc_linklist_list+0x50>
  while (curr != 0)
    80001b84:	c929                	beqz	a0,80001bd6 <free_node+0x76>
    if (curr == p)
    80001b86:	06950863          	beq	a0,s1,80001bf6 <free_node+0x96>
    curr = curr->nextproc;
    80001b8a:	87aa                	mv	a5,a0
    80001b8c:	2c853503          	ld	a0,712(a0)
  while (curr != 0)
    80001b90:	c139                	beqz	a0,80001bd6 <free_node+0x76>
    if (curr == p)
    80001b92:	fea49ce3          	bne	s1,a0,80001b8a <free_node+0x2a>
        prev->nextproc = curr->nextproc;
    80001b96:	2c853703          	ld	a4,712(a0)
    80001b9a:	2ce7b423          	sd	a4,712(a5)
      if (curr == list->tail)
    80001b9e:	00010717          	auipc	a4,0x10
    80001ba2:	e0a73703          	ld	a4,-502(a4) # 800119a8 <proc_linklist_list+0x58>
    80001ba6:	02a70363          	beq	a4,a0,80001bcc <free_node+0x6c>
      kfree((void *)curr); // 释放内存
    80001baa:	fffff097          	auipc	ra,0xfffff
    80001bae:	ecc080e7          	jalr	-308(ra) # 80000a76 <kfree>
      release(&link_list_lock);
    80001bb2:	00010517          	auipc	a0,0x10
    80001bb6:	dfe50513          	addi	a0,a0,-514 # 800119b0 <link_list_lock>
    80001bba:	fffff097          	auipc	ra,0xfffff
    80001bbe:	15c080e7          	jalr	348(ra) # 80000d16 <release>
}
    80001bc2:	60e2                	ld	ra,24(sp)
    80001bc4:	6442                	ld	s0,16(sp)
    80001bc6:	64a2                	ld	s1,8(sp)
    80001bc8:	6105                	addi	sp,sp,32
    80001bca:	8082                	ret
        list->tail = prev;
    80001bcc:	00010717          	auipc	a4,0x10
    80001bd0:	dcf73e23          	sd	a5,-548(a4) # 800119a8 <proc_linklist_list+0x58>
    80001bd4:	bfd9                	j	80001baa <free_node+0x4a>
  release(&link_list_lock);
    80001bd6:	00010517          	auipc	a0,0x10
    80001bda:	dda50513          	addi	a0,a0,-550 # 800119b0 <link_list_lock>
    80001bde:	fffff097          	auipc	ra,0xfffff
    80001be2:	138080e7          	jalr	312(ra) # 80000d16 <release>
  panic("Node not found");
    80001be6:	00006517          	auipc	a0,0x6
    80001bea:	63a50513          	addi	a0,a0,1594 # 80008220 <digits+0x1c8>
    80001bee:	fffff097          	auipc	ra,0xfffff
    80001bf2:	9e2080e7          	jalr	-1566(ra) # 800005d0 <panic>
        list->header = curr->nextproc;
    80001bf6:	2c84b783          	ld	a5,712(s1)
    80001bfa:	00010717          	auipc	a4,0x10
    80001bfe:	daf73323          	sd	a5,-602(a4) # 800119a0 <proc_linklist_list+0x50>
  struct proc *curr = list->header;
    80001c02:	8526                	mv	a0,s1
  struct proc *prev = 0;
    80001c04:	4781                	li	a5,0
    80001c06:	bf61                	j	80001b9e <free_node+0x3e>

0000000080001c08 <free_node2>:
{
    80001c08:	1101                	addi	sp,sp,-32
    80001c0a:	ec06                	sd	ra,24(sp)
    80001c0c:	e822                	sd	s0,16(sp)
    80001c0e:	e426                	sd	s1,8(sp)
    80001c10:	1000                	addi	s0,sp,32
    80001c12:	84aa                	mv	s1,a0
  move_to_trash(p->priority, p);
    80001c14:	85aa                	mv	a1,a0
    80001c16:	2ac52503          	lw	a0,684(a0)
    80001c1a:	00000097          	auipc	ra,0x0
    80001c1e:	e9a080e7          	jalr	-358(ra) # 80001ab4 <move_to_trash>
  free_node(p);
    80001c22:	8526                	mv	a0,s1
    80001c24:	00000097          	auipc	ra,0x0
    80001c28:	f3c080e7          	jalr	-196(ra) # 80001b60 <free_node>
}
    80001c2c:	60e2                	ld	ra,24(sp)
    80001c2e:	6442                	ld	s0,16(sp)
    80001c30:	64a2                	ld	s1,8(sp)
    80001c32:	6105                	addi	sp,sp,32
    80001c34:	8082                	ret

0000000080001c36 <procinit>:
{
    80001c36:	715d                	addi	sp,sp,-80
    80001c38:	e486                	sd	ra,72(sp)
    80001c3a:	e0a2                	sd	s0,64(sp)
    80001c3c:	fc26                	sd	s1,56(sp)
    80001c3e:	f84a                	sd	s2,48(sp)
    80001c40:	f44e                	sd	s3,40(sp)
    80001c42:	f052                	sd	s4,32(sp)
    80001c44:	ec56                	sd	s5,24(sp)
    80001c46:	e85a                	sd	s6,16(sp)
    80001c48:	e45e                	sd	s7,8(sp)
    80001c4a:	0880                	addi	s0,sp,80
  initlock(&pid_lock, "nextpid");
    80001c4c:	00006597          	auipc	a1,0x6
    80001c50:	5e458593          	addi	a1,a1,1508 # 80008230 <digits+0x1d8>
    80001c54:	00010517          	auipc	a0,0x10
    80001c58:	d7450513          	addi	a0,a0,-652 # 800119c8 <pid_lock>
    80001c5c:	fffff097          	auipc	ra,0xfffff
    80001c60:	f76080e7          	jalr	-138(ra) # 80000bd2 <initlock>
  initlock(&link_list_lock, "lock_for_linklist");
    80001c64:	00006597          	auipc	a1,0x6
    80001c68:	5d458593          	addi	a1,a1,1492 # 80008238 <digits+0x1e0>
    80001c6c:	00010517          	auipc	a0,0x10
    80001c70:	d4450513          	addi	a0,a0,-700 # 800119b0 <link_list_lock>
    80001c74:	fffff097          	auipc	ra,0xfffff
    80001c78:	f5e080e7          	jalr	-162(ra) # 80000bd2 <initlock>
  for (p = proc; p < &proc[NPROC]; p++)
    80001c7c:	00010917          	auipc	s2,0x10
    80001c80:	16490913          	addi	s2,s2,356 # 80011de0 <proc>
    initlock(&p->lock, "proc");
    80001c84:	00006b97          	auipc	s7,0x6
    80001c88:	5ccb8b93          	addi	s7,s7,1484 # 80008250 <digits+0x1f8>
    uint64 va = KSTACK((int)(p - proc));
    80001c8c:	8b4a                	mv	s6,s2
    80001c8e:	00006a97          	auipc	s5,0x6
    80001c92:	372a8a93          	addi	s5,s5,882 # 80008000 <etext>
    80001c96:	040009b7          	lui	s3,0x4000
    80001c9a:	19fd                	addi	s3,s3,-1 # 3ffffff <_entry-0x7c000001>
    80001c9c:	09b2                	slli	s3,s3,0xc
  for (p = proc; p < &proc[NPROC]; p++)
    80001c9e:	0001ba17          	auipc	s4,0x1b
    80001ca2:	542a0a13          	addi	s4,s4,1346 # 8001d1e0 <tickslock>
    initlock(&p->lock, "proc");
    80001ca6:	85de                	mv	a1,s7
    80001ca8:	854a                	mv	a0,s2
    80001caa:	fffff097          	auipc	ra,0xfffff
    80001cae:	f28080e7          	jalr	-216(ra) # 80000bd2 <initlock>
    char *pa = kalloc();
    80001cb2:	fffff097          	auipc	ra,0xfffff
    80001cb6:	ec0080e7          	jalr	-320(ra) # 80000b72 <kalloc>
    80001cba:	85aa                	mv	a1,a0
    if (pa == 0)
    80001cbc:	c929                	beqz	a0,80001d0e <procinit+0xd8>
    uint64 va = KSTACK((int)(p - proc));
    80001cbe:	416904b3          	sub	s1,s2,s6
    80001cc2:	8491                	srai	s1,s1,0x4
    80001cc4:	000ab783          	ld	a5,0(s5)
    80001cc8:	02f484b3          	mul	s1,s1,a5
    80001ccc:	2485                	addiw	s1,s1,1
    80001cce:	00d4949b          	slliw	s1,s1,0xd
    80001cd2:	409984b3          	sub	s1,s3,s1
    kvmmap(va, (uint64)pa, PGSIZE, PTE_R | PTE_W);
    80001cd6:	4699                	li	a3,6
    80001cd8:	6605                	lui	a2,0x1
    80001cda:	8526                	mv	a0,s1
    80001cdc:	fffff097          	auipc	ra,0xfffff
    80001ce0:	546080e7          	jalr	1350(ra) # 80001222 <kvmmap>
    p->kstack = va;
    80001ce4:	04993023          	sd	s1,64(s2)
  for (p = proc; p < &proc[NPROC]; p++)
    80001ce8:	2d090913          	addi	s2,s2,720
    80001cec:	fb491de3          	bne	s2,s4,80001ca6 <procinit+0x70>
  kvminithart();
    80001cf0:	fffff097          	auipc	ra,0xfffff
    80001cf4:	33a080e7          	jalr	826(ra) # 8000102a <kvminithart>
}
    80001cf8:	60a6                	ld	ra,72(sp)
    80001cfa:	6406                	ld	s0,64(sp)
    80001cfc:	74e2                	ld	s1,56(sp)
    80001cfe:	7942                	ld	s2,48(sp)
    80001d00:	79a2                	ld	s3,40(sp)
    80001d02:	7a02                	ld	s4,32(sp)
    80001d04:	6ae2                	ld	s5,24(sp)
    80001d06:	6b42                	ld	s6,16(sp)
    80001d08:	6ba2                	ld	s7,8(sp)
    80001d0a:	6161                	addi	sp,sp,80
    80001d0c:	8082                	ret
      panic("kalloc");
    80001d0e:	00006517          	auipc	a0,0x6
    80001d12:	54a50513          	addi	a0,a0,1354 # 80008258 <digits+0x200>
    80001d16:	fffff097          	auipc	ra,0xfffff
    80001d1a:	8ba080e7          	jalr	-1862(ra) # 800005d0 <panic>

0000000080001d1e <cpuid>:
{
    80001d1e:	1141                	addi	sp,sp,-16
    80001d20:	e422                	sd	s0,8(sp)
    80001d22:	0800                	addi	s0,sp,16
  asm volatile("mv %0, tp" : "=r" (x) );
    80001d24:	8512                	mv	a0,tp
}
    80001d26:	2501                	sext.w	a0,a0
    80001d28:	6422                	ld	s0,8(sp)
    80001d2a:	0141                	addi	sp,sp,16
    80001d2c:	8082                	ret

0000000080001d2e <mycpu>:
{
    80001d2e:	1141                	addi	sp,sp,-16
    80001d30:	e422                	sd	s0,8(sp)
    80001d32:	0800                	addi	s0,sp,16
    80001d34:	8792                	mv	a5,tp
  struct cpu *c = &cpus[id];
    80001d36:	2781                	sext.w	a5,a5
    80001d38:	079e                	slli	a5,a5,0x7
}
    80001d3a:	00010517          	auipc	a0,0x10
    80001d3e:	ca650513          	addi	a0,a0,-858 # 800119e0 <cpus>
    80001d42:	953e                	add	a0,a0,a5
    80001d44:	6422                	ld	s0,8(sp)
    80001d46:	0141                	addi	sp,sp,16
    80001d48:	8082                	ret

0000000080001d4a <myproc>:
{
    80001d4a:	1101                	addi	sp,sp,-32
    80001d4c:	ec06                	sd	ra,24(sp)
    80001d4e:	e822                	sd	s0,16(sp)
    80001d50:	e426                	sd	s1,8(sp)
    80001d52:	1000                	addi	s0,sp,32
  push_off();
    80001d54:	fffff097          	auipc	ra,0xfffff
    80001d58:	ec2080e7          	jalr	-318(ra) # 80000c16 <push_off>
    80001d5c:	8792                	mv	a5,tp
  struct proc *p = c->proc;
    80001d5e:	2781                	sext.w	a5,a5
    80001d60:	079e                	slli	a5,a5,0x7
    80001d62:	00010717          	auipc	a4,0x10
    80001d66:	bee70713          	addi	a4,a4,-1042 # 80011950 <proc_linklist_list>
    80001d6a:	97ba                	add	a5,a5,a4
    80001d6c:	6bc4                	ld	s1,144(a5)
  pop_off();
    80001d6e:	fffff097          	auipc	ra,0xfffff
    80001d72:	f48080e7          	jalr	-184(ra) # 80000cb6 <pop_off>
}
    80001d76:	8526                	mv	a0,s1
    80001d78:	60e2                	ld	ra,24(sp)
    80001d7a:	6442                	ld	s0,16(sp)
    80001d7c:	64a2                	ld	s1,8(sp)
    80001d7e:	6105                	addi	sp,sp,32
    80001d80:	8082                	ret

0000000080001d82 <forkret>:
{
    80001d82:	1141                	addi	sp,sp,-16
    80001d84:	e406                	sd	ra,8(sp)
    80001d86:	e022                	sd	s0,0(sp)
    80001d88:	0800                	addi	s0,sp,16
  release(&myproc()->lock);
    80001d8a:	00000097          	auipc	ra,0x0
    80001d8e:	fc0080e7          	jalr	-64(ra) # 80001d4a <myproc>
    80001d92:	fffff097          	auipc	ra,0xfffff
    80001d96:	f84080e7          	jalr	-124(ra) # 80000d16 <release>
  if (first)
    80001d9a:	00007797          	auipc	a5,0x7
    80001d9e:	b667a783          	lw	a5,-1178(a5) # 80008900 <first.1>
    80001da2:	eb89                	bnez	a5,80001db4 <forkret+0x32>
  usertrapret();
    80001da4:	00001097          	auipc	ra,0x1
    80001da8:	cc6080e7          	jalr	-826(ra) # 80002a6a <usertrapret>
}
    80001dac:	60a2                	ld	ra,8(sp)
    80001dae:	6402                	ld	s0,0(sp)
    80001db0:	0141                	addi	sp,sp,16
    80001db2:	8082                	ret
    first = 0;
    80001db4:	00007797          	auipc	a5,0x7
    80001db8:	b407a623          	sw	zero,-1204(a5) # 80008900 <first.1>
    fsinit(ROOTDEV);
    80001dbc:	4505                	li	a0,1
    80001dbe:	00002097          	auipc	ra,0x2
    80001dc2:	c1c080e7          	jalr	-996(ra) # 800039da <fsinit>
    80001dc6:	bff9                	j	80001da4 <forkret+0x22>

0000000080001dc8 <allocpid>:
{
    80001dc8:	1101                	addi	sp,sp,-32
    80001dca:	ec06                	sd	ra,24(sp)
    80001dcc:	e822                	sd	s0,16(sp)
    80001dce:	e426                	sd	s1,8(sp)
    80001dd0:	e04a                	sd	s2,0(sp)
    80001dd2:	1000                	addi	s0,sp,32
  acquire(&pid_lock);
    80001dd4:	00010917          	auipc	s2,0x10
    80001dd8:	bf490913          	addi	s2,s2,-1036 # 800119c8 <pid_lock>
    80001ddc:	854a                	mv	a0,s2
    80001dde:	fffff097          	auipc	ra,0xfffff
    80001de2:	e84080e7          	jalr	-380(ra) # 80000c62 <acquire>
  pid = nextpid;
    80001de6:	00007797          	auipc	a5,0x7
    80001dea:	b1e78793          	addi	a5,a5,-1250 # 80008904 <nextpid>
    80001dee:	4384                	lw	s1,0(a5)
  nextpid = nextpid + 1;
    80001df0:	0014871b          	addiw	a4,s1,1
    80001df4:	c398                	sw	a4,0(a5)
  release(&pid_lock);
    80001df6:	854a                	mv	a0,s2
    80001df8:	fffff097          	auipc	ra,0xfffff
    80001dfc:	f1e080e7          	jalr	-226(ra) # 80000d16 <release>
}
    80001e00:	8526                	mv	a0,s1
    80001e02:	60e2                	ld	ra,24(sp)
    80001e04:	6442                	ld	s0,16(sp)
    80001e06:	64a2                	ld	s1,8(sp)
    80001e08:	6902                	ld	s2,0(sp)
    80001e0a:	6105                	addi	sp,sp,32
    80001e0c:	8082                	ret

0000000080001e0e <proc_pagetable>:
{
    80001e0e:	1101                	addi	sp,sp,-32
    80001e10:	ec06                	sd	ra,24(sp)
    80001e12:	e822                	sd	s0,16(sp)
    80001e14:	e426                	sd	s1,8(sp)
    80001e16:	e04a                	sd	s2,0(sp)
    80001e18:	1000                	addi	s0,sp,32
    80001e1a:	892a                	mv	s2,a0
  pagetable = uvmcreate();
    80001e1c:	fffff097          	auipc	ra,0xfffff
    80001e20:	5d4080e7          	jalr	1492(ra) # 800013f0 <uvmcreate>
    80001e24:	84aa                	mv	s1,a0
  if (pagetable == 0)
    80001e26:	c121                	beqz	a0,80001e66 <proc_pagetable+0x58>
  if (mappages(pagetable, TRAMPOLINE, PGSIZE,
    80001e28:	4729                	li	a4,10
    80001e2a:	00005697          	auipc	a3,0x5
    80001e2e:	1d668693          	addi	a3,a3,470 # 80007000 <_trampoline>
    80001e32:	6605                	lui	a2,0x1
    80001e34:	040005b7          	lui	a1,0x4000
    80001e38:	15fd                	addi	a1,a1,-1 # 3ffffff <_entry-0x7c000001>
    80001e3a:	05b2                	slli	a1,a1,0xc
    80001e3c:	fffff097          	auipc	ra,0xfffff
    80001e40:	358080e7          	jalr	856(ra) # 80001194 <mappages>
    80001e44:	02054863          	bltz	a0,80001e74 <proc_pagetable+0x66>
  if (mappages(pagetable, TRAPFRAME, PGSIZE,
    80001e48:	4719                	li	a4,6
    80001e4a:	05893683          	ld	a3,88(s2)
    80001e4e:	6605                	lui	a2,0x1
    80001e50:	020005b7          	lui	a1,0x2000
    80001e54:	15fd                	addi	a1,a1,-1 # 1ffffff <_entry-0x7e000001>
    80001e56:	05b6                	slli	a1,a1,0xd
    80001e58:	8526                	mv	a0,s1
    80001e5a:	fffff097          	auipc	ra,0xfffff
    80001e5e:	33a080e7          	jalr	826(ra) # 80001194 <mappages>
    80001e62:	02054163          	bltz	a0,80001e84 <proc_pagetable+0x76>
}
    80001e66:	8526                	mv	a0,s1
    80001e68:	60e2                	ld	ra,24(sp)
    80001e6a:	6442                	ld	s0,16(sp)
    80001e6c:	64a2                	ld	s1,8(sp)
    80001e6e:	6902                	ld	s2,0(sp)
    80001e70:	6105                	addi	sp,sp,32
    80001e72:	8082                	ret
    uvmfree(pagetable, 0);
    80001e74:	4581                	li	a1,0
    80001e76:	8526                	mv	a0,s1
    80001e78:	fffff097          	auipc	ra,0xfffff
    80001e7c:	774080e7          	jalr	1908(ra) # 800015ec <uvmfree>
    return 0;
    80001e80:	4481                	li	s1,0
    80001e82:	b7d5                	j	80001e66 <proc_pagetable+0x58>
    uvmunmap(pagetable, TRAMPOLINE, 1, 0);
    80001e84:	4681                	li	a3,0
    80001e86:	4605                	li	a2,1
    80001e88:	040005b7          	lui	a1,0x4000
    80001e8c:	15fd                	addi	a1,a1,-1 # 3ffffff <_entry-0x7c000001>
    80001e8e:	05b2                	slli	a1,a1,0xc
    80001e90:	8526                	mv	a0,s1
    80001e92:	fffff097          	auipc	ra,0xfffff
    80001e96:	49a080e7          	jalr	1178(ra) # 8000132c <uvmunmap>
    uvmfree(pagetable, 0);
    80001e9a:	4581                	li	a1,0
    80001e9c:	8526                	mv	a0,s1
    80001e9e:	fffff097          	auipc	ra,0xfffff
    80001ea2:	74e080e7          	jalr	1870(ra) # 800015ec <uvmfree>
    return 0;
    80001ea6:	4481                	li	s1,0
    80001ea8:	bf7d                	j	80001e66 <proc_pagetable+0x58>

0000000080001eaa <proc_freepagetable>:
{
    80001eaa:	1101                	addi	sp,sp,-32
    80001eac:	ec06                	sd	ra,24(sp)
    80001eae:	e822                	sd	s0,16(sp)
    80001eb0:	e426                	sd	s1,8(sp)
    80001eb2:	e04a                	sd	s2,0(sp)
    80001eb4:	1000                	addi	s0,sp,32
    80001eb6:	84aa                	mv	s1,a0
    80001eb8:	892e                	mv	s2,a1
  uvmunmap(pagetable, TRAMPOLINE, 1, 0);
    80001eba:	4681                	li	a3,0
    80001ebc:	4605                	li	a2,1
    80001ebe:	040005b7          	lui	a1,0x4000
    80001ec2:	15fd                	addi	a1,a1,-1 # 3ffffff <_entry-0x7c000001>
    80001ec4:	05b2                	slli	a1,a1,0xc
    80001ec6:	fffff097          	auipc	ra,0xfffff
    80001eca:	466080e7          	jalr	1126(ra) # 8000132c <uvmunmap>
  uvmunmap(pagetable, TRAPFRAME, 1, 0);
    80001ece:	4681                	li	a3,0
    80001ed0:	4605                	li	a2,1
    80001ed2:	020005b7          	lui	a1,0x2000
    80001ed6:	15fd                	addi	a1,a1,-1 # 1ffffff <_entry-0x7e000001>
    80001ed8:	05b6                	slli	a1,a1,0xd
    80001eda:	8526                	mv	a0,s1
    80001edc:	fffff097          	auipc	ra,0xfffff
    80001ee0:	450080e7          	jalr	1104(ra) # 8000132c <uvmunmap>
  uvmfree(pagetable, sz);
    80001ee4:	85ca                	mv	a1,s2
    80001ee6:	8526                	mv	a0,s1
    80001ee8:	fffff097          	auipc	ra,0xfffff
    80001eec:	704080e7          	jalr	1796(ra) # 800015ec <uvmfree>
}
    80001ef0:	60e2                	ld	ra,24(sp)
    80001ef2:	6442                	ld	s0,16(sp)
    80001ef4:	64a2                	ld	s1,8(sp)
    80001ef6:	6902                	ld	s2,0(sp)
    80001ef8:	6105                	addi	sp,sp,32
    80001efa:	8082                	ret

0000000080001efc <freeproc>:
{
    80001efc:	1101                	addi	sp,sp,-32
    80001efe:	ec06                	sd	ra,24(sp)
    80001f00:	e822                	sd	s0,16(sp)
    80001f02:	e426                	sd	s1,8(sp)
    80001f04:	1000                	addi	s0,sp,32
    80001f06:	84aa                	mv	s1,a0
  p->end_time = now;
    80001f08:	00007797          	auipc	a5,0x7
    80001f0c:	1187a783          	lw	a5,280(a5) # 80009020 <ticks>
    80001f10:	2af52e23          	sw	a5,700(a0)
  p->wait_time = p->end_time - p->start_time - p->worktime;
    80001f14:	2b852703          	lw	a4,696(a0)
    80001f18:	9f99                	subw	a5,a5,a4
    80001f1a:	2b052703          	lw	a4,688(a0)
    80001f1e:	9f99                	subw	a5,a5,a4
    80001f20:	2af52a23          	sw	a5,692(a0)
  if (p->trapframe)
    80001f24:	6d28                	ld	a0,88(a0)
    80001f26:	c509                	beqz	a0,80001f30 <freeproc+0x34>
    kfree((void *)p->trapframe);
    80001f28:	fffff097          	auipc	ra,0xfffff
    80001f2c:	b4e080e7          	jalr	-1202(ra) # 80000a76 <kfree>
  p->trapframe = 0;
    80001f30:	0404bc23          	sd	zero,88(s1)
  if (p->pagetable)
    80001f34:	68a8                	ld	a0,80(s1)
    80001f36:	c511                	beqz	a0,80001f42 <freeproc+0x46>
    proc_freepagetable(p->pagetable, p->sz);
    80001f38:	64ac                	ld	a1,72(s1)
    80001f3a:	00000097          	auipc	ra,0x0
    80001f3e:	f70080e7          	jalr	-144(ra) # 80001eaa <proc_freepagetable>
  p->pagetable = 0;
    80001f42:	0404b823          	sd	zero,80(s1)
  p->sz = 0;
    80001f46:	0404b423          	sd	zero,72(s1)
  p->pid = 0;
    80001f4a:	0204ac23          	sw	zero,56(s1)
  p->parent = 0;
    80001f4e:	0204b023          	sd	zero,32(s1)
  p->name[0] = 0;
    80001f52:	14048c23          	sb	zero,344(s1)
  p->chan = 0;
    80001f56:	0204b423          	sd	zero,40(s1)
  p->killed = 0;
    80001f5a:	0204a823          	sw	zero,48(s1)
  p->xstate = 0;
    80001f5e:	0204aa23          	sw	zero,52(s1)
  p->state = UNUSED;
    80001f62:	0004ac23          	sw	zero,24(s1)
  move_to_trash(p->priority, p);
    80001f66:	85a6                	mv	a1,s1
    80001f68:	2ac4a503          	lw	a0,684(s1)
    80001f6c:	00000097          	auipc	ra,0x0
    80001f70:	b48080e7          	jalr	-1208(ra) # 80001ab4 <move_to_trash>
}
    80001f74:	60e2                	ld	ra,24(sp)
    80001f76:	6442                	ld	s0,16(sp)
    80001f78:	64a2                	ld	s1,8(sp)
    80001f7a:	6105                	addi	sp,sp,32
    80001f7c:	8082                	ret

0000000080001f7e <allocproc>:
{
    80001f7e:	1101                	addi	sp,sp,-32
    80001f80:	ec06                	sd	ra,24(sp)
    80001f82:	e822                	sd	s0,16(sp)
    80001f84:	e426                	sd	s1,8(sp)
    80001f86:	e04a                	sd	s2,0(sp)
    80001f88:	1000                	addi	s0,sp,32
  for (p = proc; p < &proc[NPROC]; p++)
    80001f8a:	00010497          	auipc	s1,0x10
    80001f8e:	e5648493          	addi	s1,s1,-426 # 80011de0 <proc>
    80001f92:	0001b917          	auipc	s2,0x1b
    80001f96:	24e90913          	addi	s2,s2,590 # 8001d1e0 <tickslock>
    acquire(&p->lock);
    80001f9a:	8526                	mv	a0,s1
    80001f9c:	fffff097          	auipc	ra,0xfffff
    80001fa0:	cc6080e7          	jalr	-826(ra) # 80000c62 <acquire>
    if (p->state == UNUSED)
    80001fa4:	4c9c                	lw	a5,24(s1)
    80001fa6:	cf81                	beqz	a5,80001fbe <allocproc+0x40>
      release(&p->lock);
    80001fa8:	8526                	mv	a0,s1
    80001faa:	fffff097          	auipc	ra,0xfffff
    80001fae:	d6c080e7          	jalr	-660(ra) # 80000d16 <release>
  for (p = proc; p < &proc[NPROC]; p++)
    80001fb2:	2d048493          	addi	s1,s1,720
    80001fb6:	ff2492e3          	bne	s1,s2,80001f9a <allocproc+0x1c>
  return 0;
    80001fba:	4481                	li	s1,0
    80001fbc:	a871                	j	80002058 <allocproc+0xda>
  p->pid = allocpid();
    80001fbe:	00000097          	auipc	ra,0x0
    80001fc2:	e0a080e7          	jalr	-502(ra) # 80001dc8 <allocpid>
    80001fc6:	dc88                	sw	a0,56(s1)
  p->interval = 0;
    80001fc8:	1604a423          	sw	zero,360(s1)
  p->InHandler = 0;
    80001fcc:	1604a623          	sw	zero,364(s1)
  p->ticks = 0;
    80001fd0:	1604ac23          	sw	zero,376(s1)
  p->handler = 0;
    80001fd4:	1604b823          	sd	zero,368(s1)
  p->ticket_limit = LIMIT;
    80001fd8:	02000793          	li	a5,32
    80001fdc:	2af4a023          	sw	a5,672(s1)
  p->now_limit = ORIGIN_LIMIT;
    80001fe0:	4789                	li	a5,2
    80001fe2:	2af4a223          	sw	a5,676(s1)
  p->my_ticket = 0;
    80001fe6:	2a04a423          	sw	zero,680(s1)
  p->priority = 0;
    80001fea:	2a04a623          	sw	zero,684(s1)
  p->worktime = 0;
    80001fee:	2a04a823          	sw	zero,688(s1)
  p->wait_time = 0;
    80001ff2:	2a04aa23          	sw	zero,692(s1)
  p->end_time = 0;
    80001ff6:	2a04ae23          	sw	zero,700(s1)
  p->nextproc = 0;
    80001ffa:	2c04b423          	sd	zero,712(s1)
  insert_node_at_tail(0, p);
    80001ffe:	85a6                	mv	a1,s1
    80002000:	4501                	li	a0,0
    80002002:	00000097          	auipc	ra,0x0
    80002006:	962080e7          	jalr	-1694(ra) # 80001964 <insert_node_at_tail>
  if ((p->trapframe = (struct trapframe *)kalloc()) == 0)
    8000200a:	fffff097          	auipc	ra,0xfffff
    8000200e:	b68080e7          	jalr	-1176(ra) # 80000b72 <kalloc>
    80002012:	892a                	mv	s2,a0
    80002014:	eca8                	sd	a0,88(s1)
    80002016:	c921                	beqz	a0,80002066 <allocproc+0xe8>
  p->pagetable = proc_pagetable(p);
    80002018:	8526                	mv	a0,s1
    8000201a:	00000097          	auipc	ra,0x0
    8000201e:	df4080e7          	jalr	-524(ra) # 80001e0e <proc_pagetable>
    80002022:	892a                	mv	s2,a0
    80002024:	e8a8                	sd	a0,80(s1)
  if (p->pagetable == 0)
    80002026:	c539                	beqz	a0,80002074 <allocproc+0xf6>
  memset(&p->context, 0, sizeof(p->context));
    80002028:	07000613          	li	a2,112
    8000202c:	4581                	li	a1,0
    8000202e:	06048513          	addi	a0,s1,96
    80002032:	fffff097          	auipc	ra,0xfffff
    80002036:	d2c080e7          	jalr	-724(ra) # 80000d5e <memset>
  p->context.ra = (uint64)forkret;
    8000203a:	00000797          	auipc	a5,0x0
    8000203e:	d4878793          	addi	a5,a5,-696 # 80001d82 <forkret>
    80002042:	f0bc                	sd	a5,96(s1)
  p->context.sp = p->kstack + PGSIZE;
    80002044:	60bc                	ld	a5,64(s1)
    80002046:	6705                	lui	a4,0x1
    80002048:	97ba                	add	a5,a5,a4
    8000204a:	f4bc                	sd	a5,104(s1)
  p->start_time = ticks;
    8000204c:	00007797          	auipc	a5,0x7
    80002050:	fd47a783          	lw	a5,-44(a5) # 80009020 <ticks>
    80002054:	2af4ac23          	sw	a5,696(s1)
}
    80002058:	8526                	mv	a0,s1
    8000205a:	60e2                	ld	ra,24(sp)
    8000205c:	6442                	ld	s0,16(sp)
    8000205e:	64a2                	ld	s1,8(sp)
    80002060:	6902                	ld	s2,0(sp)
    80002062:	6105                	addi	sp,sp,32
    80002064:	8082                	ret
    release(&p->lock);
    80002066:	8526                	mv	a0,s1
    80002068:	fffff097          	auipc	ra,0xfffff
    8000206c:	cae080e7          	jalr	-850(ra) # 80000d16 <release>
    return 0;
    80002070:	84ca                	mv	s1,s2
    80002072:	b7dd                	j	80002058 <allocproc+0xda>
    freeproc(p);
    80002074:	8526                	mv	a0,s1
    80002076:	00000097          	auipc	ra,0x0
    8000207a:	e86080e7          	jalr	-378(ra) # 80001efc <freeproc>
    release(&p->lock);
    8000207e:	8526                	mv	a0,s1
    80002080:	fffff097          	auipc	ra,0xfffff
    80002084:	c96080e7          	jalr	-874(ra) # 80000d16 <release>
    return 0;
    80002088:	84ca                	mv	s1,s2
    8000208a:	b7f9                	j	80002058 <allocproc+0xda>

000000008000208c <userinit>:
{
    8000208c:	1101                	addi	sp,sp,-32
    8000208e:	ec06                	sd	ra,24(sp)
    80002090:	e822                	sd	s0,16(sp)
    80002092:	e426                	sd	s1,8(sp)
    80002094:	1000                	addi	s0,sp,32
  p = allocproc();
    80002096:	00000097          	auipc	ra,0x0
    8000209a:	ee8080e7          	jalr	-280(ra) # 80001f7e <allocproc>
    8000209e:	84aa                	mv	s1,a0
  initproc = p;
    800020a0:	00007797          	auipc	a5,0x7
    800020a4:	f6a7bc23          	sd	a0,-136(a5) # 80009018 <initproc>
  uvminit(p->pagetable, initcode, sizeof(initcode));
    800020a8:	03400613          	li	a2,52
    800020ac:	00007597          	auipc	a1,0x7
    800020b0:	86458593          	addi	a1,a1,-1948 # 80008910 <initcode>
    800020b4:	6928                	ld	a0,80(a0)
    800020b6:	fffff097          	auipc	ra,0xfffff
    800020ba:	368080e7          	jalr	872(ra) # 8000141e <uvminit>
  p->sz = PGSIZE;
    800020be:	6785                	lui	a5,0x1
    800020c0:	e4bc                	sd	a5,72(s1)
  p->trapframe->epc = 0;     // user program counter
    800020c2:	6cb8                	ld	a4,88(s1)
    800020c4:	00073c23          	sd	zero,24(a4) # 1018 <_entry-0x7fffefe8>
  p->trapframe->sp = PGSIZE; // user stack pointer
    800020c8:	6cb8                	ld	a4,88(s1)
    800020ca:	fb1c                	sd	a5,48(a4)
  safestrcpy(p->name, "initcode", sizeof(p->name));
    800020cc:	4641                	li	a2,16
    800020ce:	00006597          	auipc	a1,0x6
    800020d2:	19258593          	addi	a1,a1,402 # 80008260 <digits+0x208>
    800020d6:	15848513          	addi	a0,s1,344
    800020da:	fffff097          	auipc	ra,0xfffff
    800020de:	dd6080e7          	jalr	-554(ra) # 80000eb0 <safestrcpy>
  p->cwd = namei("/");
    800020e2:	00006517          	auipc	a0,0x6
    800020e6:	18e50513          	addi	a0,a0,398 # 80008270 <digits+0x218>
    800020ea:	00002097          	auipc	ra,0x2
    800020ee:	318080e7          	jalr	792(ra) # 80004402 <namei>
    800020f2:	14a4b823          	sd	a0,336(s1)
  p->state = RUNNABLE;
    800020f6:	4789                	li	a5,2
    800020f8:	cc9c                	sw	a5,24(s1)
  release(&p->lock);
    800020fa:	8526                	mv	a0,s1
    800020fc:	fffff097          	auipc	ra,0xfffff
    80002100:	c1a080e7          	jalr	-998(ra) # 80000d16 <release>
}
    80002104:	60e2                	ld	ra,24(sp)
    80002106:	6442                	ld	s0,16(sp)
    80002108:	64a2                	ld	s1,8(sp)
    8000210a:	6105                	addi	sp,sp,32
    8000210c:	8082                	ret

000000008000210e <growproc>:
{
    8000210e:	1101                	addi	sp,sp,-32
    80002110:	ec06                	sd	ra,24(sp)
    80002112:	e822                	sd	s0,16(sp)
    80002114:	e426                	sd	s1,8(sp)
    80002116:	e04a                	sd	s2,0(sp)
    80002118:	1000                	addi	s0,sp,32
    8000211a:	84aa                	mv	s1,a0
  struct proc *p = myproc();
    8000211c:	00000097          	auipc	ra,0x0
    80002120:	c2e080e7          	jalr	-978(ra) # 80001d4a <myproc>
    80002124:	892a                	mv	s2,a0
  sz = p->sz;
    80002126:	652c                	ld	a1,72(a0)
    80002128:	0005861b          	sext.w	a2,a1
  if (n > 0)
    8000212c:	00904f63          	bgtz	s1,8000214a <growproc+0x3c>
  else if (n < 0)
    80002130:	0204cc63          	bltz	s1,80002168 <growproc+0x5a>
  p->sz = sz;
    80002134:	1602                	slli	a2,a2,0x20
    80002136:	9201                	srli	a2,a2,0x20
    80002138:	04c93423          	sd	a2,72(s2)
  return 0;
    8000213c:	4501                	li	a0,0
}
    8000213e:	60e2                	ld	ra,24(sp)
    80002140:	6442                	ld	s0,16(sp)
    80002142:	64a2                	ld	s1,8(sp)
    80002144:	6902                	ld	s2,0(sp)
    80002146:	6105                	addi	sp,sp,32
    80002148:	8082                	ret
    if ((sz = uvmalloc(p->pagetable, sz, sz + n)) == 0)
    8000214a:	9e25                	addw	a2,a2,s1
    8000214c:	1602                	slli	a2,a2,0x20
    8000214e:	9201                	srli	a2,a2,0x20
    80002150:	1582                	slli	a1,a1,0x20
    80002152:	9181                	srli	a1,a1,0x20
    80002154:	6928                	ld	a0,80(a0)
    80002156:	fffff097          	auipc	ra,0xfffff
    8000215a:	382080e7          	jalr	898(ra) # 800014d8 <uvmalloc>
    8000215e:	0005061b          	sext.w	a2,a0
    80002162:	fa69                	bnez	a2,80002134 <growproc+0x26>
      return -1;
    80002164:	557d                	li	a0,-1
    80002166:	bfe1                	j	8000213e <growproc+0x30>
    sz = uvmdealloc(p->pagetable, sz, sz + n);
    80002168:	9e25                	addw	a2,a2,s1
    8000216a:	1602                	slli	a2,a2,0x20
    8000216c:	9201                	srli	a2,a2,0x20
    8000216e:	1582                	slli	a1,a1,0x20
    80002170:	9181                	srli	a1,a1,0x20
    80002172:	6928                	ld	a0,80(a0)
    80002174:	fffff097          	auipc	ra,0xfffff
    80002178:	31c080e7          	jalr	796(ra) # 80001490 <uvmdealloc>
    8000217c:	0005061b          	sext.w	a2,a0
    80002180:	bf55                	j	80002134 <growproc+0x26>

0000000080002182 <fork>:
{
    80002182:	7139                	addi	sp,sp,-64
    80002184:	fc06                	sd	ra,56(sp)
    80002186:	f822                	sd	s0,48(sp)
    80002188:	f426                	sd	s1,40(sp)
    8000218a:	f04a                	sd	s2,32(sp)
    8000218c:	ec4e                	sd	s3,24(sp)
    8000218e:	e852                	sd	s4,16(sp)
    80002190:	e456                	sd	s5,8(sp)
    80002192:	0080                	addi	s0,sp,64
  struct proc *p = myproc();
    80002194:	00000097          	auipc	ra,0x0
    80002198:	bb6080e7          	jalr	-1098(ra) # 80001d4a <myproc>
    8000219c:	8aaa                	mv	s5,a0
  if ((np = allocproc()) == 0)
    8000219e:	00000097          	auipc	ra,0x0
    800021a2:	de0080e7          	jalr	-544(ra) # 80001f7e <allocproc>
    800021a6:	c17d                	beqz	a0,8000228c <fork+0x10a>
    800021a8:	8a2a                	mv	s4,a0
  if (uvmcopy(p->pagetable, np->pagetable, p->sz) < 0)
    800021aa:	048ab603          	ld	a2,72(s5)
    800021ae:	692c                	ld	a1,80(a0)
    800021b0:	050ab503          	ld	a0,80(s5)
    800021b4:	fffff097          	auipc	ra,0xfffff
    800021b8:	470080e7          	jalr	1136(ra) # 80001624 <uvmcopy>
    800021bc:	04054a63          	bltz	a0,80002210 <fork+0x8e>
  np->sz = p->sz;
    800021c0:	048ab783          	ld	a5,72(s5)
    800021c4:	04fa3423          	sd	a5,72(s4)
  np->parent = p;
    800021c8:	035a3023          	sd	s5,32(s4)
  *(np->trapframe) = *(p->trapframe);
    800021cc:	058ab683          	ld	a3,88(s5)
    800021d0:	87b6                	mv	a5,a3
    800021d2:	058a3703          	ld	a4,88(s4)
    800021d6:	12068693          	addi	a3,a3,288
    800021da:	0007b803          	ld	a6,0(a5) # 1000 <_entry-0x7ffff000>
    800021de:	6788                	ld	a0,8(a5)
    800021e0:	6b8c                	ld	a1,16(a5)
    800021e2:	6f90                	ld	a2,24(a5)
    800021e4:	01073023          	sd	a6,0(a4)
    800021e8:	e708                	sd	a0,8(a4)
    800021ea:	eb0c                	sd	a1,16(a4)
    800021ec:	ef10                	sd	a2,24(a4)
    800021ee:	02078793          	addi	a5,a5,32
    800021f2:	02070713          	addi	a4,a4,32
    800021f6:	fed792e3          	bne	a5,a3,800021da <fork+0x58>
  np->trapframe->a0 = 0;
    800021fa:	058a3783          	ld	a5,88(s4)
    800021fe:	0607b823          	sd	zero,112(a5)
  for (i = 0; i < NOFILE; i++)
    80002202:	0d0a8493          	addi	s1,s5,208
    80002206:	0d0a0913          	addi	s2,s4,208
    8000220a:	150a8993          	addi	s3,s5,336
    8000220e:	a00d                	j	80002230 <fork+0xae>
    freeproc(np);
    80002210:	8552                	mv	a0,s4
    80002212:	00000097          	auipc	ra,0x0
    80002216:	cea080e7          	jalr	-790(ra) # 80001efc <freeproc>
    release(&np->lock);
    8000221a:	8552                	mv	a0,s4
    8000221c:	fffff097          	auipc	ra,0xfffff
    80002220:	afa080e7          	jalr	-1286(ra) # 80000d16 <release>
    return -1;
    80002224:	54fd                	li	s1,-1
    80002226:	a889                	j	80002278 <fork+0xf6>
  for (i = 0; i < NOFILE; i++)
    80002228:	04a1                	addi	s1,s1,8
    8000222a:	0921                	addi	s2,s2,8
    8000222c:	01348b63          	beq	s1,s3,80002242 <fork+0xc0>
    if (p->ofile[i])
    80002230:	6088                	ld	a0,0(s1)
    80002232:	d97d                	beqz	a0,80002228 <fork+0xa6>
      np->ofile[i] = filedup(p->ofile[i]);
    80002234:	00003097          	auipc	ra,0x3
    80002238:	85e080e7          	jalr	-1954(ra) # 80004a92 <filedup>
    8000223c:	00a93023          	sd	a0,0(s2)
    80002240:	b7e5                	j	80002228 <fork+0xa6>
  np->cwd = idup(p->cwd);
    80002242:	150ab503          	ld	a0,336(s5)
    80002246:	00002097          	auipc	ra,0x2
    8000224a:	9ce080e7          	jalr	-1586(ra) # 80003c14 <idup>
    8000224e:	14aa3823          	sd	a0,336(s4)
  safestrcpy(np->name, p->name, sizeof(p->name));
    80002252:	4641                	li	a2,16
    80002254:	158a8593          	addi	a1,s5,344
    80002258:	158a0513          	addi	a0,s4,344
    8000225c:	fffff097          	auipc	ra,0xfffff
    80002260:	c54080e7          	jalr	-940(ra) # 80000eb0 <safestrcpy>
  pid = np->pid;
    80002264:	038a2483          	lw	s1,56(s4)
  np->state = RUNNABLE;
    80002268:	4789                	li	a5,2
    8000226a:	00fa2c23          	sw	a5,24(s4)
  release(&np->lock);
    8000226e:	8552                	mv	a0,s4
    80002270:	fffff097          	auipc	ra,0xfffff
    80002274:	aa6080e7          	jalr	-1370(ra) # 80000d16 <release>
}
    80002278:	8526                	mv	a0,s1
    8000227a:	70e2                	ld	ra,56(sp)
    8000227c:	7442                	ld	s0,48(sp)
    8000227e:	74a2                	ld	s1,40(sp)
    80002280:	7902                	ld	s2,32(sp)
    80002282:	69e2                	ld	s3,24(sp)
    80002284:	6a42                	ld	s4,16(sp)
    80002286:	6aa2                	ld	s5,8(sp)
    80002288:	6121                	addi	sp,sp,64
    8000228a:	8082                	ret
    return -1;
    8000228c:	54fd                	li	s1,-1
    8000228e:	b7ed                	j	80002278 <fork+0xf6>

0000000080002290 <reparent>:
{
    80002290:	7179                	addi	sp,sp,-48
    80002292:	f406                	sd	ra,40(sp)
    80002294:	f022                	sd	s0,32(sp)
    80002296:	ec26                	sd	s1,24(sp)
    80002298:	e84a                	sd	s2,16(sp)
    8000229a:	e44e                	sd	s3,8(sp)
    8000229c:	e052                	sd	s4,0(sp)
    8000229e:	1800                	addi	s0,sp,48
    800022a0:	892a                	mv	s2,a0
  for (pp = proc; pp < &proc[NPROC]; pp++)
    800022a2:	00010497          	auipc	s1,0x10
    800022a6:	b3e48493          	addi	s1,s1,-1218 # 80011de0 <proc>
      pp->parent = initproc;
    800022aa:	00007a17          	auipc	s4,0x7
    800022ae:	d6ea0a13          	addi	s4,s4,-658 # 80009018 <initproc>
  for (pp = proc; pp < &proc[NPROC]; pp++)
    800022b2:	0001b997          	auipc	s3,0x1b
    800022b6:	f2e98993          	addi	s3,s3,-210 # 8001d1e0 <tickslock>
    800022ba:	a029                	j	800022c4 <reparent+0x34>
    800022bc:	2d048493          	addi	s1,s1,720
    800022c0:	03348363          	beq	s1,s3,800022e6 <reparent+0x56>
    if (pp->parent == p)
    800022c4:	709c                	ld	a5,32(s1)
    800022c6:	ff279be3          	bne	a5,s2,800022bc <reparent+0x2c>
      acquire(&pp->lock);
    800022ca:	8526                	mv	a0,s1
    800022cc:	fffff097          	auipc	ra,0xfffff
    800022d0:	996080e7          	jalr	-1642(ra) # 80000c62 <acquire>
      pp->parent = initproc;
    800022d4:	000a3783          	ld	a5,0(s4)
    800022d8:	f09c                	sd	a5,32(s1)
      release(&pp->lock);
    800022da:	8526                	mv	a0,s1
    800022dc:	fffff097          	auipc	ra,0xfffff
    800022e0:	a3a080e7          	jalr	-1478(ra) # 80000d16 <release>
    800022e4:	bfe1                	j	800022bc <reparent+0x2c>
}
    800022e6:	70a2                	ld	ra,40(sp)
    800022e8:	7402                	ld	s0,32(sp)
    800022ea:	64e2                	ld	s1,24(sp)
    800022ec:	6942                	ld	s2,16(sp)
    800022ee:	69a2                	ld	s3,8(sp)
    800022f0:	6a02                	ld	s4,0(sp)
    800022f2:	6145                	addi	sp,sp,48
    800022f4:	8082                	ret

00000000800022f6 <scheduler>:
{
    800022f6:	7159                	addi	sp,sp,-112
    800022f8:	f486                	sd	ra,104(sp)
    800022fa:	f0a2                	sd	s0,96(sp)
    800022fc:	eca6                	sd	s1,88(sp)
    800022fe:	e8ca                	sd	s2,80(sp)
    80002300:	e4ce                	sd	s3,72(sp)
    80002302:	e0d2                	sd	s4,64(sp)
    80002304:	fc56                	sd	s5,56(sp)
    80002306:	f85a                	sd	s6,48(sp)
    80002308:	f45e                	sd	s7,40(sp)
    8000230a:	f062                	sd	s8,32(sp)
    8000230c:	ec66                	sd	s9,24(sp)
    8000230e:	e86a                	sd	s10,16(sp)
    80002310:	e46e                	sd	s11,8(sp)
    80002312:	1880                	addi	s0,sp,112
    80002314:	8792                	mv	a5,tp
  int id = r_tp();
    80002316:	2781                	sext.w	a5,a5
  c->proc = 0;
    80002318:	00779d93          	slli	s11,a5,0x7
    8000231c:	0000f717          	auipc	a4,0xf
    80002320:	63470713          	addi	a4,a4,1588 # 80011950 <proc_linklist_list>
    80002324:	976e                	add	a4,a4,s11
    80002326:	08073823          	sd	zero,144(a4)
          swtch(&c->context, &p->context);
    8000232a:	0000f717          	auipc	a4,0xf
    8000232e:	6be70713          	addi	a4,a4,1726 # 800119e8 <cpus+0x8>
    80002332:	9dba                	add	s11,s11,a4
          p->last_start_time = ticks;
    80002334:	00007b17          	auipc	s6,0x7
    80002338:	cecb0b13          	addi	s6,s6,-788 # 80009020 <ticks>
          c->proc = p;
    8000233c:	079e                	slli	a5,a5,0x7
    8000233e:	0000fa97          	auipc	s5,0xf
    80002342:	612a8a93          	addi	s5,s5,1554 # 80011950 <proc_linklist_list>
    80002346:	9abe                	add	s5,s5,a5
    80002348:	a051                	j	800023cc <scheduler+0xd6>
        release(&p->lock);
    8000234a:	854a                	mv	a0,s2
    8000234c:	fffff097          	auipc	ra,0xfffff
    80002350:	9ca080e7          	jalr	-1590(ra) # 80000d16 <release>
        current = current->nextproc;
    80002354:	2c84b483          	ld	s1,712(s1)
      while (current != 0)
    80002358:	c4b9                	beqz	s1,800023a6 <scheduler+0xb0>
        acquire(&p->lock);
    8000235a:	8926                	mv	s2,s1
    8000235c:	8526                	mv	a0,s1
    8000235e:	fffff097          	auipc	ra,0xfffff
    80002362:	904080e7          	jalr	-1788(ra) # 80000c62 <acquire>
        if (p->state == RUNNABLE)
    80002366:	4c9c                	lw	a5,24(s1)
    80002368:	ff3791e3          	bne	a5,s3,8000234a <scheduler+0x54>
          p->state = RUNNING;
    8000236c:	01a4ac23          	sw	s10,24(s1)
          p->last_start_time = ticks;
    80002370:	000b2783          	lw	a5,0(s6)
    80002374:	2cf4a023          	sw	a5,704(s1)
          c->proc = p;
    80002378:	089ab823          	sd	s1,144(s5)
          swtch(&c->context, &p->context);
    8000237c:	06048593          	addi	a1,s1,96
    80002380:	856e                	mv	a0,s11
    80002382:	00000097          	auipc	ra,0x0
    80002386:	63e080e7          	jalr	1598(ra) # 800029c0 <swtch>
          p->worktime +=ticks-p->last_start_time;
    8000238a:	2b04a783          	lw	a5,688(s1)
    8000238e:	000b2703          	lw	a4,0(s6)
    80002392:	9fb9                	addw	a5,a5,a4
    80002394:	2c04a703          	lw	a4,704(s1)
    80002398:	9f99                	subw	a5,a5,a4
    8000239a:	2af4a823          	sw	a5,688(s1)
          c->proc = 0;
    8000239e:	080ab823          	sd	zero,144(s5)
          found = 1;
    800023a2:	8c5e                	mv	s8,s7
    800023a4:	b75d                	j	8000234a <scheduler+0x54>
    for (int i = 0; i < 5; i++)
    800023a6:	0a41                	addi	s4,s4,16
    800023a8:	019a0863          	beq	s4,s9,800023b8 <scheduler+0xc2>
      if (list->header == 0)
    800023ac:	000a3483          	ld	s1,0(s4)
    800023b0:	d8fd                	beqz	s1,800023a6 <scheduler+0xb0>
        if (p->state == RUNNABLE)
    800023b2:	4989                	li	s3,2
          found = 1;
    800023b4:	4b85                	li	s7,1
    800023b6:	b755                	j	8000235a <scheduler+0x64>
        if (found == 0)
    800023b8:	000c1b63          	bnez	s8,800023ce <scheduler+0xd8>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    800023bc:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    800023c0:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    800023c4:	10079073          	csrw	sstatus,a5
          asm volatile("wfi");
    800023c8:	10500073          	wfi
          p->state = RUNNING;
    800023cc:	4d0d                	li	s10,3
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    800023ce:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    800023d2:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    800023d6:	10079073          	csrw	sstatus,a5
    for (int i = 0; i < 5; i++)
    800023da:	0000fa17          	auipc	s4,0xf
    800023de:	576a0a13          	addi	s4,s4,1398 # 80011950 <proc_linklist_list>
    800023e2:	0000fc97          	auipc	s9,0xf
    800023e6:	5bec8c93          	addi	s9,s9,1470 # 800119a0 <proc_linklist_list+0x50>
    int found = 0;
    800023ea:	4c01                	li	s8,0
    800023ec:	b7c1                	j	800023ac <scheduler+0xb6>

00000000800023ee <sched>:
{
    800023ee:	7179                	addi	sp,sp,-48
    800023f0:	f406                	sd	ra,40(sp)
    800023f2:	f022                	sd	s0,32(sp)
    800023f4:	ec26                	sd	s1,24(sp)
    800023f6:	e84a                	sd	s2,16(sp)
    800023f8:	e44e                	sd	s3,8(sp)
    800023fa:	1800                	addi	s0,sp,48
  struct proc *p = myproc();
    800023fc:	00000097          	auipc	ra,0x0
    80002400:	94e080e7          	jalr	-1714(ra) # 80001d4a <myproc>
    80002404:	84aa                	mv	s1,a0
  if (!holding(&p->lock))
    80002406:	ffffe097          	auipc	ra,0xffffe
    8000240a:	7e2080e7          	jalr	2018(ra) # 80000be8 <holding>
    8000240e:	c93d                	beqz	a0,80002484 <sched+0x96>
  asm volatile("mv %0, tp" : "=r" (x) );
    80002410:	8792                	mv	a5,tp
  if (mycpu()->noff != 1)
    80002412:	2781                	sext.w	a5,a5
    80002414:	079e                	slli	a5,a5,0x7
    80002416:	0000f717          	auipc	a4,0xf
    8000241a:	53a70713          	addi	a4,a4,1338 # 80011950 <proc_linklist_list>
    8000241e:	97ba                	add	a5,a5,a4
    80002420:	1087a703          	lw	a4,264(a5)
    80002424:	4785                	li	a5,1
    80002426:	06f71763          	bne	a4,a5,80002494 <sched+0xa6>
  if (p->state == RUNNING)
    8000242a:	4c98                	lw	a4,24(s1)
    8000242c:	478d                	li	a5,3
    8000242e:	06f70b63          	beq	a4,a5,800024a4 <sched+0xb6>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002432:	100027f3          	csrr	a5,sstatus
  return (x & SSTATUS_SIE) != 0;
    80002436:	8b89                	andi	a5,a5,2
  if (intr_get())
    80002438:	efb5                	bnez	a5,800024b4 <sched+0xc6>
  asm volatile("mv %0, tp" : "=r" (x) );
    8000243a:	8792                	mv	a5,tp
  intena = mycpu()->intena;
    8000243c:	0000f917          	auipc	s2,0xf
    80002440:	51490913          	addi	s2,s2,1300 # 80011950 <proc_linklist_list>
    80002444:	2781                	sext.w	a5,a5
    80002446:	079e                	slli	a5,a5,0x7
    80002448:	97ca                	add	a5,a5,s2
    8000244a:	10c7a983          	lw	s3,268(a5)
    8000244e:	8792                	mv	a5,tp
  swtch(&p->context, &mycpu()->context);
    80002450:	2781                	sext.w	a5,a5
    80002452:	079e                	slli	a5,a5,0x7
    80002454:	0000f597          	auipc	a1,0xf
    80002458:	59458593          	addi	a1,a1,1428 # 800119e8 <cpus+0x8>
    8000245c:	95be                	add	a1,a1,a5
    8000245e:	06048513          	addi	a0,s1,96
    80002462:	00000097          	auipc	ra,0x0
    80002466:	55e080e7          	jalr	1374(ra) # 800029c0 <swtch>
    8000246a:	8792                	mv	a5,tp
  mycpu()->intena = intena;
    8000246c:	2781                	sext.w	a5,a5
    8000246e:	079e                	slli	a5,a5,0x7
    80002470:	97ca                	add	a5,a5,s2
    80002472:	1137a623          	sw	s3,268(a5)
}
    80002476:	70a2                	ld	ra,40(sp)
    80002478:	7402                	ld	s0,32(sp)
    8000247a:	64e2                	ld	s1,24(sp)
    8000247c:	6942                	ld	s2,16(sp)
    8000247e:	69a2                	ld	s3,8(sp)
    80002480:	6145                	addi	sp,sp,48
    80002482:	8082                	ret
    panic("sched p->lock");
    80002484:	00006517          	auipc	a0,0x6
    80002488:	df450513          	addi	a0,a0,-524 # 80008278 <digits+0x220>
    8000248c:	ffffe097          	auipc	ra,0xffffe
    80002490:	144080e7          	jalr	324(ra) # 800005d0 <panic>
    panic("sched locks");
    80002494:	00006517          	auipc	a0,0x6
    80002498:	df450513          	addi	a0,a0,-524 # 80008288 <digits+0x230>
    8000249c:	ffffe097          	auipc	ra,0xffffe
    800024a0:	134080e7          	jalr	308(ra) # 800005d0 <panic>
    panic("sched running");
    800024a4:	00006517          	auipc	a0,0x6
    800024a8:	df450513          	addi	a0,a0,-524 # 80008298 <digits+0x240>
    800024ac:	ffffe097          	auipc	ra,0xffffe
    800024b0:	124080e7          	jalr	292(ra) # 800005d0 <panic>
    panic("sched interruptible");
    800024b4:	00006517          	auipc	a0,0x6
    800024b8:	df450513          	addi	a0,a0,-524 # 800082a8 <digits+0x250>
    800024bc:	ffffe097          	auipc	ra,0xffffe
    800024c0:	114080e7          	jalr	276(ra) # 800005d0 <panic>

00000000800024c4 <exit>:
{
    800024c4:	7179                	addi	sp,sp,-48
    800024c6:	f406                	sd	ra,40(sp)
    800024c8:	f022                	sd	s0,32(sp)
    800024ca:	ec26                	sd	s1,24(sp)
    800024cc:	e84a                	sd	s2,16(sp)
    800024ce:	e44e                	sd	s3,8(sp)
    800024d0:	e052                	sd	s4,0(sp)
    800024d2:	1800                	addi	s0,sp,48
    800024d4:	8a2a                	mv	s4,a0
  struct proc *p = myproc();
    800024d6:	00000097          	auipc	ra,0x0
    800024da:	874080e7          	jalr	-1932(ra) # 80001d4a <myproc>
    800024de:	89aa                	mv	s3,a0
  if (p == initproc)
    800024e0:	00007797          	auipc	a5,0x7
    800024e4:	b387b783          	ld	a5,-1224(a5) # 80009018 <initproc>
    800024e8:	0d050493          	addi	s1,a0,208
    800024ec:	15050913          	addi	s2,a0,336
    800024f0:	02a79363          	bne	a5,a0,80002516 <exit+0x52>
    panic("init exiting");
    800024f4:	00006517          	auipc	a0,0x6
    800024f8:	dcc50513          	addi	a0,a0,-564 # 800082c0 <digits+0x268>
    800024fc:	ffffe097          	auipc	ra,0xffffe
    80002500:	0d4080e7          	jalr	212(ra) # 800005d0 <panic>
      fileclose(f);
    80002504:	00002097          	auipc	ra,0x2
    80002508:	5e0080e7          	jalr	1504(ra) # 80004ae4 <fileclose>
      p->ofile[fd] = 0;
    8000250c:	0004b023          	sd	zero,0(s1)
  for (int fd = 0; fd < NOFILE; fd++)
    80002510:	04a1                	addi	s1,s1,8
    80002512:	01248563          	beq	s1,s2,8000251c <exit+0x58>
    if (p->ofile[fd])
    80002516:	6088                	ld	a0,0(s1)
    80002518:	f575                	bnez	a0,80002504 <exit+0x40>
    8000251a:	bfdd                	j	80002510 <exit+0x4c>
  begin_op();
    8000251c:	00002097          	auipc	ra,0x2
    80002520:	0f6080e7          	jalr	246(ra) # 80004612 <begin_op>
  iput(p->cwd);
    80002524:	1509b503          	ld	a0,336(s3)
    80002528:	00002097          	auipc	ra,0x2
    8000252c:	8e4080e7          	jalr	-1820(ra) # 80003e0c <iput>
  end_op();
    80002530:	00002097          	auipc	ra,0x2
    80002534:	162080e7          	jalr	354(ra) # 80004692 <end_op>
  p->cwd = 0;
    80002538:	1409b823          	sd	zero,336(s3)
  acquire(&initproc->lock);
    8000253c:	00007497          	auipc	s1,0x7
    80002540:	adc48493          	addi	s1,s1,-1316 # 80009018 <initproc>
    80002544:	6088                	ld	a0,0(s1)
    80002546:	ffffe097          	auipc	ra,0xffffe
    8000254a:	71c080e7          	jalr	1820(ra) # 80000c62 <acquire>
  wakeup1(initproc);
    8000254e:	6088                	ld	a0,0(s1)
    80002550:	fffff097          	auipc	ra,0xfffff
    80002554:	3a6080e7          	jalr	934(ra) # 800018f6 <wakeup1>
  release(&initproc->lock);
    80002558:	6088                	ld	a0,0(s1)
    8000255a:	ffffe097          	auipc	ra,0xffffe
    8000255e:	7bc080e7          	jalr	1980(ra) # 80000d16 <release>
  acquire(&p->lock);
    80002562:	854e                	mv	a0,s3
    80002564:	ffffe097          	auipc	ra,0xffffe
    80002568:	6fe080e7          	jalr	1790(ra) # 80000c62 <acquire>
  struct proc *original_parent = p->parent;
    8000256c:	0209b483          	ld	s1,32(s3)
  release(&p->lock);
    80002570:	854e                	mv	a0,s3
    80002572:	ffffe097          	auipc	ra,0xffffe
    80002576:	7a4080e7          	jalr	1956(ra) # 80000d16 <release>
  acquire(&original_parent->lock);
    8000257a:	8526                	mv	a0,s1
    8000257c:	ffffe097          	auipc	ra,0xffffe
    80002580:	6e6080e7          	jalr	1766(ra) # 80000c62 <acquire>
  acquire(&p->lock);
    80002584:	854e                	mv	a0,s3
    80002586:	ffffe097          	auipc	ra,0xffffe
    8000258a:	6dc080e7          	jalr	1756(ra) # 80000c62 <acquire>
  reparent(p);
    8000258e:	854e                	mv	a0,s3
    80002590:	00000097          	auipc	ra,0x0
    80002594:	d00080e7          	jalr	-768(ra) # 80002290 <reparent>
  wakeup1(original_parent);
    80002598:	8526                	mv	a0,s1
    8000259a:	fffff097          	auipc	ra,0xfffff
    8000259e:	35c080e7          	jalr	860(ra) # 800018f6 <wakeup1>
  p->xstate = status;
    800025a2:	0349aa23          	sw	s4,52(s3)
  p->state = ZOMBIE;
    800025a6:	4791                	li	a5,4
    800025a8:	00f9ac23          	sw	a5,24(s3)
  release(&original_parent->lock);
    800025ac:	8526                	mv	a0,s1
    800025ae:	ffffe097          	auipc	ra,0xffffe
    800025b2:	768080e7          	jalr	1896(ra) # 80000d16 <release>
  sched();
    800025b6:	00000097          	auipc	ra,0x0
    800025ba:	e38080e7          	jalr	-456(ra) # 800023ee <sched>
  panic("zombie exit");
    800025be:	00006517          	auipc	a0,0x6
    800025c2:	d1250513          	addi	a0,a0,-750 # 800082d0 <digits+0x278>
    800025c6:	ffffe097          	auipc	ra,0xffffe
    800025ca:	00a080e7          	jalr	10(ra) # 800005d0 <panic>

00000000800025ce <yield>:
{
    800025ce:	1101                	addi	sp,sp,-32
    800025d0:	ec06                	sd	ra,24(sp)
    800025d2:	e822                	sd	s0,16(sp)
    800025d4:	e426                	sd	s1,8(sp)
    800025d6:	1000                	addi	s0,sp,32
  struct proc *p = myproc();
    800025d8:	fffff097          	auipc	ra,0xfffff
    800025dc:	772080e7          	jalr	1906(ra) # 80001d4a <myproc>
    800025e0:	84aa                	mv	s1,a0
  acquire(&p->lock);
    800025e2:	ffffe097          	auipc	ra,0xffffe
    800025e6:	680080e7          	jalr	1664(ra) # 80000c62 <acquire>
  p->state = RUNNABLE;
    800025ea:	4789                	li	a5,2
    800025ec:	cc9c                	sw	a5,24(s1)
  sched();
    800025ee:	00000097          	auipc	ra,0x0
    800025f2:	e00080e7          	jalr	-512(ra) # 800023ee <sched>
  release(&p->lock);
    800025f6:	8526                	mv	a0,s1
    800025f8:	ffffe097          	auipc	ra,0xffffe
    800025fc:	71e080e7          	jalr	1822(ra) # 80000d16 <release>
}
    80002600:	60e2                	ld	ra,24(sp)
    80002602:	6442                	ld	s0,16(sp)
    80002604:	64a2                	ld	s1,8(sp)
    80002606:	6105                	addi	sp,sp,32
    80002608:	8082                	ret

000000008000260a <sleep>:
{
    8000260a:	7179                	addi	sp,sp,-48
    8000260c:	f406                	sd	ra,40(sp)
    8000260e:	f022                	sd	s0,32(sp)
    80002610:	ec26                	sd	s1,24(sp)
    80002612:	e84a                	sd	s2,16(sp)
    80002614:	e44e                	sd	s3,8(sp)
    80002616:	1800                	addi	s0,sp,48
    80002618:	89aa                	mv	s3,a0
    8000261a:	892e                	mv	s2,a1
  struct proc *p = myproc();
    8000261c:	fffff097          	auipc	ra,0xfffff
    80002620:	72e080e7          	jalr	1838(ra) # 80001d4a <myproc>
    80002624:	84aa                	mv	s1,a0
  if (lk != &p->lock)
    80002626:	05250663          	beq	a0,s2,80002672 <sleep+0x68>
    acquire(&p->lock); // DOC: sleeplock1
    8000262a:	ffffe097          	auipc	ra,0xffffe
    8000262e:	638080e7          	jalr	1592(ra) # 80000c62 <acquire>
    release(lk);
    80002632:	854a                	mv	a0,s2
    80002634:	ffffe097          	auipc	ra,0xffffe
    80002638:	6e2080e7          	jalr	1762(ra) # 80000d16 <release>
  p->chan = chan;
    8000263c:	0334b423          	sd	s3,40(s1)
  p->state = SLEEPING;
    80002640:	4785                	li	a5,1
    80002642:	cc9c                	sw	a5,24(s1)
  sched();
    80002644:	00000097          	auipc	ra,0x0
    80002648:	daa080e7          	jalr	-598(ra) # 800023ee <sched>
  p->chan = 0;
    8000264c:	0204b423          	sd	zero,40(s1)
    release(&p->lock);
    80002650:	8526                	mv	a0,s1
    80002652:	ffffe097          	auipc	ra,0xffffe
    80002656:	6c4080e7          	jalr	1732(ra) # 80000d16 <release>
    acquire(lk);
    8000265a:	854a                	mv	a0,s2
    8000265c:	ffffe097          	auipc	ra,0xffffe
    80002660:	606080e7          	jalr	1542(ra) # 80000c62 <acquire>
}
    80002664:	70a2                	ld	ra,40(sp)
    80002666:	7402                	ld	s0,32(sp)
    80002668:	64e2                	ld	s1,24(sp)
    8000266a:	6942                	ld	s2,16(sp)
    8000266c:	69a2                	ld	s3,8(sp)
    8000266e:	6145                	addi	sp,sp,48
    80002670:	8082                	ret
  p->chan = chan;
    80002672:	03353423          	sd	s3,40(a0)
  p->state = SLEEPING;
    80002676:	4785                	li	a5,1
    80002678:	cd1c                	sw	a5,24(a0)
  sched();
    8000267a:	00000097          	auipc	ra,0x0
    8000267e:	d74080e7          	jalr	-652(ra) # 800023ee <sched>
  p->chan = 0;
    80002682:	0204b423          	sd	zero,40(s1)
  if (lk != &p->lock)
    80002686:	bff9                	j	80002664 <sleep+0x5a>

0000000080002688 <wait>:
{
    80002688:	715d                	addi	sp,sp,-80
    8000268a:	e486                	sd	ra,72(sp)
    8000268c:	e0a2                	sd	s0,64(sp)
    8000268e:	fc26                	sd	s1,56(sp)
    80002690:	f84a                	sd	s2,48(sp)
    80002692:	f44e                	sd	s3,40(sp)
    80002694:	f052                	sd	s4,32(sp)
    80002696:	ec56                	sd	s5,24(sp)
    80002698:	e85a                	sd	s6,16(sp)
    8000269a:	e45e                	sd	s7,8(sp)
    8000269c:	0880                	addi	s0,sp,80
    8000269e:	8b2a                	mv	s6,a0
  struct proc *p = myproc();
    800026a0:	fffff097          	auipc	ra,0xfffff
    800026a4:	6aa080e7          	jalr	1706(ra) # 80001d4a <myproc>
    800026a8:	892a                	mv	s2,a0
  acquire(&p->lock);
    800026aa:	ffffe097          	auipc	ra,0xffffe
    800026ae:	5b8080e7          	jalr	1464(ra) # 80000c62 <acquire>
    havekids = 0;
    800026b2:	4b81                	li	s7,0
        if (np->state == ZOMBIE)
    800026b4:	4a11                	li	s4,4
        havekids = 1;
    800026b6:	4a85                	li	s5,1
    for (np = proc; np < &proc[NPROC]; np++)
    800026b8:	0001b997          	auipc	s3,0x1b
    800026bc:	b2898993          	addi	s3,s3,-1240 # 8001d1e0 <tickslock>
    havekids = 0;
    800026c0:	875e                	mv	a4,s7
    for (np = proc; np < &proc[NPROC]; np++)
    800026c2:	0000f497          	auipc	s1,0xf
    800026c6:	71e48493          	addi	s1,s1,1822 # 80011de0 <proc>
    800026ca:	a08d                	j	8000272c <wait+0xa4>
          pid = np->pid;
    800026cc:	0384a983          	lw	s3,56(s1)
          if (addr != 0 && copyout(p->pagetable, addr, (char *)&np->xstate,
    800026d0:	000b0e63          	beqz	s6,800026ec <wait+0x64>
    800026d4:	4691                	li	a3,4
    800026d6:	03448613          	addi	a2,s1,52
    800026da:	85da                	mv	a1,s6
    800026dc:	05093503          	ld	a0,80(s2)
    800026e0:	fffff097          	auipc	ra,0xfffff
    800026e4:	048080e7          	jalr	72(ra) # 80001728 <copyout>
    800026e8:	02054263          	bltz	a0,8000270c <wait+0x84>
          freeproc(np);
    800026ec:	8526                	mv	a0,s1
    800026ee:	00000097          	auipc	ra,0x0
    800026f2:	80e080e7          	jalr	-2034(ra) # 80001efc <freeproc>
          release(&np->lock);
    800026f6:	8526                	mv	a0,s1
    800026f8:	ffffe097          	auipc	ra,0xffffe
    800026fc:	61e080e7          	jalr	1566(ra) # 80000d16 <release>
          release(&p->lock);
    80002700:	854a                	mv	a0,s2
    80002702:	ffffe097          	auipc	ra,0xffffe
    80002706:	614080e7          	jalr	1556(ra) # 80000d16 <release>
          return pid;
    8000270a:	a8a9                	j	80002764 <wait+0xdc>
            release(&np->lock);
    8000270c:	8526                	mv	a0,s1
    8000270e:	ffffe097          	auipc	ra,0xffffe
    80002712:	608080e7          	jalr	1544(ra) # 80000d16 <release>
            release(&p->lock);
    80002716:	854a                	mv	a0,s2
    80002718:	ffffe097          	auipc	ra,0xffffe
    8000271c:	5fe080e7          	jalr	1534(ra) # 80000d16 <release>
            return -1;
    80002720:	59fd                	li	s3,-1
    80002722:	a089                	j	80002764 <wait+0xdc>
    for (np = proc; np < &proc[NPROC]; np++)
    80002724:	2d048493          	addi	s1,s1,720
    80002728:	03348463          	beq	s1,s3,80002750 <wait+0xc8>
      if (np->parent == p)
    8000272c:	709c                	ld	a5,32(s1)
    8000272e:	ff279be3          	bne	a5,s2,80002724 <wait+0x9c>
        acquire(&np->lock);
    80002732:	8526                	mv	a0,s1
    80002734:	ffffe097          	auipc	ra,0xffffe
    80002738:	52e080e7          	jalr	1326(ra) # 80000c62 <acquire>
        if (np->state == ZOMBIE)
    8000273c:	4c9c                	lw	a5,24(s1)
    8000273e:	f94787e3          	beq	a5,s4,800026cc <wait+0x44>
        release(&np->lock);
    80002742:	8526                	mv	a0,s1
    80002744:	ffffe097          	auipc	ra,0xffffe
    80002748:	5d2080e7          	jalr	1490(ra) # 80000d16 <release>
        havekids = 1;
    8000274c:	8756                	mv	a4,s5
    8000274e:	bfd9                	j	80002724 <wait+0x9c>
    if (!havekids || p->killed)
    80002750:	c701                	beqz	a4,80002758 <wait+0xd0>
    80002752:	03092783          	lw	a5,48(s2)
    80002756:	c39d                	beqz	a5,8000277c <wait+0xf4>
      release(&p->lock);
    80002758:	854a                	mv	a0,s2
    8000275a:	ffffe097          	auipc	ra,0xffffe
    8000275e:	5bc080e7          	jalr	1468(ra) # 80000d16 <release>
      return -1;
    80002762:	59fd                	li	s3,-1
}
    80002764:	854e                	mv	a0,s3
    80002766:	60a6                	ld	ra,72(sp)
    80002768:	6406                	ld	s0,64(sp)
    8000276a:	74e2                	ld	s1,56(sp)
    8000276c:	7942                	ld	s2,48(sp)
    8000276e:	79a2                	ld	s3,40(sp)
    80002770:	7a02                	ld	s4,32(sp)
    80002772:	6ae2                	ld	s5,24(sp)
    80002774:	6b42                	ld	s6,16(sp)
    80002776:	6ba2                	ld	s7,8(sp)
    80002778:	6161                	addi	sp,sp,80
    8000277a:	8082                	ret
    sleep(p, &p->lock); // DOC: wait-sleep
    8000277c:	85ca                	mv	a1,s2
    8000277e:	854a                	mv	a0,s2
    80002780:	00000097          	auipc	ra,0x0
    80002784:	e8a080e7          	jalr	-374(ra) # 8000260a <sleep>
    havekids = 0;
    80002788:	bf25                	j	800026c0 <wait+0x38>

000000008000278a <wakeup>:
{
    8000278a:	7139                	addi	sp,sp,-64
    8000278c:	fc06                	sd	ra,56(sp)
    8000278e:	f822                	sd	s0,48(sp)
    80002790:	f426                	sd	s1,40(sp)
    80002792:	f04a                	sd	s2,32(sp)
    80002794:	ec4e                	sd	s3,24(sp)
    80002796:	e852                	sd	s4,16(sp)
    80002798:	e456                	sd	s5,8(sp)
    8000279a:	0080                	addi	s0,sp,64
    8000279c:	8a2a                	mv	s4,a0
  for (p = proc; p < &proc[NPROC]; p++)
    8000279e:	0000f497          	auipc	s1,0xf
    800027a2:	64248493          	addi	s1,s1,1602 # 80011de0 <proc>
    if (p->state == SLEEPING && p->chan == chan)
    800027a6:	4985                	li	s3,1
      p->state = RUNNABLE;
    800027a8:	4a89                	li	s5,2
  for (p = proc; p < &proc[NPROC]; p++)
    800027aa:	0001b917          	auipc	s2,0x1b
    800027ae:	a3690913          	addi	s2,s2,-1482 # 8001d1e0 <tickslock>
    800027b2:	a811                	j	800027c6 <wakeup+0x3c>
    release(&p->lock);
    800027b4:	8526                	mv	a0,s1
    800027b6:	ffffe097          	auipc	ra,0xffffe
    800027ba:	560080e7          	jalr	1376(ra) # 80000d16 <release>
  for (p = proc; p < &proc[NPROC]; p++)
    800027be:	2d048493          	addi	s1,s1,720
    800027c2:	03248063          	beq	s1,s2,800027e2 <wakeup+0x58>
    acquire(&p->lock);
    800027c6:	8526                	mv	a0,s1
    800027c8:	ffffe097          	auipc	ra,0xffffe
    800027cc:	49a080e7          	jalr	1178(ra) # 80000c62 <acquire>
    if (p->state == SLEEPING && p->chan == chan)
    800027d0:	4c9c                	lw	a5,24(s1)
    800027d2:	ff3791e3          	bne	a5,s3,800027b4 <wakeup+0x2a>
    800027d6:	749c                	ld	a5,40(s1)
    800027d8:	fd479ee3          	bne	a5,s4,800027b4 <wakeup+0x2a>
      p->state = RUNNABLE;
    800027dc:	0154ac23          	sw	s5,24(s1)
    800027e0:	bfd1                	j	800027b4 <wakeup+0x2a>
}
    800027e2:	70e2                	ld	ra,56(sp)
    800027e4:	7442                	ld	s0,48(sp)
    800027e6:	74a2                	ld	s1,40(sp)
    800027e8:	7902                	ld	s2,32(sp)
    800027ea:	69e2                	ld	s3,24(sp)
    800027ec:	6a42                	ld	s4,16(sp)
    800027ee:	6aa2                	ld	s5,8(sp)
    800027f0:	6121                	addi	sp,sp,64
    800027f2:	8082                	ret

00000000800027f4 <kill>:

// Kill the process with the given pid.
// The victim won't exit until it tries to return
// to user space (see usertrap() in trap.c).
int kill(int pid)
{
    800027f4:	7179                	addi	sp,sp,-48
    800027f6:	f406                	sd	ra,40(sp)
    800027f8:	f022                	sd	s0,32(sp)
    800027fa:	ec26                	sd	s1,24(sp)
    800027fc:	e84a                	sd	s2,16(sp)
    800027fe:	e44e                	sd	s3,8(sp)
    80002800:	1800                	addi	s0,sp,48
    80002802:	892a                	mv	s2,a0
  struct proc *p;

  for (p = proc; p < &proc[NPROC]; p++)
    80002804:	0000f497          	auipc	s1,0xf
    80002808:	5dc48493          	addi	s1,s1,1500 # 80011de0 <proc>
    8000280c:	0001b997          	auipc	s3,0x1b
    80002810:	9d498993          	addi	s3,s3,-1580 # 8001d1e0 <tickslock>
  {
    acquire(&p->lock);
    80002814:	8526                	mv	a0,s1
    80002816:	ffffe097          	auipc	ra,0xffffe
    8000281a:	44c080e7          	jalr	1100(ra) # 80000c62 <acquire>
    if (p->pid == pid)
    8000281e:	5c9c                	lw	a5,56(s1)
    80002820:	01278d63          	beq	a5,s2,8000283a <kill+0x46>
        p->state = RUNNABLE;
      }
      release(&p->lock);
      return 0;
    }
    release(&p->lock);
    80002824:	8526                	mv	a0,s1
    80002826:	ffffe097          	auipc	ra,0xffffe
    8000282a:	4f0080e7          	jalr	1264(ra) # 80000d16 <release>
  for (p = proc; p < &proc[NPROC]; p++)
    8000282e:	2d048493          	addi	s1,s1,720
    80002832:	ff3491e3          	bne	s1,s3,80002814 <kill+0x20>
  }
  return -1;
    80002836:	557d                	li	a0,-1
    80002838:	a821                	j	80002850 <kill+0x5c>
      p->killed = 1;
    8000283a:	4785                	li	a5,1
    8000283c:	d89c                	sw	a5,48(s1)
      if (p->state == SLEEPING)
    8000283e:	4c98                	lw	a4,24(s1)
    80002840:	00f70f63          	beq	a4,a5,8000285e <kill+0x6a>
      release(&p->lock);
    80002844:	8526                	mv	a0,s1
    80002846:	ffffe097          	auipc	ra,0xffffe
    8000284a:	4d0080e7          	jalr	1232(ra) # 80000d16 <release>
      return 0;
    8000284e:	4501                	li	a0,0
}
    80002850:	70a2                	ld	ra,40(sp)
    80002852:	7402                	ld	s0,32(sp)
    80002854:	64e2                	ld	s1,24(sp)
    80002856:	6942                	ld	s2,16(sp)
    80002858:	69a2                	ld	s3,8(sp)
    8000285a:	6145                	addi	sp,sp,48
    8000285c:	8082                	ret
        p->state = RUNNABLE;
    8000285e:	4789                	li	a5,2
    80002860:	cc9c                	sw	a5,24(s1)
    80002862:	b7cd                	j	80002844 <kill+0x50>

0000000080002864 <either_copyout>:

// Copy to either a user address, or kernel address,
// depending on usr_dst.
// Returns 0 on success, -1 on error.
int either_copyout(int user_dst, uint64 dst, void *src, uint64 len)
{
    80002864:	7179                	addi	sp,sp,-48
    80002866:	f406                	sd	ra,40(sp)
    80002868:	f022                	sd	s0,32(sp)
    8000286a:	ec26                	sd	s1,24(sp)
    8000286c:	e84a                	sd	s2,16(sp)
    8000286e:	e44e                	sd	s3,8(sp)
    80002870:	e052                	sd	s4,0(sp)
    80002872:	1800                	addi	s0,sp,48
    80002874:	84aa                	mv	s1,a0
    80002876:	892e                	mv	s2,a1
    80002878:	89b2                	mv	s3,a2
    8000287a:	8a36                	mv	s4,a3
  struct proc *p = myproc();
    8000287c:	fffff097          	auipc	ra,0xfffff
    80002880:	4ce080e7          	jalr	1230(ra) # 80001d4a <myproc>
  if (user_dst)
    80002884:	c08d                	beqz	s1,800028a6 <either_copyout+0x42>
  {
    return copyout(p->pagetable, dst, src, len);
    80002886:	86d2                	mv	a3,s4
    80002888:	864e                	mv	a2,s3
    8000288a:	85ca                	mv	a1,s2
    8000288c:	6928                	ld	a0,80(a0)
    8000288e:	fffff097          	auipc	ra,0xfffff
    80002892:	e9a080e7          	jalr	-358(ra) # 80001728 <copyout>
  else
  {
    memmove((char *)dst, src, len);
    return 0;
  }
}
    80002896:	70a2                	ld	ra,40(sp)
    80002898:	7402                	ld	s0,32(sp)
    8000289a:	64e2                	ld	s1,24(sp)
    8000289c:	6942                	ld	s2,16(sp)
    8000289e:	69a2                	ld	s3,8(sp)
    800028a0:	6a02                	ld	s4,0(sp)
    800028a2:	6145                	addi	sp,sp,48
    800028a4:	8082                	ret
    memmove((char *)dst, src, len);
    800028a6:	000a061b          	sext.w	a2,s4
    800028aa:	85ce                	mv	a1,s3
    800028ac:	854a                	mv	a0,s2
    800028ae:	ffffe097          	auipc	ra,0xffffe
    800028b2:	50c080e7          	jalr	1292(ra) # 80000dba <memmove>
    return 0;
    800028b6:	8526                	mv	a0,s1
    800028b8:	bff9                	j	80002896 <either_copyout+0x32>

00000000800028ba <either_copyin>:

// Copy from either a user address, or kernel address,
// depending on usr_src.
// Returns 0 on success, -1 on error.
int either_copyin(void *dst, int user_src, uint64 src, uint64 len)
{
    800028ba:	7179                	addi	sp,sp,-48
    800028bc:	f406                	sd	ra,40(sp)
    800028be:	f022                	sd	s0,32(sp)
    800028c0:	ec26                	sd	s1,24(sp)
    800028c2:	e84a                	sd	s2,16(sp)
    800028c4:	e44e                	sd	s3,8(sp)
    800028c6:	e052                	sd	s4,0(sp)
    800028c8:	1800                	addi	s0,sp,48
    800028ca:	892a                	mv	s2,a0
    800028cc:	84ae                	mv	s1,a1
    800028ce:	89b2                	mv	s3,a2
    800028d0:	8a36                	mv	s4,a3
  struct proc *p = myproc();
    800028d2:	fffff097          	auipc	ra,0xfffff
    800028d6:	478080e7          	jalr	1144(ra) # 80001d4a <myproc>
  if (user_src)
    800028da:	c08d                	beqz	s1,800028fc <either_copyin+0x42>
  {
    return copyin(p->pagetable, dst, src, len);
    800028dc:	86d2                	mv	a3,s4
    800028de:	864e                	mv	a2,s3
    800028e0:	85ca                	mv	a1,s2
    800028e2:	6928                	ld	a0,80(a0)
    800028e4:	fffff097          	auipc	ra,0xfffff
    800028e8:	ed0080e7          	jalr	-304(ra) # 800017b4 <copyin>
  else
  {
    memmove(dst, (char *)src, len);
    return 0;
  }
}
    800028ec:	70a2                	ld	ra,40(sp)
    800028ee:	7402                	ld	s0,32(sp)
    800028f0:	64e2                	ld	s1,24(sp)
    800028f2:	6942                	ld	s2,16(sp)
    800028f4:	69a2                	ld	s3,8(sp)
    800028f6:	6a02                	ld	s4,0(sp)
    800028f8:	6145                	addi	sp,sp,48
    800028fa:	8082                	ret
    memmove(dst, (char *)src, len);
    800028fc:	000a061b          	sext.w	a2,s4
    80002900:	85ce                	mv	a1,s3
    80002902:	854a                	mv	a0,s2
    80002904:	ffffe097          	auipc	ra,0xffffe
    80002908:	4b6080e7          	jalr	1206(ra) # 80000dba <memmove>
    return 0;
    8000290c:	8526                	mv	a0,s1
    8000290e:	bff9                	j	800028ec <either_copyin+0x32>

0000000080002910 <procdump>:

// Print a process listing to console.  For debugging.
// Runs when user types ^P on console.
// No lock to avoid wedging a stuck machine further.
void procdump(void)
{
    80002910:	715d                	addi	sp,sp,-80
    80002912:	e486                	sd	ra,72(sp)
    80002914:	e0a2                	sd	s0,64(sp)
    80002916:	fc26                	sd	s1,56(sp)
    80002918:	f84a                	sd	s2,48(sp)
    8000291a:	f44e                	sd	s3,40(sp)
    8000291c:	f052                	sd	s4,32(sp)
    8000291e:	ec56                	sd	s5,24(sp)
    80002920:	e85a                	sd	s6,16(sp)
    80002922:	e45e                	sd	s7,8(sp)
    80002924:	0880                	addi	s0,sp,80
      [RUNNING] "run   ",
      [ZOMBIE] "zombie"};
  struct proc *p;
  char *state;

  printf("\n");
    80002926:	00005517          	auipc	a0,0x5
    8000292a:	7ba50513          	addi	a0,a0,1978 # 800080e0 <digits+0x88>
    8000292e:	ffffe097          	auipc	ra,0xffffe
    80002932:	cf4080e7          	jalr	-780(ra) # 80000622 <printf>
  for (p = proc; p < &proc[NPROC]; p++)
    80002936:	0000f497          	auipc	s1,0xf
    8000293a:	60248493          	addi	s1,s1,1538 # 80011f38 <proc+0x158>
    8000293e:	0001b917          	auipc	s2,0x1b
    80002942:	9fa90913          	addi	s2,s2,-1542 # 8001d338 <bcache+0x140>
  {
    if (p->state == UNUSED)
      continue;
    if (p->state >= 0 && p->state < NELEM(states) && states[p->state])
    80002946:	4b11                	li	s6,4
      state = states[p->state];
    else
      state = "???";
    80002948:	00006997          	auipc	s3,0x6
    8000294c:	99898993          	addi	s3,s3,-1640 # 800082e0 <digits+0x288>
    printf("%d %s %s", p->pid, state, p->name);
    80002950:	00006a97          	auipc	s5,0x6
    80002954:	998a8a93          	addi	s5,s5,-1640 # 800082e8 <digits+0x290>
    printf("\n");
    80002958:	00005a17          	auipc	s4,0x5
    8000295c:	788a0a13          	addi	s4,s4,1928 # 800080e0 <digits+0x88>
    if (p->state >= 0 && p->state < NELEM(states) && states[p->state])
    80002960:	00006b97          	auipc	s7,0x6
    80002964:	9c0b8b93          	addi	s7,s7,-1600 # 80008320 <states.0>
    80002968:	a00d                	j	8000298a <procdump+0x7a>
    printf("%d %s %s", p->pid, state, p->name);
    8000296a:	ee06a583          	lw	a1,-288(a3)
    8000296e:	8556                	mv	a0,s5
    80002970:	ffffe097          	auipc	ra,0xffffe
    80002974:	cb2080e7          	jalr	-846(ra) # 80000622 <printf>
    printf("\n");
    80002978:	8552                	mv	a0,s4
    8000297a:	ffffe097          	auipc	ra,0xffffe
    8000297e:	ca8080e7          	jalr	-856(ra) # 80000622 <printf>
  for (p = proc; p < &proc[NPROC]; p++)
    80002982:	2d048493          	addi	s1,s1,720
    80002986:	03248263          	beq	s1,s2,800029aa <procdump+0x9a>
    if (p->state == UNUSED)
    8000298a:	86a6                	mv	a3,s1
    8000298c:	ec04a783          	lw	a5,-320(s1)
    80002990:	dbed                	beqz	a5,80002982 <procdump+0x72>
      state = "???";
    80002992:	864e                	mv	a2,s3
    if (p->state >= 0 && p->state < NELEM(states) && states[p->state])
    80002994:	fcfb6be3          	bltu	s6,a5,8000296a <procdump+0x5a>
    80002998:	02079713          	slli	a4,a5,0x20
    8000299c:	01d75793          	srli	a5,a4,0x1d
    800029a0:	97de                	add	a5,a5,s7
    800029a2:	6390                	ld	a2,0(a5)
    800029a4:	f279                	bnez	a2,8000296a <procdump+0x5a>
      state = "???";
    800029a6:	864e                	mv	a2,s3
    800029a8:	b7c9                	j	8000296a <procdump+0x5a>
  }
}
    800029aa:	60a6                	ld	ra,72(sp)
    800029ac:	6406                	ld	s0,64(sp)
    800029ae:	74e2                	ld	s1,56(sp)
    800029b0:	7942                	ld	s2,48(sp)
    800029b2:	79a2                	ld	s3,40(sp)
    800029b4:	7a02                	ld	s4,32(sp)
    800029b6:	6ae2                	ld	s5,24(sp)
    800029b8:	6b42                	ld	s6,16(sp)
    800029ba:	6ba2                	ld	s7,8(sp)
    800029bc:	6161                	addi	sp,sp,80
    800029be:	8082                	ret

00000000800029c0 <swtch>:
    800029c0:	00153023          	sd	ra,0(a0)
    800029c4:	00253423          	sd	sp,8(a0)
    800029c8:	e900                	sd	s0,16(a0)
    800029ca:	ed04                	sd	s1,24(a0)
    800029cc:	03253023          	sd	s2,32(a0)
    800029d0:	03353423          	sd	s3,40(a0)
    800029d4:	03453823          	sd	s4,48(a0)
    800029d8:	03553c23          	sd	s5,56(a0)
    800029dc:	05653023          	sd	s6,64(a0)
    800029e0:	05753423          	sd	s7,72(a0)
    800029e4:	05853823          	sd	s8,80(a0)
    800029e8:	05953c23          	sd	s9,88(a0)
    800029ec:	07a53023          	sd	s10,96(a0)
    800029f0:	07b53423          	sd	s11,104(a0)
    800029f4:	0005b083          	ld	ra,0(a1)
    800029f8:	0085b103          	ld	sp,8(a1)
    800029fc:	6980                	ld	s0,16(a1)
    800029fe:	6d84                	ld	s1,24(a1)
    80002a00:	0205b903          	ld	s2,32(a1)
    80002a04:	0285b983          	ld	s3,40(a1)
    80002a08:	0305ba03          	ld	s4,48(a1)
    80002a0c:	0385ba83          	ld	s5,56(a1)
    80002a10:	0405bb03          	ld	s6,64(a1)
    80002a14:	0485bb83          	ld	s7,72(a1)
    80002a18:	0505bc03          	ld	s8,80(a1)
    80002a1c:	0585bc83          	ld	s9,88(a1)
    80002a20:	0605bd03          	ld	s10,96(a1)
    80002a24:	0685bd83          	ld	s11,104(a1)
    80002a28:	8082                	ret

0000000080002a2a <trapinit>:

extern int devintr();

void
trapinit(void)
{
    80002a2a:	1141                	addi	sp,sp,-16
    80002a2c:	e406                	sd	ra,8(sp)
    80002a2e:	e022                	sd	s0,0(sp)
    80002a30:	0800                	addi	s0,sp,16
  initlock(&tickslock, "time");
    80002a32:	00006597          	auipc	a1,0x6
    80002a36:	91658593          	addi	a1,a1,-1770 # 80008348 <states.0+0x28>
    80002a3a:	0001a517          	auipc	a0,0x1a
    80002a3e:	7a650513          	addi	a0,a0,1958 # 8001d1e0 <tickslock>
    80002a42:	ffffe097          	auipc	ra,0xffffe
    80002a46:	190080e7          	jalr	400(ra) # 80000bd2 <initlock>
}
    80002a4a:	60a2                	ld	ra,8(sp)
    80002a4c:	6402                	ld	s0,0(sp)
    80002a4e:	0141                	addi	sp,sp,16
    80002a50:	8082                	ret

0000000080002a52 <trapinithart>:

// set up to take exceptions and traps while in the kernel.
void
trapinithart(void)
{
    80002a52:	1141                	addi	sp,sp,-16
    80002a54:	e422                	sd	s0,8(sp)
    80002a56:	0800                	addi	s0,sp,16
  asm volatile("csrw stvec, %0" : : "r" (x));
    80002a58:	00003797          	auipc	a5,0x3
    80002a5c:	6e878793          	addi	a5,a5,1768 # 80006140 <kernelvec>
    80002a60:	10579073          	csrw	stvec,a5
  w_stvec((uint64)kernelvec);
}
    80002a64:	6422                	ld	s0,8(sp)
    80002a66:	0141                	addi	sp,sp,16
    80002a68:	8082                	ret

0000000080002a6a <usertrapret>:
//
// return to user space
//
void
usertrapret(void)
{
    80002a6a:	1141                	addi	sp,sp,-16
    80002a6c:	e406                	sd	ra,8(sp)
    80002a6e:	e022                	sd	s0,0(sp)
    80002a70:	0800                	addi	s0,sp,16
  struct proc *p = myproc();
    80002a72:	fffff097          	auipc	ra,0xfffff
    80002a76:	2d8080e7          	jalr	728(ra) # 80001d4a <myproc>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002a7a:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() & ~SSTATUS_SIE);
    80002a7e:	9bf5                	andi	a5,a5,-3
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002a80:	10079073          	csrw	sstatus,a5
  // kerneltrap() to usertrap(), so turn off interrupts until
  // we're back in user space, where usertrap() is correct.
  intr_off();

  // send syscalls, interrupts, and exceptions to trampoline.S
  w_stvec(TRAMPOLINE + (uservec - trampoline));
    80002a84:	00004617          	auipc	a2,0x4
    80002a88:	57c60613          	addi	a2,a2,1404 # 80007000 <_trampoline>
    80002a8c:	00004697          	auipc	a3,0x4
    80002a90:	57468693          	addi	a3,a3,1396 # 80007000 <_trampoline>
    80002a94:	8e91                	sub	a3,a3,a2
    80002a96:	040007b7          	lui	a5,0x4000
    80002a9a:	17fd                	addi	a5,a5,-1 # 3ffffff <_entry-0x7c000001>
    80002a9c:	07b2                	slli	a5,a5,0xc
    80002a9e:	96be                	add	a3,a3,a5
  asm volatile("csrw stvec, %0" : : "r" (x));
    80002aa0:	10569073          	csrw	stvec,a3

  // set up trapframe values that uservec will need when
  // the process next re-enters the kernel.
  p->trapframe->kernel_satp = r_satp();         // kernel page table
    80002aa4:	6d38                	ld	a4,88(a0)
  asm volatile("csrr %0, satp" : "=r" (x) );
    80002aa6:	180026f3          	csrr	a3,satp
    80002aaa:	e314                	sd	a3,0(a4)
  p->trapframe->kernel_sp = p->kstack + PGSIZE; // process's kernel stack
    80002aac:	6d38                	ld	a4,88(a0)
    80002aae:	6134                	ld	a3,64(a0)
    80002ab0:	6585                	lui	a1,0x1
    80002ab2:	96ae                	add	a3,a3,a1
    80002ab4:	e714                	sd	a3,8(a4)
  p->trapframe->kernel_trap = (uint64)usertrap;
    80002ab6:	6d38                	ld	a4,88(a0)
    80002ab8:	00000697          	auipc	a3,0x0
    80002abc:	13868693          	addi	a3,a3,312 # 80002bf0 <usertrap>
    80002ac0:	eb14                	sd	a3,16(a4)
  p->trapframe->kernel_hartid = r_tp();         // hartid for cpuid()
    80002ac2:	6d38                	ld	a4,88(a0)
  asm volatile("mv %0, tp" : "=r" (x) );
    80002ac4:	8692                	mv	a3,tp
    80002ac6:	f314                	sd	a3,32(a4)
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002ac8:	100026f3          	csrr	a3,sstatus
  // set up the registers that trampoline.S's sret will use
  // to get to user space.
  
  // set S Previous Privilege mode to User.
  unsigned long x = r_sstatus();
  x &= ~SSTATUS_SPP; // clear SPP to 0 for user mode
    80002acc:	eff6f693          	andi	a3,a3,-257
  x |= SSTATUS_SPIE; // enable interrupts in user mode
    80002ad0:	0206e693          	ori	a3,a3,32
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002ad4:	10069073          	csrw	sstatus,a3
  w_sstatus(x);

  // set S Exception Program Counter to the saved user pc.
  w_sepc(p->trapframe->epc);
    80002ad8:	6d38                	ld	a4,88(a0)
  asm volatile("csrw sepc, %0" : : "r" (x));
    80002ada:	6f18                	ld	a4,24(a4)
    80002adc:	14171073          	csrw	sepc,a4

  // tell trampoline.S the user page table to switch to.
  uint64 satp = MAKE_SATP(p->pagetable);
    80002ae0:	692c                	ld	a1,80(a0)
    80002ae2:	81b1                	srli	a1,a1,0xc

  // jump to trampoline.S at the top of memory, which 
  // switches to the user page table, restores user registers,
  // and switches to user mode with sret.
  uint64 fn = TRAMPOLINE + (userret - trampoline);
    80002ae4:	00004717          	auipc	a4,0x4
    80002ae8:	5ac70713          	addi	a4,a4,1452 # 80007090 <userret>
    80002aec:	8f11                	sub	a4,a4,a2
    80002aee:	97ba                	add	a5,a5,a4
  ((void (*)(uint64,uint64))fn)(TRAPFRAME, satp);
    80002af0:	577d                	li	a4,-1
    80002af2:	177e                	slli	a4,a4,0x3f
    80002af4:	8dd9                	or	a1,a1,a4
    80002af6:	02000537          	lui	a0,0x2000
    80002afa:	157d                	addi	a0,a0,-1 # 1ffffff <_entry-0x7e000001>
    80002afc:	0536                	slli	a0,a0,0xd
    80002afe:	9782                	jalr	a5
}
    80002b00:	60a2                	ld	ra,8(sp)
    80002b02:	6402                	ld	s0,0(sp)
    80002b04:	0141                	addi	sp,sp,16
    80002b06:	8082                	ret

0000000080002b08 <clockintr>:
  w_sstatus(sstatus);
}

void
clockintr()
{
    80002b08:	1101                	addi	sp,sp,-32
    80002b0a:	ec06                	sd	ra,24(sp)
    80002b0c:	e822                	sd	s0,16(sp)
    80002b0e:	e426                	sd	s1,8(sp)
    80002b10:	1000                	addi	s0,sp,32
  acquire(&tickslock);
    80002b12:	0001a497          	auipc	s1,0x1a
    80002b16:	6ce48493          	addi	s1,s1,1742 # 8001d1e0 <tickslock>
    80002b1a:	8526                	mv	a0,s1
    80002b1c:	ffffe097          	auipc	ra,0xffffe
    80002b20:	146080e7          	jalr	326(ra) # 80000c62 <acquire>
  ticks++;
    80002b24:	00006517          	auipc	a0,0x6
    80002b28:	4fc50513          	addi	a0,a0,1276 # 80009020 <ticks>
    80002b2c:	411c                	lw	a5,0(a0)
    80002b2e:	2785                	addiw	a5,a5,1
    80002b30:	c11c                	sw	a5,0(a0)
  wakeup(&ticks);
    80002b32:	00000097          	auipc	ra,0x0
    80002b36:	c58080e7          	jalr	-936(ra) # 8000278a <wakeup>
  release(&tickslock);
    80002b3a:	8526                	mv	a0,s1
    80002b3c:	ffffe097          	auipc	ra,0xffffe
    80002b40:	1da080e7          	jalr	474(ra) # 80000d16 <release>
}
    80002b44:	60e2                	ld	ra,24(sp)
    80002b46:	6442                	ld	s0,16(sp)
    80002b48:	64a2                	ld	s1,8(sp)
    80002b4a:	6105                	addi	sp,sp,32
    80002b4c:	8082                	ret

0000000080002b4e <devintr>:
// returns 2 if timer interrupt,
// 1 if other device,
// 0 if not recognized.
int
devintr()
{
    80002b4e:	1101                	addi	sp,sp,-32
    80002b50:	ec06                	sd	ra,24(sp)
    80002b52:	e822                	sd	s0,16(sp)
    80002b54:	e426                	sd	s1,8(sp)
    80002b56:	1000                	addi	s0,sp,32
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002b58:	14202773          	csrr	a4,scause
  uint64 scause = r_scause();

  if((scause & 0x8000000000000000L) &&
    80002b5c:	00074d63          	bltz	a4,80002b76 <devintr+0x28>
    // now allowed to interrupt again.
    if(irq)
      plic_complete(irq);

    return 1;
  } else if(scause == 0x8000000000000001L){
    80002b60:	57fd                	li	a5,-1
    80002b62:	17fe                	slli	a5,a5,0x3f
    80002b64:	0785                	addi	a5,a5,1
    // the SSIP bit in sip.
    w_sip(r_sip() & ~2);

    return 2;
  } else {
    return 0;
    80002b66:	4501                	li	a0,0
  } else if(scause == 0x8000000000000001L){
    80002b68:	06f70363          	beq	a4,a5,80002bce <devintr+0x80>
  }
}
    80002b6c:	60e2                	ld	ra,24(sp)
    80002b6e:	6442                	ld	s0,16(sp)
    80002b70:	64a2                	ld	s1,8(sp)
    80002b72:	6105                	addi	sp,sp,32
    80002b74:	8082                	ret
     (scause & 0xff) == 9){
    80002b76:	0ff77793          	zext.b	a5,a4
  if((scause & 0x8000000000000000L) &&
    80002b7a:	46a5                	li	a3,9
    80002b7c:	fed792e3          	bne	a5,a3,80002b60 <devintr+0x12>
    int irq = plic_claim();
    80002b80:	00003097          	auipc	ra,0x3
    80002b84:	6c8080e7          	jalr	1736(ra) # 80006248 <plic_claim>
    80002b88:	84aa                	mv	s1,a0
    if(irq == UART0_IRQ){
    80002b8a:	47a9                	li	a5,10
    80002b8c:	02f50763          	beq	a0,a5,80002bba <devintr+0x6c>
    } else if(irq == VIRTIO0_IRQ){
    80002b90:	4785                	li	a5,1
    80002b92:	02f50963          	beq	a0,a5,80002bc4 <devintr+0x76>
    return 1;
    80002b96:	4505                	li	a0,1
    } else if(irq){
    80002b98:	d8f1                	beqz	s1,80002b6c <devintr+0x1e>
      printf("unexpected interrupt irq=%d\n", irq);
    80002b9a:	85a6                	mv	a1,s1
    80002b9c:	00005517          	auipc	a0,0x5
    80002ba0:	7b450513          	addi	a0,a0,1972 # 80008350 <states.0+0x30>
    80002ba4:	ffffe097          	auipc	ra,0xffffe
    80002ba8:	a7e080e7          	jalr	-1410(ra) # 80000622 <printf>
      plic_complete(irq);
    80002bac:	8526                	mv	a0,s1
    80002bae:	00003097          	auipc	ra,0x3
    80002bb2:	6be080e7          	jalr	1726(ra) # 8000626c <plic_complete>
    return 1;
    80002bb6:	4505                	li	a0,1
    80002bb8:	bf55                	j	80002b6c <devintr+0x1e>
      uartintr();
    80002bba:	ffffe097          	auipc	ra,0xffffe
    80002bbe:	e6c080e7          	jalr	-404(ra) # 80000a26 <uartintr>
    80002bc2:	b7ed                	j	80002bac <devintr+0x5e>
      virtio_disk_intr();
    80002bc4:	00004097          	auipc	ra,0x4
    80002bc8:	b22080e7          	jalr	-1246(ra) # 800066e6 <virtio_disk_intr>
    80002bcc:	b7c5                	j	80002bac <devintr+0x5e>
    if(cpuid() == 0){
    80002bce:	fffff097          	auipc	ra,0xfffff
    80002bd2:	150080e7          	jalr	336(ra) # 80001d1e <cpuid>
    80002bd6:	c901                	beqz	a0,80002be6 <devintr+0x98>
  asm volatile("csrr %0, sip" : "=r" (x) );
    80002bd8:	144027f3          	csrr	a5,sip
    w_sip(r_sip() & ~2);
    80002bdc:	9bf5                	andi	a5,a5,-3
  asm volatile("csrw sip, %0" : : "r" (x));
    80002bde:	14479073          	csrw	sip,a5
    return 2;
    80002be2:	4509                	li	a0,2
    80002be4:	b761                	j	80002b6c <devintr+0x1e>
      clockintr();
    80002be6:	00000097          	auipc	ra,0x0
    80002bea:	f22080e7          	jalr	-222(ra) # 80002b08 <clockintr>
    80002bee:	b7ed                	j	80002bd8 <devintr+0x8a>

0000000080002bf0 <usertrap>:
{
    80002bf0:	1101                	addi	sp,sp,-32
    80002bf2:	ec06                	sd	ra,24(sp)
    80002bf4:	e822                	sd	s0,16(sp)
    80002bf6:	e426                	sd	s1,8(sp)
    80002bf8:	e04a                	sd	s2,0(sp)
    80002bfa:	1000                	addi	s0,sp,32
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002bfc:	100027f3          	csrr	a5,sstatus
  if((r_sstatus() & SSTATUS_SPP) != 0)
    80002c00:	1007f793          	andi	a5,a5,256
    80002c04:	e3ad                	bnez	a5,80002c66 <usertrap+0x76>
  asm volatile("csrw stvec, %0" : : "r" (x));
    80002c06:	00003797          	auipc	a5,0x3
    80002c0a:	53a78793          	addi	a5,a5,1338 # 80006140 <kernelvec>
    80002c0e:	10579073          	csrw	stvec,a5
  struct proc *p = myproc();
    80002c12:	fffff097          	auipc	ra,0xfffff
    80002c16:	138080e7          	jalr	312(ra) # 80001d4a <myproc>
    80002c1a:	84aa                	mv	s1,a0
  p->trapframe->epc = r_sepc();
    80002c1c:	6d3c                	ld	a5,88(a0)
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002c1e:	14102773          	csrr	a4,sepc
    80002c22:	ef98                	sd	a4,24(a5)
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002c24:	14202773          	csrr	a4,scause
  if(r_scause() == 8){
    80002c28:	47a1                	li	a5,8
    80002c2a:	04f71c63          	bne	a4,a5,80002c82 <usertrap+0x92>
    if(p->killed)
    80002c2e:	591c                	lw	a5,48(a0)
    80002c30:	e3b9                	bnez	a5,80002c76 <usertrap+0x86>
    p->trapframe->epc += 4;
    80002c32:	6cb8                	ld	a4,88(s1)
    80002c34:	6f1c                	ld	a5,24(a4)
    80002c36:	0791                	addi	a5,a5,4
    80002c38:	ef1c                	sd	a5,24(a4)
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002c3a:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80002c3e:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002c42:	10079073          	csrw	sstatus,a5
    syscall();
    80002c46:	00000097          	auipc	ra,0x0
    80002c4a:	3a4080e7          	jalr	932(ra) # 80002fea <syscall>
  if(p->killed)
    80002c4e:	589c                	lw	a5,48(s1)
    80002c50:	ebe1                	bnez	a5,80002d20 <usertrap+0x130>
  usertrapret();
    80002c52:	00000097          	auipc	ra,0x0
    80002c56:	e18080e7          	jalr	-488(ra) # 80002a6a <usertrapret>
}
    80002c5a:	60e2                	ld	ra,24(sp)
    80002c5c:	6442                	ld	s0,16(sp)
    80002c5e:	64a2                	ld	s1,8(sp)
    80002c60:	6902                	ld	s2,0(sp)
    80002c62:	6105                	addi	sp,sp,32
    80002c64:	8082                	ret
    panic("usertrap: not from user mode");
    80002c66:	00005517          	auipc	a0,0x5
    80002c6a:	70a50513          	addi	a0,a0,1802 # 80008370 <states.0+0x50>
    80002c6e:	ffffe097          	auipc	ra,0xffffe
    80002c72:	962080e7          	jalr	-1694(ra) # 800005d0 <panic>
      exit(-1);
    80002c76:	557d                	li	a0,-1
    80002c78:	00000097          	auipc	ra,0x0
    80002c7c:	84c080e7          	jalr	-1972(ra) # 800024c4 <exit>
    80002c80:	bf4d                	j	80002c32 <usertrap+0x42>
  } else if((which_dev = devintr()) != 0){
    80002c82:	00000097          	auipc	ra,0x0
    80002c86:	ecc080e7          	jalr	-308(ra) # 80002b4e <devintr>
    80002c8a:	892a                	mv	s2,a0
    80002c8c:	c501                	beqz	a0,80002c94 <usertrap+0xa4>
  if(p->killed)
    80002c8e:	589c                	lw	a5,48(s1)
    80002c90:	c3a1                	beqz	a5,80002cd0 <usertrap+0xe0>
    80002c92:	a815                	j	80002cc6 <usertrap+0xd6>
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002c94:	142025f3          	csrr	a1,scause
    printf("usertrap(): unexpected scause %p pid=%d\n", r_scause(), p->pid);
    80002c98:	5c90                	lw	a2,56(s1)
    80002c9a:	00005517          	auipc	a0,0x5
    80002c9e:	6f650513          	addi	a0,a0,1782 # 80008390 <states.0+0x70>
    80002ca2:	ffffe097          	auipc	ra,0xffffe
    80002ca6:	980080e7          	jalr	-1664(ra) # 80000622 <printf>
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002caa:	141025f3          	csrr	a1,sepc
  asm volatile("csrr %0, stval" : "=r" (x) );
    80002cae:	14302673          	csrr	a2,stval
    printf("            sepc=%p stval=%p\n", r_sepc(), r_stval());
    80002cb2:	00005517          	auipc	a0,0x5
    80002cb6:	70e50513          	addi	a0,a0,1806 # 800083c0 <states.0+0xa0>
    80002cba:	ffffe097          	auipc	ra,0xffffe
    80002cbe:	968080e7          	jalr	-1688(ra) # 80000622 <printf>
    p->killed = 1;
    80002cc2:	4785                	li	a5,1
    80002cc4:	d89c                	sw	a5,48(s1)
    exit(-1);
    80002cc6:	557d                	li	a0,-1
    80002cc8:	fffff097          	auipc	ra,0xfffff
    80002ccc:	7fc080e7          	jalr	2044(ra) # 800024c4 <exit>
  if(which_dev == 2) {
    80002cd0:	4789                	li	a5,2
    80002cd2:	f8f910e3          	bne	s2,a5,80002c52 <usertrap+0x62>
    printf("time interupt!\n");
    80002cd6:	00005517          	auipc	a0,0x5
    80002cda:	70a50513          	addi	a0,a0,1802 # 800083e0 <states.0+0xc0>
    80002cde:	ffffe097          	auipc	ra,0xffffe
    80002ce2:	944080e7          	jalr	-1724(ra) # 80000622 <printf>
    p-> my_ticket++;
    80002ce6:	2a84a783          	lw	a5,680(s1)
    80002cea:	2785                	addiw	a5,a5,1
    80002cec:	0007871b          	sext.w	a4,a5
    80002cf0:	2af4a423          	sw	a5,680(s1)
    if (p-> my_ticket == p-> now_limit)
    80002cf4:	2a44a783          	lw	a5,676(s1)
    80002cf8:	02f70663          	beq	a4,a5,80002d24 <usertrap+0x134>
    if(p->interval < 0 )
    80002cfc:	1684a703          	lw	a4,360(s1)
    80002d00:	00074b63          	bltz	a4,80002d16 <usertrap+0x126>
    p->ticks++;
    80002d04:	1784a783          	lw	a5,376(s1)
    80002d08:	2785                	addiw	a5,a5,1
    80002d0a:	0007869b          	sext.w	a3,a5
    80002d0e:	16f4ac23          	sw	a5,376(s1)
    if(p->ticks == p->interval && p->InHandler==0) {
    80002d12:	04d70b63          	beq	a4,a3,80002d68 <usertrap+0x178>
      yield();
    80002d16:	00000097          	auipc	ra,0x0
    80002d1a:	8b8080e7          	jalr	-1864(ra) # 800025ce <yield>
    80002d1e:	bf15                	j	80002c52 <usertrap+0x62>
  int which_dev = 0;
    80002d20:	4901                	li	s2,0
    80002d22:	b755                	j	80002cc6 <usertrap+0xd6>
      if (p-> now_limit != p-> ticket_limit)
    80002d24:	2a04a703          	lw	a4,672(s1)
    80002d28:	02f70563          	beq	a4,a5,80002d52 <usertrap+0x162>
        p-> my_ticket = 0;
    80002d2c:	2a04a423          	sw	zero,680(s1)
        p-> priority+=1;
    80002d30:	2ac4a503          	lw	a0,684(s1)
    80002d34:	0015059b          	addiw	a1,a0,1
    80002d38:	2ab4a623          	sw	a1,684(s1)
        p-> now_limit *=2;
    80002d3c:	0017979b          	slliw	a5,a5,0x1
    80002d40:	2af4a223          	sw	a5,676(s1)
        move_proc_between_lists(p-> priority-1,p-> priority,p);
    80002d44:	8626                	mv	a2,s1
    80002d46:	2581                	sext.w	a1,a1
    80002d48:	fffff097          	auipc	ra,0xfffff
    80002d4c:	c82080e7          	jalr	-894(ra) # 800019ca <move_proc_between_lists>
        sign = 1;
    80002d50:	b775                	j	80002cfc <usertrap+0x10c>
        p-> my_ticket = 0;
    80002d52:	2a04a423          	sw	zero,680(s1)
        move_proc_between_lists(p-> priority,p-> priority,p);
    80002d56:	2ac4a503          	lw	a0,684(s1)
    80002d5a:	8626                	mv	a2,s1
    80002d5c:	85aa                	mv	a1,a0
    80002d5e:	fffff097          	auipc	ra,0xfffff
    80002d62:	c6c080e7          	jalr	-916(ra) # 800019ca <move_proc_between_lists>
        sign = 1;
    80002d66:	bf59                	j	80002cfc <usertrap+0x10c>
    if(p->ticks == p->interval && p->InHandler==0) {
    80002d68:	16c4a783          	lw	a5,364(s1)
    80002d6c:	f7cd                	bnez	a5,80002d16 <usertrap+0x126>
      p->InHandler=1;
    80002d6e:	4785                	li	a5,1
    80002d70:	16f4a623          	sw	a5,364(s1)
      p->trapframe2 = *p->trapframe;
    80002d74:	0584b883          	ld	a7,88(s1)
    80002d78:	87c6                	mv	a5,a7
    80002d7a:	18048713          	addi	a4,s1,384
    80002d7e:	12088813          	addi	a6,a7,288
    80002d82:	6388                	ld	a0,0(a5)
    80002d84:	678c                	ld	a1,8(a5)
    80002d86:	6b90                	ld	a2,16(a5)
    80002d88:	6f94                	ld	a3,24(a5)
    80002d8a:	e308                	sd	a0,0(a4)
    80002d8c:	e70c                	sd	a1,8(a4)
    80002d8e:	eb10                	sd	a2,16(a4)
    80002d90:	ef14                	sd	a3,24(a4)
    80002d92:	02078793          	addi	a5,a5,32
    80002d96:	02070713          	addi	a4,a4,32
    80002d9a:	ff0794e3          	bne	a5,a6,80002d82 <usertrap+0x192>
      p->trapframe->epc = p->handler;
    80002d9e:	1704b783          	ld	a5,368(s1)
    80002da2:	00f8bc23          	sd	a5,24(a7)
    80002da6:	bf85                	j	80002d16 <usertrap+0x126>

0000000080002da8 <kerneltrap>:
{
    80002da8:	7179                	addi	sp,sp,-48
    80002daa:	f406                	sd	ra,40(sp)
    80002dac:	f022                	sd	s0,32(sp)
    80002dae:	ec26                	sd	s1,24(sp)
    80002db0:	e84a                	sd	s2,16(sp)
    80002db2:	e44e                	sd	s3,8(sp)
    80002db4:	1800                	addi	s0,sp,48
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002db6:	14102973          	csrr	s2,sepc
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002dba:	100024f3          	csrr	s1,sstatus
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002dbe:	142029f3          	csrr	s3,scause
  if((sstatus & SSTATUS_SPP) == 0)
    80002dc2:	1004f793          	andi	a5,s1,256
    80002dc6:	cb85                	beqz	a5,80002df6 <kerneltrap+0x4e>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002dc8:	100027f3          	csrr	a5,sstatus
  return (x & SSTATUS_SIE) != 0;
    80002dcc:	8b89                	andi	a5,a5,2
  if(intr_get() != 0)
    80002dce:	ef85                	bnez	a5,80002e06 <kerneltrap+0x5e>
  if((which_dev = devintr()) == 0){
    80002dd0:	00000097          	auipc	ra,0x0
    80002dd4:	d7e080e7          	jalr	-642(ra) # 80002b4e <devintr>
    80002dd8:	cd1d                	beqz	a0,80002e16 <kerneltrap+0x6e>
  if(which_dev == 2 && myproc() != 0 && myproc()->state == RUNNING)
    80002dda:	4789                	li	a5,2
    80002ddc:	06f50a63          	beq	a0,a5,80002e50 <kerneltrap+0xa8>
  asm volatile("csrw sepc, %0" : : "r" (x));
    80002de0:	14191073          	csrw	sepc,s2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002de4:	10049073          	csrw	sstatus,s1
}
    80002de8:	70a2                	ld	ra,40(sp)
    80002dea:	7402                	ld	s0,32(sp)
    80002dec:	64e2                	ld	s1,24(sp)
    80002dee:	6942                	ld	s2,16(sp)
    80002df0:	69a2                	ld	s3,8(sp)
    80002df2:	6145                	addi	sp,sp,48
    80002df4:	8082                	ret
    panic("kerneltrap: not from supervisor mode");
    80002df6:	00005517          	auipc	a0,0x5
    80002dfa:	5fa50513          	addi	a0,a0,1530 # 800083f0 <states.0+0xd0>
    80002dfe:	ffffd097          	auipc	ra,0xffffd
    80002e02:	7d2080e7          	jalr	2002(ra) # 800005d0 <panic>
    panic("kerneltrap: interrupts enabled");
    80002e06:	00005517          	auipc	a0,0x5
    80002e0a:	61250513          	addi	a0,a0,1554 # 80008418 <states.0+0xf8>
    80002e0e:	ffffd097          	auipc	ra,0xffffd
    80002e12:	7c2080e7          	jalr	1986(ra) # 800005d0 <panic>
    printf("scause %p\n", scause);
    80002e16:	85ce                	mv	a1,s3
    80002e18:	00005517          	auipc	a0,0x5
    80002e1c:	62050513          	addi	a0,a0,1568 # 80008438 <states.0+0x118>
    80002e20:	ffffe097          	auipc	ra,0xffffe
    80002e24:	802080e7          	jalr	-2046(ra) # 80000622 <printf>
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002e28:	141025f3          	csrr	a1,sepc
  asm volatile("csrr %0, stval" : "=r" (x) );
    80002e2c:	14302673          	csrr	a2,stval
    printf("sepc=%p stval=%p\n", r_sepc(), r_stval());
    80002e30:	00005517          	auipc	a0,0x5
    80002e34:	61850513          	addi	a0,a0,1560 # 80008448 <states.0+0x128>
    80002e38:	ffffd097          	auipc	ra,0xffffd
    80002e3c:	7ea080e7          	jalr	2026(ra) # 80000622 <printf>
    panic("kerneltrap");
    80002e40:	00005517          	auipc	a0,0x5
    80002e44:	62050513          	addi	a0,a0,1568 # 80008460 <states.0+0x140>
    80002e48:	ffffd097          	auipc	ra,0xffffd
    80002e4c:	788080e7          	jalr	1928(ra) # 800005d0 <panic>
  if(which_dev == 2 && myproc() != 0 && myproc()->state == RUNNING)
    80002e50:	fffff097          	auipc	ra,0xfffff
    80002e54:	efa080e7          	jalr	-262(ra) # 80001d4a <myproc>
    80002e58:	d541                	beqz	a0,80002de0 <kerneltrap+0x38>
    80002e5a:	fffff097          	auipc	ra,0xfffff
    80002e5e:	ef0080e7          	jalr	-272(ra) # 80001d4a <myproc>
    80002e62:	4d18                	lw	a4,24(a0)
    80002e64:	478d                	li	a5,3
    80002e66:	f6f71de3          	bne	a4,a5,80002de0 <kerneltrap+0x38>
    yield();
    80002e6a:	fffff097          	auipc	ra,0xfffff
    80002e6e:	764080e7          	jalr	1892(ra) # 800025ce <yield>
    80002e72:	b7bd                	j	80002de0 <kerneltrap+0x38>

0000000080002e74 <argraw>:
  return strlen(buf);
}

static uint64
argraw(int n)
{
    80002e74:	1101                	addi	sp,sp,-32
    80002e76:	ec06                	sd	ra,24(sp)
    80002e78:	e822                	sd	s0,16(sp)
    80002e7a:	e426                	sd	s1,8(sp)
    80002e7c:	1000                	addi	s0,sp,32
    80002e7e:	84aa                	mv	s1,a0
  struct proc *p = myproc();
    80002e80:	fffff097          	auipc	ra,0xfffff
    80002e84:	eca080e7          	jalr	-310(ra) # 80001d4a <myproc>
  switch (n) {
    80002e88:	4795                	li	a5,5
    80002e8a:	0497e163          	bltu	a5,s1,80002ecc <argraw+0x58>
    80002e8e:	048a                	slli	s1,s1,0x2
    80002e90:	00005717          	auipc	a4,0x5
    80002e94:	60870713          	addi	a4,a4,1544 # 80008498 <states.0+0x178>
    80002e98:	94ba                	add	s1,s1,a4
    80002e9a:	409c                	lw	a5,0(s1)
    80002e9c:	97ba                	add	a5,a5,a4
    80002e9e:	8782                	jr	a5
  case 0:
    return p->trapframe->a0;
    80002ea0:	6d3c                	ld	a5,88(a0)
    80002ea2:	7ba8                	ld	a0,112(a5)
  case 5:
    return p->trapframe->a5;
  }
  panic("argraw");
  return -1;
}
    80002ea4:	60e2                	ld	ra,24(sp)
    80002ea6:	6442                	ld	s0,16(sp)
    80002ea8:	64a2                	ld	s1,8(sp)
    80002eaa:	6105                	addi	sp,sp,32
    80002eac:	8082                	ret
    return p->trapframe->a1;
    80002eae:	6d3c                	ld	a5,88(a0)
    80002eb0:	7fa8                	ld	a0,120(a5)
    80002eb2:	bfcd                	j	80002ea4 <argraw+0x30>
    return p->trapframe->a2;
    80002eb4:	6d3c                	ld	a5,88(a0)
    80002eb6:	63c8                	ld	a0,128(a5)
    80002eb8:	b7f5                	j	80002ea4 <argraw+0x30>
    return p->trapframe->a3;
    80002eba:	6d3c                	ld	a5,88(a0)
    80002ebc:	67c8                	ld	a0,136(a5)
    80002ebe:	b7dd                	j	80002ea4 <argraw+0x30>
    return p->trapframe->a4;
    80002ec0:	6d3c                	ld	a5,88(a0)
    80002ec2:	6bc8                	ld	a0,144(a5)
    80002ec4:	b7c5                	j	80002ea4 <argraw+0x30>
    return p->trapframe->a5;
    80002ec6:	6d3c                	ld	a5,88(a0)
    80002ec8:	6fc8                	ld	a0,152(a5)
    80002eca:	bfe9                	j	80002ea4 <argraw+0x30>
  panic("argraw");
    80002ecc:	00005517          	auipc	a0,0x5
    80002ed0:	5a450513          	addi	a0,a0,1444 # 80008470 <states.0+0x150>
    80002ed4:	ffffd097          	auipc	ra,0xffffd
    80002ed8:	6fc080e7          	jalr	1788(ra) # 800005d0 <panic>

0000000080002edc <fetchaddr>:
{
    80002edc:	1101                	addi	sp,sp,-32
    80002ede:	ec06                	sd	ra,24(sp)
    80002ee0:	e822                	sd	s0,16(sp)
    80002ee2:	e426                	sd	s1,8(sp)
    80002ee4:	e04a                	sd	s2,0(sp)
    80002ee6:	1000                	addi	s0,sp,32
    80002ee8:	84aa                	mv	s1,a0
    80002eea:	892e                	mv	s2,a1
  struct proc *p = myproc();
    80002eec:	fffff097          	auipc	ra,0xfffff
    80002ef0:	e5e080e7          	jalr	-418(ra) # 80001d4a <myproc>
  if(addr >= p->sz || addr+sizeof(uint64) > p->sz)
    80002ef4:	653c                	ld	a5,72(a0)
    80002ef6:	02f4f863          	bgeu	s1,a5,80002f26 <fetchaddr+0x4a>
    80002efa:	00848713          	addi	a4,s1,8
    80002efe:	02e7e663          	bltu	a5,a4,80002f2a <fetchaddr+0x4e>
  if(copyin(p->pagetable, (char *)ip, addr, sizeof(*ip)) != 0)
    80002f02:	46a1                	li	a3,8
    80002f04:	8626                	mv	a2,s1
    80002f06:	85ca                	mv	a1,s2
    80002f08:	6928                	ld	a0,80(a0)
    80002f0a:	fffff097          	auipc	ra,0xfffff
    80002f0e:	8aa080e7          	jalr	-1878(ra) # 800017b4 <copyin>
    80002f12:	00a03533          	snez	a0,a0
    80002f16:	40a00533          	neg	a0,a0
}
    80002f1a:	60e2                	ld	ra,24(sp)
    80002f1c:	6442                	ld	s0,16(sp)
    80002f1e:	64a2                	ld	s1,8(sp)
    80002f20:	6902                	ld	s2,0(sp)
    80002f22:	6105                	addi	sp,sp,32
    80002f24:	8082                	ret
    return -1;
    80002f26:	557d                	li	a0,-1
    80002f28:	bfcd                	j	80002f1a <fetchaddr+0x3e>
    80002f2a:	557d                	li	a0,-1
    80002f2c:	b7fd                	j	80002f1a <fetchaddr+0x3e>

0000000080002f2e <fetchstr>:
{
    80002f2e:	7179                	addi	sp,sp,-48
    80002f30:	f406                	sd	ra,40(sp)
    80002f32:	f022                	sd	s0,32(sp)
    80002f34:	ec26                	sd	s1,24(sp)
    80002f36:	e84a                	sd	s2,16(sp)
    80002f38:	e44e                	sd	s3,8(sp)
    80002f3a:	1800                	addi	s0,sp,48
    80002f3c:	892a                	mv	s2,a0
    80002f3e:	84ae                	mv	s1,a1
    80002f40:	89b2                	mv	s3,a2
  struct proc *p = myproc();
    80002f42:	fffff097          	auipc	ra,0xfffff
    80002f46:	e08080e7          	jalr	-504(ra) # 80001d4a <myproc>
  int err = copyinstr(p->pagetable, buf, addr, max);
    80002f4a:	86ce                	mv	a3,s3
    80002f4c:	864a                	mv	a2,s2
    80002f4e:	85a6                	mv	a1,s1
    80002f50:	6928                	ld	a0,80(a0)
    80002f52:	fffff097          	auipc	ra,0xfffff
    80002f56:	8f0080e7          	jalr	-1808(ra) # 80001842 <copyinstr>
  if(err < 0)
    80002f5a:	00054763          	bltz	a0,80002f68 <fetchstr+0x3a>
  return strlen(buf);
    80002f5e:	8526                	mv	a0,s1
    80002f60:	ffffe097          	auipc	ra,0xffffe
    80002f64:	f82080e7          	jalr	-126(ra) # 80000ee2 <strlen>
}
    80002f68:	70a2                	ld	ra,40(sp)
    80002f6a:	7402                	ld	s0,32(sp)
    80002f6c:	64e2                	ld	s1,24(sp)
    80002f6e:	6942                	ld	s2,16(sp)
    80002f70:	69a2                	ld	s3,8(sp)
    80002f72:	6145                	addi	sp,sp,48
    80002f74:	8082                	ret

0000000080002f76 <argint>:

// Fetch the nth 32-bit system call argument.
int
argint(int n, int *ip)
{
    80002f76:	1101                	addi	sp,sp,-32
    80002f78:	ec06                	sd	ra,24(sp)
    80002f7a:	e822                	sd	s0,16(sp)
    80002f7c:	e426                	sd	s1,8(sp)
    80002f7e:	1000                	addi	s0,sp,32
    80002f80:	84ae                	mv	s1,a1
  *ip = argraw(n);
    80002f82:	00000097          	auipc	ra,0x0
    80002f86:	ef2080e7          	jalr	-270(ra) # 80002e74 <argraw>
    80002f8a:	c088                	sw	a0,0(s1)
  return 0;
}
    80002f8c:	4501                	li	a0,0
    80002f8e:	60e2                	ld	ra,24(sp)
    80002f90:	6442                	ld	s0,16(sp)
    80002f92:	64a2                	ld	s1,8(sp)
    80002f94:	6105                	addi	sp,sp,32
    80002f96:	8082                	ret

0000000080002f98 <argaddr>:
// Retrieve an argument as a pointer.
// Doesn't check for legality, since
// copyin/copyout will do that.
int
argaddr(int n, uint64 *ip)
{
    80002f98:	1101                	addi	sp,sp,-32
    80002f9a:	ec06                	sd	ra,24(sp)
    80002f9c:	e822                	sd	s0,16(sp)
    80002f9e:	e426                	sd	s1,8(sp)
    80002fa0:	1000                	addi	s0,sp,32
    80002fa2:	84ae                	mv	s1,a1
  *ip = argraw(n);
    80002fa4:	00000097          	auipc	ra,0x0
    80002fa8:	ed0080e7          	jalr	-304(ra) # 80002e74 <argraw>
    80002fac:	e088                	sd	a0,0(s1)
  return 0;
}
    80002fae:	4501                	li	a0,0
    80002fb0:	60e2                	ld	ra,24(sp)
    80002fb2:	6442                	ld	s0,16(sp)
    80002fb4:	64a2                	ld	s1,8(sp)
    80002fb6:	6105                	addi	sp,sp,32
    80002fb8:	8082                	ret

0000000080002fba <argstr>:
// Fetch the nth word-sized system call argument as a null-terminated string.
// Copies into buf, at most max.
// Returns string length if OK (including nul), -1 if error.
int
argstr(int n, char *buf, int max)
{
    80002fba:	1101                	addi	sp,sp,-32
    80002fbc:	ec06                	sd	ra,24(sp)
    80002fbe:	e822                	sd	s0,16(sp)
    80002fc0:	e426                	sd	s1,8(sp)
    80002fc2:	e04a                	sd	s2,0(sp)
    80002fc4:	1000                	addi	s0,sp,32
    80002fc6:	84ae                	mv	s1,a1
    80002fc8:	8932                	mv	s2,a2
  *ip = argraw(n);
    80002fca:	00000097          	auipc	ra,0x0
    80002fce:	eaa080e7          	jalr	-342(ra) # 80002e74 <argraw>
  uint64 addr;
  if(argaddr(n, &addr) < 0)
    return -1;
  return fetchstr(addr, buf, max);
    80002fd2:	864a                	mv	a2,s2
    80002fd4:	85a6                	mv	a1,s1
    80002fd6:	00000097          	auipc	ra,0x0
    80002fda:	f58080e7          	jalr	-168(ra) # 80002f2e <fetchstr>
}
    80002fde:	60e2                	ld	ra,24(sp)
    80002fe0:	6442                	ld	s0,16(sp)
    80002fe2:	64a2                	ld	s1,8(sp)
    80002fe4:	6902                	ld	s2,0(sp)
    80002fe6:	6105                	addi	sp,sp,32
    80002fe8:	8082                	ret

0000000080002fea <syscall>:

};

void
syscall(void)
{
    80002fea:	1101                	addi	sp,sp,-32
    80002fec:	ec06                	sd	ra,24(sp)
    80002fee:	e822                	sd	s0,16(sp)
    80002ff0:	e426                	sd	s1,8(sp)
    80002ff2:	e04a                	sd	s2,0(sp)
    80002ff4:	1000                	addi	s0,sp,32
  int num;
  struct proc *p = myproc();
    80002ff6:	fffff097          	auipc	ra,0xfffff
    80002ffa:	d54080e7          	jalr	-684(ra) # 80001d4a <myproc>
    80002ffe:	84aa                	mv	s1,a0

  num = p->trapframe->a7;
    80003000:	05853903          	ld	s2,88(a0)
    80003004:	0a893783          	ld	a5,168(s2)
    80003008:	0007869b          	sext.w	a3,a5
  if(num > 0 && num < NELEM(syscalls) && syscalls[num]) {
    8000300c:	37fd                	addiw	a5,a5,-1
    8000300e:	4765                	li	a4,25
    80003010:	00f76f63          	bltu	a4,a5,8000302e <syscall+0x44>
    80003014:	00369713          	slli	a4,a3,0x3
    80003018:	00005797          	auipc	a5,0x5
    8000301c:	49878793          	addi	a5,a5,1176 # 800084b0 <syscalls>
    80003020:	97ba                	add	a5,a5,a4
    80003022:	639c                	ld	a5,0(a5)
    80003024:	c789                	beqz	a5,8000302e <syscall+0x44>
    p->trapframe->a0 = syscalls[num]();
    80003026:	9782                	jalr	a5
    80003028:	06a93823          	sd	a0,112(s2)
    8000302c:	a839                	j	8000304a <syscall+0x60>
  } else {
    printf("%d %s: unknown sys call %d\n",
    8000302e:	15848613          	addi	a2,s1,344
    80003032:	5c8c                	lw	a1,56(s1)
    80003034:	00005517          	auipc	a0,0x5
    80003038:	44450513          	addi	a0,a0,1092 # 80008478 <states.0+0x158>
    8000303c:	ffffd097          	auipc	ra,0xffffd
    80003040:	5e6080e7          	jalr	1510(ra) # 80000622 <printf>
            p->pid, p->name, num);
    p->trapframe->a0 = -1;
    80003044:	6cbc                	ld	a5,88(s1)
    80003046:	577d                	li	a4,-1
    80003048:	fbb8                	sd	a4,112(a5)
  }
}
    8000304a:	60e2                	ld	ra,24(sp)
    8000304c:	6442                	ld	s0,16(sp)
    8000304e:	64a2                	ld	s1,8(sp)
    80003050:	6902                	ld	s2,0(sp)
    80003052:	6105                	addi	sp,sp,32
    80003054:	8082                	ret

0000000080003056 <sys_exit>:
#include "spinlock.h"
#include "proc.h"

uint64
sys_exit(void)
{
    80003056:	1101                	addi	sp,sp,-32
    80003058:	ec06                	sd	ra,24(sp)
    8000305a:	e822                	sd	s0,16(sp)
    8000305c:	1000                	addi	s0,sp,32
  int n;
  if(argint(0, &n) < 0)
    8000305e:	fec40593          	addi	a1,s0,-20
    80003062:	4501                	li	a0,0
    80003064:	00000097          	auipc	ra,0x0
    80003068:	f12080e7          	jalr	-238(ra) # 80002f76 <argint>
    return -1;
    8000306c:	57fd                	li	a5,-1
  if(argint(0, &n) < 0)
    8000306e:	00054963          	bltz	a0,80003080 <sys_exit+0x2a>
  exit(n);
    80003072:	fec42503          	lw	a0,-20(s0)
    80003076:	fffff097          	auipc	ra,0xfffff
    8000307a:	44e080e7          	jalr	1102(ra) # 800024c4 <exit>
  return 0;  // not reached
    8000307e:	4781                	li	a5,0
}
    80003080:	853e                	mv	a0,a5
    80003082:	60e2                	ld	ra,24(sp)
    80003084:	6442                	ld	s0,16(sp)
    80003086:	6105                	addi	sp,sp,32
    80003088:	8082                	ret

000000008000308a <sys_getpid>:

uint64
sys_getpid(void)
{
    8000308a:	1141                	addi	sp,sp,-16
    8000308c:	e406                	sd	ra,8(sp)
    8000308e:	e022                	sd	s0,0(sp)
    80003090:	0800                	addi	s0,sp,16
  return myproc()->pid;
    80003092:	fffff097          	auipc	ra,0xfffff
    80003096:	cb8080e7          	jalr	-840(ra) # 80001d4a <myproc>
}
    8000309a:	5d08                	lw	a0,56(a0)
    8000309c:	60a2                	ld	ra,8(sp)
    8000309e:	6402                	ld	s0,0(sp)
    800030a0:	0141                	addi	sp,sp,16
    800030a2:	8082                	ret

00000000800030a4 <sys_fork>:

uint64
sys_fork(void)
{
    800030a4:	1141                	addi	sp,sp,-16
    800030a6:	e406                	sd	ra,8(sp)
    800030a8:	e022                	sd	s0,0(sp)
    800030aa:	0800                	addi	s0,sp,16
  return fork();
    800030ac:	fffff097          	auipc	ra,0xfffff
    800030b0:	0d6080e7          	jalr	214(ra) # 80002182 <fork>
}
    800030b4:	60a2                	ld	ra,8(sp)
    800030b6:	6402                	ld	s0,0(sp)
    800030b8:	0141                	addi	sp,sp,16
    800030ba:	8082                	ret

00000000800030bc <sys_wait>:

uint64
sys_wait(void)
{
    800030bc:	1101                	addi	sp,sp,-32
    800030be:	ec06                	sd	ra,24(sp)
    800030c0:	e822                	sd	s0,16(sp)
    800030c2:	1000                	addi	s0,sp,32
  uint64 p;
  if(argaddr(0, &p) < 0)
    800030c4:	fe840593          	addi	a1,s0,-24
    800030c8:	4501                	li	a0,0
    800030ca:	00000097          	auipc	ra,0x0
    800030ce:	ece080e7          	jalr	-306(ra) # 80002f98 <argaddr>
    800030d2:	87aa                	mv	a5,a0
    return -1;
    800030d4:	557d                	li	a0,-1
  if(argaddr(0, &p) < 0)
    800030d6:	0007c863          	bltz	a5,800030e6 <sys_wait+0x2a>
  return wait(p);
    800030da:	fe843503          	ld	a0,-24(s0)
    800030de:	fffff097          	auipc	ra,0xfffff
    800030e2:	5aa080e7          	jalr	1450(ra) # 80002688 <wait>
}
    800030e6:	60e2                	ld	ra,24(sp)
    800030e8:	6442                	ld	s0,16(sp)
    800030ea:	6105                	addi	sp,sp,32
    800030ec:	8082                	ret

00000000800030ee <sys_sbrk>:

uint64
sys_sbrk(void)
{
    800030ee:	7179                	addi	sp,sp,-48
    800030f0:	f406                	sd	ra,40(sp)
    800030f2:	f022                	sd	s0,32(sp)
    800030f4:	ec26                	sd	s1,24(sp)
    800030f6:	1800                	addi	s0,sp,48
  int addr;
  int n;

  if(argint(0, &n) < 0)
    800030f8:	fdc40593          	addi	a1,s0,-36
    800030fc:	4501                	li	a0,0
    800030fe:	00000097          	auipc	ra,0x0
    80003102:	e78080e7          	jalr	-392(ra) # 80002f76 <argint>
    return -1;
    80003106:	54fd                	li	s1,-1
  if(argint(0, &n) < 0)
    80003108:	00054f63          	bltz	a0,80003126 <sys_sbrk+0x38>
  addr = myproc()->sz;
    8000310c:	fffff097          	auipc	ra,0xfffff
    80003110:	c3e080e7          	jalr	-962(ra) # 80001d4a <myproc>
    80003114:	4524                	lw	s1,72(a0)
  if(growproc(n) < 0)
    80003116:	fdc42503          	lw	a0,-36(s0)
    8000311a:	fffff097          	auipc	ra,0xfffff
    8000311e:	ff4080e7          	jalr	-12(ra) # 8000210e <growproc>
    80003122:	00054863          	bltz	a0,80003132 <sys_sbrk+0x44>
    return -1;
  return addr;
}
    80003126:	8526                	mv	a0,s1
    80003128:	70a2                	ld	ra,40(sp)
    8000312a:	7402                	ld	s0,32(sp)
    8000312c:	64e2                	ld	s1,24(sp)
    8000312e:	6145                	addi	sp,sp,48
    80003130:	8082                	ret
    return -1;
    80003132:	54fd                	li	s1,-1
    80003134:	bfcd                	j	80003126 <sys_sbrk+0x38>

0000000080003136 <sys_sleep>:

uint64
sys_sleep(void)
{
    80003136:	7139                	addi	sp,sp,-64
    80003138:	fc06                	sd	ra,56(sp)
    8000313a:	f822                	sd	s0,48(sp)
    8000313c:	f426                	sd	s1,40(sp)
    8000313e:	f04a                	sd	s2,32(sp)
    80003140:	ec4e                	sd	s3,24(sp)
    80003142:	0080                	addi	s0,sp,64
  int n;
  uint ticks0;

  if(argint(0, &n) < 0)
    80003144:	fcc40593          	addi	a1,s0,-52
    80003148:	4501                	li	a0,0
    8000314a:	00000097          	auipc	ra,0x0
    8000314e:	e2c080e7          	jalr	-468(ra) # 80002f76 <argint>
    return -1;
    80003152:	57fd                	li	a5,-1
  if(argint(0, &n) < 0)
    80003154:	06054963          	bltz	a0,800031c6 <sys_sleep+0x90>
  acquire(&tickslock);
    80003158:	0001a517          	auipc	a0,0x1a
    8000315c:	08850513          	addi	a0,a0,136 # 8001d1e0 <tickslock>
    80003160:	ffffe097          	auipc	ra,0xffffe
    80003164:	b02080e7          	jalr	-1278(ra) # 80000c62 <acquire>
  ticks0 = ticks;
    80003168:	00006917          	auipc	s2,0x6
    8000316c:	eb892903          	lw	s2,-328(s2) # 80009020 <ticks>
  while(ticks - ticks0 < n){
    80003170:	fcc42783          	lw	a5,-52(s0)
    80003174:	cf85                	beqz	a5,800031ac <sys_sleep+0x76>
    if(myproc()->killed){
      release(&tickslock);
      return -1;
    }
    sleep(&ticks, &tickslock);
    80003176:	0001a997          	auipc	s3,0x1a
    8000317a:	06a98993          	addi	s3,s3,106 # 8001d1e0 <tickslock>
    8000317e:	00006497          	auipc	s1,0x6
    80003182:	ea248493          	addi	s1,s1,-350 # 80009020 <ticks>
    if(myproc()->killed){
    80003186:	fffff097          	auipc	ra,0xfffff
    8000318a:	bc4080e7          	jalr	-1084(ra) # 80001d4a <myproc>
    8000318e:	591c                	lw	a5,48(a0)
    80003190:	e3b9                	bnez	a5,800031d6 <sys_sleep+0xa0>
    sleep(&ticks, &tickslock);
    80003192:	85ce                	mv	a1,s3
    80003194:	8526                	mv	a0,s1
    80003196:	fffff097          	auipc	ra,0xfffff
    8000319a:	474080e7          	jalr	1140(ra) # 8000260a <sleep>
  while(ticks - ticks0 < n){
    8000319e:	409c                	lw	a5,0(s1)
    800031a0:	412787bb          	subw	a5,a5,s2
    800031a4:	fcc42703          	lw	a4,-52(s0)
    800031a8:	fce7efe3          	bltu	a5,a4,80003186 <sys_sleep+0x50>
  }
  release(&tickslock);
    800031ac:	0001a517          	auipc	a0,0x1a
    800031b0:	03450513          	addi	a0,a0,52 # 8001d1e0 <tickslock>
    800031b4:	ffffe097          	auipc	ra,0xffffe
    800031b8:	b62080e7          	jalr	-1182(ra) # 80000d16 <release>
  backtrace();
    800031bc:	ffffd097          	auipc	ra,0xffffd
    800031c0:	3b8080e7          	jalr	952(ra) # 80000574 <backtrace>
  return 0;
    800031c4:	4781                	li	a5,0
}
    800031c6:	853e                	mv	a0,a5
    800031c8:	70e2                	ld	ra,56(sp)
    800031ca:	7442                	ld	s0,48(sp)
    800031cc:	74a2                	ld	s1,40(sp)
    800031ce:	7902                	ld	s2,32(sp)
    800031d0:	69e2                	ld	s3,24(sp)
    800031d2:	6121                	addi	sp,sp,64
    800031d4:	8082                	ret
      release(&tickslock);
    800031d6:	0001a517          	auipc	a0,0x1a
    800031da:	00a50513          	addi	a0,a0,10 # 8001d1e0 <tickslock>
    800031de:	ffffe097          	auipc	ra,0xffffe
    800031e2:	b38080e7          	jalr	-1224(ra) # 80000d16 <release>
      return -1;
    800031e6:	57fd                	li	a5,-1
    800031e8:	bff9                	j	800031c6 <sys_sleep+0x90>

00000000800031ea <sys_kill>:

uint64
sys_kill(void)
{
    800031ea:	1101                	addi	sp,sp,-32
    800031ec:	ec06                	sd	ra,24(sp)
    800031ee:	e822                	sd	s0,16(sp)
    800031f0:	1000                	addi	s0,sp,32
  int pid;

  if(argint(0, &pid) < 0)
    800031f2:	fec40593          	addi	a1,s0,-20
    800031f6:	4501                	li	a0,0
    800031f8:	00000097          	auipc	ra,0x0
    800031fc:	d7e080e7          	jalr	-642(ra) # 80002f76 <argint>
    80003200:	87aa                	mv	a5,a0
    return -1;
    80003202:	557d                	li	a0,-1
  if(argint(0, &pid) < 0)
    80003204:	0007c863          	bltz	a5,80003214 <sys_kill+0x2a>
  return kill(pid);
    80003208:	fec42503          	lw	a0,-20(s0)
    8000320c:	fffff097          	auipc	ra,0xfffff
    80003210:	5e8080e7          	jalr	1512(ra) # 800027f4 <kill>
}
    80003214:	60e2                	ld	ra,24(sp)
    80003216:	6442                	ld	s0,16(sp)
    80003218:	6105                	addi	sp,sp,32
    8000321a:	8082                	ret

000000008000321c <sys_uptime>:

// return how many clock tick interrupts have occurred
// since start.
uint64
sys_uptime(void)
{
    8000321c:	1101                	addi	sp,sp,-32
    8000321e:	ec06                	sd	ra,24(sp)
    80003220:	e822                	sd	s0,16(sp)
    80003222:	e426                	sd	s1,8(sp)
    80003224:	1000                	addi	s0,sp,32
  uint xticks;

  acquire(&tickslock);
    80003226:	0001a517          	auipc	a0,0x1a
    8000322a:	fba50513          	addi	a0,a0,-70 # 8001d1e0 <tickslock>
    8000322e:	ffffe097          	auipc	ra,0xffffe
    80003232:	a34080e7          	jalr	-1484(ra) # 80000c62 <acquire>
  xticks = ticks;
    80003236:	00006497          	auipc	s1,0x6
    8000323a:	dea4a483          	lw	s1,-534(s1) # 80009020 <ticks>
  release(&tickslock);
    8000323e:	0001a517          	auipc	a0,0x1a
    80003242:	fa250513          	addi	a0,a0,-94 # 8001d1e0 <tickslock>
    80003246:	ffffe097          	auipc	ra,0xffffe
    8000324a:	ad0080e7          	jalr	-1328(ra) # 80000d16 <release>
  return xticks;
}
    8000324e:	02049513          	slli	a0,s1,0x20
    80003252:	9101                	srli	a0,a0,0x20
    80003254:	60e2                	ld	ra,24(sp)
    80003256:	6442                	ld	s0,16(sp)
    80003258:	64a2                	ld	s1,8(sp)
    8000325a:	6105                	addi	sp,sp,32
    8000325c:	8082                	ret

000000008000325e <sys_sigalarm>:

uint64
sys_sigalarm(void)
{
    8000325e:	1101                	addi	sp,sp,-32
    80003260:	ec06                	sd	ra,24(sp)
    80003262:	e822                	sd	s0,16(sp)
    80003264:	1000                	addi	s0,sp,32
int interval;
uint64 handler;
struct proc* p;
if(argint(0, &interval)<0 || argaddr(1, &handler)<0)
    80003266:	fec40593          	addi	a1,s0,-20
    8000326a:	4501                	li	a0,0
    8000326c:	00000097          	auipc	ra,0x0
    80003270:	d0a080e7          	jalr	-758(ra) # 80002f76 <argint>
return -1;
    80003274:	57fd                	li	a5,-1
if(argint(0, &interval)<0 || argaddr(1, &handler)<0)
    80003276:	02054b63          	bltz	a0,800032ac <sys_sigalarm+0x4e>
    8000327a:	fe040593          	addi	a1,s0,-32
    8000327e:	4505                	li	a0,1
    80003280:	00000097          	auipc	ra,0x0
    80003284:	d18080e7          	jalr	-744(ra) # 80002f98 <argaddr>
return -1;
    80003288:	57fd                	li	a5,-1
if(argint(0, &interval)<0 || argaddr(1, &handler)<0)
    8000328a:	02054163          	bltz	a0,800032ac <sys_sigalarm+0x4e>
p = myproc();
    8000328e:	fffff097          	auipc	ra,0xfffff
    80003292:	abc080e7          	jalr	-1348(ra) # 80001d4a <myproc>
p->interval = interval;
    80003296:	fec42783          	lw	a5,-20(s0)
    8000329a:	16f52423          	sw	a5,360(a0)
p->handler = handler;
    8000329e:	fe043783          	ld	a5,-32(s0)
    800032a2:	16f53823          	sd	a5,368(a0)
p->InHandler=0;
    800032a6:	16052623          	sw	zero,364(a0)
return 0;
    800032aa:	4781                	li	a5,0
}
    800032ac:	853e                	mv	a0,a5
    800032ae:	60e2                	ld	ra,24(sp)
    800032b0:	6442                	ld	s0,16(sp)
    800032b2:	6105                	addi	sp,sp,32
    800032b4:	8082                	ret

00000000800032b6 <sys_sigreturn>:

uint64
sys_sigreturn(void)
{
    800032b6:	1141                	addi	sp,sp,-16
    800032b8:	e406                	sd	ra,8(sp)
    800032ba:	e022                	sd	s0,0(sp)
    800032bc:	0800                	addi	s0,sp,16
  struct proc* p;
  p = myproc();
    800032be:	fffff097          	auipc	ra,0xfffff
    800032c2:	a8c080e7          	jalr	-1396(ra) # 80001d4a <myproc>
  *p->trapframe = p->trapframe2;
    800032c6:	18050793          	addi	a5,a0,384
    800032ca:	6d38                	ld	a4,88(a0)
    800032cc:	2a050693          	addi	a3,a0,672
    800032d0:	0007b883          	ld	a7,0(a5)
    800032d4:	0087b803          	ld	a6,8(a5)
    800032d8:	6b8c                	ld	a1,16(a5)
    800032da:	6f90                	ld	a2,24(a5)
    800032dc:	01173023          	sd	a7,0(a4)
    800032e0:	01073423          	sd	a6,8(a4)
    800032e4:	eb0c                	sd	a1,16(a4)
    800032e6:	ef10                	sd	a2,24(a4)
    800032e8:	02078793          	addi	a5,a5,32
    800032ec:	02070713          	addi	a4,a4,32
    800032f0:	fed790e3          	bne	a5,a3,800032d0 <sys_sigreturn+0x1a>
  /** 为下⼀次回调handler函数做准备 */
  p->ticks = 0;
    800032f4:	16052c23          	sw	zero,376(a0)
  p->InHandler = 0;
    800032f8:	16052623          	sw	zero,364(a0)
  return 0;
}
    800032fc:	4501                	li	a0,0
    800032fe:	60a2                	ld	ra,8(sp)
    80003300:	6402                	ld	s0,0(sp)
    80003302:	0141                	addi	sp,sp,16
    80003304:	8082                	ret

0000000080003306 <sys_change_priority>:

uint64
sys_change_priority(void)
{
    80003306:	7179                	addi	sp,sp,-48
    80003308:	f406                	sd	ra,40(sp)
    8000330a:	f022                	sd	s0,32(sp)
    8000330c:	ec26                	sd	s1,24(sp)
    8000330e:	1800                	addi	s0,sp,48
  int dest_offset;
  argint(0, &dest_offset);
    80003310:	fdc40593          	addi	a1,s0,-36
    80003314:	4501                	li	a0,0
    80003316:	00000097          	auipc	ra,0x0
    8000331a:	c60080e7          	jalr	-928(ra) # 80002f76 <argint>
  struct proc *p = myproc();
    8000331e:	fffff097          	auipc	ra,0xfffff
    80003322:	a2c080e7          	jalr	-1492(ra) # 80001d4a <myproc>
    80003326:	84aa                	mv	s1,a0
  int src_offset = p->priority;
  move_proc_between_lists(src_offset, dest_offset, p);
    80003328:	862a                	mv	a2,a0
    8000332a:	fdc42583          	lw	a1,-36(s0)
    8000332e:	2ac52503          	lw	a0,684(a0)
    80003332:	ffffe097          	auipc	ra,0xffffe
    80003336:	698080e7          	jalr	1688(ra) # 800019ca <move_proc_between_lists>

  p->now_limit = 1 << (dest_offset + 2); // 现在的限制
    8000333a:	fdc42703          	lw	a4,-36(s0)
    8000333e:	0027069b          	addiw	a3,a4,2
    80003342:	4785                	li	a5,1
    80003344:	00d797bb          	sllw	a5,a5,a3
    80003348:	2af4a223          	sw	a5,676(s1)
  p->my_ticket = 0;                      // 现在的轮数
    8000334c:	2a04a423          	sw	zero,680(s1)
  p->priority = dest_offset;             // 对应的在第几个优先级队列
    80003350:	2ae4a623          	sw	a4,684(s1)
  return 0;
}
    80003354:	4501                	li	a0,0
    80003356:	70a2                	ld	ra,40(sp)
    80003358:	7402                	ld	s0,32(sp)
    8000335a:	64e2                	ld	s1,24(sp)
    8000335c:	6145                	addi	sp,sp,48
    8000335e:	8082                	ret

0000000080003360 <sys_show_priority>:

uint64
sys_show_priority(void)
{
    80003360:	1141                	addi	sp,sp,-16
    80003362:	e406                	sd	ra,8(sp)
    80003364:	e022                	sd	s0,0(sp)
    80003366:	0800                	addi	s0,sp,16
  struct proc *p = myproc();
    80003368:	fffff097          	auipc	ra,0xfffff
    8000336c:	9e2080e7          	jalr	-1566(ra) # 80001d4a <myproc>
  printf("Limit: %d Ticket: %d Priority: %d\n",
    80003370:	2ac52683          	lw	a3,684(a0)
    80003374:	2a852603          	lw	a2,680(a0)
    80003378:	2a452583          	lw	a1,676(a0)
    8000337c:	00005517          	auipc	a0,0x5
    80003380:	20c50513          	addi	a0,a0,524 # 80008588 <syscalls+0xd8>
    80003384:	ffffd097          	auipc	ra,0xffffd
    80003388:	29e080e7          	jalr	670(ra) # 80000622 <printf>
   p->now_limit,p->my_ticket, p->priority);
  return 0;
}
    8000338c:	4501                	li	a0,0
    8000338e:	60a2                	ld	ra,8(sp)
    80003390:	6402                	ld	s0,0(sp)
    80003392:	0141                	addi	sp,sp,16
    80003394:	8082                	ret

0000000080003396 <sys_show_time>:

uint64
sys_show_time(void)
{
    80003396:	1141                	addi	sp,sp,-16
    80003398:	e406                	sd	ra,8(sp)
    8000339a:	e022                	sd	s0,0(sp)
    8000339c:	0800                	addi	s0,sp,16
  printf("\nticket_time now is %d\n",ticks);
    8000339e:	00006597          	auipc	a1,0x6
    800033a2:	c825a583          	lw	a1,-894(a1) # 80009020 <ticks>
    800033a6:	00005517          	auipc	a0,0x5
    800033aa:	20a50513          	addi	a0,a0,522 # 800085b0 <syscalls+0x100>
    800033ae:	ffffd097          	auipc	ra,0xffffd
    800033b2:	274080e7          	jalr	628(ra) # 80000622 <printf>
  return 0;
    800033b6:	4501                	li	a0,0
    800033b8:	60a2                	ld	ra,8(sp)
    800033ba:	6402                	ld	s0,0(sp)
    800033bc:	0141                	addi	sp,sp,16
    800033be:	8082                	ret

00000000800033c0 <binit>:
  struct buf head;
} bcache;

void
binit(void)
{
    800033c0:	7179                	addi	sp,sp,-48
    800033c2:	f406                	sd	ra,40(sp)
    800033c4:	f022                	sd	s0,32(sp)
    800033c6:	ec26                	sd	s1,24(sp)
    800033c8:	e84a                	sd	s2,16(sp)
    800033ca:	e44e                	sd	s3,8(sp)
    800033cc:	e052                	sd	s4,0(sp)
    800033ce:	1800                	addi	s0,sp,48
  struct buf *b;

  initlock(&bcache.lock, "bcache");
    800033d0:	00005597          	auipc	a1,0x5
    800033d4:	1f858593          	addi	a1,a1,504 # 800085c8 <syscalls+0x118>
    800033d8:	0001a517          	auipc	a0,0x1a
    800033dc:	e2050513          	addi	a0,a0,-480 # 8001d1f8 <bcache>
    800033e0:	ffffd097          	auipc	ra,0xffffd
    800033e4:	7f2080e7          	jalr	2034(ra) # 80000bd2 <initlock>

  // Create linked list of buffers
  bcache.head.prev = &bcache.head;
    800033e8:	00022797          	auipc	a5,0x22
    800033ec:	e1078793          	addi	a5,a5,-496 # 800251f8 <bcache+0x8000>
    800033f0:	00022717          	auipc	a4,0x22
    800033f4:	07070713          	addi	a4,a4,112 # 80025460 <bcache+0x8268>
    800033f8:	2ae7b823          	sd	a4,688(a5)
  bcache.head.next = &bcache.head;
    800033fc:	2ae7bc23          	sd	a4,696(a5)
  for(b = bcache.buf; b < bcache.buf+NBUF; b++){
    80003400:	0001a497          	auipc	s1,0x1a
    80003404:	e1048493          	addi	s1,s1,-496 # 8001d210 <bcache+0x18>
    b->next = bcache.head.next;
    80003408:	893e                	mv	s2,a5
    b->prev = &bcache.head;
    8000340a:	89ba                	mv	s3,a4
    initsleeplock(&b->lock, "buffer");
    8000340c:	00005a17          	auipc	s4,0x5
    80003410:	1c4a0a13          	addi	s4,s4,452 # 800085d0 <syscalls+0x120>
    b->next = bcache.head.next;
    80003414:	2b893783          	ld	a5,696(s2)
    80003418:	e8bc                	sd	a5,80(s1)
    b->prev = &bcache.head;
    8000341a:	0534b423          	sd	s3,72(s1)
    initsleeplock(&b->lock, "buffer");
    8000341e:	85d2                	mv	a1,s4
    80003420:	01048513          	addi	a0,s1,16
    80003424:	00001097          	auipc	ra,0x1
    80003428:	4b2080e7          	jalr	1202(ra) # 800048d6 <initsleeplock>
    bcache.head.next->prev = b;
    8000342c:	2b893783          	ld	a5,696(s2)
    80003430:	e7a4                	sd	s1,72(a5)
    bcache.head.next = b;
    80003432:	2a993c23          	sd	s1,696(s2)
  for(b = bcache.buf; b < bcache.buf+NBUF; b++){
    80003436:	45848493          	addi	s1,s1,1112
    8000343a:	fd349de3          	bne	s1,s3,80003414 <binit+0x54>
  }
}
    8000343e:	70a2                	ld	ra,40(sp)
    80003440:	7402                	ld	s0,32(sp)
    80003442:	64e2                	ld	s1,24(sp)
    80003444:	6942                	ld	s2,16(sp)
    80003446:	69a2                	ld	s3,8(sp)
    80003448:	6a02                	ld	s4,0(sp)
    8000344a:	6145                	addi	sp,sp,48
    8000344c:	8082                	ret

000000008000344e <bread>:
}

// Return a locked buf with the contents of the indicated block.
struct buf*
bread(uint dev, uint blockno)
{
    8000344e:	7179                	addi	sp,sp,-48
    80003450:	f406                	sd	ra,40(sp)
    80003452:	f022                	sd	s0,32(sp)
    80003454:	ec26                	sd	s1,24(sp)
    80003456:	e84a                	sd	s2,16(sp)
    80003458:	e44e                	sd	s3,8(sp)
    8000345a:	1800                	addi	s0,sp,48
    8000345c:	892a                	mv	s2,a0
    8000345e:	89ae                	mv	s3,a1
  acquire(&bcache.lock);
    80003460:	0001a517          	auipc	a0,0x1a
    80003464:	d9850513          	addi	a0,a0,-616 # 8001d1f8 <bcache>
    80003468:	ffffd097          	auipc	ra,0xffffd
    8000346c:	7fa080e7          	jalr	2042(ra) # 80000c62 <acquire>
  for(b = bcache.head.next; b != &bcache.head; b = b->next){
    80003470:	00022497          	auipc	s1,0x22
    80003474:	0404b483          	ld	s1,64(s1) # 800254b0 <bcache+0x82b8>
    80003478:	00022797          	auipc	a5,0x22
    8000347c:	fe878793          	addi	a5,a5,-24 # 80025460 <bcache+0x8268>
    80003480:	02f48f63          	beq	s1,a5,800034be <bread+0x70>
    80003484:	873e                	mv	a4,a5
    80003486:	a021                	j	8000348e <bread+0x40>
    80003488:	68a4                	ld	s1,80(s1)
    8000348a:	02e48a63          	beq	s1,a4,800034be <bread+0x70>
    if(b->dev == dev && b->blockno == blockno){
    8000348e:	449c                	lw	a5,8(s1)
    80003490:	ff279ce3          	bne	a5,s2,80003488 <bread+0x3a>
    80003494:	44dc                	lw	a5,12(s1)
    80003496:	ff3799e3          	bne	a5,s3,80003488 <bread+0x3a>
      b->refcnt++;
    8000349a:	40bc                	lw	a5,64(s1)
    8000349c:	2785                	addiw	a5,a5,1
    8000349e:	c0bc                	sw	a5,64(s1)
      release(&bcache.lock);
    800034a0:	0001a517          	auipc	a0,0x1a
    800034a4:	d5850513          	addi	a0,a0,-680 # 8001d1f8 <bcache>
    800034a8:	ffffe097          	auipc	ra,0xffffe
    800034ac:	86e080e7          	jalr	-1938(ra) # 80000d16 <release>
      acquiresleep(&b->lock);
    800034b0:	01048513          	addi	a0,s1,16
    800034b4:	00001097          	auipc	ra,0x1
    800034b8:	45c080e7          	jalr	1116(ra) # 80004910 <acquiresleep>
      return b;
    800034bc:	a8b9                	j	8000351a <bread+0xcc>
  for(b = bcache.head.prev; b != &bcache.head; b = b->prev){
    800034be:	00022497          	auipc	s1,0x22
    800034c2:	fea4b483          	ld	s1,-22(s1) # 800254a8 <bcache+0x82b0>
    800034c6:	00022797          	auipc	a5,0x22
    800034ca:	f9a78793          	addi	a5,a5,-102 # 80025460 <bcache+0x8268>
    800034ce:	00f48863          	beq	s1,a5,800034de <bread+0x90>
    800034d2:	873e                	mv	a4,a5
    if(b->refcnt == 0) {
    800034d4:	40bc                	lw	a5,64(s1)
    800034d6:	cf81                	beqz	a5,800034ee <bread+0xa0>
  for(b = bcache.head.prev; b != &bcache.head; b = b->prev){
    800034d8:	64a4                	ld	s1,72(s1)
    800034da:	fee49de3          	bne	s1,a4,800034d4 <bread+0x86>
  panic("bget: no buffers");
    800034de:	00005517          	auipc	a0,0x5
    800034e2:	0fa50513          	addi	a0,a0,250 # 800085d8 <syscalls+0x128>
    800034e6:	ffffd097          	auipc	ra,0xffffd
    800034ea:	0ea080e7          	jalr	234(ra) # 800005d0 <panic>
      b->dev = dev;
    800034ee:	0124a423          	sw	s2,8(s1)
      b->blockno = blockno;
    800034f2:	0134a623          	sw	s3,12(s1)
      b->valid = 0;
    800034f6:	0004a023          	sw	zero,0(s1)
      b->refcnt = 1;
    800034fa:	4785                	li	a5,1
    800034fc:	c0bc                	sw	a5,64(s1)
      release(&bcache.lock);
    800034fe:	0001a517          	auipc	a0,0x1a
    80003502:	cfa50513          	addi	a0,a0,-774 # 8001d1f8 <bcache>
    80003506:	ffffe097          	auipc	ra,0xffffe
    8000350a:	810080e7          	jalr	-2032(ra) # 80000d16 <release>
      acquiresleep(&b->lock);
    8000350e:	01048513          	addi	a0,s1,16
    80003512:	00001097          	auipc	ra,0x1
    80003516:	3fe080e7          	jalr	1022(ra) # 80004910 <acquiresleep>
  struct buf *b;

  b = bget(dev, blockno);
  if(!b->valid) {
    8000351a:	409c                	lw	a5,0(s1)
    8000351c:	cb89                	beqz	a5,8000352e <bread+0xe0>
    virtio_disk_rw(b, 0);
    b->valid = 1;
  }
  return b;
}
    8000351e:	8526                	mv	a0,s1
    80003520:	70a2                	ld	ra,40(sp)
    80003522:	7402                	ld	s0,32(sp)
    80003524:	64e2                	ld	s1,24(sp)
    80003526:	6942                	ld	s2,16(sp)
    80003528:	69a2                	ld	s3,8(sp)
    8000352a:	6145                	addi	sp,sp,48
    8000352c:	8082                	ret
    virtio_disk_rw(b, 0);
    8000352e:	4581                	li	a1,0
    80003530:	8526                	mv	a0,s1
    80003532:	00003097          	auipc	ra,0x3
    80003536:	f2a080e7          	jalr	-214(ra) # 8000645c <virtio_disk_rw>
    b->valid = 1;
    8000353a:	4785                	li	a5,1
    8000353c:	c09c                	sw	a5,0(s1)
  return b;
    8000353e:	b7c5                	j	8000351e <bread+0xd0>

0000000080003540 <bwrite>:

// Write b's contents to disk.  Must be locked.
void
bwrite(struct buf *b)
{
    80003540:	1101                	addi	sp,sp,-32
    80003542:	ec06                	sd	ra,24(sp)
    80003544:	e822                	sd	s0,16(sp)
    80003546:	e426                	sd	s1,8(sp)
    80003548:	1000                	addi	s0,sp,32
    8000354a:	84aa                	mv	s1,a0
  if(!holdingsleep(&b->lock))
    8000354c:	0541                	addi	a0,a0,16
    8000354e:	00001097          	auipc	ra,0x1
    80003552:	45c080e7          	jalr	1116(ra) # 800049aa <holdingsleep>
    80003556:	cd01                	beqz	a0,8000356e <bwrite+0x2e>
    panic("bwrite");
  virtio_disk_rw(b, 1);
    80003558:	4585                	li	a1,1
    8000355a:	8526                	mv	a0,s1
    8000355c:	00003097          	auipc	ra,0x3
    80003560:	f00080e7          	jalr	-256(ra) # 8000645c <virtio_disk_rw>
}
    80003564:	60e2                	ld	ra,24(sp)
    80003566:	6442                	ld	s0,16(sp)
    80003568:	64a2                	ld	s1,8(sp)
    8000356a:	6105                	addi	sp,sp,32
    8000356c:	8082                	ret
    panic("bwrite");
    8000356e:	00005517          	auipc	a0,0x5
    80003572:	08250513          	addi	a0,a0,130 # 800085f0 <syscalls+0x140>
    80003576:	ffffd097          	auipc	ra,0xffffd
    8000357a:	05a080e7          	jalr	90(ra) # 800005d0 <panic>

000000008000357e <brelse>:

// Release a locked buffer.
// Move to the head of the most-recently-used list.
void
brelse(struct buf *b)
{
    8000357e:	1101                	addi	sp,sp,-32
    80003580:	ec06                	sd	ra,24(sp)
    80003582:	e822                	sd	s0,16(sp)
    80003584:	e426                	sd	s1,8(sp)
    80003586:	e04a                	sd	s2,0(sp)
    80003588:	1000                	addi	s0,sp,32
    8000358a:	84aa                	mv	s1,a0
  if(!holdingsleep(&b->lock))
    8000358c:	01050913          	addi	s2,a0,16
    80003590:	854a                	mv	a0,s2
    80003592:	00001097          	auipc	ra,0x1
    80003596:	418080e7          	jalr	1048(ra) # 800049aa <holdingsleep>
    8000359a:	c92d                	beqz	a0,8000360c <brelse+0x8e>
    panic("brelse");

  releasesleep(&b->lock);
    8000359c:	854a                	mv	a0,s2
    8000359e:	00001097          	auipc	ra,0x1
    800035a2:	3c8080e7          	jalr	968(ra) # 80004966 <releasesleep>

  acquire(&bcache.lock);
    800035a6:	0001a517          	auipc	a0,0x1a
    800035aa:	c5250513          	addi	a0,a0,-942 # 8001d1f8 <bcache>
    800035ae:	ffffd097          	auipc	ra,0xffffd
    800035b2:	6b4080e7          	jalr	1716(ra) # 80000c62 <acquire>
  b->refcnt--;
    800035b6:	40bc                	lw	a5,64(s1)
    800035b8:	37fd                	addiw	a5,a5,-1
    800035ba:	0007871b          	sext.w	a4,a5
    800035be:	c0bc                	sw	a5,64(s1)
  if (b->refcnt == 0) {
    800035c0:	eb05                	bnez	a4,800035f0 <brelse+0x72>
    // no one is waiting for it.
    b->next->prev = b->prev;
    800035c2:	68bc                	ld	a5,80(s1)
    800035c4:	64b8                	ld	a4,72(s1)
    800035c6:	e7b8                	sd	a4,72(a5)
    b->prev->next = b->next;
    800035c8:	64bc                	ld	a5,72(s1)
    800035ca:	68b8                	ld	a4,80(s1)
    800035cc:	ebb8                	sd	a4,80(a5)
    b->next = bcache.head.next;
    800035ce:	00022797          	auipc	a5,0x22
    800035d2:	c2a78793          	addi	a5,a5,-982 # 800251f8 <bcache+0x8000>
    800035d6:	2b87b703          	ld	a4,696(a5)
    800035da:	e8b8                	sd	a4,80(s1)
    b->prev = &bcache.head;
    800035dc:	00022717          	auipc	a4,0x22
    800035e0:	e8470713          	addi	a4,a4,-380 # 80025460 <bcache+0x8268>
    800035e4:	e4b8                	sd	a4,72(s1)
    bcache.head.next->prev = b;
    800035e6:	2b87b703          	ld	a4,696(a5)
    800035ea:	e724                	sd	s1,72(a4)
    bcache.head.next = b;
    800035ec:	2a97bc23          	sd	s1,696(a5)
  }
  
  release(&bcache.lock);
    800035f0:	0001a517          	auipc	a0,0x1a
    800035f4:	c0850513          	addi	a0,a0,-1016 # 8001d1f8 <bcache>
    800035f8:	ffffd097          	auipc	ra,0xffffd
    800035fc:	71e080e7          	jalr	1822(ra) # 80000d16 <release>
}
    80003600:	60e2                	ld	ra,24(sp)
    80003602:	6442                	ld	s0,16(sp)
    80003604:	64a2                	ld	s1,8(sp)
    80003606:	6902                	ld	s2,0(sp)
    80003608:	6105                	addi	sp,sp,32
    8000360a:	8082                	ret
    panic("brelse");
    8000360c:	00005517          	auipc	a0,0x5
    80003610:	fec50513          	addi	a0,a0,-20 # 800085f8 <syscalls+0x148>
    80003614:	ffffd097          	auipc	ra,0xffffd
    80003618:	fbc080e7          	jalr	-68(ra) # 800005d0 <panic>

000000008000361c <bpin>:

void
bpin(struct buf *b) {
    8000361c:	1101                	addi	sp,sp,-32
    8000361e:	ec06                	sd	ra,24(sp)
    80003620:	e822                	sd	s0,16(sp)
    80003622:	e426                	sd	s1,8(sp)
    80003624:	1000                	addi	s0,sp,32
    80003626:	84aa                	mv	s1,a0
  acquire(&bcache.lock);
    80003628:	0001a517          	auipc	a0,0x1a
    8000362c:	bd050513          	addi	a0,a0,-1072 # 8001d1f8 <bcache>
    80003630:	ffffd097          	auipc	ra,0xffffd
    80003634:	632080e7          	jalr	1586(ra) # 80000c62 <acquire>
  b->refcnt++;
    80003638:	40bc                	lw	a5,64(s1)
    8000363a:	2785                	addiw	a5,a5,1
    8000363c:	c0bc                	sw	a5,64(s1)
  release(&bcache.lock);
    8000363e:	0001a517          	auipc	a0,0x1a
    80003642:	bba50513          	addi	a0,a0,-1094 # 8001d1f8 <bcache>
    80003646:	ffffd097          	auipc	ra,0xffffd
    8000364a:	6d0080e7          	jalr	1744(ra) # 80000d16 <release>
}
    8000364e:	60e2                	ld	ra,24(sp)
    80003650:	6442                	ld	s0,16(sp)
    80003652:	64a2                	ld	s1,8(sp)
    80003654:	6105                	addi	sp,sp,32
    80003656:	8082                	ret

0000000080003658 <bunpin>:

void
bunpin(struct buf *b) {
    80003658:	1101                	addi	sp,sp,-32
    8000365a:	ec06                	sd	ra,24(sp)
    8000365c:	e822                	sd	s0,16(sp)
    8000365e:	e426                	sd	s1,8(sp)
    80003660:	1000                	addi	s0,sp,32
    80003662:	84aa                	mv	s1,a0
  acquire(&bcache.lock);
    80003664:	0001a517          	auipc	a0,0x1a
    80003668:	b9450513          	addi	a0,a0,-1132 # 8001d1f8 <bcache>
    8000366c:	ffffd097          	auipc	ra,0xffffd
    80003670:	5f6080e7          	jalr	1526(ra) # 80000c62 <acquire>
  b->refcnt--;
    80003674:	40bc                	lw	a5,64(s1)
    80003676:	37fd                	addiw	a5,a5,-1
    80003678:	c0bc                	sw	a5,64(s1)
  release(&bcache.lock);
    8000367a:	0001a517          	auipc	a0,0x1a
    8000367e:	b7e50513          	addi	a0,a0,-1154 # 8001d1f8 <bcache>
    80003682:	ffffd097          	auipc	ra,0xffffd
    80003686:	694080e7          	jalr	1684(ra) # 80000d16 <release>
}
    8000368a:	60e2                	ld	ra,24(sp)
    8000368c:	6442                	ld	s0,16(sp)
    8000368e:	64a2                	ld	s1,8(sp)
    80003690:	6105                	addi	sp,sp,32
    80003692:	8082                	ret

0000000080003694 <bfree>:
}

// Free a disk block.
static void
bfree(int dev, uint b)
{
    80003694:	1101                	addi	sp,sp,-32
    80003696:	ec06                	sd	ra,24(sp)
    80003698:	e822                	sd	s0,16(sp)
    8000369a:	e426                	sd	s1,8(sp)
    8000369c:	e04a                	sd	s2,0(sp)
    8000369e:	1000                	addi	s0,sp,32
    800036a0:	84ae                	mv	s1,a1
  struct buf *bp;
  int bi, m;

  bp = bread(dev, BBLOCK(b, sb));
    800036a2:	00d5d59b          	srliw	a1,a1,0xd
    800036a6:	00022797          	auipc	a5,0x22
    800036aa:	22e7a783          	lw	a5,558(a5) # 800258d4 <sb+0x1c>
    800036ae:	9dbd                	addw	a1,a1,a5
    800036b0:	00000097          	auipc	ra,0x0
    800036b4:	d9e080e7          	jalr	-610(ra) # 8000344e <bread>
  bi = b % BPB;
  m = 1 << (bi % 8);
    800036b8:	0074f713          	andi	a4,s1,7
    800036bc:	4785                	li	a5,1
    800036be:	00e797bb          	sllw	a5,a5,a4
  if((bp->data[bi/8] & m) == 0)
    800036c2:	14ce                	slli	s1,s1,0x33
    800036c4:	90d9                	srli	s1,s1,0x36
    800036c6:	00950733          	add	a4,a0,s1
    800036ca:	05874703          	lbu	a4,88(a4)
    800036ce:	00e7f6b3          	and	a3,a5,a4
    800036d2:	c69d                	beqz	a3,80003700 <bfree+0x6c>
    800036d4:	892a                	mv	s2,a0
    panic("freeing free block");
  bp->data[bi/8] &= ~m;
    800036d6:	94aa                	add	s1,s1,a0
    800036d8:	fff7c793          	not	a5,a5
    800036dc:	8ff9                	and	a5,a5,a4
    800036de:	04f48c23          	sb	a5,88(s1)
  log_write(bp);
    800036e2:	00001097          	auipc	ra,0x1
    800036e6:	106080e7          	jalr	262(ra) # 800047e8 <log_write>
  brelse(bp);
    800036ea:	854a                	mv	a0,s2
    800036ec:	00000097          	auipc	ra,0x0
    800036f0:	e92080e7          	jalr	-366(ra) # 8000357e <brelse>
}
    800036f4:	60e2                	ld	ra,24(sp)
    800036f6:	6442                	ld	s0,16(sp)
    800036f8:	64a2                	ld	s1,8(sp)
    800036fa:	6902                	ld	s2,0(sp)
    800036fc:	6105                	addi	sp,sp,32
    800036fe:	8082                	ret
    panic("freeing free block");
    80003700:	00005517          	auipc	a0,0x5
    80003704:	f0050513          	addi	a0,a0,-256 # 80008600 <syscalls+0x150>
    80003708:	ffffd097          	auipc	ra,0xffffd
    8000370c:	ec8080e7          	jalr	-312(ra) # 800005d0 <panic>

0000000080003710 <balloc>:
{
    80003710:	711d                	addi	sp,sp,-96
    80003712:	ec86                	sd	ra,88(sp)
    80003714:	e8a2                	sd	s0,80(sp)
    80003716:	e4a6                	sd	s1,72(sp)
    80003718:	e0ca                	sd	s2,64(sp)
    8000371a:	fc4e                	sd	s3,56(sp)
    8000371c:	f852                	sd	s4,48(sp)
    8000371e:	f456                	sd	s5,40(sp)
    80003720:	f05a                	sd	s6,32(sp)
    80003722:	ec5e                	sd	s7,24(sp)
    80003724:	e862                	sd	s8,16(sp)
    80003726:	e466                	sd	s9,8(sp)
    80003728:	1080                	addi	s0,sp,96
  for(b = 0; b < sb.size; b += BPB){
    8000372a:	00022797          	auipc	a5,0x22
    8000372e:	1927a783          	lw	a5,402(a5) # 800258bc <sb+0x4>
    80003732:	cbd1                	beqz	a5,800037c6 <balloc+0xb6>
    80003734:	8baa                	mv	s7,a0
    80003736:	4a81                	li	s5,0
    bp = bread(dev, BBLOCK(b, sb));
    80003738:	00022b17          	auipc	s6,0x22
    8000373c:	180b0b13          	addi	s6,s6,384 # 800258b8 <sb>
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    80003740:	4c01                	li	s8,0
      m = 1 << (bi % 8);
    80003742:	4985                	li	s3,1
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    80003744:	6a09                	lui	s4,0x2
  for(b = 0; b < sb.size; b += BPB){
    80003746:	6c89                	lui	s9,0x2
    80003748:	a831                	j	80003764 <balloc+0x54>
    brelse(bp);
    8000374a:	854a                	mv	a0,s2
    8000374c:	00000097          	auipc	ra,0x0
    80003750:	e32080e7          	jalr	-462(ra) # 8000357e <brelse>
  for(b = 0; b < sb.size; b += BPB){
    80003754:	015c87bb          	addw	a5,s9,s5
    80003758:	00078a9b          	sext.w	s5,a5
    8000375c:	004b2703          	lw	a4,4(s6)
    80003760:	06eaf363          	bgeu	s5,a4,800037c6 <balloc+0xb6>
    bp = bread(dev, BBLOCK(b, sb));
    80003764:	41fad79b          	sraiw	a5,s5,0x1f
    80003768:	0137d79b          	srliw	a5,a5,0x13
    8000376c:	015787bb          	addw	a5,a5,s5
    80003770:	40d7d79b          	sraiw	a5,a5,0xd
    80003774:	01cb2583          	lw	a1,28(s6)
    80003778:	9dbd                	addw	a1,a1,a5
    8000377a:	855e                	mv	a0,s7
    8000377c:	00000097          	auipc	ra,0x0
    80003780:	cd2080e7          	jalr	-814(ra) # 8000344e <bread>
    80003784:	892a                	mv	s2,a0
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    80003786:	004b2503          	lw	a0,4(s6)
    8000378a:	000a849b          	sext.w	s1,s5
    8000378e:	8662                	mv	a2,s8
    80003790:	faa4fde3          	bgeu	s1,a0,8000374a <balloc+0x3a>
      m = 1 << (bi % 8);
    80003794:	41f6579b          	sraiw	a5,a2,0x1f
    80003798:	01d7d69b          	srliw	a3,a5,0x1d
    8000379c:	00c6873b          	addw	a4,a3,a2
    800037a0:	00777793          	andi	a5,a4,7
    800037a4:	9f95                	subw	a5,a5,a3
    800037a6:	00f997bb          	sllw	a5,s3,a5
      if((bp->data[bi/8] & m) == 0){  // Is block free?
    800037aa:	4037571b          	sraiw	a4,a4,0x3
    800037ae:	00e906b3          	add	a3,s2,a4
    800037b2:	0586c683          	lbu	a3,88(a3)
    800037b6:	00d7f5b3          	and	a1,a5,a3
    800037ba:	cd91                	beqz	a1,800037d6 <balloc+0xc6>
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    800037bc:	2605                	addiw	a2,a2,1
    800037be:	2485                	addiw	s1,s1,1
    800037c0:	fd4618e3          	bne	a2,s4,80003790 <balloc+0x80>
    800037c4:	b759                	j	8000374a <balloc+0x3a>
  panic("balloc: out of blocks");
    800037c6:	00005517          	auipc	a0,0x5
    800037ca:	e5250513          	addi	a0,a0,-430 # 80008618 <syscalls+0x168>
    800037ce:	ffffd097          	auipc	ra,0xffffd
    800037d2:	e02080e7          	jalr	-510(ra) # 800005d0 <panic>
        bp->data[bi/8] |= m;  // Mark block in use.
    800037d6:	974a                	add	a4,a4,s2
    800037d8:	8fd5                	or	a5,a5,a3
    800037da:	04f70c23          	sb	a5,88(a4)
        log_write(bp);
    800037de:	854a                	mv	a0,s2
    800037e0:	00001097          	auipc	ra,0x1
    800037e4:	008080e7          	jalr	8(ra) # 800047e8 <log_write>
        brelse(bp);
    800037e8:	854a                	mv	a0,s2
    800037ea:	00000097          	auipc	ra,0x0
    800037ee:	d94080e7          	jalr	-620(ra) # 8000357e <brelse>
  bp = bread(dev, bno);
    800037f2:	85a6                	mv	a1,s1
    800037f4:	855e                	mv	a0,s7
    800037f6:	00000097          	auipc	ra,0x0
    800037fa:	c58080e7          	jalr	-936(ra) # 8000344e <bread>
    800037fe:	892a                	mv	s2,a0
  memset(bp->data, 0, BSIZE);
    80003800:	40000613          	li	a2,1024
    80003804:	4581                	li	a1,0
    80003806:	05850513          	addi	a0,a0,88
    8000380a:	ffffd097          	auipc	ra,0xffffd
    8000380e:	554080e7          	jalr	1364(ra) # 80000d5e <memset>
  log_write(bp);
    80003812:	854a                	mv	a0,s2
    80003814:	00001097          	auipc	ra,0x1
    80003818:	fd4080e7          	jalr	-44(ra) # 800047e8 <log_write>
  brelse(bp);
    8000381c:	854a                	mv	a0,s2
    8000381e:	00000097          	auipc	ra,0x0
    80003822:	d60080e7          	jalr	-672(ra) # 8000357e <brelse>
}
    80003826:	8526                	mv	a0,s1
    80003828:	60e6                	ld	ra,88(sp)
    8000382a:	6446                	ld	s0,80(sp)
    8000382c:	64a6                	ld	s1,72(sp)
    8000382e:	6906                	ld	s2,64(sp)
    80003830:	79e2                	ld	s3,56(sp)
    80003832:	7a42                	ld	s4,48(sp)
    80003834:	7aa2                	ld	s5,40(sp)
    80003836:	7b02                	ld	s6,32(sp)
    80003838:	6be2                	ld	s7,24(sp)
    8000383a:	6c42                	ld	s8,16(sp)
    8000383c:	6ca2                	ld	s9,8(sp)
    8000383e:	6125                	addi	sp,sp,96
    80003840:	8082                	ret

0000000080003842 <bmap>:

// Return the disk block address of the nth block in inode ip.
// If there is no such block, bmap allocates one.
static uint
bmap(struct inode *ip, uint bn)
{
    80003842:	7179                	addi	sp,sp,-48
    80003844:	f406                	sd	ra,40(sp)
    80003846:	f022                	sd	s0,32(sp)
    80003848:	ec26                	sd	s1,24(sp)
    8000384a:	e84a                	sd	s2,16(sp)
    8000384c:	e44e                	sd	s3,8(sp)
    8000384e:	e052                	sd	s4,0(sp)
    80003850:	1800                	addi	s0,sp,48
    80003852:	892a                	mv	s2,a0
  uint addr, *a;
  struct buf *bp;

  if(bn < NDIRECT){
    80003854:	47ad                	li	a5,11
    80003856:	04b7fe63          	bgeu	a5,a1,800038b2 <bmap+0x70>
    if((addr = ip->addrs[bn]) == 0)
      ip->addrs[bn] = addr = balloc(ip->dev);
    return addr;
  }
  bn -= NDIRECT;
    8000385a:	ff45849b          	addiw	s1,a1,-12
    8000385e:	0004871b          	sext.w	a4,s1

  if(bn < NINDIRECT){
    80003862:	0ff00793          	li	a5,255
    80003866:	0ae7e463          	bltu	a5,a4,8000390e <bmap+0xcc>
    // Load indirect block, allocating if necessary.
    if((addr = ip->addrs[NDIRECT]) == 0)
    8000386a:	08052583          	lw	a1,128(a0)
    8000386e:	c5b5                	beqz	a1,800038da <bmap+0x98>
      ip->addrs[NDIRECT] = addr = balloc(ip->dev);
    bp = bread(ip->dev, addr);
    80003870:	00092503          	lw	a0,0(s2)
    80003874:	00000097          	auipc	ra,0x0
    80003878:	bda080e7          	jalr	-1062(ra) # 8000344e <bread>
    8000387c:	8a2a                	mv	s4,a0
    a = (uint*)bp->data;
    8000387e:	05850793          	addi	a5,a0,88
    if((addr = a[bn]) == 0){
    80003882:	02049713          	slli	a4,s1,0x20
    80003886:	01e75593          	srli	a1,a4,0x1e
    8000388a:	00b784b3          	add	s1,a5,a1
    8000388e:	0004a983          	lw	s3,0(s1)
    80003892:	04098e63          	beqz	s3,800038ee <bmap+0xac>
      a[bn] = addr = balloc(ip->dev);
      log_write(bp);
    }
    brelse(bp);
    80003896:	8552                	mv	a0,s4
    80003898:	00000097          	auipc	ra,0x0
    8000389c:	ce6080e7          	jalr	-794(ra) # 8000357e <brelse>
    return addr;
  }

  panic("bmap: out of range");
}
    800038a0:	854e                	mv	a0,s3
    800038a2:	70a2                	ld	ra,40(sp)
    800038a4:	7402                	ld	s0,32(sp)
    800038a6:	64e2                	ld	s1,24(sp)
    800038a8:	6942                	ld	s2,16(sp)
    800038aa:	69a2                	ld	s3,8(sp)
    800038ac:	6a02                	ld	s4,0(sp)
    800038ae:	6145                	addi	sp,sp,48
    800038b0:	8082                	ret
    if((addr = ip->addrs[bn]) == 0)
    800038b2:	02059793          	slli	a5,a1,0x20
    800038b6:	01e7d593          	srli	a1,a5,0x1e
    800038ba:	00b504b3          	add	s1,a0,a1
    800038be:	0504a983          	lw	s3,80(s1)
    800038c2:	fc099fe3          	bnez	s3,800038a0 <bmap+0x5e>
      ip->addrs[bn] = addr = balloc(ip->dev);
    800038c6:	4108                	lw	a0,0(a0)
    800038c8:	00000097          	auipc	ra,0x0
    800038cc:	e48080e7          	jalr	-440(ra) # 80003710 <balloc>
    800038d0:	0005099b          	sext.w	s3,a0
    800038d4:	0534a823          	sw	s3,80(s1)
    800038d8:	b7e1                	j	800038a0 <bmap+0x5e>
      ip->addrs[NDIRECT] = addr = balloc(ip->dev);
    800038da:	4108                	lw	a0,0(a0)
    800038dc:	00000097          	auipc	ra,0x0
    800038e0:	e34080e7          	jalr	-460(ra) # 80003710 <balloc>
    800038e4:	0005059b          	sext.w	a1,a0
    800038e8:	08b92023          	sw	a1,128(s2)
    800038ec:	b751                	j	80003870 <bmap+0x2e>
      a[bn] = addr = balloc(ip->dev);
    800038ee:	00092503          	lw	a0,0(s2)
    800038f2:	00000097          	auipc	ra,0x0
    800038f6:	e1e080e7          	jalr	-482(ra) # 80003710 <balloc>
    800038fa:	0005099b          	sext.w	s3,a0
    800038fe:	0134a023          	sw	s3,0(s1)
      log_write(bp);
    80003902:	8552                	mv	a0,s4
    80003904:	00001097          	auipc	ra,0x1
    80003908:	ee4080e7          	jalr	-284(ra) # 800047e8 <log_write>
    8000390c:	b769                	j	80003896 <bmap+0x54>
  panic("bmap: out of range");
    8000390e:	00005517          	auipc	a0,0x5
    80003912:	d2250513          	addi	a0,a0,-734 # 80008630 <syscalls+0x180>
    80003916:	ffffd097          	auipc	ra,0xffffd
    8000391a:	cba080e7          	jalr	-838(ra) # 800005d0 <panic>

000000008000391e <iget>:
{
    8000391e:	7179                	addi	sp,sp,-48
    80003920:	f406                	sd	ra,40(sp)
    80003922:	f022                	sd	s0,32(sp)
    80003924:	ec26                	sd	s1,24(sp)
    80003926:	e84a                	sd	s2,16(sp)
    80003928:	e44e                	sd	s3,8(sp)
    8000392a:	e052                	sd	s4,0(sp)
    8000392c:	1800                	addi	s0,sp,48
    8000392e:	89aa                	mv	s3,a0
    80003930:	8a2e                	mv	s4,a1
  acquire(&icache.lock);
    80003932:	00022517          	auipc	a0,0x22
    80003936:	fa650513          	addi	a0,a0,-90 # 800258d8 <icache>
    8000393a:	ffffd097          	auipc	ra,0xffffd
    8000393e:	328080e7          	jalr	808(ra) # 80000c62 <acquire>
  empty = 0;
    80003942:	4901                	li	s2,0
  for(ip = &icache.inode[0]; ip < &icache.inode[NINODE]; ip++){
    80003944:	00022497          	auipc	s1,0x22
    80003948:	fac48493          	addi	s1,s1,-84 # 800258f0 <icache+0x18>
    8000394c:	00024697          	auipc	a3,0x24
    80003950:	a3468693          	addi	a3,a3,-1484 # 80027380 <log>
    80003954:	a039                	j	80003962 <iget+0x44>
    if(empty == 0 && ip->ref == 0)    // Remember empty slot.
    80003956:	02090b63          	beqz	s2,8000398c <iget+0x6e>
  for(ip = &icache.inode[0]; ip < &icache.inode[NINODE]; ip++){
    8000395a:	08848493          	addi	s1,s1,136
    8000395e:	02d48a63          	beq	s1,a3,80003992 <iget+0x74>
    if(ip->ref > 0 && ip->dev == dev && ip->inum == inum){
    80003962:	449c                	lw	a5,8(s1)
    80003964:	fef059e3          	blez	a5,80003956 <iget+0x38>
    80003968:	4098                	lw	a4,0(s1)
    8000396a:	ff3716e3          	bne	a4,s3,80003956 <iget+0x38>
    8000396e:	40d8                	lw	a4,4(s1)
    80003970:	ff4713e3          	bne	a4,s4,80003956 <iget+0x38>
      ip->ref++;
    80003974:	2785                	addiw	a5,a5,1
    80003976:	c49c                	sw	a5,8(s1)
      release(&icache.lock);
    80003978:	00022517          	auipc	a0,0x22
    8000397c:	f6050513          	addi	a0,a0,-160 # 800258d8 <icache>
    80003980:	ffffd097          	auipc	ra,0xffffd
    80003984:	396080e7          	jalr	918(ra) # 80000d16 <release>
      return ip;
    80003988:	8926                	mv	s2,s1
    8000398a:	a03d                	j	800039b8 <iget+0x9a>
    if(empty == 0 && ip->ref == 0)    // Remember empty slot.
    8000398c:	f7f9                	bnez	a5,8000395a <iget+0x3c>
    8000398e:	8926                	mv	s2,s1
    80003990:	b7e9                	j	8000395a <iget+0x3c>
  if(empty == 0)
    80003992:	02090c63          	beqz	s2,800039ca <iget+0xac>
  ip->dev = dev;
    80003996:	01392023          	sw	s3,0(s2)
  ip->inum = inum;
    8000399a:	01492223          	sw	s4,4(s2)
  ip->ref = 1;
    8000399e:	4785                	li	a5,1
    800039a0:	00f92423          	sw	a5,8(s2)
  ip->valid = 0;
    800039a4:	04092023          	sw	zero,64(s2)
  release(&icache.lock);
    800039a8:	00022517          	auipc	a0,0x22
    800039ac:	f3050513          	addi	a0,a0,-208 # 800258d8 <icache>
    800039b0:	ffffd097          	auipc	ra,0xffffd
    800039b4:	366080e7          	jalr	870(ra) # 80000d16 <release>
}
    800039b8:	854a                	mv	a0,s2
    800039ba:	70a2                	ld	ra,40(sp)
    800039bc:	7402                	ld	s0,32(sp)
    800039be:	64e2                	ld	s1,24(sp)
    800039c0:	6942                	ld	s2,16(sp)
    800039c2:	69a2                	ld	s3,8(sp)
    800039c4:	6a02                	ld	s4,0(sp)
    800039c6:	6145                	addi	sp,sp,48
    800039c8:	8082                	ret
    panic("iget: no inodes");
    800039ca:	00005517          	auipc	a0,0x5
    800039ce:	c7e50513          	addi	a0,a0,-898 # 80008648 <syscalls+0x198>
    800039d2:	ffffd097          	auipc	ra,0xffffd
    800039d6:	bfe080e7          	jalr	-1026(ra) # 800005d0 <panic>

00000000800039da <fsinit>:
fsinit(int dev) {
    800039da:	7179                	addi	sp,sp,-48
    800039dc:	f406                	sd	ra,40(sp)
    800039de:	f022                	sd	s0,32(sp)
    800039e0:	ec26                	sd	s1,24(sp)
    800039e2:	e84a                	sd	s2,16(sp)
    800039e4:	e44e                	sd	s3,8(sp)
    800039e6:	1800                	addi	s0,sp,48
    800039e8:	892a                	mv	s2,a0
  bp = bread(dev, 1);
    800039ea:	4585                	li	a1,1
    800039ec:	00000097          	auipc	ra,0x0
    800039f0:	a62080e7          	jalr	-1438(ra) # 8000344e <bread>
    800039f4:	84aa                	mv	s1,a0
  memmove(sb, bp->data, sizeof(*sb));
    800039f6:	00022997          	auipc	s3,0x22
    800039fa:	ec298993          	addi	s3,s3,-318 # 800258b8 <sb>
    800039fe:	02000613          	li	a2,32
    80003a02:	05850593          	addi	a1,a0,88
    80003a06:	854e                	mv	a0,s3
    80003a08:	ffffd097          	auipc	ra,0xffffd
    80003a0c:	3b2080e7          	jalr	946(ra) # 80000dba <memmove>
  brelse(bp);
    80003a10:	8526                	mv	a0,s1
    80003a12:	00000097          	auipc	ra,0x0
    80003a16:	b6c080e7          	jalr	-1172(ra) # 8000357e <brelse>
  if(sb.magic != FSMAGIC)
    80003a1a:	0009a703          	lw	a4,0(s3)
    80003a1e:	102037b7          	lui	a5,0x10203
    80003a22:	04078793          	addi	a5,a5,64 # 10203040 <_entry-0x6fdfcfc0>
    80003a26:	02f71263          	bne	a4,a5,80003a4a <fsinit+0x70>
  initlog(dev, &sb);
    80003a2a:	00022597          	auipc	a1,0x22
    80003a2e:	e8e58593          	addi	a1,a1,-370 # 800258b8 <sb>
    80003a32:	854a                	mv	a0,s2
    80003a34:	00001097          	auipc	ra,0x1
    80003a38:	b3a080e7          	jalr	-1222(ra) # 8000456e <initlog>
}
    80003a3c:	70a2                	ld	ra,40(sp)
    80003a3e:	7402                	ld	s0,32(sp)
    80003a40:	64e2                	ld	s1,24(sp)
    80003a42:	6942                	ld	s2,16(sp)
    80003a44:	69a2                	ld	s3,8(sp)
    80003a46:	6145                	addi	sp,sp,48
    80003a48:	8082                	ret
    panic("invalid file system");
    80003a4a:	00005517          	auipc	a0,0x5
    80003a4e:	c0e50513          	addi	a0,a0,-1010 # 80008658 <syscalls+0x1a8>
    80003a52:	ffffd097          	auipc	ra,0xffffd
    80003a56:	b7e080e7          	jalr	-1154(ra) # 800005d0 <panic>

0000000080003a5a <iinit>:
{
    80003a5a:	7179                	addi	sp,sp,-48
    80003a5c:	f406                	sd	ra,40(sp)
    80003a5e:	f022                	sd	s0,32(sp)
    80003a60:	ec26                	sd	s1,24(sp)
    80003a62:	e84a                	sd	s2,16(sp)
    80003a64:	e44e                	sd	s3,8(sp)
    80003a66:	1800                	addi	s0,sp,48
  initlock(&icache.lock, "icache");
    80003a68:	00005597          	auipc	a1,0x5
    80003a6c:	c0858593          	addi	a1,a1,-1016 # 80008670 <syscalls+0x1c0>
    80003a70:	00022517          	auipc	a0,0x22
    80003a74:	e6850513          	addi	a0,a0,-408 # 800258d8 <icache>
    80003a78:	ffffd097          	auipc	ra,0xffffd
    80003a7c:	15a080e7          	jalr	346(ra) # 80000bd2 <initlock>
  for(i = 0; i < NINODE; i++) {
    80003a80:	00022497          	auipc	s1,0x22
    80003a84:	e8048493          	addi	s1,s1,-384 # 80025900 <icache+0x28>
    80003a88:	00024997          	auipc	s3,0x24
    80003a8c:	90898993          	addi	s3,s3,-1784 # 80027390 <log+0x10>
    initsleeplock(&icache.inode[i].lock, "inode");
    80003a90:	00005917          	auipc	s2,0x5
    80003a94:	be890913          	addi	s2,s2,-1048 # 80008678 <syscalls+0x1c8>
    80003a98:	85ca                	mv	a1,s2
    80003a9a:	8526                	mv	a0,s1
    80003a9c:	00001097          	auipc	ra,0x1
    80003aa0:	e3a080e7          	jalr	-454(ra) # 800048d6 <initsleeplock>
  for(i = 0; i < NINODE; i++) {
    80003aa4:	08848493          	addi	s1,s1,136
    80003aa8:	ff3498e3          	bne	s1,s3,80003a98 <iinit+0x3e>
}
    80003aac:	70a2                	ld	ra,40(sp)
    80003aae:	7402                	ld	s0,32(sp)
    80003ab0:	64e2                	ld	s1,24(sp)
    80003ab2:	6942                	ld	s2,16(sp)
    80003ab4:	69a2                	ld	s3,8(sp)
    80003ab6:	6145                	addi	sp,sp,48
    80003ab8:	8082                	ret

0000000080003aba <ialloc>:
{
    80003aba:	715d                	addi	sp,sp,-80
    80003abc:	e486                	sd	ra,72(sp)
    80003abe:	e0a2                	sd	s0,64(sp)
    80003ac0:	fc26                	sd	s1,56(sp)
    80003ac2:	f84a                	sd	s2,48(sp)
    80003ac4:	f44e                	sd	s3,40(sp)
    80003ac6:	f052                	sd	s4,32(sp)
    80003ac8:	ec56                	sd	s5,24(sp)
    80003aca:	e85a                	sd	s6,16(sp)
    80003acc:	e45e                	sd	s7,8(sp)
    80003ace:	0880                	addi	s0,sp,80
  for(inum = 1; inum < sb.ninodes; inum++){
    80003ad0:	00022717          	auipc	a4,0x22
    80003ad4:	df472703          	lw	a4,-524(a4) # 800258c4 <sb+0xc>
    80003ad8:	4785                	li	a5,1
    80003ada:	04e7fa63          	bgeu	a5,a4,80003b2e <ialloc+0x74>
    80003ade:	8aaa                	mv	s5,a0
    80003ae0:	8bae                	mv	s7,a1
    80003ae2:	4485                	li	s1,1
    bp = bread(dev, IBLOCK(inum, sb));
    80003ae4:	00022a17          	auipc	s4,0x22
    80003ae8:	dd4a0a13          	addi	s4,s4,-556 # 800258b8 <sb>
    80003aec:	00048b1b          	sext.w	s6,s1
    80003af0:	0044d793          	srli	a5,s1,0x4
    80003af4:	018a2583          	lw	a1,24(s4)
    80003af8:	9dbd                	addw	a1,a1,a5
    80003afa:	8556                	mv	a0,s5
    80003afc:	00000097          	auipc	ra,0x0
    80003b00:	952080e7          	jalr	-1710(ra) # 8000344e <bread>
    80003b04:	892a                	mv	s2,a0
    dip = (struct dinode*)bp->data + inum%IPB;
    80003b06:	05850993          	addi	s3,a0,88
    80003b0a:	00f4f793          	andi	a5,s1,15
    80003b0e:	079a                	slli	a5,a5,0x6
    80003b10:	99be                	add	s3,s3,a5
    if(dip->type == 0){  // a free inode
    80003b12:	00099783          	lh	a5,0(s3)
    80003b16:	c785                	beqz	a5,80003b3e <ialloc+0x84>
    brelse(bp);
    80003b18:	00000097          	auipc	ra,0x0
    80003b1c:	a66080e7          	jalr	-1434(ra) # 8000357e <brelse>
  for(inum = 1; inum < sb.ninodes; inum++){
    80003b20:	0485                	addi	s1,s1,1
    80003b22:	00ca2703          	lw	a4,12(s4)
    80003b26:	0004879b          	sext.w	a5,s1
    80003b2a:	fce7e1e3          	bltu	a5,a4,80003aec <ialloc+0x32>
  panic("ialloc: no inodes");
    80003b2e:	00005517          	auipc	a0,0x5
    80003b32:	b5250513          	addi	a0,a0,-1198 # 80008680 <syscalls+0x1d0>
    80003b36:	ffffd097          	auipc	ra,0xffffd
    80003b3a:	a9a080e7          	jalr	-1382(ra) # 800005d0 <panic>
      memset(dip, 0, sizeof(*dip));
    80003b3e:	04000613          	li	a2,64
    80003b42:	4581                	li	a1,0
    80003b44:	854e                	mv	a0,s3
    80003b46:	ffffd097          	auipc	ra,0xffffd
    80003b4a:	218080e7          	jalr	536(ra) # 80000d5e <memset>
      dip->type = type;
    80003b4e:	01799023          	sh	s7,0(s3)
      log_write(bp);   // mark it allocated on the disk
    80003b52:	854a                	mv	a0,s2
    80003b54:	00001097          	auipc	ra,0x1
    80003b58:	c94080e7          	jalr	-876(ra) # 800047e8 <log_write>
      brelse(bp);
    80003b5c:	854a                	mv	a0,s2
    80003b5e:	00000097          	auipc	ra,0x0
    80003b62:	a20080e7          	jalr	-1504(ra) # 8000357e <brelse>
      return iget(dev, inum);
    80003b66:	85da                	mv	a1,s6
    80003b68:	8556                	mv	a0,s5
    80003b6a:	00000097          	auipc	ra,0x0
    80003b6e:	db4080e7          	jalr	-588(ra) # 8000391e <iget>
}
    80003b72:	60a6                	ld	ra,72(sp)
    80003b74:	6406                	ld	s0,64(sp)
    80003b76:	74e2                	ld	s1,56(sp)
    80003b78:	7942                	ld	s2,48(sp)
    80003b7a:	79a2                	ld	s3,40(sp)
    80003b7c:	7a02                	ld	s4,32(sp)
    80003b7e:	6ae2                	ld	s5,24(sp)
    80003b80:	6b42                	ld	s6,16(sp)
    80003b82:	6ba2                	ld	s7,8(sp)
    80003b84:	6161                	addi	sp,sp,80
    80003b86:	8082                	ret

0000000080003b88 <iupdate>:
{
    80003b88:	1101                	addi	sp,sp,-32
    80003b8a:	ec06                	sd	ra,24(sp)
    80003b8c:	e822                	sd	s0,16(sp)
    80003b8e:	e426                	sd	s1,8(sp)
    80003b90:	e04a                	sd	s2,0(sp)
    80003b92:	1000                	addi	s0,sp,32
    80003b94:	84aa                	mv	s1,a0
  bp = bread(ip->dev, IBLOCK(ip->inum, sb));
    80003b96:	415c                	lw	a5,4(a0)
    80003b98:	0047d79b          	srliw	a5,a5,0x4
    80003b9c:	00022597          	auipc	a1,0x22
    80003ba0:	d345a583          	lw	a1,-716(a1) # 800258d0 <sb+0x18>
    80003ba4:	9dbd                	addw	a1,a1,a5
    80003ba6:	4108                	lw	a0,0(a0)
    80003ba8:	00000097          	auipc	ra,0x0
    80003bac:	8a6080e7          	jalr	-1882(ra) # 8000344e <bread>
    80003bb0:	892a                	mv	s2,a0
  dip = (struct dinode*)bp->data + ip->inum%IPB;
    80003bb2:	05850793          	addi	a5,a0,88
    80003bb6:	40c8                	lw	a0,4(s1)
    80003bb8:	893d                	andi	a0,a0,15
    80003bba:	051a                	slli	a0,a0,0x6
    80003bbc:	953e                	add	a0,a0,a5
  dip->type = ip->type;
    80003bbe:	04449703          	lh	a4,68(s1)
    80003bc2:	00e51023          	sh	a4,0(a0)
  dip->major = ip->major;
    80003bc6:	04649703          	lh	a4,70(s1)
    80003bca:	00e51123          	sh	a4,2(a0)
  dip->minor = ip->minor;
    80003bce:	04849703          	lh	a4,72(s1)
    80003bd2:	00e51223          	sh	a4,4(a0)
  dip->nlink = ip->nlink;
    80003bd6:	04a49703          	lh	a4,74(s1)
    80003bda:	00e51323          	sh	a4,6(a0)
  dip->size = ip->size;
    80003bde:	44f8                	lw	a4,76(s1)
    80003be0:	c518                	sw	a4,8(a0)
  memmove(dip->addrs, ip->addrs, sizeof(ip->addrs));
    80003be2:	03400613          	li	a2,52
    80003be6:	05048593          	addi	a1,s1,80
    80003bea:	0531                	addi	a0,a0,12
    80003bec:	ffffd097          	auipc	ra,0xffffd
    80003bf0:	1ce080e7          	jalr	462(ra) # 80000dba <memmove>
  log_write(bp);
    80003bf4:	854a                	mv	a0,s2
    80003bf6:	00001097          	auipc	ra,0x1
    80003bfa:	bf2080e7          	jalr	-1038(ra) # 800047e8 <log_write>
  brelse(bp);
    80003bfe:	854a                	mv	a0,s2
    80003c00:	00000097          	auipc	ra,0x0
    80003c04:	97e080e7          	jalr	-1666(ra) # 8000357e <brelse>
}
    80003c08:	60e2                	ld	ra,24(sp)
    80003c0a:	6442                	ld	s0,16(sp)
    80003c0c:	64a2                	ld	s1,8(sp)
    80003c0e:	6902                	ld	s2,0(sp)
    80003c10:	6105                	addi	sp,sp,32
    80003c12:	8082                	ret

0000000080003c14 <idup>:
{
    80003c14:	1101                	addi	sp,sp,-32
    80003c16:	ec06                	sd	ra,24(sp)
    80003c18:	e822                	sd	s0,16(sp)
    80003c1a:	e426                	sd	s1,8(sp)
    80003c1c:	1000                	addi	s0,sp,32
    80003c1e:	84aa                	mv	s1,a0
  acquire(&icache.lock);
    80003c20:	00022517          	auipc	a0,0x22
    80003c24:	cb850513          	addi	a0,a0,-840 # 800258d8 <icache>
    80003c28:	ffffd097          	auipc	ra,0xffffd
    80003c2c:	03a080e7          	jalr	58(ra) # 80000c62 <acquire>
  ip->ref++;
    80003c30:	449c                	lw	a5,8(s1)
    80003c32:	2785                	addiw	a5,a5,1
    80003c34:	c49c                	sw	a5,8(s1)
  release(&icache.lock);
    80003c36:	00022517          	auipc	a0,0x22
    80003c3a:	ca250513          	addi	a0,a0,-862 # 800258d8 <icache>
    80003c3e:	ffffd097          	auipc	ra,0xffffd
    80003c42:	0d8080e7          	jalr	216(ra) # 80000d16 <release>
}
    80003c46:	8526                	mv	a0,s1
    80003c48:	60e2                	ld	ra,24(sp)
    80003c4a:	6442                	ld	s0,16(sp)
    80003c4c:	64a2                	ld	s1,8(sp)
    80003c4e:	6105                	addi	sp,sp,32
    80003c50:	8082                	ret

0000000080003c52 <ilock>:
{
    80003c52:	1101                	addi	sp,sp,-32
    80003c54:	ec06                	sd	ra,24(sp)
    80003c56:	e822                	sd	s0,16(sp)
    80003c58:	e426                	sd	s1,8(sp)
    80003c5a:	e04a                	sd	s2,0(sp)
    80003c5c:	1000                	addi	s0,sp,32
  if(ip == 0 || ip->ref < 1)
    80003c5e:	c115                	beqz	a0,80003c82 <ilock+0x30>
    80003c60:	84aa                	mv	s1,a0
    80003c62:	451c                	lw	a5,8(a0)
    80003c64:	00f05f63          	blez	a5,80003c82 <ilock+0x30>
  acquiresleep(&ip->lock);
    80003c68:	0541                	addi	a0,a0,16
    80003c6a:	00001097          	auipc	ra,0x1
    80003c6e:	ca6080e7          	jalr	-858(ra) # 80004910 <acquiresleep>
  if(ip->valid == 0){
    80003c72:	40bc                	lw	a5,64(s1)
    80003c74:	cf99                	beqz	a5,80003c92 <ilock+0x40>
}
    80003c76:	60e2                	ld	ra,24(sp)
    80003c78:	6442                	ld	s0,16(sp)
    80003c7a:	64a2                	ld	s1,8(sp)
    80003c7c:	6902                	ld	s2,0(sp)
    80003c7e:	6105                	addi	sp,sp,32
    80003c80:	8082                	ret
    panic("ilock");
    80003c82:	00005517          	auipc	a0,0x5
    80003c86:	a1650513          	addi	a0,a0,-1514 # 80008698 <syscalls+0x1e8>
    80003c8a:	ffffd097          	auipc	ra,0xffffd
    80003c8e:	946080e7          	jalr	-1722(ra) # 800005d0 <panic>
    bp = bread(ip->dev, IBLOCK(ip->inum, sb));
    80003c92:	40dc                	lw	a5,4(s1)
    80003c94:	0047d79b          	srliw	a5,a5,0x4
    80003c98:	00022597          	auipc	a1,0x22
    80003c9c:	c385a583          	lw	a1,-968(a1) # 800258d0 <sb+0x18>
    80003ca0:	9dbd                	addw	a1,a1,a5
    80003ca2:	4088                	lw	a0,0(s1)
    80003ca4:	fffff097          	auipc	ra,0xfffff
    80003ca8:	7aa080e7          	jalr	1962(ra) # 8000344e <bread>
    80003cac:	892a                	mv	s2,a0
    dip = (struct dinode*)bp->data + ip->inum%IPB;
    80003cae:	05850593          	addi	a1,a0,88
    80003cb2:	40dc                	lw	a5,4(s1)
    80003cb4:	8bbd                	andi	a5,a5,15
    80003cb6:	079a                	slli	a5,a5,0x6
    80003cb8:	95be                	add	a1,a1,a5
    ip->type = dip->type;
    80003cba:	00059783          	lh	a5,0(a1)
    80003cbe:	04f49223          	sh	a5,68(s1)
    ip->major = dip->major;
    80003cc2:	00259783          	lh	a5,2(a1)
    80003cc6:	04f49323          	sh	a5,70(s1)
    ip->minor = dip->minor;
    80003cca:	00459783          	lh	a5,4(a1)
    80003cce:	04f49423          	sh	a5,72(s1)
    ip->nlink = dip->nlink;
    80003cd2:	00659783          	lh	a5,6(a1)
    80003cd6:	04f49523          	sh	a5,74(s1)
    ip->size = dip->size;
    80003cda:	459c                	lw	a5,8(a1)
    80003cdc:	c4fc                	sw	a5,76(s1)
    memmove(ip->addrs, dip->addrs, sizeof(ip->addrs));
    80003cde:	03400613          	li	a2,52
    80003ce2:	05b1                	addi	a1,a1,12
    80003ce4:	05048513          	addi	a0,s1,80
    80003ce8:	ffffd097          	auipc	ra,0xffffd
    80003cec:	0d2080e7          	jalr	210(ra) # 80000dba <memmove>
    brelse(bp);
    80003cf0:	854a                	mv	a0,s2
    80003cf2:	00000097          	auipc	ra,0x0
    80003cf6:	88c080e7          	jalr	-1908(ra) # 8000357e <brelse>
    ip->valid = 1;
    80003cfa:	4785                	li	a5,1
    80003cfc:	c0bc                	sw	a5,64(s1)
    if(ip->type == 0)
    80003cfe:	04449783          	lh	a5,68(s1)
    80003d02:	fbb5                	bnez	a5,80003c76 <ilock+0x24>
      panic("ilock: no type");
    80003d04:	00005517          	auipc	a0,0x5
    80003d08:	99c50513          	addi	a0,a0,-1636 # 800086a0 <syscalls+0x1f0>
    80003d0c:	ffffd097          	auipc	ra,0xffffd
    80003d10:	8c4080e7          	jalr	-1852(ra) # 800005d0 <panic>

0000000080003d14 <iunlock>:
{
    80003d14:	1101                	addi	sp,sp,-32
    80003d16:	ec06                	sd	ra,24(sp)
    80003d18:	e822                	sd	s0,16(sp)
    80003d1a:	e426                	sd	s1,8(sp)
    80003d1c:	e04a                	sd	s2,0(sp)
    80003d1e:	1000                	addi	s0,sp,32
  if(ip == 0 || !holdingsleep(&ip->lock) || ip->ref < 1)
    80003d20:	c905                	beqz	a0,80003d50 <iunlock+0x3c>
    80003d22:	84aa                	mv	s1,a0
    80003d24:	01050913          	addi	s2,a0,16
    80003d28:	854a                	mv	a0,s2
    80003d2a:	00001097          	auipc	ra,0x1
    80003d2e:	c80080e7          	jalr	-896(ra) # 800049aa <holdingsleep>
    80003d32:	cd19                	beqz	a0,80003d50 <iunlock+0x3c>
    80003d34:	449c                	lw	a5,8(s1)
    80003d36:	00f05d63          	blez	a5,80003d50 <iunlock+0x3c>
  releasesleep(&ip->lock);
    80003d3a:	854a                	mv	a0,s2
    80003d3c:	00001097          	auipc	ra,0x1
    80003d40:	c2a080e7          	jalr	-982(ra) # 80004966 <releasesleep>
}
    80003d44:	60e2                	ld	ra,24(sp)
    80003d46:	6442                	ld	s0,16(sp)
    80003d48:	64a2                	ld	s1,8(sp)
    80003d4a:	6902                	ld	s2,0(sp)
    80003d4c:	6105                	addi	sp,sp,32
    80003d4e:	8082                	ret
    panic("iunlock");
    80003d50:	00005517          	auipc	a0,0x5
    80003d54:	96050513          	addi	a0,a0,-1696 # 800086b0 <syscalls+0x200>
    80003d58:	ffffd097          	auipc	ra,0xffffd
    80003d5c:	878080e7          	jalr	-1928(ra) # 800005d0 <panic>

0000000080003d60 <itrunc>:

// Truncate inode (discard contents).
// Caller must hold ip->lock.
void
itrunc(struct inode *ip)
{
    80003d60:	7179                	addi	sp,sp,-48
    80003d62:	f406                	sd	ra,40(sp)
    80003d64:	f022                	sd	s0,32(sp)
    80003d66:	ec26                	sd	s1,24(sp)
    80003d68:	e84a                	sd	s2,16(sp)
    80003d6a:	e44e                	sd	s3,8(sp)
    80003d6c:	e052                	sd	s4,0(sp)
    80003d6e:	1800                	addi	s0,sp,48
    80003d70:	89aa                	mv	s3,a0
  int i, j;
  struct buf *bp;
  uint *a;

  for(i = 0; i < NDIRECT; i++){
    80003d72:	05050493          	addi	s1,a0,80
    80003d76:	08050913          	addi	s2,a0,128
    80003d7a:	a021                	j	80003d82 <itrunc+0x22>
    80003d7c:	0491                	addi	s1,s1,4
    80003d7e:	01248d63          	beq	s1,s2,80003d98 <itrunc+0x38>
    if(ip->addrs[i]){
    80003d82:	408c                	lw	a1,0(s1)
    80003d84:	dde5                	beqz	a1,80003d7c <itrunc+0x1c>
      bfree(ip->dev, ip->addrs[i]);
    80003d86:	0009a503          	lw	a0,0(s3)
    80003d8a:	00000097          	auipc	ra,0x0
    80003d8e:	90a080e7          	jalr	-1782(ra) # 80003694 <bfree>
      ip->addrs[i] = 0;
    80003d92:	0004a023          	sw	zero,0(s1)
    80003d96:	b7dd                	j	80003d7c <itrunc+0x1c>
    }
  }

  if(ip->addrs[NDIRECT]){
    80003d98:	0809a583          	lw	a1,128(s3)
    80003d9c:	e185                	bnez	a1,80003dbc <itrunc+0x5c>
    brelse(bp);
    bfree(ip->dev, ip->addrs[NDIRECT]);
    ip->addrs[NDIRECT] = 0;
  }

  ip->size = 0;
    80003d9e:	0409a623          	sw	zero,76(s3)
  iupdate(ip);
    80003da2:	854e                	mv	a0,s3
    80003da4:	00000097          	auipc	ra,0x0
    80003da8:	de4080e7          	jalr	-540(ra) # 80003b88 <iupdate>
}
    80003dac:	70a2                	ld	ra,40(sp)
    80003dae:	7402                	ld	s0,32(sp)
    80003db0:	64e2                	ld	s1,24(sp)
    80003db2:	6942                	ld	s2,16(sp)
    80003db4:	69a2                	ld	s3,8(sp)
    80003db6:	6a02                	ld	s4,0(sp)
    80003db8:	6145                	addi	sp,sp,48
    80003dba:	8082                	ret
    bp = bread(ip->dev, ip->addrs[NDIRECT]);
    80003dbc:	0009a503          	lw	a0,0(s3)
    80003dc0:	fffff097          	auipc	ra,0xfffff
    80003dc4:	68e080e7          	jalr	1678(ra) # 8000344e <bread>
    80003dc8:	8a2a                	mv	s4,a0
    for(j = 0; j < NINDIRECT; j++){
    80003dca:	05850493          	addi	s1,a0,88
    80003dce:	45850913          	addi	s2,a0,1112
    80003dd2:	a021                	j	80003dda <itrunc+0x7a>
    80003dd4:	0491                	addi	s1,s1,4
    80003dd6:	01248b63          	beq	s1,s2,80003dec <itrunc+0x8c>
      if(a[j])
    80003dda:	408c                	lw	a1,0(s1)
    80003ddc:	dde5                	beqz	a1,80003dd4 <itrunc+0x74>
        bfree(ip->dev, a[j]);
    80003dde:	0009a503          	lw	a0,0(s3)
    80003de2:	00000097          	auipc	ra,0x0
    80003de6:	8b2080e7          	jalr	-1870(ra) # 80003694 <bfree>
    80003dea:	b7ed                	j	80003dd4 <itrunc+0x74>
    brelse(bp);
    80003dec:	8552                	mv	a0,s4
    80003dee:	fffff097          	auipc	ra,0xfffff
    80003df2:	790080e7          	jalr	1936(ra) # 8000357e <brelse>
    bfree(ip->dev, ip->addrs[NDIRECT]);
    80003df6:	0809a583          	lw	a1,128(s3)
    80003dfa:	0009a503          	lw	a0,0(s3)
    80003dfe:	00000097          	auipc	ra,0x0
    80003e02:	896080e7          	jalr	-1898(ra) # 80003694 <bfree>
    ip->addrs[NDIRECT] = 0;
    80003e06:	0809a023          	sw	zero,128(s3)
    80003e0a:	bf51                	j	80003d9e <itrunc+0x3e>

0000000080003e0c <iput>:
{
    80003e0c:	1101                	addi	sp,sp,-32
    80003e0e:	ec06                	sd	ra,24(sp)
    80003e10:	e822                	sd	s0,16(sp)
    80003e12:	e426                	sd	s1,8(sp)
    80003e14:	e04a                	sd	s2,0(sp)
    80003e16:	1000                	addi	s0,sp,32
    80003e18:	84aa                	mv	s1,a0
  acquire(&icache.lock);
    80003e1a:	00022517          	auipc	a0,0x22
    80003e1e:	abe50513          	addi	a0,a0,-1346 # 800258d8 <icache>
    80003e22:	ffffd097          	auipc	ra,0xffffd
    80003e26:	e40080e7          	jalr	-448(ra) # 80000c62 <acquire>
  if(ip->ref == 1 && ip->valid && ip->nlink == 0){
    80003e2a:	4498                	lw	a4,8(s1)
    80003e2c:	4785                	li	a5,1
    80003e2e:	02f70363          	beq	a4,a5,80003e54 <iput+0x48>
  ip->ref--;
    80003e32:	449c                	lw	a5,8(s1)
    80003e34:	37fd                	addiw	a5,a5,-1
    80003e36:	c49c                	sw	a5,8(s1)
  release(&icache.lock);
    80003e38:	00022517          	auipc	a0,0x22
    80003e3c:	aa050513          	addi	a0,a0,-1376 # 800258d8 <icache>
    80003e40:	ffffd097          	auipc	ra,0xffffd
    80003e44:	ed6080e7          	jalr	-298(ra) # 80000d16 <release>
}
    80003e48:	60e2                	ld	ra,24(sp)
    80003e4a:	6442                	ld	s0,16(sp)
    80003e4c:	64a2                	ld	s1,8(sp)
    80003e4e:	6902                	ld	s2,0(sp)
    80003e50:	6105                	addi	sp,sp,32
    80003e52:	8082                	ret
  if(ip->ref == 1 && ip->valid && ip->nlink == 0){
    80003e54:	40bc                	lw	a5,64(s1)
    80003e56:	dff1                	beqz	a5,80003e32 <iput+0x26>
    80003e58:	04a49783          	lh	a5,74(s1)
    80003e5c:	fbf9                	bnez	a5,80003e32 <iput+0x26>
    acquiresleep(&ip->lock);
    80003e5e:	01048913          	addi	s2,s1,16
    80003e62:	854a                	mv	a0,s2
    80003e64:	00001097          	auipc	ra,0x1
    80003e68:	aac080e7          	jalr	-1364(ra) # 80004910 <acquiresleep>
    release(&icache.lock);
    80003e6c:	00022517          	auipc	a0,0x22
    80003e70:	a6c50513          	addi	a0,a0,-1428 # 800258d8 <icache>
    80003e74:	ffffd097          	auipc	ra,0xffffd
    80003e78:	ea2080e7          	jalr	-350(ra) # 80000d16 <release>
    itrunc(ip);
    80003e7c:	8526                	mv	a0,s1
    80003e7e:	00000097          	auipc	ra,0x0
    80003e82:	ee2080e7          	jalr	-286(ra) # 80003d60 <itrunc>
    ip->type = 0;
    80003e86:	04049223          	sh	zero,68(s1)
    iupdate(ip);
    80003e8a:	8526                	mv	a0,s1
    80003e8c:	00000097          	auipc	ra,0x0
    80003e90:	cfc080e7          	jalr	-772(ra) # 80003b88 <iupdate>
    ip->valid = 0;
    80003e94:	0404a023          	sw	zero,64(s1)
    releasesleep(&ip->lock);
    80003e98:	854a                	mv	a0,s2
    80003e9a:	00001097          	auipc	ra,0x1
    80003e9e:	acc080e7          	jalr	-1332(ra) # 80004966 <releasesleep>
    acquire(&icache.lock);
    80003ea2:	00022517          	auipc	a0,0x22
    80003ea6:	a3650513          	addi	a0,a0,-1482 # 800258d8 <icache>
    80003eaa:	ffffd097          	auipc	ra,0xffffd
    80003eae:	db8080e7          	jalr	-584(ra) # 80000c62 <acquire>
    80003eb2:	b741                	j	80003e32 <iput+0x26>

0000000080003eb4 <iunlockput>:
{
    80003eb4:	1101                	addi	sp,sp,-32
    80003eb6:	ec06                	sd	ra,24(sp)
    80003eb8:	e822                	sd	s0,16(sp)
    80003eba:	e426                	sd	s1,8(sp)
    80003ebc:	1000                	addi	s0,sp,32
    80003ebe:	84aa                	mv	s1,a0
  iunlock(ip);
    80003ec0:	00000097          	auipc	ra,0x0
    80003ec4:	e54080e7          	jalr	-428(ra) # 80003d14 <iunlock>
  iput(ip);
    80003ec8:	8526                	mv	a0,s1
    80003eca:	00000097          	auipc	ra,0x0
    80003ece:	f42080e7          	jalr	-190(ra) # 80003e0c <iput>
}
    80003ed2:	60e2                	ld	ra,24(sp)
    80003ed4:	6442                	ld	s0,16(sp)
    80003ed6:	64a2                	ld	s1,8(sp)
    80003ed8:	6105                	addi	sp,sp,32
    80003eda:	8082                	ret

0000000080003edc <stati>:

// Copy stat information from inode.
// Caller must hold ip->lock.
void
stati(struct inode *ip, struct stat *st)
{
    80003edc:	1141                	addi	sp,sp,-16
    80003ede:	e422                	sd	s0,8(sp)
    80003ee0:	0800                	addi	s0,sp,16
  st->dev = ip->dev;
    80003ee2:	411c                	lw	a5,0(a0)
    80003ee4:	c19c                	sw	a5,0(a1)
  st->ino = ip->inum;
    80003ee6:	415c                	lw	a5,4(a0)
    80003ee8:	c1dc                	sw	a5,4(a1)
  st->type = ip->type;
    80003eea:	04451783          	lh	a5,68(a0)
    80003eee:	00f59423          	sh	a5,8(a1)
  st->nlink = ip->nlink;
    80003ef2:	04a51783          	lh	a5,74(a0)
    80003ef6:	00f59523          	sh	a5,10(a1)
  st->size = ip->size;
    80003efa:	04c56783          	lwu	a5,76(a0)
    80003efe:	e99c                	sd	a5,16(a1)
}
    80003f00:	6422                	ld	s0,8(sp)
    80003f02:	0141                	addi	sp,sp,16
    80003f04:	8082                	ret

0000000080003f06 <readi>:
readi(struct inode *ip, int user_dst, uint64 dst, uint off, uint n)
{
  uint tot, m;
  struct buf *bp;

  if(off > ip->size || off + n < off)
    80003f06:	457c                	lw	a5,76(a0)
    80003f08:	0ed7e863          	bltu	a5,a3,80003ff8 <readi+0xf2>
{
    80003f0c:	7159                	addi	sp,sp,-112
    80003f0e:	f486                	sd	ra,104(sp)
    80003f10:	f0a2                	sd	s0,96(sp)
    80003f12:	eca6                	sd	s1,88(sp)
    80003f14:	e8ca                	sd	s2,80(sp)
    80003f16:	e4ce                	sd	s3,72(sp)
    80003f18:	e0d2                	sd	s4,64(sp)
    80003f1a:	fc56                	sd	s5,56(sp)
    80003f1c:	f85a                	sd	s6,48(sp)
    80003f1e:	f45e                	sd	s7,40(sp)
    80003f20:	f062                	sd	s8,32(sp)
    80003f22:	ec66                	sd	s9,24(sp)
    80003f24:	e86a                	sd	s10,16(sp)
    80003f26:	e46e                	sd	s11,8(sp)
    80003f28:	1880                	addi	s0,sp,112
    80003f2a:	8baa                	mv	s7,a0
    80003f2c:	8c2e                	mv	s8,a1
    80003f2e:	8ab2                	mv	s5,a2
    80003f30:	84b6                	mv	s1,a3
    80003f32:	8b3a                	mv	s6,a4
  if(off > ip->size || off + n < off)
    80003f34:	9f35                	addw	a4,a4,a3
    return 0;
    80003f36:	4501                	li	a0,0
  if(off > ip->size || off + n < off)
    80003f38:	08d76f63          	bltu	a4,a3,80003fd6 <readi+0xd0>
  if(off + n > ip->size)
    80003f3c:	00e7f463          	bgeu	a5,a4,80003f44 <readi+0x3e>
    n = ip->size - off;
    80003f40:	40d78b3b          	subw	s6,a5,a3

  for(tot=0; tot<n; tot+=m, off+=m, dst+=m){
    80003f44:	0a0b0863          	beqz	s6,80003ff4 <readi+0xee>
    80003f48:	4981                	li	s3,0
    bp = bread(ip->dev, bmap(ip, off/BSIZE));
    m = min(n - tot, BSIZE - off%BSIZE);
    80003f4a:	40000d13          	li	s10,1024
    if(either_copyout(user_dst, dst, bp->data + (off % BSIZE), m) == -1) {
    80003f4e:	5cfd                	li	s9,-1
    80003f50:	a82d                	j	80003f8a <readi+0x84>
    80003f52:	020a1d93          	slli	s11,s4,0x20
    80003f56:	020ddd93          	srli	s11,s11,0x20
    80003f5a:	05890793          	addi	a5,s2,88
    80003f5e:	86ee                	mv	a3,s11
    80003f60:	963e                	add	a2,a2,a5
    80003f62:	85d6                	mv	a1,s5
    80003f64:	8562                	mv	a0,s8
    80003f66:	fffff097          	auipc	ra,0xfffff
    80003f6a:	8fe080e7          	jalr	-1794(ra) # 80002864 <either_copyout>
    80003f6e:	05950d63          	beq	a0,s9,80003fc8 <readi+0xc2>
      brelse(bp);
      break;
    }
    brelse(bp);
    80003f72:	854a                	mv	a0,s2
    80003f74:	fffff097          	auipc	ra,0xfffff
    80003f78:	60a080e7          	jalr	1546(ra) # 8000357e <brelse>
  for(tot=0; tot<n; tot+=m, off+=m, dst+=m){
    80003f7c:	013a09bb          	addw	s3,s4,s3
    80003f80:	009a04bb          	addw	s1,s4,s1
    80003f84:	9aee                	add	s5,s5,s11
    80003f86:	0569f663          	bgeu	s3,s6,80003fd2 <readi+0xcc>
    bp = bread(ip->dev, bmap(ip, off/BSIZE));
    80003f8a:	000ba903          	lw	s2,0(s7)
    80003f8e:	00a4d59b          	srliw	a1,s1,0xa
    80003f92:	855e                	mv	a0,s7
    80003f94:	00000097          	auipc	ra,0x0
    80003f98:	8ae080e7          	jalr	-1874(ra) # 80003842 <bmap>
    80003f9c:	0005059b          	sext.w	a1,a0
    80003fa0:	854a                	mv	a0,s2
    80003fa2:	fffff097          	auipc	ra,0xfffff
    80003fa6:	4ac080e7          	jalr	1196(ra) # 8000344e <bread>
    80003faa:	892a                	mv	s2,a0
    m = min(n - tot, BSIZE - off%BSIZE);
    80003fac:	3ff4f613          	andi	a2,s1,1023
    80003fb0:	40cd07bb          	subw	a5,s10,a2
    80003fb4:	413b073b          	subw	a4,s6,s3
    80003fb8:	8a3e                	mv	s4,a5
    80003fba:	2781                	sext.w	a5,a5
    80003fbc:	0007069b          	sext.w	a3,a4
    80003fc0:	f8f6f9e3          	bgeu	a3,a5,80003f52 <readi+0x4c>
    80003fc4:	8a3a                	mv	s4,a4
    80003fc6:	b771                	j	80003f52 <readi+0x4c>
      brelse(bp);
    80003fc8:	854a                	mv	a0,s2
    80003fca:	fffff097          	auipc	ra,0xfffff
    80003fce:	5b4080e7          	jalr	1460(ra) # 8000357e <brelse>
  }
  return tot;
    80003fd2:	0009851b          	sext.w	a0,s3
}
    80003fd6:	70a6                	ld	ra,104(sp)
    80003fd8:	7406                	ld	s0,96(sp)
    80003fda:	64e6                	ld	s1,88(sp)
    80003fdc:	6946                	ld	s2,80(sp)
    80003fde:	69a6                	ld	s3,72(sp)
    80003fe0:	6a06                	ld	s4,64(sp)
    80003fe2:	7ae2                	ld	s5,56(sp)
    80003fe4:	7b42                	ld	s6,48(sp)
    80003fe6:	7ba2                	ld	s7,40(sp)
    80003fe8:	7c02                	ld	s8,32(sp)
    80003fea:	6ce2                	ld	s9,24(sp)
    80003fec:	6d42                	ld	s10,16(sp)
    80003fee:	6da2                	ld	s11,8(sp)
    80003ff0:	6165                	addi	sp,sp,112
    80003ff2:	8082                	ret
  for(tot=0; tot<n; tot+=m, off+=m, dst+=m){
    80003ff4:	89da                	mv	s3,s6
    80003ff6:	bff1                	j	80003fd2 <readi+0xcc>
    return 0;
    80003ff8:	4501                	li	a0,0
}
    80003ffa:	8082                	ret

0000000080003ffc <writei>:
writei(struct inode *ip, int user_src, uint64 src, uint off, uint n)
{
  uint tot, m;
  struct buf *bp;

  if(off > ip->size || off + n < off)
    80003ffc:	457c                	lw	a5,76(a0)
    80003ffe:	10d7e663          	bltu	a5,a3,8000410a <writei+0x10e>
{
    80004002:	7159                	addi	sp,sp,-112
    80004004:	f486                	sd	ra,104(sp)
    80004006:	f0a2                	sd	s0,96(sp)
    80004008:	eca6                	sd	s1,88(sp)
    8000400a:	e8ca                	sd	s2,80(sp)
    8000400c:	e4ce                	sd	s3,72(sp)
    8000400e:	e0d2                	sd	s4,64(sp)
    80004010:	fc56                	sd	s5,56(sp)
    80004012:	f85a                	sd	s6,48(sp)
    80004014:	f45e                	sd	s7,40(sp)
    80004016:	f062                	sd	s8,32(sp)
    80004018:	ec66                	sd	s9,24(sp)
    8000401a:	e86a                	sd	s10,16(sp)
    8000401c:	e46e                	sd	s11,8(sp)
    8000401e:	1880                	addi	s0,sp,112
    80004020:	8baa                	mv	s7,a0
    80004022:	8c2e                	mv	s8,a1
    80004024:	8ab2                	mv	s5,a2
    80004026:	8936                	mv	s2,a3
    80004028:	8b3a                	mv	s6,a4
  if(off > ip->size || off + n < off)
    8000402a:	00e687bb          	addw	a5,a3,a4
    8000402e:	0ed7e063          	bltu	a5,a3,8000410e <writei+0x112>
    return -1;
  if(off + n > MAXFILE*BSIZE)
    80004032:	00043737          	lui	a4,0x43
    80004036:	0cf76e63          	bltu	a4,a5,80004112 <writei+0x116>
    return -1;

  for(tot=0; tot<n; tot+=m, off+=m, src+=m){
    8000403a:	0a0b0763          	beqz	s6,800040e8 <writei+0xec>
    8000403e:	4a01                	li	s4,0
    bp = bread(ip->dev, bmap(ip, off/BSIZE));
    m = min(n - tot, BSIZE - off%BSIZE);
    80004040:	40000d13          	li	s10,1024
    if(either_copyin(bp->data + (off % BSIZE), user_src, src, m) == -1) {
    80004044:	5cfd                	li	s9,-1
    80004046:	a091                	j	8000408a <writei+0x8e>
    80004048:	02099d93          	slli	s11,s3,0x20
    8000404c:	020ddd93          	srli	s11,s11,0x20
    80004050:	05848793          	addi	a5,s1,88
    80004054:	86ee                	mv	a3,s11
    80004056:	8656                	mv	a2,s5
    80004058:	85e2                	mv	a1,s8
    8000405a:	953e                	add	a0,a0,a5
    8000405c:	fffff097          	auipc	ra,0xfffff
    80004060:	85e080e7          	jalr	-1954(ra) # 800028ba <either_copyin>
    80004064:	07950263          	beq	a0,s9,800040c8 <writei+0xcc>
      brelse(bp);
      break;
    }
    log_write(bp);
    80004068:	8526                	mv	a0,s1
    8000406a:	00000097          	auipc	ra,0x0
    8000406e:	77e080e7          	jalr	1918(ra) # 800047e8 <log_write>
    brelse(bp);
    80004072:	8526                	mv	a0,s1
    80004074:	fffff097          	auipc	ra,0xfffff
    80004078:	50a080e7          	jalr	1290(ra) # 8000357e <brelse>
  for(tot=0; tot<n; tot+=m, off+=m, src+=m){
    8000407c:	01498a3b          	addw	s4,s3,s4
    80004080:	0129893b          	addw	s2,s3,s2
    80004084:	9aee                	add	s5,s5,s11
    80004086:	056a7663          	bgeu	s4,s6,800040d2 <writei+0xd6>
    bp = bread(ip->dev, bmap(ip, off/BSIZE));
    8000408a:	000ba483          	lw	s1,0(s7)
    8000408e:	00a9559b          	srliw	a1,s2,0xa
    80004092:	855e                	mv	a0,s7
    80004094:	fffff097          	auipc	ra,0xfffff
    80004098:	7ae080e7          	jalr	1966(ra) # 80003842 <bmap>
    8000409c:	0005059b          	sext.w	a1,a0
    800040a0:	8526                	mv	a0,s1
    800040a2:	fffff097          	auipc	ra,0xfffff
    800040a6:	3ac080e7          	jalr	940(ra) # 8000344e <bread>
    800040aa:	84aa                	mv	s1,a0
    m = min(n - tot, BSIZE - off%BSIZE);
    800040ac:	3ff97513          	andi	a0,s2,1023
    800040b0:	40ad07bb          	subw	a5,s10,a0
    800040b4:	414b073b          	subw	a4,s6,s4
    800040b8:	89be                	mv	s3,a5
    800040ba:	2781                	sext.w	a5,a5
    800040bc:	0007069b          	sext.w	a3,a4
    800040c0:	f8f6f4e3          	bgeu	a3,a5,80004048 <writei+0x4c>
    800040c4:	89ba                	mv	s3,a4
    800040c6:	b749                	j	80004048 <writei+0x4c>
      brelse(bp);
    800040c8:	8526                	mv	a0,s1
    800040ca:	fffff097          	auipc	ra,0xfffff
    800040ce:	4b4080e7          	jalr	1204(ra) # 8000357e <brelse>
  }

  if(n > 0){
    if(off > ip->size)
    800040d2:	04cba783          	lw	a5,76(s7)
    800040d6:	0127f463          	bgeu	a5,s2,800040de <writei+0xe2>
      ip->size = off;
    800040da:	052ba623          	sw	s2,76(s7)
    // write the i-node back to disk even if the size didn't change
    // because the loop above might have called bmap() and added a new
    // block to ip->addrs[].
    iupdate(ip);
    800040de:	855e                	mv	a0,s7
    800040e0:	00000097          	auipc	ra,0x0
    800040e4:	aa8080e7          	jalr	-1368(ra) # 80003b88 <iupdate>
  }

  return n;
    800040e8:	000b051b          	sext.w	a0,s6
}
    800040ec:	70a6                	ld	ra,104(sp)
    800040ee:	7406                	ld	s0,96(sp)
    800040f0:	64e6                	ld	s1,88(sp)
    800040f2:	6946                	ld	s2,80(sp)
    800040f4:	69a6                	ld	s3,72(sp)
    800040f6:	6a06                	ld	s4,64(sp)
    800040f8:	7ae2                	ld	s5,56(sp)
    800040fa:	7b42                	ld	s6,48(sp)
    800040fc:	7ba2                	ld	s7,40(sp)
    800040fe:	7c02                	ld	s8,32(sp)
    80004100:	6ce2                	ld	s9,24(sp)
    80004102:	6d42                	ld	s10,16(sp)
    80004104:	6da2                	ld	s11,8(sp)
    80004106:	6165                	addi	sp,sp,112
    80004108:	8082                	ret
    return -1;
    8000410a:	557d                	li	a0,-1
}
    8000410c:	8082                	ret
    return -1;
    8000410e:	557d                	li	a0,-1
    80004110:	bff1                	j	800040ec <writei+0xf0>
    return -1;
    80004112:	557d                	li	a0,-1
    80004114:	bfe1                	j	800040ec <writei+0xf0>

0000000080004116 <namecmp>:

// Directories

int
namecmp(const char *s, const char *t)
{
    80004116:	1141                	addi	sp,sp,-16
    80004118:	e406                	sd	ra,8(sp)
    8000411a:	e022                	sd	s0,0(sp)
    8000411c:	0800                	addi	s0,sp,16
  return strncmp(s, t, DIRSIZ);
    8000411e:	4639                	li	a2,14
    80004120:	ffffd097          	auipc	ra,0xffffd
    80004124:	d16080e7          	jalr	-746(ra) # 80000e36 <strncmp>
}
    80004128:	60a2                	ld	ra,8(sp)
    8000412a:	6402                	ld	s0,0(sp)
    8000412c:	0141                	addi	sp,sp,16
    8000412e:	8082                	ret

0000000080004130 <dirlookup>:

// Look for a directory entry in a directory.
// If found, set *poff to byte offset of entry.
struct inode*
dirlookup(struct inode *dp, char *name, uint *poff)
{
    80004130:	7139                	addi	sp,sp,-64
    80004132:	fc06                	sd	ra,56(sp)
    80004134:	f822                	sd	s0,48(sp)
    80004136:	f426                	sd	s1,40(sp)
    80004138:	f04a                	sd	s2,32(sp)
    8000413a:	ec4e                	sd	s3,24(sp)
    8000413c:	e852                	sd	s4,16(sp)
    8000413e:	0080                	addi	s0,sp,64
  uint off, inum;
  struct dirent de;

  if(dp->type != T_DIR)
    80004140:	04451703          	lh	a4,68(a0)
    80004144:	4785                	li	a5,1
    80004146:	00f71a63          	bne	a4,a5,8000415a <dirlookup+0x2a>
    8000414a:	892a                	mv	s2,a0
    8000414c:	89ae                	mv	s3,a1
    8000414e:	8a32                	mv	s4,a2
    panic("dirlookup not DIR");

  for(off = 0; off < dp->size; off += sizeof(de)){
    80004150:	457c                	lw	a5,76(a0)
    80004152:	4481                	li	s1,0
      inum = de.inum;
      return iget(dp->dev, inum);
    }
  }

  return 0;
    80004154:	4501                	li	a0,0
  for(off = 0; off < dp->size; off += sizeof(de)){
    80004156:	e79d                	bnez	a5,80004184 <dirlookup+0x54>
    80004158:	a8a5                	j	800041d0 <dirlookup+0xa0>
    panic("dirlookup not DIR");
    8000415a:	00004517          	auipc	a0,0x4
    8000415e:	55e50513          	addi	a0,a0,1374 # 800086b8 <syscalls+0x208>
    80004162:	ffffc097          	auipc	ra,0xffffc
    80004166:	46e080e7          	jalr	1134(ra) # 800005d0 <panic>
      panic("dirlookup read");
    8000416a:	00004517          	auipc	a0,0x4
    8000416e:	56650513          	addi	a0,a0,1382 # 800086d0 <syscalls+0x220>
    80004172:	ffffc097          	auipc	ra,0xffffc
    80004176:	45e080e7          	jalr	1118(ra) # 800005d0 <panic>
  for(off = 0; off < dp->size; off += sizeof(de)){
    8000417a:	24c1                	addiw	s1,s1,16
    8000417c:	04c92783          	lw	a5,76(s2)
    80004180:	04f4f763          	bgeu	s1,a5,800041ce <dirlookup+0x9e>
    if(readi(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    80004184:	4741                	li	a4,16
    80004186:	86a6                	mv	a3,s1
    80004188:	fc040613          	addi	a2,s0,-64
    8000418c:	4581                	li	a1,0
    8000418e:	854a                	mv	a0,s2
    80004190:	00000097          	auipc	ra,0x0
    80004194:	d76080e7          	jalr	-650(ra) # 80003f06 <readi>
    80004198:	47c1                	li	a5,16
    8000419a:	fcf518e3          	bne	a0,a5,8000416a <dirlookup+0x3a>
    if(de.inum == 0)
    8000419e:	fc045783          	lhu	a5,-64(s0)
    800041a2:	dfe1                	beqz	a5,8000417a <dirlookup+0x4a>
    if(namecmp(name, de.name) == 0){
    800041a4:	fc240593          	addi	a1,s0,-62
    800041a8:	854e                	mv	a0,s3
    800041aa:	00000097          	auipc	ra,0x0
    800041ae:	f6c080e7          	jalr	-148(ra) # 80004116 <namecmp>
    800041b2:	f561                	bnez	a0,8000417a <dirlookup+0x4a>
      if(poff)
    800041b4:	000a0463          	beqz	s4,800041bc <dirlookup+0x8c>
        *poff = off;
    800041b8:	009a2023          	sw	s1,0(s4)
      return iget(dp->dev, inum);
    800041bc:	fc045583          	lhu	a1,-64(s0)
    800041c0:	00092503          	lw	a0,0(s2)
    800041c4:	fffff097          	auipc	ra,0xfffff
    800041c8:	75a080e7          	jalr	1882(ra) # 8000391e <iget>
    800041cc:	a011                	j	800041d0 <dirlookup+0xa0>
  return 0;
    800041ce:	4501                	li	a0,0
}
    800041d0:	70e2                	ld	ra,56(sp)
    800041d2:	7442                	ld	s0,48(sp)
    800041d4:	74a2                	ld	s1,40(sp)
    800041d6:	7902                	ld	s2,32(sp)
    800041d8:	69e2                	ld	s3,24(sp)
    800041da:	6a42                	ld	s4,16(sp)
    800041dc:	6121                	addi	sp,sp,64
    800041de:	8082                	ret

00000000800041e0 <namex>:
// If parent != 0, return the inode for the parent and copy the final
// path element into name, which must have room for DIRSIZ bytes.
// Must be called inside a transaction since it calls iput().
static struct inode*
namex(char *path, int nameiparent, char *name)
{
    800041e0:	711d                	addi	sp,sp,-96
    800041e2:	ec86                	sd	ra,88(sp)
    800041e4:	e8a2                	sd	s0,80(sp)
    800041e6:	e4a6                	sd	s1,72(sp)
    800041e8:	e0ca                	sd	s2,64(sp)
    800041ea:	fc4e                	sd	s3,56(sp)
    800041ec:	f852                	sd	s4,48(sp)
    800041ee:	f456                	sd	s5,40(sp)
    800041f0:	f05a                	sd	s6,32(sp)
    800041f2:	ec5e                	sd	s7,24(sp)
    800041f4:	e862                	sd	s8,16(sp)
    800041f6:	e466                	sd	s9,8(sp)
    800041f8:	1080                	addi	s0,sp,96
    800041fa:	84aa                	mv	s1,a0
    800041fc:	8aae                	mv	s5,a1
    800041fe:	8a32                	mv	s4,a2
  struct inode *ip, *next;

  if(*path == '/')
    80004200:	00054703          	lbu	a4,0(a0)
    80004204:	02f00793          	li	a5,47
    80004208:	02f70363          	beq	a4,a5,8000422e <namex+0x4e>
    ip = iget(ROOTDEV, ROOTINO);
  else
    ip = idup(myproc()->cwd);
    8000420c:	ffffe097          	auipc	ra,0xffffe
    80004210:	b3e080e7          	jalr	-1218(ra) # 80001d4a <myproc>
    80004214:	15053503          	ld	a0,336(a0)
    80004218:	00000097          	auipc	ra,0x0
    8000421c:	9fc080e7          	jalr	-1540(ra) # 80003c14 <idup>
    80004220:	89aa                	mv	s3,a0
  while(*path == '/')
    80004222:	02f00913          	li	s2,47
  len = path - s;
    80004226:	4b01                	li	s6,0
  if(len >= DIRSIZ)
    80004228:	4c35                	li	s8,13

  while((path = skipelem(path, name)) != 0){
    ilock(ip);
    if(ip->type != T_DIR){
    8000422a:	4b85                	li	s7,1
    8000422c:	a865                	j	800042e4 <namex+0x104>
    ip = iget(ROOTDEV, ROOTINO);
    8000422e:	4585                	li	a1,1
    80004230:	4505                	li	a0,1
    80004232:	fffff097          	auipc	ra,0xfffff
    80004236:	6ec080e7          	jalr	1772(ra) # 8000391e <iget>
    8000423a:	89aa                	mv	s3,a0
    8000423c:	b7dd                	j	80004222 <namex+0x42>
      iunlockput(ip);
    8000423e:	854e                	mv	a0,s3
    80004240:	00000097          	auipc	ra,0x0
    80004244:	c74080e7          	jalr	-908(ra) # 80003eb4 <iunlockput>
      return 0;
    80004248:	4981                	li	s3,0
  if(nameiparent){
    iput(ip);
    return 0;
  }
  return ip;
}
    8000424a:	854e                	mv	a0,s3
    8000424c:	60e6                	ld	ra,88(sp)
    8000424e:	6446                	ld	s0,80(sp)
    80004250:	64a6                	ld	s1,72(sp)
    80004252:	6906                	ld	s2,64(sp)
    80004254:	79e2                	ld	s3,56(sp)
    80004256:	7a42                	ld	s4,48(sp)
    80004258:	7aa2                	ld	s5,40(sp)
    8000425a:	7b02                	ld	s6,32(sp)
    8000425c:	6be2                	ld	s7,24(sp)
    8000425e:	6c42                	ld	s8,16(sp)
    80004260:	6ca2                	ld	s9,8(sp)
    80004262:	6125                	addi	sp,sp,96
    80004264:	8082                	ret
      iunlock(ip);
    80004266:	854e                	mv	a0,s3
    80004268:	00000097          	auipc	ra,0x0
    8000426c:	aac080e7          	jalr	-1364(ra) # 80003d14 <iunlock>
      return ip;
    80004270:	bfe9                	j	8000424a <namex+0x6a>
      iunlockput(ip);
    80004272:	854e                	mv	a0,s3
    80004274:	00000097          	auipc	ra,0x0
    80004278:	c40080e7          	jalr	-960(ra) # 80003eb4 <iunlockput>
      return 0;
    8000427c:	89e6                	mv	s3,s9
    8000427e:	b7f1                	j	8000424a <namex+0x6a>
  len = path - s;
    80004280:	40b48633          	sub	a2,s1,a1
    80004284:	00060c9b          	sext.w	s9,a2
  if(len >= DIRSIZ)
    80004288:	099c5463          	bge	s8,s9,80004310 <namex+0x130>
    memmove(name, s, DIRSIZ);
    8000428c:	4639                	li	a2,14
    8000428e:	8552                	mv	a0,s4
    80004290:	ffffd097          	auipc	ra,0xffffd
    80004294:	b2a080e7          	jalr	-1238(ra) # 80000dba <memmove>
  while(*path == '/')
    80004298:	0004c783          	lbu	a5,0(s1)
    8000429c:	01279763          	bne	a5,s2,800042aa <namex+0xca>
    path++;
    800042a0:	0485                	addi	s1,s1,1
  while(*path == '/')
    800042a2:	0004c783          	lbu	a5,0(s1)
    800042a6:	ff278de3          	beq	a5,s2,800042a0 <namex+0xc0>
    ilock(ip);
    800042aa:	854e                	mv	a0,s3
    800042ac:	00000097          	auipc	ra,0x0
    800042b0:	9a6080e7          	jalr	-1626(ra) # 80003c52 <ilock>
    if(ip->type != T_DIR){
    800042b4:	04499783          	lh	a5,68(s3)
    800042b8:	f97793e3          	bne	a5,s7,8000423e <namex+0x5e>
    if(nameiparent && *path == '\0'){
    800042bc:	000a8563          	beqz	s5,800042c6 <namex+0xe6>
    800042c0:	0004c783          	lbu	a5,0(s1)
    800042c4:	d3cd                	beqz	a5,80004266 <namex+0x86>
    if((next = dirlookup(ip, name, 0)) == 0){
    800042c6:	865a                	mv	a2,s6
    800042c8:	85d2                	mv	a1,s4
    800042ca:	854e                	mv	a0,s3
    800042cc:	00000097          	auipc	ra,0x0
    800042d0:	e64080e7          	jalr	-412(ra) # 80004130 <dirlookup>
    800042d4:	8caa                	mv	s9,a0
    800042d6:	dd51                	beqz	a0,80004272 <namex+0x92>
    iunlockput(ip);
    800042d8:	854e                	mv	a0,s3
    800042da:	00000097          	auipc	ra,0x0
    800042de:	bda080e7          	jalr	-1062(ra) # 80003eb4 <iunlockput>
    ip = next;
    800042e2:	89e6                	mv	s3,s9
  while(*path == '/')
    800042e4:	0004c783          	lbu	a5,0(s1)
    800042e8:	05279763          	bne	a5,s2,80004336 <namex+0x156>
    path++;
    800042ec:	0485                	addi	s1,s1,1
  while(*path == '/')
    800042ee:	0004c783          	lbu	a5,0(s1)
    800042f2:	ff278de3          	beq	a5,s2,800042ec <namex+0x10c>
  if(*path == 0)
    800042f6:	c79d                	beqz	a5,80004324 <namex+0x144>
    path++;
    800042f8:	85a6                	mv	a1,s1
  len = path - s;
    800042fa:	8cda                	mv	s9,s6
    800042fc:	865a                	mv	a2,s6
  while(*path != '/' && *path != 0)
    800042fe:	01278963          	beq	a5,s2,80004310 <namex+0x130>
    80004302:	dfbd                	beqz	a5,80004280 <namex+0xa0>
    path++;
    80004304:	0485                	addi	s1,s1,1
  while(*path != '/' && *path != 0)
    80004306:	0004c783          	lbu	a5,0(s1)
    8000430a:	ff279ce3          	bne	a5,s2,80004302 <namex+0x122>
    8000430e:	bf8d                	j	80004280 <namex+0xa0>
    memmove(name, s, len);
    80004310:	2601                	sext.w	a2,a2
    80004312:	8552                	mv	a0,s4
    80004314:	ffffd097          	auipc	ra,0xffffd
    80004318:	aa6080e7          	jalr	-1370(ra) # 80000dba <memmove>
    name[len] = 0;
    8000431c:	9cd2                	add	s9,s9,s4
    8000431e:	000c8023          	sb	zero,0(s9) # 2000 <_entry-0x7fffe000>
    80004322:	bf9d                	j	80004298 <namex+0xb8>
  if(nameiparent){
    80004324:	f20a83e3          	beqz	s5,8000424a <namex+0x6a>
    iput(ip);
    80004328:	854e                	mv	a0,s3
    8000432a:	00000097          	auipc	ra,0x0
    8000432e:	ae2080e7          	jalr	-1310(ra) # 80003e0c <iput>
    return 0;
    80004332:	4981                	li	s3,0
    80004334:	bf19                	j	8000424a <namex+0x6a>
  if(*path == 0)
    80004336:	d7fd                	beqz	a5,80004324 <namex+0x144>
  while(*path != '/' && *path != 0)
    80004338:	0004c783          	lbu	a5,0(s1)
    8000433c:	85a6                	mv	a1,s1
    8000433e:	b7d1                	j	80004302 <namex+0x122>

0000000080004340 <dirlink>:
{
    80004340:	7139                	addi	sp,sp,-64
    80004342:	fc06                	sd	ra,56(sp)
    80004344:	f822                	sd	s0,48(sp)
    80004346:	f426                	sd	s1,40(sp)
    80004348:	f04a                	sd	s2,32(sp)
    8000434a:	ec4e                	sd	s3,24(sp)
    8000434c:	e852                	sd	s4,16(sp)
    8000434e:	0080                	addi	s0,sp,64
    80004350:	892a                	mv	s2,a0
    80004352:	8a2e                	mv	s4,a1
    80004354:	89b2                	mv	s3,a2
  if((ip = dirlookup(dp, name, 0)) != 0){
    80004356:	4601                	li	a2,0
    80004358:	00000097          	auipc	ra,0x0
    8000435c:	dd8080e7          	jalr	-552(ra) # 80004130 <dirlookup>
    80004360:	e93d                	bnez	a0,800043d6 <dirlink+0x96>
  for(off = 0; off < dp->size; off += sizeof(de)){
    80004362:	04c92483          	lw	s1,76(s2)
    80004366:	c49d                	beqz	s1,80004394 <dirlink+0x54>
    80004368:	4481                	li	s1,0
    if(readi(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    8000436a:	4741                	li	a4,16
    8000436c:	86a6                	mv	a3,s1
    8000436e:	fc040613          	addi	a2,s0,-64
    80004372:	4581                	li	a1,0
    80004374:	854a                	mv	a0,s2
    80004376:	00000097          	auipc	ra,0x0
    8000437a:	b90080e7          	jalr	-1136(ra) # 80003f06 <readi>
    8000437e:	47c1                	li	a5,16
    80004380:	06f51163          	bne	a0,a5,800043e2 <dirlink+0xa2>
    if(de.inum == 0)
    80004384:	fc045783          	lhu	a5,-64(s0)
    80004388:	c791                	beqz	a5,80004394 <dirlink+0x54>
  for(off = 0; off < dp->size; off += sizeof(de)){
    8000438a:	24c1                	addiw	s1,s1,16
    8000438c:	04c92783          	lw	a5,76(s2)
    80004390:	fcf4ede3          	bltu	s1,a5,8000436a <dirlink+0x2a>
  strncpy(de.name, name, DIRSIZ);
    80004394:	4639                	li	a2,14
    80004396:	85d2                	mv	a1,s4
    80004398:	fc240513          	addi	a0,s0,-62
    8000439c:	ffffd097          	auipc	ra,0xffffd
    800043a0:	ad6080e7          	jalr	-1322(ra) # 80000e72 <strncpy>
  de.inum = inum;
    800043a4:	fd341023          	sh	s3,-64(s0)
  if(writei(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    800043a8:	4741                	li	a4,16
    800043aa:	86a6                	mv	a3,s1
    800043ac:	fc040613          	addi	a2,s0,-64
    800043b0:	4581                	li	a1,0
    800043b2:	854a                	mv	a0,s2
    800043b4:	00000097          	auipc	ra,0x0
    800043b8:	c48080e7          	jalr	-952(ra) # 80003ffc <writei>
    800043bc:	872a                	mv	a4,a0
    800043be:	47c1                	li	a5,16
  return 0;
    800043c0:	4501                	li	a0,0
  if(writei(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    800043c2:	02f71863          	bne	a4,a5,800043f2 <dirlink+0xb2>
}
    800043c6:	70e2                	ld	ra,56(sp)
    800043c8:	7442                	ld	s0,48(sp)
    800043ca:	74a2                	ld	s1,40(sp)
    800043cc:	7902                	ld	s2,32(sp)
    800043ce:	69e2                	ld	s3,24(sp)
    800043d0:	6a42                	ld	s4,16(sp)
    800043d2:	6121                	addi	sp,sp,64
    800043d4:	8082                	ret
    iput(ip);
    800043d6:	00000097          	auipc	ra,0x0
    800043da:	a36080e7          	jalr	-1482(ra) # 80003e0c <iput>
    return -1;
    800043de:	557d                	li	a0,-1
    800043e0:	b7dd                	j	800043c6 <dirlink+0x86>
      panic("dirlink read");
    800043e2:	00004517          	auipc	a0,0x4
    800043e6:	2fe50513          	addi	a0,a0,766 # 800086e0 <syscalls+0x230>
    800043ea:	ffffc097          	auipc	ra,0xffffc
    800043ee:	1e6080e7          	jalr	486(ra) # 800005d0 <panic>
    panic("dirlink");
    800043f2:	00004517          	auipc	a0,0x4
    800043f6:	40e50513          	addi	a0,a0,1038 # 80008800 <syscalls+0x350>
    800043fa:	ffffc097          	auipc	ra,0xffffc
    800043fe:	1d6080e7          	jalr	470(ra) # 800005d0 <panic>

0000000080004402 <namei>:

struct inode*
namei(char *path)
{
    80004402:	1101                	addi	sp,sp,-32
    80004404:	ec06                	sd	ra,24(sp)
    80004406:	e822                	sd	s0,16(sp)
    80004408:	1000                	addi	s0,sp,32
  char name[DIRSIZ];
  return namex(path, 0, name);
    8000440a:	fe040613          	addi	a2,s0,-32
    8000440e:	4581                	li	a1,0
    80004410:	00000097          	auipc	ra,0x0
    80004414:	dd0080e7          	jalr	-560(ra) # 800041e0 <namex>
}
    80004418:	60e2                	ld	ra,24(sp)
    8000441a:	6442                	ld	s0,16(sp)
    8000441c:	6105                	addi	sp,sp,32
    8000441e:	8082                	ret

0000000080004420 <nameiparent>:

struct inode*
nameiparent(char *path, char *name)
{
    80004420:	1141                	addi	sp,sp,-16
    80004422:	e406                	sd	ra,8(sp)
    80004424:	e022                	sd	s0,0(sp)
    80004426:	0800                	addi	s0,sp,16
    80004428:	862e                	mv	a2,a1
  return namex(path, 1, name);
    8000442a:	4585                	li	a1,1
    8000442c:	00000097          	auipc	ra,0x0
    80004430:	db4080e7          	jalr	-588(ra) # 800041e0 <namex>
}
    80004434:	60a2                	ld	ra,8(sp)
    80004436:	6402                	ld	s0,0(sp)
    80004438:	0141                	addi	sp,sp,16
    8000443a:	8082                	ret

000000008000443c <write_head>:
// Write in-memory log header to disk.
// This is the true point at which the
// current transaction commits.
static void
write_head(void)
{
    8000443c:	1101                	addi	sp,sp,-32
    8000443e:	ec06                	sd	ra,24(sp)
    80004440:	e822                	sd	s0,16(sp)
    80004442:	e426                	sd	s1,8(sp)
    80004444:	e04a                	sd	s2,0(sp)
    80004446:	1000                	addi	s0,sp,32
  struct buf *buf = bread(log.dev, log.start);
    80004448:	00023917          	auipc	s2,0x23
    8000444c:	f3890913          	addi	s2,s2,-200 # 80027380 <log>
    80004450:	01892583          	lw	a1,24(s2)
    80004454:	02892503          	lw	a0,40(s2)
    80004458:	fffff097          	auipc	ra,0xfffff
    8000445c:	ff6080e7          	jalr	-10(ra) # 8000344e <bread>
    80004460:	84aa                	mv	s1,a0
  struct logheader *hb = (struct logheader *) (buf->data);
  int i;
  hb->n = log.lh.n;
    80004462:	02c92683          	lw	a3,44(s2)
    80004466:	cd34                	sw	a3,88(a0)
  for (i = 0; i < log.lh.n; i++) {
    80004468:	02d05863          	blez	a3,80004498 <write_head+0x5c>
    8000446c:	00023797          	auipc	a5,0x23
    80004470:	f4478793          	addi	a5,a5,-188 # 800273b0 <log+0x30>
    80004474:	05c50713          	addi	a4,a0,92
    80004478:	36fd                	addiw	a3,a3,-1
    8000447a:	02069613          	slli	a2,a3,0x20
    8000447e:	01e65693          	srli	a3,a2,0x1e
    80004482:	00023617          	auipc	a2,0x23
    80004486:	f3260613          	addi	a2,a2,-206 # 800273b4 <log+0x34>
    8000448a:	96b2                	add	a3,a3,a2
    hb->block[i] = log.lh.block[i];
    8000448c:	4390                	lw	a2,0(a5)
    8000448e:	c310                	sw	a2,0(a4)
  for (i = 0; i < log.lh.n; i++) {
    80004490:	0791                	addi	a5,a5,4
    80004492:	0711                	addi	a4,a4,4 # 43004 <_entry-0x7ffbcffc>
    80004494:	fed79ce3          	bne	a5,a3,8000448c <write_head+0x50>
  }
  bwrite(buf);
    80004498:	8526                	mv	a0,s1
    8000449a:	fffff097          	auipc	ra,0xfffff
    8000449e:	0a6080e7          	jalr	166(ra) # 80003540 <bwrite>
  brelse(buf);
    800044a2:	8526                	mv	a0,s1
    800044a4:	fffff097          	auipc	ra,0xfffff
    800044a8:	0da080e7          	jalr	218(ra) # 8000357e <brelse>
}
    800044ac:	60e2                	ld	ra,24(sp)
    800044ae:	6442                	ld	s0,16(sp)
    800044b0:	64a2                	ld	s1,8(sp)
    800044b2:	6902                	ld	s2,0(sp)
    800044b4:	6105                	addi	sp,sp,32
    800044b6:	8082                	ret

00000000800044b8 <install_trans>:
  for (tail = 0; tail < log.lh.n; tail++) {
    800044b8:	00023797          	auipc	a5,0x23
    800044bc:	ef47a783          	lw	a5,-268(a5) # 800273ac <log+0x2c>
    800044c0:	0af05663          	blez	a5,8000456c <install_trans+0xb4>
{
    800044c4:	7139                	addi	sp,sp,-64
    800044c6:	fc06                	sd	ra,56(sp)
    800044c8:	f822                	sd	s0,48(sp)
    800044ca:	f426                	sd	s1,40(sp)
    800044cc:	f04a                	sd	s2,32(sp)
    800044ce:	ec4e                	sd	s3,24(sp)
    800044d0:	e852                	sd	s4,16(sp)
    800044d2:	e456                	sd	s5,8(sp)
    800044d4:	0080                	addi	s0,sp,64
    800044d6:	00023a97          	auipc	s5,0x23
    800044da:	edaa8a93          	addi	s5,s5,-294 # 800273b0 <log+0x30>
  for (tail = 0; tail < log.lh.n; tail++) {
    800044de:	4a01                	li	s4,0
    struct buf *lbuf = bread(log.dev, log.start+tail+1); // read log block
    800044e0:	00023997          	auipc	s3,0x23
    800044e4:	ea098993          	addi	s3,s3,-352 # 80027380 <log>
    800044e8:	0189a583          	lw	a1,24(s3)
    800044ec:	014585bb          	addw	a1,a1,s4
    800044f0:	2585                	addiw	a1,a1,1
    800044f2:	0289a503          	lw	a0,40(s3)
    800044f6:	fffff097          	auipc	ra,0xfffff
    800044fa:	f58080e7          	jalr	-168(ra) # 8000344e <bread>
    800044fe:	892a                	mv	s2,a0
    struct buf *dbuf = bread(log.dev, log.lh.block[tail]); // read dst
    80004500:	000aa583          	lw	a1,0(s5)
    80004504:	0289a503          	lw	a0,40(s3)
    80004508:	fffff097          	auipc	ra,0xfffff
    8000450c:	f46080e7          	jalr	-186(ra) # 8000344e <bread>
    80004510:	84aa                	mv	s1,a0
    memmove(dbuf->data, lbuf->data, BSIZE);  // copy block to dst
    80004512:	40000613          	li	a2,1024
    80004516:	05890593          	addi	a1,s2,88
    8000451a:	05850513          	addi	a0,a0,88
    8000451e:	ffffd097          	auipc	ra,0xffffd
    80004522:	89c080e7          	jalr	-1892(ra) # 80000dba <memmove>
    bwrite(dbuf);  // write dst to disk
    80004526:	8526                	mv	a0,s1
    80004528:	fffff097          	auipc	ra,0xfffff
    8000452c:	018080e7          	jalr	24(ra) # 80003540 <bwrite>
    bunpin(dbuf);
    80004530:	8526                	mv	a0,s1
    80004532:	fffff097          	auipc	ra,0xfffff
    80004536:	126080e7          	jalr	294(ra) # 80003658 <bunpin>
    brelse(lbuf);
    8000453a:	854a                	mv	a0,s2
    8000453c:	fffff097          	auipc	ra,0xfffff
    80004540:	042080e7          	jalr	66(ra) # 8000357e <brelse>
    brelse(dbuf);
    80004544:	8526                	mv	a0,s1
    80004546:	fffff097          	auipc	ra,0xfffff
    8000454a:	038080e7          	jalr	56(ra) # 8000357e <brelse>
  for (tail = 0; tail < log.lh.n; tail++) {
    8000454e:	2a05                	addiw	s4,s4,1
    80004550:	0a91                	addi	s5,s5,4
    80004552:	02c9a783          	lw	a5,44(s3)
    80004556:	f8fa49e3          	blt	s4,a5,800044e8 <install_trans+0x30>
}
    8000455a:	70e2                	ld	ra,56(sp)
    8000455c:	7442                	ld	s0,48(sp)
    8000455e:	74a2                	ld	s1,40(sp)
    80004560:	7902                	ld	s2,32(sp)
    80004562:	69e2                	ld	s3,24(sp)
    80004564:	6a42                	ld	s4,16(sp)
    80004566:	6aa2                	ld	s5,8(sp)
    80004568:	6121                	addi	sp,sp,64
    8000456a:	8082                	ret
    8000456c:	8082                	ret

000000008000456e <initlog>:
{
    8000456e:	7179                	addi	sp,sp,-48
    80004570:	f406                	sd	ra,40(sp)
    80004572:	f022                	sd	s0,32(sp)
    80004574:	ec26                	sd	s1,24(sp)
    80004576:	e84a                	sd	s2,16(sp)
    80004578:	e44e                	sd	s3,8(sp)
    8000457a:	1800                	addi	s0,sp,48
    8000457c:	892a                	mv	s2,a0
    8000457e:	89ae                	mv	s3,a1
  initlock(&log.lock, "log");
    80004580:	00023497          	auipc	s1,0x23
    80004584:	e0048493          	addi	s1,s1,-512 # 80027380 <log>
    80004588:	00004597          	auipc	a1,0x4
    8000458c:	16858593          	addi	a1,a1,360 # 800086f0 <syscalls+0x240>
    80004590:	8526                	mv	a0,s1
    80004592:	ffffc097          	auipc	ra,0xffffc
    80004596:	640080e7          	jalr	1600(ra) # 80000bd2 <initlock>
  log.start = sb->logstart;
    8000459a:	0149a583          	lw	a1,20(s3)
    8000459e:	cc8c                	sw	a1,24(s1)
  log.size = sb->nlog;
    800045a0:	0109a783          	lw	a5,16(s3)
    800045a4:	ccdc                	sw	a5,28(s1)
  log.dev = dev;
    800045a6:	0324a423          	sw	s2,40(s1)
  struct buf *buf = bread(log.dev, log.start);
    800045aa:	854a                	mv	a0,s2
    800045ac:	fffff097          	auipc	ra,0xfffff
    800045b0:	ea2080e7          	jalr	-350(ra) # 8000344e <bread>
  log.lh.n = lh->n;
    800045b4:	4d34                	lw	a3,88(a0)
    800045b6:	d4d4                	sw	a3,44(s1)
  for (i = 0; i < log.lh.n; i++) {
    800045b8:	02d05663          	blez	a3,800045e4 <initlog+0x76>
    800045bc:	05c50793          	addi	a5,a0,92
    800045c0:	00023717          	auipc	a4,0x23
    800045c4:	df070713          	addi	a4,a4,-528 # 800273b0 <log+0x30>
    800045c8:	36fd                	addiw	a3,a3,-1
    800045ca:	02069613          	slli	a2,a3,0x20
    800045ce:	01e65693          	srli	a3,a2,0x1e
    800045d2:	06050613          	addi	a2,a0,96
    800045d6:	96b2                	add	a3,a3,a2
    log.lh.block[i] = lh->block[i];
    800045d8:	4390                	lw	a2,0(a5)
    800045da:	c310                	sw	a2,0(a4)
  for (i = 0; i < log.lh.n; i++) {
    800045dc:	0791                	addi	a5,a5,4
    800045de:	0711                	addi	a4,a4,4
    800045e0:	fed79ce3          	bne	a5,a3,800045d8 <initlog+0x6a>
  brelse(buf);
    800045e4:	fffff097          	auipc	ra,0xfffff
    800045e8:	f9a080e7          	jalr	-102(ra) # 8000357e <brelse>

static void
recover_from_log(void)
{
  read_head();
  install_trans(); // if committed, copy from log to disk
    800045ec:	00000097          	auipc	ra,0x0
    800045f0:	ecc080e7          	jalr	-308(ra) # 800044b8 <install_trans>
  log.lh.n = 0;
    800045f4:	00023797          	auipc	a5,0x23
    800045f8:	da07ac23          	sw	zero,-584(a5) # 800273ac <log+0x2c>
  write_head(); // clear the log
    800045fc:	00000097          	auipc	ra,0x0
    80004600:	e40080e7          	jalr	-448(ra) # 8000443c <write_head>
}
    80004604:	70a2                	ld	ra,40(sp)
    80004606:	7402                	ld	s0,32(sp)
    80004608:	64e2                	ld	s1,24(sp)
    8000460a:	6942                	ld	s2,16(sp)
    8000460c:	69a2                	ld	s3,8(sp)
    8000460e:	6145                	addi	sp,sp,48
    80004610:	8082                	ret

0000000080004612 <begin_op>:
}

// called at the start of each FS system call.
void
begin_op(void)
{
    80004612:	1101                	addi	sp,sp,-32
    80004614:	ec06                	sd	ra,24(sp)
    80004616:	e822                	sd	s0,16(sp)
    80004618:	e426                	sd	s1,8(sp)
    8000461a:	e04a                	sd	s2,0(sp)
    8000461c:	1000                	addi	s0,sp,32
  acquire(&log.lock);
    8000461e:	00023517          	auipc	a0,0x23
    80004622:	d6250513          	addi	a0,a0,-670 # 80027380 <log>
    80004626:	ffffc097          	auipc	ra,0xffffc
    8000462a:	63c080e7          	jalr	1596(ra) # 80000c62 <acquire>
  while(1){
    if(log.committing){
    8000462e:	00023497          	auipc	s1,0x23
    80004632:	d5248493          	addi	s1,s1,-686 # 80027380 <log>
      sleep(&log, &log.lock);
    } else if(log.lh.n + (log.outstanding+1)*MAXOPBLOCKS > LOGSIZE){
    80004636:	4979                	li	s2,30
    80004638:	a039                	j	80004646 <begin_op+0x34>
      sleep(&log, &log.lock);
    8000463a:	85a6                	mv	a1,s1
    8000463c:	8526                	mv	a0,s1
    8000463e:	ffffe097          	auipc	ra,0xffffe
    80004642:	fcc080e7          	jalr	-52(ra) # 8000260a <sleep>
    if(log.committing){
    80004646:	50dc                	lw	a5,36(s1)
    80004648:	fbed                	bnez	a5,8000463a <begin_op+0x28>
    } else if(log.lh.n + (log.outstanding+1)*MAXOPBLOCKS > LOGSIZE){
    8000464a:	509c                	lw	a5,32(s1)
    8000464c:	0017871b          	addiw	a4,a5,1
    80004650:	0007069b          	sext.w	a3,a4
    80004654:	0027179b          	slliw	a5,a4,0x2
    80004658:	9fb9                	addw	a5,a5,a4
    8000465a:	0017979b          	slliw	a5,a5,0x1
    8000465e:	54d8                	lw	a4,44(s1)
    80004660:	9fb9                	addw	a5,a5,a4
    80004662:	00f95963          	bge	s2,a5,80004674 <begin_op+0x62>
      // this op might exhaust log space; wait for commit.
      sleep(&log, &log.lock);
    80004666:	85a6                	mv	a1,s1
    80004668:	8526                	mv	a0,s1
    8000466a:	ffffe097          	auipc	ra,0xffffe
    8000466e:	fa0080e7          	jalr	-96(ra) # 8000260a <sleep>
    80004672:	bfd1                	j	80004646 <begin_op+0x34>
    } else {
      log.outstanding += 1;
    80004674:	00023517          	auipc	a0,0x23
    80004678:	d0c50513          	addi	a0,a0,-756 # 80027380 <log>
    8000467c:	d114                	sw	a3,32(a0)
      release(&log.lock);
    8000467e:	ffffc097          	auipc	ra,0xffffc
    80004682:	698080e7          	jalr	1688(ra) # 80000d16 <release>
      break;
    }
  }
}
    80004686:	60e2                	ld	ra,24(sp)
    80004688:	6442                	ld	s0,16(sp)
    8000468a:	64a2                	ld	s1,8(sp)
    8000468c:	6902                	ld	s2,0(sp)
    8000468e:	6105                	addi	sp,sp,32
    80004690:	8082                	ret

0000000080004692 <end_op>:

// called at the end of each FS system call.
// commits if this was the last outstanding operation.
void
end_op(void)
{
    80004692:	7139                	addi	sp,sp,-64
    80004694:	fc06                	sd	ra,56(sp)
    80004696:	f822                	sd	s0,48(sp)
    80004698:	f426                	sd	s1,40(sp)
    8000469a:	f04a                	sd	s2,32(sp)
    8000469c:	ec4e                	sd	s3,24(sp)
    8000469e:	e852                	sd	s4,16(sp)
    800046a0:	e456                	sd	s5,8(sp)
    800046a2:	0080                	addi	s0,sp,64
  int do_commit = 0;

  acquire(&log.lock);
    800046a4:	00023497          	auipc	s1,0x23
    800046a8:	cdc48493          	addi	s1,s1,-804 # 80027380 <log>
    800046ac:	8526                	mv	a0,s1
    800046ae:	ffffc097          	auipc	ra,0xffffc
    800046b2:	5b4080e7          	jalr	1460(ra) # 80000c62 <acquire>
  log.outstanding -= 1;
    800046b6:	509c                	lw	a5,32(s1)
    800046b8:	37fd                	addiw	a5,a5,-1
    800046ba:	0007891b          	sext.w	s2,a5
    800046be:	d09c                	sw	a5,32(s1)
  if(log.committing)
    800046c0:	50dc                	lw	a5,36(s1)
    800046c2:	e7b9                	bnez	a5,80004710 <end_op+0x7e>
    panic("log.committing");
  if(log.outstanding == 0){
    800046c4:	04091e63          	bnez	s2,80004720 <end_op+0x8e>
    do_commit = 1;
    log.committing = 1;
    800046c8:	00023497          	auipc	s1,0x23
    800046cc:	cb848493          	addi	s1,s1,-840 # 80027380 <log>
    800046d0:	4785                	li	a5,1
    800046d2:	d0dc                	sw	a5,36(s1)
    // begin_op() may be waiting for log space,
    // and decrementing log.outstanding has decreased
    // the amount of reserved space.
    wakeup(&log);
  }
  release(&log.lock);
    800046d4:	8526                	mv	a0,s1
    800046d6:	ffffc097          	auipc	ra,0xffffc
    800046da:	640080e7          	jalr	1600(ra) # 80000d16 <release>
}

static void
commit()
{
  if (log.lh.n > 0) {
    800046de:	54dc                	lw	a5,44(s1)
    800046e0:	06f04763          	bgtz	a5,8000474e <end_op+0xbc>
    acquire(&log.lock);
    800046e4:	00023497          	auipc	s1,0x23
    800046e8:	c9c48493          	addi	s1,s1,-868 # 80027380 <log>
    800046ec:	8526                	mv	a0,s1
    800046ee:	ffffc097          	auipc	ra,0xffffc
    800046f2:	574080e7          	jalr	1396(ra) # 80000c62 <acquire>
    log.committing = 0;
    800046f6:	0204a223          	sw	zero,36(s1)
    wakeup(&log);
    800046fa:	8526                	mv	a0,s1
    800046fc:	ffffe097          	auipc	ra,0xffffe
    80004700:	08e080e7          	jalr	142(ra) # 8000278a <wakeup>
    release(&log.lock);
    80004704:	8526                	mv	a0,s1
    80004706:	ffffc097          	auipc	ra,0xffffc
    8000470a:	610080e7          	jalr	1552(ra) # 80000d16 <release>
}
    8000470e:	a03d                	j	8000473c <end_op+0xaa>
    panic("log.committing");
    80004710:	00004517          	auipc	a0,0x4
    80004714:	fe850513          	addi	a0,a0,-24 # 800086f8 <syscalls+0x248>
    80004718:	ffffc097          	auipc	ra,0xffffc
    8000471c:	eb8080e7          	jalr	-328(ra) # 800005d0 <panic>
    wakeup(&log);
    80004720:	00023497          	auipc	s1,0x23
    80004724:	c6048493          	addi	s1,s1,-928 # 80027380 <log>
    80004728:	8526                	mv	a0,s1
    8000472a:	ffffe097          	auipc	ra,0xffffe
    8000472e:	060080e7          	jalr	96(ra) # 8000278a <wakeup>
  release(&log.lock);
    80004732:	8526                	mv	a0,s1
    80004734:	ffffc097          	auipc	ra,0xffffc
    80004738:	5e2080e7          	jalr	1506(ra) # 80000d16 <release>
}
    8000473c:	70e2                	ld	ra,56(sp)
    8000473e:	7442                	ld	s0,48(sp)
    80004740:	74a2                	ld	s1,40(sp)
    80004742:	7902                	ld	s2,32(sp)
    80004744:	69e2                	ld	s3,24(sp)
    80004746:	6a42                	ld	s4,16(sp)
    80004748:	6aa2                	ld	s5,8(sp)
    8000474a:	6121                	addi	sp,sp,64
    8000474c:	8082                	ret
  for (tail = 0; tail < log.lh.n; tail++) {
    8000474e:	00023a97          	auipc	s5,0x23
    80004752:	c62a8a93          	addi	s5,s5,-926 # 800273b0 <log+0x30>
    struct buf *to = bread(log.dev, log.start+tail+1); // log block
    80004756:	00023a17          	auipc	s4,0x23
    8000475a:	c2aa0a13          	addi	s4,s4,-982 # 80027380 <log>
    8000475e:	018a2583          	lw	a1,24(s4)
    80004762:	012585bb          	addw	a1,a1,s2
    80004766:	2585                	addiw	a1,a1,1
    80004768:	028a2503          	lw	a0,40(s4)
    8000476c:	fffff097          	auipc	ra,0xfffff
    80004770:	ce2080e7          	jalr	-798(ra) # 8000344e <bread>
    80004774:	84aa                	mv	s1,a0
    struct buf *from = bread(log.dev, log.lh.block[tail]); // cache block
    80004776:	000aa583          	lw	a1,0(s5)
    8000477a:	028a2503          	lw	a0,40(s4)
    8000477e:	fffff097          	auipc	ra,0xfffff
    80004782:	cd0080e7          	jalr	-816(ra) # 8000344e <bread>
    80004786:	89aa                	mv	s3,a0
    memmove(to->data, from->data, BSIZE);
    80004788:	40000613          	li	a2,1024
    8000478c:	05850593          	addi	a1,a0,88
    80004790:	05848513          	addi	a0,s1,88
    80004794:	ffffc097          	auipc	ra,0xffffc
    80004798:	626080e7          	jalr	1574(ra) # 80000dba <memmove>
    bwrite(to);  // write the log
    8000479c:	8526                	mv	a0,s1
    8000479e:	fffff097          	auipc	ra,0xfffff
    800047a2:	da2080e7          	jalr	-606(ra) # 80003540 <bwrite>
    brelse(from);
    800047a6:	854e                	mv	a0,s3
    800047a8:	fffff097          	auipc	ra,0xfffff
    800047ac:	dd6080e7          	jalr	-554(ra) # 8000357e <brelse>
    brelse(to);
    800047b0:	8526                	mv	a0,s1
    800047b2:	fffff097          	auipc	ra,0xfffff
    800047b6:	dcc080e7          	jalr	-564(ra) # 8000357e <brelse>
  for (tail = 0; tail < log.lh.n; tail++) {
    800047ba:	2905                	addiw	s2,s2,1
    800047bc:	0a91                	addi	s5,s5,4
    800047be:	02ca2783          	lw	a5,44(s4)
    800047c2:	f8f94ee3          	blt	s2,a5,8000475e <end_op+0xcc>
    write_log();     // Write modified blocks from cache to log
    write_head();    // Write header to disk -- the real commit
    800047c6:	00000097          	auipc	ra,0x0
    800047ca:	c76080e7          	jalr	-906(ra) # 8000443c <write_head>
    install_trans(); // Now install writes to home locations
    800047ce:	00000097          	auipc	ra,0x0
    800047d2:	cea080e7          	jalr	-790(ra) # 800044b8 <install_trans>
    log.lh.n = 0;
    800047d6:	00023797          	auipc	a5,0x23
    800047da:	bc07ab23          	sw	zero,-1066(a5) # 800273ac <log+0x2c>
    write_head();    // Erase the transaction from the log
    800047de:	00000097          	auipc	ra,0x0
    800047e2:	c5e080e7          	jalr	-930(ra) # 8000443c <write_head>
    800047e6:	bdfd                	j	800046e4 <end_op+0x52>

00000000800047e8 <log_write>:
//   modify bp->data[]
//   log_write(bp)
//   brelse(bp)
void
log_write(struct buf *b)
{
    800047e8:	1101                	addi	sp,sp,-32
    800047ea:	ec06                	sd	ra,24(sp)
    800047ec:	e822                	sd	s0,16(sp)
    800047ee:	e426                	sd	s1,8(sp)
    800047f0:	e04a                	sd	s2,0(sp)
    800047f2:	1000                	addi	s0,sp,32
  int i;

  if (log.lh.n >= LOGSIZE || log.lh.n >= log.size - 1)
    800047f4:	00023717          	auipc	a4,0x23
    800047f8:	bb872703          	lw	a4,-1096(a4) # 800273ac <log+0x2c>
    800047fc:	47f5                	li	a5,29
    800047fe:	08e7c063          	blt	a5,a4,8000487e <log_write+0x96>
    80004802:	84aa                	mv	s1,a0
    80004804:	00023797          	auipc	a5,0x23
    80004808:	b987a783          	lw	a5,-1128(a5) # 8002739c <log+0x1c>
    8000480c:	37fd                	addiw	a5,a5,-1
    8000480e:	06f75863          	bge	a4,a5,8000487e <log_write+0x96>
    panic("too big a transaction");
  if (log.outstanding < 1)
    80004812:	00023797          	auipc	a5,0x23
    80004816:	b8e7a783          	lw	a5,-1138(a5) # 800273a0 <log+0x20>
    8000481a:	06f05a63          	blez	a5,8000488e <log_write+0xa6>
    panic("log_write outside of trans");

  acquire(&log.lock);
    8000481e:	00023917          	auipc	s2,0x23
    80004822:	b6290913          	addi	s2,s2,-1182 # 80027380 <log>
    80004826:	854a                	mv	a0,s2
    80004828:	ffffc097          	auipc	ra,0xffffc
    8000482c:	43a080e7          	jalr	1082(ra) # 80000c62 <acquire>
  for (i = 0; i < log.lh.n; i++) {
    80004830:	02c92603          	lw	a2,44(s2)
    80004834:	06c05563          	blez	a2,8000489e <log_write+0xb6>
    if (log.lh.block[i] == b->blockno)   // log absorbtion
    80004838:	44cc                	lw	a1,12(s1)
    8000483a:	00023717          	auipc	a4,0x23
    8000483e:	b7670713          	addi	a4,a4,-1162 # 800273b0 <log+0x30>
  for (i = 0; i < log.lh.n; i++) {
    80004842:	4781                	li	a5,0
    if (log.lh.block[i] == b->blockno)   // log absorbtion
    80004844:	4314                	lw	a3,0(a4)
    80004846:	04b68d63          	beq	a3,a1,800048a0 <log_write+0xb8>
  for (i = 0; i < log.lh.n; i++) {
    8000484a:	2785                	addiw	a5,a5,1
    8000484c:	0711                	addi	a4,a4,4
    8000484e:	fec79be3          	bne	a5,a2,80004844 <log_write+0x5c>
      break;
  }
  log.lh.block[i] = b->blockno;
    80004852:	0621                	addi	a2,a2,8
    80004854:	060a                	slli	a2,a2,0x2
    80004856:	00023797          	auipc	a5,0x23
    8000485a:	b2a78793          	addi	a5,a5,-1238 # 80027380 <log>
    8000485e:	963e                	add	a2,a2,a5
    80004860:	44dc                	lw	a5,12(s1)
    80004862:	ca1c                	sw	a5,16(a2)
  if (i == log.lh.n) {  // Add new block to log?
    bpin(b);
    80004864:	8526                	mv	a0,s1
    80004866:	fffff097          	auipc	ra,0xfffff
    8000486a:	db6080e7          	jalr	-586(ra) # 8000361c <bpin>
    log.lh.n++;
    8000486e:	00023717          	auipc	a4,0x23
    80004872:	b1270713          	addi	a4,a4,-1262 # 80027380 <log>
    80004876:	575c                	lw	a5,44(a4)
    80004878:	2785                	addiw	a5,a5,1
    8000487a:	d75c                	sw	a5,44(a4)
    8000487c:	a83d                	j	800048ba <log_write+0xd2>
    panic("too big a transaction");
    8000487e:	00004517          	auipc	a0,0x4
    80004882:	e8a50513          	addi	a0,a0,-374 # 80008708 <syscalls+0x258>
    80004886:	ffffc097          	auipc	ra,0xffffc
    8000488a:	d4a080e7          	jalr	-694(ra) # 800005d0 <panic>
    panic("log_write outside of trans");
    8000488e:	00004517          	auipc	a0,0x4
    80004892:	e9250513          	addi	a0,a0,-366 # 80008720 <syscalls+0x270>
    80004896:	ffffc097          	auipc	ra,0xffffc
    8000489a:	d3a080e7          	jalr	-710(ra) # 800005d0 <panic>
  for (i = 0; i < log.lh.n; i++) {
    8000489e:	4781                	li	a5,0
  log.lh.block[i] = b->blockno;
    800048a0:	00878713          	addi	a4,a5,8
    800048a4:	00271693          	slli	a3,a4,0x2
    800048a8:	00023717          	auipc	a4,0x23
    800048ac:	ad870713          	addi	a4,a4,-1320 # 80027380 <log>
    800048b0:	9736                	add	a4,a4,a3
    800048b2:	44d4                	lw	a3,12(s1)
    800048b4:	cb14                	sw	a3,16(a4)
  if (i == log.lh.n) {  // Add new block to log?
    800048b6:	faf607e3          	beq	a2,a5,80004864 <log_write+0x7c>
  }
  release(&log.lock);
    800048ba:	00023517          	auipc	a0,0x23
    800048be:	ac650513          	addi	a0,a0,-1338 # 80027380 <log>
    800048c2:	ffffc097          	auipc	ra,0xffffc
    800048c6:	454080e7          	jalr	1108(ra) # 80000d16 <release>
}
    800048ca:	60e2                	ld	ra,24(sp)
    800048cc:	6442                	ld	s0,16(sp)
    800048ce:	64a2                	ld	s1,8(sp)
    800048d0:	6902                	ld	s2,0(sp)
    800048d2:	6105                	addi	sp,sp,32
    800048d4:	8082                	ret

00000000800048d6 <initsleeplock>:
#include "proc.h"
#include "sleeplock.h"

void
initsleeplock(struct sleeplock *lk, char *name)
{
    800048d6:	1101                	addi	sp,sp,-32
    800048d8:	ec06                	sd	ra,24(sp)
    800048da:	e822                	sd	s0,16(sp)
    800048dc:	e426                	sd	s1,8(sp)
    800048de:	e04a                	sd	s2,0(sp)
    800048e0:	1000                	addi	s0,sp,32
    800048e2:	84aa                	mv	s1,a0
    800048e4:	892e                	mv	s2,a1
  initlock(&lk->lk, "sleep lock");
    800048e6:	00004597          	auipc	a1,0x4
    800048ea:	e5a58593          	addi	a1,a1,-422 # 80008740 <syscalls+0x290>
    800048ee:	0521                	addi	a0,a0,8
    800048f0:	ffffc097          	auipc	ra,0xffffc
    800048f4:	2e2080e7          	jalr	738(ra) # 80000bd2 <initlock>
  lk->name = name;
    800048f8:	0324b023          	sd	s2,32(s1)
  lk->locked = 0;
    800048fc:	0004a023          	sw	zero,0(s1)
  lk->pid = 0;
    80004900:	0204a423          	sw	zero,40(s1)
}
    80004904:	60e2                	ld	ra,24(sp)
    80004906:	6442                	ld	s0,16(sp)
    80004908:	64a2                	ld	s1,8(sp)
    8000490a:	6902                	ld	s2,0(sp)
    8000490c:	6105                	addi	sp,sp,32
    8000490e:	8082                	ret

0000000080004910 <acquiresleep>:

void
acquiresleep(struct sleeplock *lk)
{
    80004910:	1101                	addi	sp,sp,-32
    80004912:	ec06                	sd	ra,24(sp)
    80004914:	e822                	sd	s0,16(sp)
    80004916:	e426                	sd	s1,8(sp)
    80004918:	e04a                	sd	s2,0(sp)
    8000491a:	1000                	addi	s0,sp,32
    8000491c:	84aa                	mv	s1,a0
  acquire(&lk->lk);
    8000491e:	00850913          	addi	s2,a0,8
    80004922:	854a                	mv	a0,s2
    80004924:	ffffc097          	auipc	ra,0xffffc
    80004928:	33e080e7          	jalr	830(ra) # 80000c62 <acquire>
  while (lk->locked) {
    8000492c:	409c                	lw	a5,0(s1)
    8000492e:	cb89                	beqz	a5,80004940 <acquiresleep+0x30>
    sleep(lk, &lk->lk);
    80004930:	85ca                	mv	a1,s2
    80004932:	8526                	mv	a0,s1
    80004934:	ffffe097          	auipc	ra,0xffffe
    80004938:	cd6080e7          	jalr	-810(ra) # 8000260a <sleep>
  while (lk->locked) {
    8000493c:	409c                	lw	a5,0(s1)
    8000493e:	fbed                	bnez	a5,80004930 <acquiresleep+0x20>
  }
  lk->locked = 1;
    80004940:	4785                	li	a5,1
    80004942:	c09c                	sw	a5,0(s1)
  lk->pid = myproc()->pid;
    80004944:	ffffd097          	auipc	ra,0xffffd
    80004948:	406080e7          	jalr	1030(ra) # 80001d4a <myproc>
    8000494c:	5d1c                	lw	a5,56(a0)
    8000494e:	d49c                	sw	a5,40(s1)
  release(&lk->lk);
    80004950:	854a                	mv	a0,s2
    80004952:	ffffc097          	auipc	ra,0xffffc
    80004956:	3c4080e7          	jalr	964(ra) # 80000d16 <release>
}
    8000495a:	60e2                	ld	ra,24(sp)
    8000495c:	6442                	ld	s0,16(sp)
    8000495e:	64a2                	ld	s1,8(sp)
    80004960:	6902                	ld	s2,0(sp)
    80004962:	6105                	addi	sp,sp,32
    80004964:	8082                	ret

0000000080004966 <releasesleep>:

void
releasesleep(struct sleeplock *lk)
{
    80004966:	1101                	addi	sp,sp,-32
    80004968:	ec06                	sd	ra,24(sp)
    8000496a:	e822                	sd	s0,16(sp)
    8000496c:	e426                	sd	s1,8(sp)
    8000496e:	e04a                	sd	s2,0(sp)
    80004970:	1000                	addi	s0,sp,32
    80004972:	84aa                	mv	s1,a0
  acquire(&lk->lk);
    80004974:	00850913          	addi	s2,a0,8
    80004978:	854a                	mv	a0,s2
    8000497a:	ffffc097          	auipc	ra,0xffffc
    8000497e:	2e8080e7          	jalr	744(ra) # 80000c62 <acquire>
  lk->locked = 0;
    80004982:	0004a023          	sw	zero,0(s1)
  lk->pid = 0;
    80004986:	0204a423          	sw	zero,40(s1)
  wakeup(lk);
    8000498a:	8526                	mv	a0,s1
    8000498c:	ffffe097          	auipc	ra,0xffffe
    80004990:	dfe080e7          	jalr	-514(ra) # 8000278a <wakeup>
  release(&lk->lk);
    80004994:	854a                	mv	a0,s2
    80004996:	ffffc097          	auipc	ra,0xffffc
    8000499a:	380080e7          	jalr	896(ra) # 80000d16 <release>
}
    8000499e:	60e2                	ld	ra,24(sp)
    800049a0:	6442                	ld	s0,16(sp)
    800049a2:	64a2                	ld	s1,8(sp)
    800049a4:	6902                	ld	s2,0(sp)
    800049a6:	6105                	addi	sp,sp,32
    800049a8:	8082                	ret

00000000800049aa <holdingsleep>:

int
holdingsleep(struct sleeplock *lk)
{
    800049aa:	7179                	addi	sp,sp,-48
    800049ac:	f406                	sd	ra,40(sp)
    800049ae:	f022                	sd	s0,32(sp)
    800049b0:	ec26                	sd	s1,24(sp)
    800049b2:	e84a                	sd	s2,16(sp)
    800049b4:	e44e                	sd	s3,8(sp)
    800049b6:	1800                	addi	s0,sp,48
    800049b8:	84aa                	mv	s1,a0
  int r;
  
  acquire(&lk->lk);
    800049ba:	00850913          	addi	s2,a0,8
    800049be:	854a                	mv	a0,s2
    800049c0:	ffffc097          	auipc	ra,0xffffc
    800049c4:	2a2080e7          	jalr	674(ra) # 80000c62 <acquire>
  r = lk->locked && (lk->pid == myproc()->pid);
    800049c8:	409c                	lw	a5,0(s1)
    800049ca:	ef99                	bnez	a5,800049e8 <holdingsleep+0x3e>
    800049cc:	4481                	li	s1,0
  release(&lk->lk);
    800049ce:	854a                	mv	a0,s2
    800049d0:	ffffc097          	auipc	ra,0xffffc
    800049d4:	346080e7          	jalr	838(ra) # 80000d16 <release>
  return r;
}
    800049d8:	8526                	mv	a0,s1
    800049da:	70a2                	ld	ra,40(sp)
    800049dc:	7402                	ld	s0,32(sp)
    800049de:	64e2                	ld	s1,24(sp)
    800049e0:	6942                	ld	s2,16(sp)
    800049e2:	69a2                	ld	s3,8(sp)
    800049e4:	6145                	addi	sp,sp,48
    800049e6:	8082                	ret
  r = lk->locked && (lk->pid == myproc()->pid);
    800049e8:	0284a983          	lw	s3,40(s1)
    800049ec:	ffffd097          	auipc	ra,0xffffd
    800049f0:	35e080e7          	jalr	862(ra) # 80001d4a <myproc>
    800049f4:	5d04                	lw	s1,56(a0)
    800049f6:	413484b3          	sub	s1,s1,s3
    800049fa:	0014b493          	seqz	s1,s1
    800049fe:	bfc1                	j	800049ce <holdingsleep+0x24>

0000000080004a00 <fileinit>:
  struct file file[NFILE];
} ftable;

void
fileinit(void)
{
    80004a00:	1141                	addi	sp,sp,-16
    80004a02:	e406                	sd	ra,8(sp)
    80004a04:	e022                	sd	s0,0(sp)
    80004a06:	0800                	addi	s0,sp,16
  initlock(&ftable.lock, "ftable");
    80004a08:	00004597          	auipc	a1,0x4
    80004a0c:	d4858593          	addi	a1,a1,-696 # 80008750 <syscalls+0x2a0>
    80004a10:	00023517          	auipc	a0,0x23
    80004a14:	ab850513          	addi	a0,a0,-1352 # 800274c8 <ftable>
    80004a18:	ffffc097          	auipc	ra,0xffffc
    80004a1c:	1ba080e7          	jalr	442(ra) # 80000bd2 <initlock>
}
    80004a20:	60a2                	ld	ra,8(sp)
    80004a22:	6402                	ld	s0,0(sp)
    80004a24:	0141                	addi	sp,sp,16
    80004a26:	8082                	ret

0000000080004a28 <filealloc>:

// Allocate a file structure.
struct file*
filealloc(void)
{
    80004a28:	1101                	addi	sp,sp,-32
    80004a2a:	ec06                	sd	ra,24(sp)
    80004a2c:	e822                	sd	s0,16(sp)
    80004a2e:	e426                	sd	s1,8(sp)
    80004a30:	1000                	addi	s0,sp,32
  struct file *f;

  acquire(&ftable.lock);
    80004a32:	00023517          	auipc	a0,0x23
    80004a36:	a9650513          	addi	a0,a0,-1386 # 800274c8 <ftable>
    80004a3a:	ffffc097          	auipc	ra,0xffffc
    80004a3e:	228080e7          	jalr	552(ra) # 80000c62 <acquire>
  for(f = ftable.file; f < ftable.file + NFILE; f++){
    80004a42:	00023497          	auipc	s1,0x23
    80004a46:	a9e48493          	addi	s1,s1,-1378 # 800274e0 <ftable+0x18>
    80004a4a:	00024717          	auipc	a4,0x24
    80004a4e:	a3670713          	addi	a4,a4,-1482 # 80028480 <ftable+0xfb8>
    if(f->ref == 0){
    80004a52:	40dc                	lw	a5,4(s1)
    80004a54:	cf99                	beqz	a5,80004a72 <filealloc+0x4a>
  for(f = ftable.file; f < ftable.file + NFILE; f++){
    80004a56:	02848493          	addi	s1,s1,40
    80004a5a:	fee49ce3          	bne	s1,a4,80004a52 <filealloc+0x2a>
      f->ref = 1;
      release(&ftable.lock);
      return f;
    }
  }
  release(&ftable.lock);
    80004a5e:	00023517          	auipc	a0,0x23
    80004a62:	a6a50513          	addi	a0,a0,-1430 # 800274c8 <ftable>
    80004a66:	ffffc097          	auipc	ra,0xffffc
    80004a6a:	2b0080e7          	jalr	688(ra) # 80000d16 <release>
  return 0;
    80004a6e:	4481                	li	s1,0
    80004a70:	a819                	j	80004a86 <filealloc+0x5e>
      f->ref = 1;
    80004a72:	4785                	li	a5,1
    80004a74:	c0dc                	sw	a5,4(s1)
      release(&ftable.lock);
    80004a76:	00023517          	auipc	a0,0x23
    80004a7a:	a5250513          	addi	a0,a0,-1454 # 800274c8 <ftable>
    80004a7e:	ffffc097          	auipc	ra,0xffffc
    80004a82:	298080e7          	jalr	664(ra) # 80000d16 <release>
}
    80004a86:	8526                	mv	a0,s1
    80004a88:	60e2                	ld	ra,24(sp)
    80004a8a:	6442                	ld	s0,16(sp)
    80004a8c:	64a2                	ld	s1,8(sp)
    80004a8e:	6105                	addi	sp,sp,32
    80004a90:	8082                	ret

0000000080004a92 <filedup>:

// Increment ref count for file f.
struct file*
filedup(struct file *f)
{
    80004a92:	1101                	addi	sp,sp,-32
    80004a94:	ec06                	sd	ra,24(sp)
    80004a96:	e822                	sd	s0,16(sp)
    80004a98:	e426                	sd	s1,8(sp)
    80004a9a:	1000                	addi	s0,sp,32
    80004a9c:	84aa                	mv	s1,a0
  acquire(&ftable.lock);
    80004a9e:	00023517          	auipc	a0,0x23
    80004aa2:	a2a50513          	addi	a0,a0,-1494 # 800274c8 <ftable>
    80004aa6:	ffffc097          	auipc	ra,0xffffc
    80004aaa:	1bc080e7          	jalr	444(ra) # 80000c62 <acquire>
  if(f->ref < 1)
    80004aae:	40dc                	lw	a5,4(s1)
    80004ab0:	02f05263          	blez	a5,80004ad4 <filedup+0x42>
    panic("filedup");
  f->ref++;
    80004ab4:	2785                	addiw	a5,a5,1
    80004ab6:	c0dc                	sw	a5,4(s1)
  release(&ftable.lock);
    80004ab8:	00023517          	auipc	a0,0x23
    80004abc:	a1050513          	addi	a0,a0,-1520 # 800274c8 <ftable>
    80004ac0:	ffffc097          	auipc	ra,0xffffc
    80004ac4:	256080e7          	jalr	598(ra) # 80000d16 <release>
  return f;
}
    80004ac8:	8526                	mv	a0,s1
    80004aca:	60e2                	ld	ra,24(sp)
    80004acc:	6442                	ld	s0,16(sp)
    80004ace:	64a2                	ld	s1,8(sp)
    80004ad0:	6105                	addi	sp,sp,32
    80004ad2:	8082                	ret
    panic("filedup");
    80004ad4:	00004517          	auipc	a0,0x4
    80004ad8:	c8450513          	addi	a0,a0,-892 # 80008758 <syscalls+0x2a8>
    80004adc:	ffffc097          	auipc	ra,0xffffc
    80004ae0:	af4080e7          	jalr	-1292(ra) # 800005d0 <panic>

0000000080004ae4 <fileclose>:

// Close file f.  (Decrement ref count, close when reaches 0.)
void
fileclose(struct file *f)
{
    80004ae4:	7139                	addi	sp,sp,-64
    80004ae6:	fc06                	sd	ra,56(sp)
    80004ae8:	f822                	sd	s0,48(sp)
    80004aea:	f426                	sd	s1,40(sp)
    80004aec:	f04a                	sd	s2,32(sp)
    80004aee:	ec4e                	sd	s3,24(sp)
    80004af0:	e852                	sd	s4,16(sp)
    80004af2:	e456                	sd	s5,8(sp)
    80004af4:	0080                	addi	s0,sp,64
    80004af6:	84aa                	mv	s1,a0
  struct file ff;

  acquire(&ftable.lock);
    80004af8:	00023517          	auipc	a0,0x23
    80004afc:	9d050513          	addi	a0,a0,-1584 # 800274c8 <ftable>
    80004b00:	ffffc097          	auipc	ra,0xffffc
    80004b04:	162080e7          	jalr	354(ra) # 80000c62 <acquire>
  if(f->ref < 1)
    80004b08:	40dc                	lw	a5,4(s1)
    80004b0a:	06f05163          	blez	a5,80004b6c <fileclose+0x88>
    panic("fileclose");
  if(--f->ref > 0){
    80004b0e:	37fd                	addiw	a5,a5,-1
    80004b10:	0007871b          	sext.w	a4,a5
    80004b14:	c0dc                	sw	a5,4(s1)
    80004b16:	06e04363          	bgtz	a4,80004b7c <fileclose+0x98>
    release(&ftable.lock);
    return;
  }
  ff = *f;
    80004b1a:	0004a903          	lw	s2,0(s1)
    80004b1e:	0094ca83          	lbu	s5,9(s1)
    80004b22:	0104ba03          	ld	s4,16(s1)
    80004b26:	0184b983          	ld	s3,24(s1)
  f->ref = 0;
    80004b2a:	0004a223          	sw	zero,4(s1)
  f->type = FD_NONE;
    80004b2e:	0004a023          	sw	zero,0(s1)
  release(&ftable.lock);
    80004b32:	00023517          	auipc	a0,0x23
    80004b36:	99650513          	addi	a0,a0,-1642 # 800274c8 <ftable>
    80004b3a:	ffffc097          	auipc	ra,0xffffc
    80004b3e:	1dc080e7          	jalr	476(ra) # 80000d16 <release>

  if(ff.type == FD_PIPE){
    80004b42:	4785                	li	a5,1
    80004b44:	04f90d63          	beq	s2,a5,80004b9e <fileclose+0xba>
    pipeclose(ff.pipe, ff.writable);
  } else if(ff.type == FD_INODE || ff.type == FD_DEVICE){
    80004b48:	3979                	addiw	s2,s2,-2
    80004b4a:	4785                	li	a5,1
    80004b4c:	0527e063          	bltu	a5,s2,80004b8c <fileclose+0xa8>
    begin_op();
    80004b50:	00000097          	auipc	ra,0x0
    80004b54:	ac2080e7          	jalr	-1342(ra) # 80004612 <begin_op>
    iput(ff.ip);
    80004b58:	854e                	mv	a0,s3
    80004b5a:	fffff097          	auipc	ra,0xfffff
    80004b5e:	2b2080e7          	jalr	690(ra) # 80003e0c <iput>
    end_op();
    80004b62:	00000097          	auipc	ra,0x0
    80004b66:	b30080e7          	jalr	-1232(ra) # 80004692 <end_op>
    80004b6a:	a00d                	j	80004b8c <fileclose+0xa8>
    panic("fileclose");
    80004b6c:	00004517          	auipc	a0,0x4
    80004b70:	bf450513          	addi	a0,a0,-1036 # 80008760 <syscalls+0x2b0>
    80004b74:	ffffc097          	auipc	ra,0xffffc
    80004b78:	a5c080e7          	jalr	-1444(ra) # 800005d0 <panic>
    release(&ftable.lock);
    80004b7c:	00023517          	auipc	a0,0x23
    80004b80:	94c50513          	addi	a0,a0,-1716 # 800274c8 <ftable>
    80004b84:	ffffc097          	auipc	ra,0xffffc
    80004b88:	192080e7          	jalr	402(ra) # 80000d16 <release>
  }
}
    80004b8c:	70e2                	ld	ra,56(sp)
    80004b8e:	7442                	ld	s0,48(sp)
    80004b90:	74a2                	ld	s1,40(sp)
    80004b92:	7902                	ld	s2,32(sp)
    80004b94:	69e2                	ld	s3,24(sp)
    80004b96:	6a42                	ld	s4,16(sp)
    80004b98:	6aa2                	ld	s5,8(sp)
    80004b9a:	6121                	addi	sp,sp,64
    80004b9c:	8082                	ret
    pipeclose(ff.pipe, ff.writable);
    80004b9e:	85d6                	mv	a1,s5
    80004ba0:	8552                	mv	a0,s4
    80004ba2:	00000097          	auipc	ra,0x0
    80004ba6:	372080e7          	jalr	882(ra) # 80004f14 <pipeclose>
    80004baa:	b7cd                	j	80004b8c <fileclose+0xa8>

0000000080004bac <filestat>:

// Get metadata about file f.
// addr is a user virtual address, pointing to a struct stat.
int
filestat(struct file *f, uint64 addr)
{
    80004bac:	715d                	addi	sp,sp,-80
    80004bae:	e486                	sd	ra,72(sp)
    80004bb0:	e0a2                	sd	s0,64(sp)
    80004bb2:	fc26                	sd	s1,56(sp)
    80004bb4:	f84a                	sd	s2,48(sp)
    80004bb6:	f44e                	sd	s3,40(sp)
    80004bb8:	0880                	addi	s0,sp,80
    80004bba:	84aa                	mv	s1,a0
    80004bbc:	89ae                	mv	s3,a1
  struct proc *p = myproc();
    80004bbe:	ffffd097          	auipc	ra,0xffffd
    80004bc2:	18c080e7          	jalr	396(ra) # 80001d4a <myproc>
  struct stat st;
  
  if(f->type == FD_INODE || f->type == FD_DEVICE){
    80004bc6:	409c                	lw	a5,0(s1)
    80004bc8:	37f9                	addiw	a5,a5,-2
    80004bca:	4705                	li	a4,1
    80004bcc:	04f76763          	bltu	a4,a5,80004c1a <filestat+0x6e>
    80004bd0:	892a                	mv	s2,a0
    ilock(f->ip);
    80004bd2:	6c88                	ld	a0,24(s1)
    80004bd4:	fffff097          	auipc	ra,0xfffff
    80004bd8:	07e080e7          	jalr	126(ra) # 80003c52 <ilock>
    stati(f->ip, &st);
    80004bdc:	fb840593          	addi	a1,s0,-72
    80004be0:	6c88                	ld	a0,24(s1)
    80004be2:	fffff097          	auipc	ra,0xfffff
    80004be6:	2fa080e7          	jalr	762(ra) # 80003edc <stati>
    iunlock(f->ip);
    80004bea:	6c88                	ld	a0,24(s1)
    80004bec:	fffff097          	auipc	ra,0xfffff
    80004bf0:	128080e7          	jalr	296(ra) # 80003d14 <iunlock>
    if(copyout(p->pagetable, addr, (char *)&st, sizeof(st)) < 0)
    80004bf4:	46e1                	li	a3,24
    80004bf6:	fb840613          	addi	a2,s0,-72
    80004bfa:	85ce                	mv	a1,s3
    80004bfc:	05093503          	ld	a0,80(s2)
    80004c00:	ffffd097          	auipc	ra,0xffffd
    80004c04:	b28080e7          	jalr	-1240(ra) # 80001728 <copyout>
    80004c08:	41f5551b          	sraiw	a0,a0,0x1f
      return -1;
    return 0;
  }
  return -1;
}
    80004c0c:	60a6                	ld	ra,72(sp)
    80004c0e:	6406                	ld	s0,64(sp)
    80004c10:	74e2                	ld	s1,56(sp)
    80004c12:	7942                	ld	s2,48(sp)
    80004c14:	79a2                	ld	s3,40(sp)
    80004c16:	6161                	addi	sp,sp,80
    80004c18:	8082                	ret
  return -1;
    80004c1a:	557d                	li	a0,-1
    80004c1c:	bfc5                	j	80004c0c <filestat+0x60>

0000000080004c1e <fileread>:

// Read from file f.
// addr is a user virtual address.
int
fileread(struct file *f, uint64 addr, int n)
{
    80004c1e:	7179                	addi	sp,sp,-48
    80004c20:	f406                	sd	ra,40(sp)
    80004c22:	f022                	sd	s0,32(sp)
    80004c24:	ec26                	sd	s1,24(sp)
    80004c26:	e84a                	sd	s2,16(sp)
    80004c28:	e44e                	sd	s3,8(sp)
    80004c2a:	1800                	addi	s0,sp,48
  int r = 0;

  if(f->readable == 0)
    80004c2c:	00854783          	lbu	a5,8(a0)
    80004c30:	c3d5                	beqz	a5,80004cd4 <fileread+0xb6>
    80004c32:	84aa                	mv	s1,a0
    80004c34:	89ae                	mv	s3,a1
    80004c36:	8932                	mv	s2,a2
    return -1;

  if(f->type == FD_PIPE){
    80004c38:	411c                	lw	a5,0(a0)
    80004c3a:	4705                	li	a4,1
    80004c3c:	04e78963          	beq	a5,a4,80004c8e <fileread+0x70>
    r = piperead(f->pipe, addr, n);
  } else if(f->type == FD_DEVICE){
    80004c40:	470d                	li	a4,3
    80004c42:	04e78d63          	beq	a5,a4,80004c9c <fileread+0x7e>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].read)
      return -1;
    r = devsw[f->major].read(1, addr, n);
  } else if(f->type == FD_INODE){
    80004c46:	4709                	li	a4,2
    80004c48:	06e79e63          	bne	a5,a4,80004cc4 <fileread+0xa6>
    ilock(f->ip);
    80004c4c:	6d08                	ld	a0,24(a0)
    80004c4e:	fffff097          	auipc	ra,0xfffff
    80004c52:	004080e7          	jalr	4(ra) # 80003c52 <ilock>
    if((r = readi(f->ip, 1, addr, f->off, n)) > 0)
    80004c56:	874a                	mv	a4,s2
    80004c58:	5094                	lw	a3,32(s1)
    80004c5a:	864e                	mv	a2,s3
    80004c5c:	4585                	li	a1,1
    80004c5e:	6c88                	ld	a0,24(s1)
    80004c60:	fffff097          	auipc	ra,0xfffff
    80004c64:	2a6080e7          	jalr	678(ra) # 80003f06 <readi>
    80004c68:	892a                	mv	s2,a0
    80004c6a:	00a05563          	blez	a0,80004c74 <fileread+0x56>
      f->off += r;
    80004c6e:	509c                	lw	a5,32(s1)
    80004c70:	9fa9                	addw	a5,a5,a0
    80004c72:	d09c                	sw	a5,32(s1)
    iunlock(f->ip);
    80004c74:	6c88                	ld	a0,24(s1)
    80004c76:	fffff097          	auipc	ra,0xfffff
    80004c7a:	09e080e7          	jalr	158(ra) # 80003d14 <iunlock>
  } else {
    panic("fileread");
  }

  return r;
}
    80004c7e:	854a                	mv	a0,s2
    80004c80:	70a2                	ld	ra,40(sp)
    80004c82:	7402                	ld	s0,32(sp)
    80004c84:	64e2                	ld	s1,24(sp)
    80004c86:	6942                	ld	s2,16(sp)
    80004c88:	69a2                	ld	s3,8(sp)
    80004c8a:	6145                	addi	sp,sp,48
    80004c8c:	8082                	ret
    r = piperead(f->pipe, addr, n);
    80004c8e:	6908                	ld	a0,16(a0)
    80004c90:	00000097          	auipc	ra,0x0
    80004c94:	3f4080e7          	jalr	1012(ra) # 80005084 <piperead>
    80004c98:	892a                	mv	s2,a0
    80004c9a:	b7d5                	j	80004c7e <fileread+0x60>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].read)
    80004c9c:	02451783          	lh	a5,36(a0)
    80004ca0:	03079693          	slli	a3,a5,0x30
    80004ca4:	92c1                	srli	a3,a3,0x30
    80004ca6:	4725                	li	a4,9
    80004ca8:	02d76863          	bltu	a4,a3,80004cd8 <fileread+0xba>
    80004cac:	0792                	slli	a5,a5,0x4
    80004cae:	00022717          	auipc	a4,0x22
    80004cb2:	77a70713          	addi	a4,a4,1914 # 80027428 <devsw>
    80004cb6:	97ba                	add	a5,a5,a4
    80004cb8:	639c                	ld	a5,0(a5)
    80004cba:	c38d                	beqz	a5,80004cdc <fileread+0xbe>
    r = devsw[f->major].read(1, addr, n);
    80004cbc:	4505                	li	a0,1
    80004cbe:	9782                	jalr	a5
    80004cc0:	892a                	mv	s2,a0
    80004cc2:	bf75                	j	80004c7e <fileread+0x60>
    panic("fileread");
    80004cc4:	00004517          	auipc	a0,0x4
    80004cc8:	aac50513          	addi	a0,a0,-1364 # 80008770 <syscalls+0x2c0>
    80004ccc:	ffffc097          	auipc	ra,0xffffc
    80004cd0:	904080e7          	jalr	-1788(ra) # 800005d0 <panic>
    return -1;
    80004cd4:	597d                	li	s2,-1
    80004cd6:	b765                	j	80004c7e <fileread+0x60>
      return -1;
    80004cd8:	597d                	li	s2,-1
    80004cda:	b755                	j	80004c7e <fileread+0x60>
    80004cdc:	597d                	li	s2,-1
    80004cde:	b745                	j	80004c7e <fileread+0x60>

0000000080004ce0 <filewrite>:
int
filewrite(struct file *f, uint64 addr, int n)
{
  int r, ret = 0;

  if(f->writable == 0)
    80004ce0:	00954783          	lbu	a5,9(a0)
    80004ce4:	14078563          	beqz	a5,80004e2e <filewrite+0x14e>
{
    80004ce8:	715d                	addi	sp,sp,-80
    80004cea:	e486                	sd	ra,72(sp)
    80004cec:	e0a2                	sd	s0,64(sp)
    80004cee:	fc26                	sd	s1,56(sp)
    80004cf0:	f84a                	sd	s2,48(sp)
    80004cf2:	f44e                	sd	s3,40(sp)
    80004cf4:	f052                	sd	s4,32(sp)
    80004cf6:	ec56                	sd	s5,24(sp)
    80004cf8:	e85a                	sd	s6,16(sp)
    80004cfa:	e45e                	sd	s7,8(sp)
    80004cfc:	e062                	sd	s8,0(sp)
    80004cfe:	0880                	addi	s0,sp,80
    80004d00:	892a                	mv	s2,a0
    80004d02:	8aae                	mv	s5,a1
    80004d04:	8a32                	mv	s4,a2
    return -1;

  if(f->type == FD_PIPE){
    80004d06:	411c                	lw	a5,0(a0)
    80004d08:	4705                	li	a4,1
    80004d0a:	02e78263          	beq	a5,a4,80004d2e <filewrite+0x4e>
    ret = pipewrite(f->pipe, addr, n);
  } else if(f->type == FD_DEVICE){
    80004d0e:	470d                	li	a4,3
    80004d10:	02e78563          	beq	a5,a4,80004d3a <filewrite+0x5a>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].write)
      return -1;
    ret = devsw[f->major].write(1, addr, n);
  } else if(f->type == FD_INODE){
    80004d14:	4709                	li	a4,2
    80004d16:	10e79463          	bne	a5,a4,80004e1e <filewrite+0x13e>
    // and 2 blocks of slop for non-aligned writes.
    // this really belongs lower down, since writei()
    // might be writing a device like the console.
    int max = ((MAXOPBLOCKS-1-1-2) / 2) * BSIZE;
    int i = 0;
    while(i < n){
    80004d1a:	0ec05e63          	blez	a2,80004e16 <filewrite+0x136>
    int i = 0;
    80004d1e:	4981                	li	s3,0
    80004d20:	6b05                	lui	s6,0x1
    80004d22:	c00b0b13          	addi	s6,s6,-1024 # c00 <_entry-0x7ffff400>
    80004d26:	6b85                	lui	s7,0x1
    80004d28:	c00b8b9b          	addiw	s7,s7,-1024 # c00 <_entry-0x7ffff400>
    80004d2c:	a851                	j	80004dc0 <filewrite+0xe0>
    ret = pipewrite(f->pipe, addr, n);
    80004d2e:	6908                	ld	a0,16(a0)
    80004d30:	00000097          	auipc	ra,0x0
    80004d34:	254080e7          	jalr	596(ra) # 80004f84 <pipewrite>
    80004d38:	a85d                	j	80004dee <filewrite+0x10e>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].write)
    80004d3a:	02451783          	lh	a5,36(a0)
    80004d3e:	03079693          	slli	a3,a5,0x30
    80004d42:	92c1                	srli	a3,a3,0x30
    80004d44:	4725                	li	a4,9
    80004d46:	0ed76663          	bltu	a4,a3,80004e32 <filewrite+0x152>
    80004d4a:	0792                	slli	a5,a5,0x4
    80004d4c:	00022717          	auipc	a4,0x22
    80004d50:	6dc70713          	addi	a4,a4,1756 # 80027428 <devsw>
    80004d54:	97ba                	add	a5,a5,a4
    80004d56:	679c                	ld	a5,8(a5)
    80004d58:	cff9                	beqz	a5,80004e36 <filewrite+0x156>
    ret = devsw[f->major].write(1, addr, n);
    80004d5a:	4505                	li	a0,1
    80004d5c:	9782                	jalr	a5
    80004d5e:	a841                	j	80004dee <filewrite+0x10e>
    80004d60:	00048c1b          	sext.w	s8,s1
      int n1 = n - i;
      if(n1 > max)
        n1 = max;

      begin_op();
    80004d64:	00000097          	auipc	ra,0x0
    80004d68:	8ae080e7          	jalr	-1874(ra) # 80004612 <begin_op>
      ilock(f->ip);
    80004d6c:	01893503          	ld	a0,24(s2)
    80004d70:	fffff097          	auipc	ra,0xfffff
    80004d74:	ee2080e7          	jalr	-286(ra) # 80003c52 <ilock>
      if ((r = writei(f->ip, 1, addr + i, f->off, n1)) > 0)
    80004d78:	8762                	mv	a4,s8
    80004d7a:	02092683          	lw	a3,32(s2)
    80004d7e:	01598633          	add	a2,s3,s5
    80004d82:	4585                	li	a1,1
    80004d84:	01893503          	ld	a0,24(s2)
    80004d88:	fffff097          	auipc	ra,0xfffff
    80004d8c:	274080e7          	jalr	628(ra) # 80003ffc <writei>
    80004d90:	84aa                	mv	s1,a0
    80004d92:	02a05f63          	blez	a0,80004dd0 <filewrite+0xf0>
        f->off += r;
    80004d96:	02092783          	lw	a5,32(s2)
    80004d9a:	9fa9                	addw	a5,a5,a0
    80004d9c:	02f92023          	sw	a5,32(s2)
      iunlock(f->ip);
    80004da0:	01893503          	ld	a0,24(s2)
    80004da4:	fffff097          	auipc	ra,0xfffff
    80004da8:	f70080e7          	jalr	-144(ra) # 80003d14 <iunlock>
      end_op();
    80004dac:	00000097          	auipc	ra,0x0
    80004db0:	8e6080e7          	jalr	-1818(ra) # 80004692 <end_op>

      if(r < 0)
        break;
      if(r != n1)
    80004db4:	049c1963          	bne	s8,s1,80004e06 <filewrite+0x126>
        panic("short filewrite");
      i += r;
    80004db8:	013489bb          	addw	s3,s1,s3
    while(i < n){
    80004dbc:	0349d663          	bge	s3,s4,80004de8 <filewrite+0x108>
      int n1 = n - i;
    80004dc0:	413a07bb          	subw	a5,s4,s3
      if(n1 > max)
    80004dc4:	84be                	mv	s1,a5
    80004dc6:	2781                	sext.w	a5,a5
    80004dc8:	f8fb5ce3          	bge	s6,a5,80004d60 <filewrite+0x80>
    80004dcc:	84de                	mv	s1,s7
    80004dce:	bf49                	j	80004d60 <filewrite+0x80>
      iunlock(f->ip);
    80004dd0:	01893503          	ld	a0,24(s2)
    80004dd4:	fffff097          	auipc	ra,0xfffff
    80004dd8:	f40080e7          	jalr	-192(ra) # 80003d14 <iunlock>
      end_op();
    80004ddc:	00000097          	auipc	ra,0x0
    80004de0:	8b6080e7          	jalr	-1866(ra) # 80004692 <end_op>
      if(r < 0)
    80004de4:	fc04d8e3          	bgez	s1,80004db4 <filewrite+0xd4>
    }
    ret = (i == n ? n : -1);
    80004de8:	8552                	mv	a0,s4
    80004dea:	033a1863          	bne	s4,s3,80004e1a <filewrite+0x13a>
  } else {
    panic("filewrite");
  }

  return ret;
}
    80004dee:	60a6                	ld	ra,72(sp)
    80004df0:	6406                	ld	s0,64(sp)
    80004df2:	74e2                	ld	s1,56(sp)
    80004df4:	7942                	ld	s2,48(sp)
    80004df6:	79a2                	ld	s3,40(sp)
    80004df8:	7a02                	ld	s4,32(sp)
    80004dfa:	6ae2                	ld	s5,24(sp)
    80004dfc:	6b42                	ld	s6,16(sp)
    80004dfe:	6ba2                	ld	s7,8(sp)
    80004e00:	6c02                	ld	s8,0(sp)
    80004e02:	6161                	addi	sp,sp,80
    80004e04:	8082                	ret
        panic("short filewrite");
    80004e06:	00004517          	auipc	a0,0x4
    80004e0a:	97a50513          	addi	a0,a0,-1670 # 80008780 <syscalls+0x2d0>
    80004e0e:	ffffb097          	auipc	ra,0xffffb
    80004e12:	7c2080e7          	jalr	1986(ra) # 800005d0 <panic>
    int i = 0;
    80004e16:	4981                	li	s3,0
    80004e18:	bfc1                	j	80004de8 <filewrite+0x108>
    ret = (i == n ? n : -1);
    80004e1a:	557d                	li	a0,-1
    80004e1c:	bfc9                	j	80004dee <filewrite+0x10e>
    panic("filewrite");
    80004e1e:	00004517          	auipc	a0,0x4
    80004e22:	97250513          	addi	a0,a0,-1678 # 80008790 <syscalls+0x2e0>
    80004e26:	ffffb097          	auipc	ra,0xffffb
    80004e2a:	7aa080e7          	jalr	1962(ra) # 800005d0 <panic>
    return -1;
    80004e2e:	557d                	li	a0,-1
}
    80004e30:	8082                	ret
      return -1;
    80004e32:	557d                	li	a0,-1
    80004e34:	bf6d                	j	80004dee <filewrite+0x10e>
    80004e36:	557d                	li	a0,-1
    80004e38:	bf5d                	j	80004dee <filewrite+0x10e>

0000000080004e3a <pipealloc>:
  int writeopen;  // write fd is still open
};

int
pipealloc(struct file **f0, struct file **f1)
{
    80004e3a:	7179                	addi	sp,sp,-48
    80004e3c:	f406                	sd	ra,40(sp)
    80004e3e:	f022                	sd	s0,32(sp)
    80004e40:	ec26                	sd	s1,24(sp)
    80004e42:	e84a                	sd	s2,16(sp)
    80004e44:	e44e                	sd	s3,8(sp)
    80004e46:	e052                	sd	s4,0(sp)
    80004e48:	1800                	addi	s0,sp,48
    80004e4a:	84aa                	mv	s1,a0
    80004e4c:	8a2e                	mv	s4,a1
  struct pipe *pi;

  pi = 0;
  *f0 = *f1 = 0;
    80004e4e:	0005b023          	sd	zero,0(a1)
    80004e52:	00053023          	sd	zero,0(a0)
  if((*f0 = filealloc()) == 0 || (*f1 = filealloc()) == 0)
    80004e56:	00000097          	auipc	ra,0x0
    80004e5a:	bd2080e7          	jalr	-1070(ra) # 80004a28 <filealloc>
    80004e5e:	e088                	sd	a0,0(s1)
    80004e60:	c551                	beqz	a0,80004eec <pipealloc+0xb2>
    80004e62:	00000097          	auipc	ra,0x0
    80004e66:	bc6080e7          	jalr	-1082(ra) # 80004a28 <filealloc>
    80004e6a:	00aa3023          	sd	a0,0(s4)
    80004e6e:	c92d                	beqz	a0,80004ee0 <pipealloc+0xa6>
    goto bad;
  if((pi = (struct pipe*)kalloc()) == 0)
    80004e70:	ffffc097          	auipc	ra,0xffffc
    80004e74:	d02080e7          	jalr	-766(ra) # 80000b72 <kalloc>
    80004e78:	892a                	mv	s2,a0
    80004e7a:	c125                	beqz	a0,80004eda <pipealloc+0xa0>
    goto bad;
  pi->readopen = 1;
    80004e7c:	4985                	li	s3,1
    80004e7e:	23352023          	sw	s3,544(a0)
  pi->writeopen = 1;
    80004e82:	23352223          	sw	s3,548(a0)
  pi->nwrite = 0;
    80004e86:	20052e23          	sw	zero,540(a0)
  pi->nread = 0;
    80004e8a:	20052c23          	sw	zero,536(a0)
  initlock(&pi->lock, "pipe");
    80004e8e:	00004597          	auipc	a1,0x4
    80004e92:	91258593          	addi	a1,a1,-1774 # 800087a0 <syscalls+0x2f0>
    80004e96:	ffffc097          	auipc	ra,0xffffc
    80004e9a:	d3c080e7          	jalr	-708(ra) # 80000bd2 <initlock>
  (*f0)->type = FD_PIPE;
    80004e9e:	609c                	ld	a5,0(s1)
    80004ea0:	0137a023          	sw	s3,0(a5)
  (*f0)->readable = 1;
    80004ea4:	609c                	ld	a5,0(s1)
    80004ea6:	01378423          	sb	s3,8(a5)
  (*f0)->writable = 0;
    80004eaa:	609c                	ld	a5,0(s1)
    80004eac:	000784a3          	sb	zero,9(a5)
  (*f0)->pipe = pi;
    80004eb0:	609c                	ld	a5,0(s1)
    80004eb2:	0127b823          	sd	s2,16(a5)
  (*f1)->type = FD_PIPE;
    80004eb6:	000a3783          	ld	a5,0(s4)
    80004eba:	0137a023          	sw	s3,0(a5)
  (*f1)->readable = 0;
    80004ebe:	000a3783          	ld	a5,0(s4)
    80004ec2:	00078423          	sb	zero,8(a5)
  (*f1)->writable = 1;
    80004ec6:	000a3783          	ld	a5,0(s4)
    80004eca:	013784a3          	sb	s3,9(a5)
  (*f1)->pipe = pi;
    80004ece:	000a3783          	ld	a5,0(s4)
    80004ed2:	0127b823          	sd	s2,16(a5)
  return 0;
    80004ed6:	4501                	li	a0,0
    80004ed8:	a025                	j	80004f00 <pipealloc+0xc6>

 bad:
  if(pi)
    kfree((char*)pi);
  if(*f0)
    80004eda:	6088                	ld	a0,0(s1)
    80004edc:	e501                	bnez	a0,80004ee4 <pipealloc+0xaa>
    80004ede:	a039                	j	80004eec <pipealloc+0xb2>
    80004ee0:	6088                	ld	a0,0(s1)
    80004ee2:	c51d                	beqz	a0,80004f10 <pipealloc+0xd6>
    fileclose(*f0);
    80004ee4:	00000097          	auipc	ra,0x0
    80004ee8:	c00080e7          	jalr	-1024(ra) # 80004ae4 <fileclose>
  if(*f1)
    80004eec:	000a3783          	ld	a5,0(s4)
    fileclose(*f1);
  return -1;
    80004ef0:	557d                	li	a0,-1
  if(*f1)
    80004ef2:	c799                	beqz	a5,80004f00 <pipealloc+0xc6>
    fileclose(*f1);
    80004ef4:	853e                	mv	a0,a5
    80004ef6:	00000097          	auipc	ra,0x0
    80004efa:	bee080e7          	jalr	-1042(ra) # 80004ae4 <fileclose>
  return -1;
    80004efe:	557d                	li	a0,-1
}
    80004f00:	70a2                	ld	ra,40(sp)
    80004f02:	7402                	ld	s0,32(sp)
    80004f04:	64e2                	ld	s1,24(sp)
    80004f06:	6942                	ld	s2,16(sp)
    80004f08:	69a2                	ld	s3,8(sp)
    80004f0a:	6a02                	ld	s4,0(sp)
    80004f0c:	6145                	addi	sp,sp,48
    80004f0e:	8082                	ret
  return -1;
    80004f10:	557d                	li	a0,-1
    80004f12:	b7fd                	j	80004f00 <pipealloc+0xc6>

0000000080004f14 <pipeclose>:

void
pipeclose(struct pipe *pi, int writable)
{
    80004f14:	1101                	addi	sp,sp,-32
    80004f16:	ec06                	sd	ra,24(sp)
    80004f18:	e822                	sd	s0,16(sp)
    80004f1a:	e426                	sd	s1,8(sp)
    80004f1c:	e04a                	sd	s2,0(sp)
    80004f1e:	1000                	addi	s0,sp,32
    80004f20:	84aa                	mv	s1,a0
    80004f22:	892e                	mv	s2,a1
  acquire(&pi->lock);
    80004f24:	ffffc097          	auipc	ra,0xffffc
    80004f28:	d3e080e7          	jalr	-706(ra) # 80000c62 <acquire>
  if(writable){
    80004f2c:	02090d63          	beqz	s2,80004f66 <pipeclose+0x52>
    pi->writeopen = 0;
    80004f30:	2204a223          	sw	zero,548(s1)
    wakeup(&pi->nread);
    80004f34:	21848513          	addi	a0,s1,536
    80004f38:	ffffe097          	auipc	ra,0xffffe
    80004f3c:	852080e7          	jalr	-1966(ra) # 8000278a <wakeup>
  } else {
    pi->readopen = 0;
    wakeup(&pi->nwrite);
  }
  if(pi->readopen == 0 && pi->writeopen == 0){
    80004f40:	2204b783          	ld	a5,544(s1)
    80004f44:	eb95                	bnez	a5,80004f78 <pipeclose+0x64>
    release(&pi->lock);
    80004f46:	8526                	mv	a0,s1
    80004f48:	ffffc097          	auipc	ra,0xffffc
    80004f4c:	dce080e7          	jalr	-562(ra) # 80000d16 <release>
    kfree((char*)pi);
    80004f50:	8526                	mv	a0,s1
    80004f52:	ffffc097          	auipc	ra,0xffffc
    80004f56:	b24080e7          	jalr	-1244(ra) # 80000a76 <kfree>
  } else
    release(&pi->lock);
}
    80004f5a:	60e2                	ld	ra,24(sp)
    80004f5c:	6442                	ld	s0,16(sp)
    80004f5e:	64a2                	ld	s1,8(sp)
    80004f60:	6902                	ld	s2,0(sp)
    80004f62:	6105                	addi	sp,sp,32
    80004f64:	8082                	ret
    pi->readopen = 0;
    80004f66:	2204a023          	sw	zero,544(s1)
    wakeup(&pi->nwrite);
    80004f6a:	21c48513          	addi	a0,s1,540
    80004f6e:	ffffe097          	auipc	ra,0xffffe
    80004f72:	81c080e7          	jalr	-2020(ra) # 8000278a <wakeup>
    80004f76:	b7e9                	j	80004f40 <pipeclose+0x2c>
    release(&pi->lock);
    80004f78:	8526                	mv	a0,s1
    80004f7a:	ffffc097          	auipc	ra,0xffffc
    80004f7e:	d9c080e7          	jalr	-612(ra) # 80000d16 <release>
}
    80004f82:	bfe1                	j	80004f5a <pipeclose+0x46>

0000000080004f84 <pipewrite>:

int
pipewrite(struct pipe *pi, uint64 addr, int n)
{
    80004f84:	711d                	addi	sp,sp,-96
    80004f86:	ec86                	sd	ra,88(sp)
    80004f88:	e8a2                	sd	s0,80(sp)
    80004f8a:	e4a6                	sd	s1,72(sp)
    80004f8c:	e0ca                	sd	s2,64(sp)
    80004f8e:	fc4e                	sd	s3,56(sp)
    80004f90:	f852                	sd	s4,48(sp)
    80004f92:	f456                	sd	s5,40(sp)
    80004f94:	f05a                	sd	s6,32(sp)
    80004f96:	ec5e                	sd	s7,24(sp)
    80004f98:	e862                	sd	s8,16(sp)
    80004f9a:	1080                	addi	s0,sp,96
    80004f9c:	84aa                	mv	s1,a0
    80004f9e:	8b2e                	mv	s6,a1
    80004fa0:	8ab2                	mv	s5,a2
  int i;
  char ch;
  struct proc *pr = myproc();
    80004fa2:	ffffd097          	auipc	ra,0xffffd
    80004fa6:	da8080e7          	jalr	-600(ra) # 80001d4a <myproc>
    80004faa:	892a                	mv	s2,a0

  acquire(&pi->lock);
    80004fac:	8526                	mv	a0,s1
    80004fae:	ffffc097          	auipc	ra,0xffffc
    80004fb2:	cb4080e7          	jalr	-844(ra) # 80000c62 <acquire>
  for(i = 0; i < n; i++){
    80004fb6:	09505763          	blez	s5,80005044 <pipewrite+0xc0>
    80004fba:	4b81                	li	s7,0
    while(pi->nwrite == pi->nread + PIPESIZE){  //DOC: pipewrite-full
      if(pi->readopen == 0 || pr->killed){
        release(&pi->lock);
        return -1;
      }
      wakeup(&pi->nread);
    80004fbc:	21848a13          	addi	s4,s1,536
      sleep(&pi->nwrite, &pi->lock);
    80004fc0:	21c48993          	addi	s3,s1,540
    }
    if(copyin(pr->pagetable, &ch, addr + i, 1) == -1)
    80004fc4:	5c7d                	li	s8,-1
    while(pi->nwrite == pi->nread + PIPESIZE){  //DOC: pipewrite-full
    80004fc6:	2184a783          	lw	a5,536(s1)
    80004fca:	21c4a703          	lw	a4,540(s1)
    80004fce:	2007879b          	addiw	a5,a5,512
    80004fd2:	02f71b63          	bne	a4,a5,80005008 <pipewrite+0x84>
      if(pi->readopen == 0 || pr->killed){
    80004fd6:	2204a783          	lw	a5,544(s1)
    80004fda:	c3d1                	beqz	a5,8000505e <pipewrite+0xda>
    80004fdc:	03092783          	lw	a5,48(s2)
    80004fe0:	efbd                	bnez	a5,8000505e <pipewrite+0xda>
      wakeup(&pi->nread);
    80004fe2:	8552                	mv	a0,s4
    80004fe4:	ffffd097          	auipc	ra,0xffffd
    80004fe8:	7a6080e7          	jalr	1958(ra) # 8000278a <wakeup>
      sleep(&pi->nwrite, &pi->lock);
    80004fec:	85a6                	mv	a1,s1
    80004fee:	854e                	mv	a0,s3
    80004ff0:	ffffd097          	auipc	ra,0xffffd
    80004ff4:	61a080e7          	jalr	1562(ra) # 8000260a <sleep>
    while(pi->nwrite == pi->nread + PIPESIZE){  //DOC: pipewrite-full
    80004ff8:	2184a783          	lw	a5,536(s1)
    80004ffc:	21c4a703          	lw	a4,540(s1)
    80005000:	2007879b          	addiw	a5,a5,512
    80005004:	fcf709e3          	beq	a4,a5,80004fd6 <pipewrite+0x52>
    if(copyin(pr->pagetable, &ch, addr + i, 1) == -1)
    80005008:	4685                	li	a3,1
    8000500a:	865a                	mv	a2,s6
    8000500c:	faf40593          	addi	a1,s0,-81
    80005010:	05093503          	ld	a0,80(s2)
    80005014:	ffffc097          	auipc	ra,0xffffc
    80005018:	7a0080e7          	jalr	1952(ra) # 800017b4 <copyin>
    8000501c:	03850563          	beq	a0,s8,80005046 <pipewrite+0xc2>
      break;
    pi->data[pi->nwrite++ % PIPESIZE] = ch;
    80005020:	21c4a783          	lw	a5,540(s1)
    80005024:	0017871b          	addiw	a4,a5,1
    80005028:	20e4ae23          	sw	a4,540(s1)
    8000502c:	1ff7f793          	andi	a5,a5,511
    80005030:	97a6                	add	a5,a5,s1
    80005032:	faf44703          	lbu	a4,-81(s0)
    80005036:	00e78c23          	sb	a4,24(a5)
  for(i = 0; i < n; i++){
    8000503a:	2b85                	addiw	s7,s7,1
    8000503c:	0b05                	addi	s6,s6,1
    8000503e:	f97a94e3          	bne	s5,s7,80004fc6 <pipewrite+0x42>
    80005042:	a011                	j	80005046 <pipewrite+0xc2>
    80005044:	4b81                	li	s7,0
  }
  wakeup(&pi->nread);
    80005046:	21848513          	addi	a0,s1,536
    8000504a:	ffffd097          	auipc	ra,0xffffd
    8000504e:	740080e7          	jalr	1856(ra) # 8000278a <wakeup>
  release(&pi->lock);
    80005052:	8526                	mv	a0,s1
    80005054:	ffffc097          	auipc	ra,0xffffc
    80005058:	cc2080e7          	jalr	-830(ra) # 80000d16 <release>
  return i;
    8000505c:	a039                	j	8000506a <pipewrite+0xe6>
        release(&pi->lock);
    8000505e:	8526                	mv	a0,s1
    80005060:	ffffc097          	auipc	ra,0xffffc
    80005064:	cb6080e7          	jalr	-842(ra) # 80000d16 <release>
        return -1;
    80005068:	5bfd                	li	s7,-1
}
    8000506a:	855e                	mv	a0,s7
    8000506c:	60e6                	ld	ra,88(sp)
    8000506e:	6446                	ld	s0,80(sp)
    80005070:	64a6                	ld	s1,72(sp)
    80005072:	6906                	ld	s2,64(sp)
    80005074:	79e2                	ld	s3,56(sp)
    80005076:	7a42                	ld	s4,48(sp)
    80005078:	7aa2                	ld	s5,40(sp)
    8000507a:	7b02                	ld	s6,32(sp)
    8000507c:	6be2                	ld	s7,24(sp)
    8000507e:	6c42                	ld	s8,16(sp)
    80005080:	6125                	addi	sp,sp,96
    80005082:	8082                	ret

0000000080005084 <piperead>:

int
piperead(struct pipe *pi, uint64 addr, int n)
{
    80005084:	715d                	addi	sp,sp,-80
    80005086:	e486                	sd	ra,72(sp)
    80005088:	e0a2                	sd	s0,64(sp)
    8000508a:	fc26                	sd	s1,56(sp)
    8000508c:	f84a                	sd	s2,48(sp)
    8000508e:	f44e                	sd	s3,40(sp)
    80005090:	f052                	sd	s4,32(sp)
    80005092:	ec56                	sd	s5,24(sp)
    80005094:	e85a                	sd	s6,16(sp)
    80005096:	0880                	addi	s0,sp,80
    80005098:	84aa                	mv	s1,a0
    8000509a:	892e                	mv	s2,a1
    8000509c:	8ab2                	mv	s5,a2
  int i;
  struct proc *pr = myproc();
    8000509e:	ffffd097          	auipc	ra,0xffffd
    800050a2:	cac080e7          	jalr	-852(ra) # 80001d4a <myproc>
    800050a6:	8a2a                	mv	s4,a0
  char ch;

  acquire(&pi->lock);
    800050a8:	8526                	mv	a0,s1
    800050aa:	ffffc097          	auipc	ra,0xffffc
    800050ae:	bb8080e7          	jalr	-1096(ra) # 80000c62 <acquire>
  while(pi->nread == pi->nwrite && pi->writeopen){  //DOC: pipe-empty
    800050b2:	2184a703          	lw	a4,536(s1)
    800050b6:	21c4a783          	lw	a5,540(s1)
    if(pr->killed){
      release(&pi->lock);
      return -1;
    }
    sleep(&pi->nread, &pi->lock); //DOC: piperead-sleep
    800050ba:	21848993          	addi	s3,s1,536
  while(pi->nread == pi->nwrite && pi->writeopen){  //DOC: pipe-empty
    800050be:	02f71463          	bne	a4,a5,800050e6 <piperead+0x62>
    800050c2:	2244a783          	lw	a5,548(s1)
    800050c6:	c385                	beqz	a5,800050e6 <piperead+0x62>
    if(pr->killed){
    800050c8:	030a2783          	lw	a5,48(s4)
    800050cc:	ebc1                	bnez	a5,8000515c <piperead+0xd8>
    sleep(&pi->nread, &pi->lock); //DOC: piperead-sleep
    800050ce:	85a6                	mv	a1,s1
    800050d0:	854e                	mv	a0,s3
    800050d2:	ffffd097          	auipc	ra,0xffffd
    800050d6:	538080e7          	jalr	1336(ra) # 8000260a <sleep>
  while(pi->nread == pi->nwrite && pi->writeopen){  //DOC: pipe-empty
    800050da:	2184a703          	lw	a4,536(s1)
    800050de:	21c4a783          	lw	a5,540(s1)
    800050e2:	fef700e3          	beq	a4,a5,800050c2 <piperead+0x3e>
  }
  for(i = 0; i < n; i++){  //DOC: piperead-copy
    800050e6:	4981                	li	s3,0
    if(pi->nread == pi->nwrite)
      break;
    ch = pi->data[pi->nread++ % PIPESIZE];
    if(copyout(pr->pagetable, addr + i, &ch, 1) == -1)
    800050e8:	5b7d                	li	s6,-1
  for(i = 0; i < n; i++){  //DOC: piperead-copy
    800050ea:	05505363          	blez	s5,80005130 <piperead+0xac>
    if(pi->nread == pi->nwrite)
    800050ee:	2184a783          	lw	a5,536(s1)
    800050f2:	21c4a703          	lw	a4,540(s1)
    800050f6:	02f70d63          	beq	a4,a5,80005130 <piperead+0xac>
    ch = pi->data[pi->nread++ % PIPESIZE];
    800050fa:	0017871b          	addiw	a4,a5,1
    800050fe:	20e4ac23          	sw	a4,536(s1)
    80005102:	1ff7f793          	andi	a5,a5,511
    80005106:	97a6                	add	a5,a5,s1
    80005108:	0187c783          	lbu	a5,24(a5)
    8000510c:	faf40fa3          	sb	a5,-65(s0)
    if(copyout(pr->pagetable, addr + i, &ch, 1) == -1)
    80005110:	4685                	li	a3,1
    80005112:	fbf40613          	addi	a2,s0,-65
    80005116:	85ca                	mv	a1,s2
    80005118:	050a3503          	ld	a0,80(s4)
    8000511c:	ffffc097          	auipc	ra,0xffffc
    80005120:	60c080e7          	jalr	1548(ra) # 80001728 <copyout>
    80005124:	01650663          	beq	a0,s6,80005130 <piperead+0xac>
  for(i = 0; i < n; i++){  //DOC: piperead-copy
    80005128:	2985                	addiw	s3,s3,1
    8000512a:	0905                	addi	s2,s2,1
    8000512c:	fd3a91e3          	bne	s5,s3,800050ee <piperead+0x6a>
      break;
  }
  wakeup(&pi->nwrite);  //DOC: piperead-wakeup
    80005130:	21c48513          	addi	a0,s1,540
    80005134:	ffffd097          	auipc	ra,0xffffd
    80005138:	656080e7          	jalr	1622(ra) # 8000278a <wakeup>
  release(&pi->lock);
    8000513c:	8526                	mv	a0,s1
    8000513e:	ffffc097          	auipc	ra,0xffffc
    80005142:	bd8080e7          	jalr	-1064(ra) # 80000d16 <release>
  return i;
}
    80005146:	854e                	mv	a0,s3
    80005148:	60a6                	ld	ra,72(sp)
    8000514a:	6406                	ld	s0,64(sp)
    8000514c:	74e2                	ld	s1,56(sp)
    8000514e:	7942                	ld	s2,48(sp)
    80005150:	79a2                	ld	s3,40(sp)
    80005152:	7a02                	ld	s4,32(sp)
    80005154:	6ae2                	ld	s5,24(sp)
    80005156:	6b42                	ld	s6,16(sp)
    80005158:	6161                	addi	sp,sp,80
    8000515a:	8082                	ret
      release(&pi->lock);
    8000515c:	8526                	mv	a0,s1
    8000515e:	ffffc097          	auipc	ra,0xffffc
    80005162:	bb8080e7          	jalr	-1096(ra) # 80000d16 <release>
      return -1;
    80005166:	59fd                	li	s3,-1
    80005168:	bff9                	j	80005146 <piperead+0xc2>

000000008000516a <exec>:

static int loadseg(pde_t *pgdir, uint64 addr, struct inode *ip, uint offset, uint sz);

int
exec(char *path, char **argv)
{
    8000516a:	de010113          	addi	sp,sp,-544
    8000516e:	20113c23          	sd	ra,536(sp)
    80005172:	20813823          	sd	s0,528(sp)
    80005176:	20913423          	sd	s1,520(sp)
    8000517a:	21213023          	sd	s2,512(sp)
    8000517e:	ffce                	sd	s3,504(sp)
    80005180:	fbd2                	sd	s4,496(sp)
    80005182:	f7d6                	sd	s5,488(sp)
    80005184:	f3da                	sd	s6,480(sp)
    80005186:	efde                	sd	s7,472(sp)
    80005188:	ebe2                	sd	s8,464(sp)
    8000518a:	e7e6                	sd	s9,456(sp)
    8000518c:	e3ea                	sd	s10,448(sp)
    8000518e:	ff6e                	sd	s11,440(sp)
    80005190:	1400                	addi	s0,sp,544
    80005192:	892a                	mv	s2,a0
    80005194:	dea43423          	sd	a0,-536(s0)
    80005198:	deb43823          	sd	a1,-528(s0)
  uint64 argc, sz = 0, sp, ustack[MAXARG+1], stackbase;
  struct elfhdr elf;
  struct inode *ip;
  struct proghdr ph;
  pagetable_t pagetable = 0, oldpagetable;
  struct proc *p = myproc();
    8000519c:	ffffd097          	auipc	ra,0xffffd
    800051a0:	bae080e7          	jalr	-1106(ra) # 80001d4a <myproc>
    800051a4:	84aa                	mv	s1,a0

  begin_op();
    800051a6:	fffff097          	auipc	ra,0xfffff
    800051aa:	46c080e7          	jalr	1132(ra) # 80004612 <begin_op>

  if((ip = namei(path)) == 0){
    800051ae:	854a                	mv	a0,s2
    800051b0:	fffff097          	auipc	ra,0xfffff
    800051b4:	252080e7          	jalr	594(ra) # 80004402 <namei>
    800051b8:	c93d                	beqz	a0,8000522e <exec+0xc4>
    800051ba:	8aaa                	mv	s5,a0
    end_op();
    return -1;
  }
  ilock(ip);
    800051bc:	fffff097          	auipc	ra,0xfffff
    800051c0:	a96080e7          	jalr	-1386(ra) # 80003c52 <ilock>

  // Check ELF header
  if(readi(ip, 0, (uint64)&elf, 0, sizeof(elf)) != sizeof(elf))
    800051c4:	04000713          	li	a4,64
    800051c8:	4681                	li	a3,0
    800051ca:	e4840613          	addi	a2,s0,-440
    800051ce:	4581                	li	a1,0
    800051d0:	8556                	mv	a0,s5
    800051d2:	fffff097          	auipc	ra,0xfffff
    800051d6:	d34080e7          	jalr	-716(ra) # 80003f06 <readi>
    800051da:	04000793          	li	a5,64
    800051de:	00f51a63          	bne	a0,a5,800051f2 <exec+0x88>
    goto bad;
  if(elf.magic != ELF_MAGIC)
    800051e2:	e4842703          	lw	a4,-440(s0)
    800051e6:	464c47b7          	lui	a5,0x464c4
    800051ea:	57f78793          	addi	a5,a5,1407 # 464c457f <_entry-0x39b3ba81>
    800051ee:	04f70663          	beq	a4,a5,8000523a <exec+0xd0>

 bad:
  if(pagetable)
    proc_freepagetable(pagetable, sz);
  if(ip){
    iunlockput(ip);
    800051f2:	8556                	mv	a0,s5
    800051f4:	fffff097          	auipc	ra,0xfffff
    800051f8:	cc0080e7          	jalr	-832(ra) # 80003eb4 <iunlockput>
    end_op();
    800051fc:	fffff097          	auipc	ra,0xfffff
    80005200:	496080e7          	jalr	1174(ra) # 80004692 <end_op>
  }
  return -1;
    80005204:	557d                	li	a0,-1
}
    80005206:	21813083          	ld	ra,536(sp)
    8000520a:	21013403          	ld	s0,528(sp)
    8000520e:	20813483          	ld	s1,520(sp)
    80005212:	20013903          	ld	s2,512(sp)
    80005216:	79fe                	ld	s3,504(sp)
    80005218:	7a5e                	ld	s4,496(sp)
    8000521a:	7abe                	ld	s5,488(sp)
    8000521c:	7b1e                	ld	s6,480(sp)
    8000521e:	6bfe                	ld	s7,472(sp)
    80005220:	6c5e                	ld	s8,464(sp)
    80005222:	6cbe                	ld	s9,456(sp)
    80005224:	6d1e                	ld	s10,448(sp)
    80005226:	7dfa                	ld	s11,440(sp)
    80005228:	22010113          	addi	sp,sp,544
    8000522c:	8082                	ret
    end_op();
    8000522e:	fffff097          	auipc	ra,0xfffff
    80005232:	464080e7          	jalr	1124(ra) # 80004692 <end_op>
    return -1;
    80005236:	557d                	li	a0,-1
    80005238:	b7f9                	j	80005206 <exec+0x9c>
  if((pagetable = proc_pagetable(p)) == 0)
    8000523a:	8526                	mv	a0,s1
    8000523c:	ffffd097          	auipc	ra,0xffffd
    80005240:	bd2080e7          	jalr	-1070(ra) # 80001e0e <proc_pagetable>
    80005244:	8b2a                	mv	s6,a0
    80005246:	d555                	beqz	a0,800051f2 <exec+0x88>
  for(i=0, off=elf.phoff; i<elf.phnum; i++, off+=sizeof(ph)){
    80005248:	e6842783          	lw	a5,-408(s0)
    8000524c:	e8045703          	lhu	a4,-384(s0)
    80005250:	c735                	beqz	a4,800052bc <exec+0x152>
  uint64 argc, sz = 0, sp, ustack[MAXARG+1], stackbase;
    80005252:	4481                	li	s1,0
  for(i=0, off=elf.phoff; i<elf.phnum; i++, off+=sizeof(ph)){
    80005254:	e0043423          	sd	zero,-504(s0)
    if(ph.vaddr % PGSIZE != 0)
    80005258:	6a05                	lui	s4,0x1
    8000525a:	fffa0713          	addi	a4,s4,-1 # fff <_entry-0x7ffff001>
    8000525e:	dee43023          	sd	a4,-544(s0)
  uint64 pa;

  if((va % PGSIZE) != 0)
    panic("loadseg: va must be page aligned");

  for(i = 0; i < sz; i += PGSIZE){
    80005262:	6d85                	lui	s11,0x1
    80005264:	7d7d                	lui	s10,0xfffff
    80005266:	ac1d                	j	8000549c <exec+0x332>
    pa = walkaddr(pagetable, va + i);
    if(pa == 0)
      panic("loadseg: address should exist");
    80005268:	00003517          	auipc	a0,0x3
    8000526c:	54050513          	addi	a0,a0,1344 # 800087a8 <syscalls+0x2f8>
    80005270:	ffffb097          	auipc	ra,0xffffb
    80005274:	360080e7          	jalr	864(ra) # 800005d0 <panic>
    if(sz - i < PGSIZE)
      n = sz - i;
    else
      n = PGSIZE;
    if(readi(ip, 0, (uint64)pa, offset+i, n) != n)
    80005278:	874a                	mv	a4,s2
    8000527a:	009c86bb          	addw	a3,s9,s1
    8000527e:	4581                	li	a1,0
    80005280:	8556                	mv	a0,s5
    80005282:	fffff097          	auipc	ra,0xfffff
    80005286:	c84080e7          	jalr	-892(ra) # 80003f06 <readi>
    8000528a:	2501                	sext.w	a0,a0
    8000528c:	1aa91863          	bne	s2,a0,8000543c <exec+0x2d2>
  for(i = 0; i < sz; i += PGSIZE){
    80005290:	009d84bb          	addw	s1,s11,s1
    80005294:	013d09bb          	addw	s3,s10,s3
    80005298:	1f74f263          	bgeu	s1,s7,8000547c <exec+0x312>
    pa = walkaddr(pagetable, va + i);
    8000529c:	02049593          	slli	a1,s1,0x20
    800052a0:	9181                	srli	a1,a1,0x20
    800052a2:	95e2                	add	a1,a1,s8
    800052a4:	855a                	mv	a0,s6
    800052a6:	ffffc097          	auipc	ra,0xffffc
    800052aa:	e4e080e7          	jalr	-434(ra) # 800010f4 <walkaddr>
    800052ae:	862a                	mv	a2,a0
    if(pa == 0)
    800052b0:	dd45                	beqz	a0,80005268 <exec+0xfe>
      n = PGSIZE;
    800052b2:	8952                	mv	s2,s4
    if(sz - i < PGSIZE)
    800052b4:	fd49f2e3          	bgeu	s3,s4,80005278 <exec+0x10e>
      n = sz - i;
    800052b8:	894e                	mv	s2,s3
    800052ba:	bf7d                	j	80005278 <exec+0x10e>
  uint64 argc, sz = 0, sp, ustack[MAXARG+1], stackbase;
    800052bc:	4481                	li	s1,0
  iunlockput(ip);
    800052be:	8556                	mv	a0,s5
    800052c0:	fffff097          	auipc	ra,0xfffff
    800052c4:	bf4080e7          	jalr	-1036(ra) # 80003eb4 <iunlockput>
  end_op();
    800052c8:	fffff097          	auipc	ra,0xfffff
    800052cc:	3ca080e7          	jalr	970(ra) # 80004692 <end_op>
  p = myproc();
    800052d0:	ffffd097          	auipc	ra,0xffffd
    800052d4:	a7a080e7          	jalr	-1414(ra) # 80001d4a <myproc>
    800052d8:	8baa                	mv	s7,a0
  uint64 oldsz = p->sz;
    800052da:	04853d03          	ld	s10,72(a0)
  sz = PGROUNDUP(sz);
    800052de:	6785                	lui	a5,0x1
    800052e0:	17fd                	addi	a5,a5,-1 # fff <_entry-0x7ffff001>
    800052e2:	94be                	add	s1,s1,a5
    800052e4:	77fd                	lui	a5,0xfffff
    800052e6:	8fe5                	and	a5,a5,s1
    800052e8:	def43c23          	sd	a5,-520(s0)
  if((sz1 = uvmalloc(pagetable, sz, sz + 2*PGSIZE)) == 0)
    800052ec:	6609                	lui	a2,0x2
    800052ee:	963e                	add	a2,a2,a5
    800052f0:	85be                	mv	a1,a5
    800052f2:	855a                	mv	a0,s6
    800052f4:	ffffc097          	auipc	ra,0xffffc
    800052f8:	1e4080e7          	jalr	484(ra) # 800014d8 <uvmalloc>
    800052fc:	8c2a                	mv	s8,a0
  ip = 0;
    800052fe:	4a81                	li	s5,0
  if((sz1 = uvmalloc(pagetable, sz, sz + 2*PGSIZE)) == 0)
    80005300:	12050e63          	beqz	a0,8000543c <exec+0x2d2>
  uvmclear(pagetable, sz-2*PGSIZE);
    80005304:	75f9                	lui	a1,0xffffe
    80005306:	95aa                	add	a1,a1,a0
    80005308:	855a                	mv	a0,s6
    8000530a:	ffffc097          	auipc	ra,0xffffc
    8000530e:	3ec080e7          	jalr	1004(ra) # 800016f6 <uvmclear>
  stackbase = sp - PGSIZE;
    80005312:	7afd                	lui	s5,0xfffff
    80005314:	9ae2                	add	s5,s5,s8
  for(argc = 0; argv[argc]; argc++) {
    80005316:	df043783          	ld	a5,-528(s0)
    8000531a:	6388                	ld	a0,0(a5)
    8000531c:	c925                	beqz	a0,8000538c <exec+0x222>
    8000531e:	e8840993          	addi	s3,s0,-376
    80005322:	f8840c93          	addi	s9,s0,-120
  sp = sz;
    80005326:	8962                	mv	s2,s8
  for(argc = 0; argv[argc]; argc++) {
    80005328:	4481                	li	s1,0
    sp -= strlen(argv[argc]) + 1;
    8000532a:	ffffc097          	auipc	ra,0xffffc
    8000532e:	bb8080e7          	jalr	-1096(ra) # 80000ee2 <strlen>
    80005332:	0015079b          	addiw	a5,a0,1
    80005336:	40f90933          	sub	s2,s2,a5
    sp -= sp % 16; // riscv sp must be 16-byte aligned
    8000533a:	ff097913          	andi	s2,s2,-16
    if(sp < stackbase)
    8000533e:	13596363          	bltu	s2,s5,80005464 <exec+0x2fa>
    if(copyout(pagetable, sp, argv[argc], strlen(argv[argc]) + 1) < 0)
    80005342:	df043d83          	ld	s11,-528(s0)
    80005346:	000dba03          	ld	s4,0(s11) # 1000 <_entry-0x7ffff000>
    8000534a:	8552                	mv	a0,s4
    8000534c:	ffffc097          	auipc	ra,0xffffc
    80005350:	b96080e7          	jalr	-1130(ra) # 80000ee2 <strlen>
    80005354:	0015069b          	addiw	a3,a0,1
    80005358:	8652                	mv	a2,s4
    8000535a:	85ca                	mv	a1,s2
    8000535c:	855a                	mv	a0,s6
    8000535e:	ffffc097          	auipc	ra,0xffffc
    80005362:	3ca080e7          	jalr	970(ra) # 80001728 <copyout>
    80005366:	10054363          	bltz	a0,8000546c <exec+0x302>
    ustack[argc] = sp;
    8000536a:	0129b023          	sd	s2,0(s3)
  for(argc = 0; argv[argc]; argc++) {
    8000536e:	0485                	addi	s1,s1,1
    80005370:	008d8793          	addi	a5,s11,8
    80005374:	def43823          	sd	a5,-528(s0)
    80005378:	008db503          	ld	a0,8(s11)
    8000537c:	c911                	beqz	a0,80005390 <exec+0x226>
    if(argc >= MAXARG)
    8000537e:	09a1                	addi	s3,s3,8
    80005380:	fb3c95e3          	bne	s9,s3,8000532a <exec+0x1c0>
  sz = sz1;
    80005384:	df843c23          	sd	s8,-520(s0)
  ip = 0;
    80005388:	4a81                	li	s5,0
    8000538a:	a84d                	j	8000543c <exec+0x2d2>
  sp = sz;
    8000538c:	8962                	mv	s2,s8
  for(argc = 0; argv[argc]; argc++) {
    8000538e:	4481                	li	s1,0
  ustack[argc] = 0;
    80005390:	00349793          	slli	a5,s1,0x3
    80005394:	f9040713          	addi	a4,s0,-112
    80005398:	97ba                	add	a5,a5,a4
    8000539a:	ee07bc23          	sd	zero,-264(a5) # ffffffffffffeef8 <end+0xffffffff7ffd2ef8>
  sp -= (argc+1) * sizeof(uint64);
    8000539e:	00148693          	addi	a3,s1,1
    800053a2:	068e                	slli	a3,a3,0x3
    800053a4:	40d90933          	sub	s2,s2,a3
  sp -= sp % 16;
    800053a8:	ff097913          	andi	s2,s2,-16
  if(sp < stackbase)
    800053ac:	01597663          	bgeu	s2,s5,800053b8 <exec+0x24e>
  sz = sz1;
    800053b0:	df843c23          	sd	s8,-520(s0)
  ip = 0;
    800053b4:	4a81                	li	s5,0
    800053b6:	a059                	j	8000543c <exec+0x2d2>
  if(copyout(pagetable, sp, (char *)ustack, (argc+1)*sizeof(uint64)) < 0)
    800053b8:	e8840613          	addi	a2,s0,-376
    800053bc:	85ca                	mv	a1,s2
    800053be:	855a                	mv	a0,s6
    800053c0:	ffffc097          	auipc	ra,0xffffc
    800053c4:	368080e7          	jalr	872(ra) # 80001728 <copyout>
    800053c8:	0a054663          	bltz	a0,80005474 <exec+0x30a>
  p->trapframe->a1 = sp;
    800053cc:	058bb783          	ld	a5,88(s7)
    800053d0:	0727bc23          	sd	s2,120(a5)
  for(last=s=path; *s; s++)
    800053d4:	de843783          	ld	a5,-536(s0)
    800053d8:	0007c703          	lbu	a4,0(a5)
    800053dc:	cf11                	beqz	a4,800053f8 <exec+0x28e>
    800053de:	0785                	addi	a5,a5,1
    if(*s == '/')
    800053e0:	02f00693          	li	a3,47
    800053e4:	a039                	j	800053f2 <exec+0x288>
      last = s+1;
    800053e6:	def43423          	sd	a5,-536(s0)
  for(last=s=path; *s; s++)
    800053ea:	0785                	addi	a5,a5,1
    800053ec:	fff7c703          	lbu	a4,-1(a5)
    800053f0:	c701                	beqz	a4,800053f8 <exec+0x28e>
    if(*s == '/')
    800053f2:	fed71ce3          	bne	a4,a3,800053ea <exec+0x280>
    800053f6:	bfc5                	j	800053e6 <exec+0x27c>
  safestrcpy(p->name, last, sizeof(p->name));
    800053f8:	4641                	li	a2,16
    800053fa:	de843583          	ld	a1,-536(s0)
    800053fe:	158b8513          	addi	a0,s7,344
    80005402:	ffffc097          	auipc	ra,0xffffc
    80005406:	aae080e7          	jalr	-1362(ra) # 80000eb0 <safestrcpy>
  oldpagetable = p->pagetable;
    8000540a:	050bb503          	ld	a0,80(s7)
  p->pagetable = pagetable;
    8000540e:	056bb823          	sd	s6,80(s7)
  p->sz = sz;
    80005412:	058bb423          	sd	s8,72(s7)
  p->trapframe->epc = elf.entry;  // initial program counter = main
    80005416:	058bb783          	ld	a5,88(s7)
    8000541a:	e6043703          	ld	a4,-416(s0)
    8000541e:	ef98                	sd	a4,24(a5)
  p->trapframe->sp = sp; // initial stack pointer
    80005420:	058bb783          	ld	a5,88(s7)
    80005424:	0327b823          	sd	s2,48(a5)
  proc_freepagetable(oldpagetable, oldsz);
    80005428:	85ea                	mv	a1,s10
    8000542a:	ffffd097          	auipc	ra,0xffffd
    8000542e:	a80080e7          	jalr	-1408(ra) # 80001eaa <proc_freepagetable>
  return argc; // this ends up in a0, the first argument to main(argc, argv)
    80005432:	0004851b          	sext.w	a0,s1
    80005436:	bbc1                	j	80005206 <exec+0x9c>
    80005438:	de943c23          	sd	s1,-520(s0)
    proc_freepagetable(pagetable, sz);
    8000543c:	df843583          	ld	a1,-520(s0)
    80005440:	855a                	mv	a0,s6
    80005442:	ffffd097          	auipc	ra,0xffffd
    80005446:	a68080e7          	jalr	-1432(ra) # 80001eaa <proc_freepagetable>
  if(ip){
    8000544a:	da0a94e3          	bnez	s5,800051f2 <exec+0x88>
  return -1;
    8000544e:	557d                	li	a0,-1
    80005450:	bb5d                	j	80005206 <exec+0x9c>
    80005452:	de943c23          	sd	s1,-520(s0)
    80005456:	b7dd                	j	8000543c <exec+0x2d2>
    80005458:	de943c23          	sd	s1,-520(s0)
    8000545c:	b7c5                	j	8000543c <exec+0x2d2>
    8000545e:	de943c23          	sd	s1,-520(s0)
    80005462:	bfe9                	j	8000543c <exec+0x2d2>
  sz = sz1;
    80005464:	df843c23          	sd	s8,-520(s0)
  ip = 0;
    80005468:	4a81                	li	s5,0
    8000546a:	bfc9                	j	8000543c <exec+0x2d2>
  sz = sz1;
    8000546c:	df843c23          	sd	s8,-520(s0)
  ip = 0;
    80005470:	4a81                	li	s5,0
    80005472:	b7e9                	j	8000543c <exec+0x2d2>
  sz = sz1;
    80005474:	df843c23          	sd	s8,-520(s0)
  ip = 0;
    80005478:	4a81                	li	s5,0
    8000547a:	b7c9                	j	8000543c <exec+0x2d2>
    if((sz1 = uvmalloc(pagetable, sz, ph.vaddr + ph.memsz)) == 0)
    8000547c:	df843483          	ld	s1,-520(s0)
  for(i=0, off=elf.phoff; i<elf.phnum; i++, off+=sizeof(ph)){
    80005480:	e0843783          	ld	a5,-504(s0)
    80005484:	0017869b          	addiw	a3,a5,1
    80005488:	e0d43423          	sd	a3,-504(s0)
    8000548c:	e0043783          	ld	a5,-512(s0)
    80005490:	0387879b          	addiw	a5,a5,56
    80005494:	e8045703          	lhu	a4,-384(s0)
    80005498:	e2e6d3e3          	bge	a3,a4,800052be <exec+0x154>
    if(readi(ip, 0, (uint64)&ph, off, sizeof(ph)) != sizeof(ph))
    8000549c:	2781                	sext.w	a5,a5
    8000549e:	e0f43023          	sd	a5,-512(s0)
    800054a2:	03800713          	li	a4,56
    800054a6:	86be                	mv	a3,a5
    800054a8:	e1040613          	addi	a2,s0,-496
    800054ac:	4581                	li	a1,0
    800054ae:	8556                	mv	a0,s5
    800054b0:	fffff097          	auipc	ra,0xfffff
    800054b4:	a56080e7          	jalr	-1450(ra) # 80003f06 <readi>
    800054b8:	03800793          	li	a5,56
    800054bc:	f6f51ee3          	bne	a0,a5,80005438 <exec+0x2ce>
    if(ph.type != ELF_PROG_LOAD)
    800054c0:	e1042783          	lw	a5,-496(s0)
    800054c4:	4705                	li	a4,1
    800054c6:	fae79de3          	bne	a5,a4,80005480 <exec+0x316>
    if(ph.memsz < ph.filesz)
    800054ca:	e3843603          	ld	a2,-456(s0)
    800054ce:	e3043783          	ld	a5,-464(s0)
    800054d2:	f8f660e3          	bltu	a2,a5,80005452 <exec+0x2e8>
    if(ph.vaddr + ph.memsz < ph.vaddr)
    800054d6:	e2043783          	ld	a5,-480(s0)
    800054da:	963e                	add	a2,a2,a5
    800054dc:	f6f66ee3          	bltu	a2,a5,80005458 <exec+0x2ee>
    if((sz1 = uvmalloc(pagetable, sz, ph.vaddr + ph.memsz)) == 0)
    800054e0:	85a6                	mv	a1,s1
    800054e2:	855a                	mv	a0,s6
    800054e4:	ffffc097          	auipc	ra,0xffffc
    800054e8:	ff4080e7          	jalr	-12(ra) # 800014d8 <uvmalloc>
    800054ec:	dea43c23          	sd	a0,-520(s0)
    800054f0:	d53d                	beqz	a0,8000545e <exec+0x2f4>
    if(ph.vaddr % PGSIZE != 0)
    800054f2:	e2043c03          	ld	s8,-480(s0)
    800054f6:	de043783          	ld	a5,-544(s0)
    800054fa:	00fc77b3          	and	a5,s8,a5
    800054fe:	ff9d                	bnez	a5,8000543c <exec+0x2d2>
    if(loadseg(pagetable, ph.vaddr, ip, ph.off, ph.filesz) < 0)
    80005500:	e1842c83          	lw	s9,-488(s0)
    80005504:	e3042b83          	lw	s7,-464(s0)
  for(i = 0; i < sz; i += PGSIZE){
    80005508:	f60b8ae3          	beqz	s7,8000547c <exec+0x312>
    8000550c:	89de                	mv	s3,s7
    8000550e:	4481                	li	s1,0
    80005510:	b371                	j	8000529c <exec+0x132>

0000000080005512 <argfd>:

// Fetch the nth word-sized system call argument as a file descriptor
// and return both the descriptor and the corresponding struct file.
static int
argfd(int n, int *pfd, struct file **pf)
{
    80005512:	7179                	addi	sp,sp,-48
    80005514:	f406                	sd	ra,40(sp)
    80005516:	f022                	sd	s0,32(sp)
    80005518:	ec26                	sd	s1,24(sp)
    8000551a:	e84a                	sd	s2,16(sp)
    8000551c:	1800                	addi	s0,sp,48
    8000551e:	892e                	mv	s2,a1
    80005520:	84b2                	mv	s1,a2
  int fd;
  struct file *f;

  if(argint(n, &fd) < 0)
    80005522:	fdc40593          	addi	a1,s0,-36
    80005526:	ffffe097          	auipc	ra,0xffffe
    8000552a:	a50080e7          	jalr	-1456(ra) # 80002f76 <argint>
    8000552e:	04054063          	bltz	a0,8000556e <argfd+0x5c>
    return -1;
  if(fd < 0 || fd >= NOFILE || (f=myproc()->ofile[fd]) == 0)
    80005532:	fdc42703          	lw	a4,-36(s0)
    80005536:	47bd                	li	a5,15
    80005538:	02e7ed63          	bltu	a5,a4,80005572 <argfd+0x60>
    8000553c:	ffffd097          	auipc	ra,0xffffd
    80005540:	80e080e7          	jalr	-2034(ra) # 80001d4a <myproc>
    80005544:	fdc42703          	lw	a4,-36(s0)
    80005548:	01a70793          	addi	a5,a4,26
    8000554c:	078e                	slli	a5,a5,0x3
    8000554e:	953e                	add	a0,a0,a5
    80005550:	611c                	ld	a5,0(a0)
    80005552:	c395                	beqz	a5,80005576 <argfd+0x64>
    return -1;
  if(pfd)
    80005554:	00090463          	beqz	s2,8000555c <argfd+0x4a>
    *pfd = fd;
    80005558:	00e92023          	sw	a4,0(s2)
  if(pf)
    *pf = f;
  return 0;
    8000555c:	4501                	li	a0,0
  if(pf)
    8000555e:	c091                	beqz	s1,80005562 <argfd+0x50>
    *pf = f;
    80005560:	e09c                	sd	a5,0(s1)
}
    80005562:	70a2                	ld	ra,40(sp)
    80005564:	7402                	ld	s0,32(sp)
    80005566:	64e2                	ld	s1,24(sp)
    80005568:	6942                	ld	s2,16(sp)
    8000556a:	6145                	addi	sp,sp,48
    8000556c:	8082                	ret
    return -1;
    8000556e:	557d                	li	a0,-1
    80005570:	bfcd                	j	80005562 <argfd+0x50>
    return -1;
    80005572:	557d                	li	a0,-1
    80005574:	b7fd                	j	80005562 <argfd+0x50>
    80005576:	557d                	li	a0,-1
    80005578:	b7ed                	j	80005562 <argfd+0x50>

000000008000557a <fdalloc>:

// Allocate a file descriptor for the given file.
// Takes over file reference from caller on success.
static int
fdalloc(struct file *f)
{
    8000557a:	1101                	addi	sp,sp,-32
    8000557c:	ec06                	sd	ra,24(sp)
    8000557e:	e822                	sd	s0,16(sp)
    80005580:	e426                	sd	s1,8(sp)
    80005582:	1000                	addi	s0,sp,32
    80005584:	84aa                	mv	s1,a0
  int fd;
  struct proc *p = myproc();
    80005586:	ffffc097          	auipc	ra,0xffffc
    8000558a:	7c4080e7          	jalr	1988(ra) # 80001d4a <myproc>
    8000558e:	862a                	mv	a2,a0

  for(fd = 0; fd < NOFILE; fd++){
    80005590:	0d050793          	addi	a5,a0,208
    80005594:	4501                	li	a0,0
    80005596:	46c1                	li	a3,16
    if(p->ofile[fd] == 0){
    80005598:	6398                	ld	a4,0(a5)
    8000559a:	cb19                	beqz	a4,800055b0 <fdalloc+0x36>
  for(fd = 0; fd < NOFILE; fd++){
    8000559c:	2505                	addiw	a0,a0,1
    8000559e:	07a1                	addi	a5,a5,8
    800055a0:	fed51ce3          	bne	a0,a3,80005598 <fdalloc+0x1e>
      p->ofile[fd] = f;
      return fd;
    }
  }
  return -1;
    800055a4:	557d                	li	a0,-1
}
    800055a6:	60e2                	ld	ra,24(sp)
    800055a8:	6442                	ld	s0,16(sp)
    800055aa:	64a2                	ld	s1,8(sp)
    800055ac:	6105                	addi	sp,sp,32
    800055ae:	8082                	ret
      p->ofile[fd] = f;
    800055b0:	01a50793          	addi	a5,a0,26
    800055b4:	078e                	slli	a5,a5,0x3
    800055b6:	963e                	add	a2,a2,a5
    800055b8:	e204                	sd	s1,0(a2)
      return fd;
    800055ba:	b7f5                	j	800055a6 <fdalloc+0x2c>

00000000800055bc <create>:
  return -1;
}

static struct inode*
create(char *path, short type, short major, short minor)
{
    800055bc:	715d                	addi	sp,sp,-80
    800055be:	e486                	sd	ra,72(sp)
    800055c0:	e0a2                	sd	s0,64(sp)
    800055c2:	fc26                	sd	s1,56(sp)
    800055c4:	f84a                	sd	s2,48(sp)
    800055c6:	f44e                	sd	s3,40(sp)
    800055c8:	f052                	sd	s4,32(sp)
    800055ca:	ec56                	sd	s5,24(sp)
    800055cc:	0880                	addi	s0,sp,80
    800055ce:	89ae                	mv	s3,a1
    800055d0:	8ab2                	mv	s5,a2
    800055d2:	8a36                	mv	s4,a3
  struct inode *ip, *dp;
  char name[DIRSIZ];

  if((dp = nameiparent(path, name)) == 0)
    800055d4:	fb040593          	addi	a1,s0,-80
    800055d8:	fffff097          	auipc	ra,0xfffff
    800055dc:	e48080e7          	jalr	-440(ra) # 80004420 <nameiparent>
    800055e0:	892a                	mv	s2,a0
    800055e2:	12050e63          	beqz	a0,8000571e <create+0x162>
    return 0;

  ilock(dp);
    800055e6:	ffffe097          	auipc	ra,0xffffe
    800055ea:	66c080e7          	jalr	1644(ra) # 80003c52 <ilock>

  if((ip = dirlookup(dp, name, 0)) != 0){
    800055ee:	4601                	li	a2,0
    800055f0:	fb040593          	addi	a1,s0,-80
    800055f4:	854a                	mv	a0,s2
    800055f6:	fffff097          	auipc	ra,0xfffff
    800055fa:	b3a080e7          	jalr	-1222(ra) # 80004130 <dirlookup>
    800055fe:	84aa                	mv	s1,a0
    80005600:	c921                	beqz	a0,80005650 <create+0x94>
    iunlockput(dp);
    80005602:	854a                	mv	a0,s2
    80005604:	fffff097          	auipc	ra,0xfffff
    80005608:	8b0080e7          	jalr	-1872(ra) # 80003eb4 <iunlockput>
    ilock(ip);
    8000560c:	8526                	mv	a0,s1
    8000560e:	ffffe097          	auipc	ra,0xffffe
    80005612:	644080e7          	jalr	1604(ra) # 80003c52 <ilock>
    if(type == T_FILE && (ip->type == T_FILE || ip->type == T_DEVICE))
    80005616:	2981                	sext.w	s3,s3
    80005618:	4789                	li	a5,2
    8000561a:	02f99463          	bne	s3,a5,80005642 <create+0x86>
    8000561e:	0444d783          	lhu	a5,68(s1)
    80005622:	37f9                	addiw	a5,a5,-2
    80005624:	17c2                	slli	a5,a5,0x30
    80005626:	93c1                	srli	a5,a5,0x30
    80005628:	4705                	li	a4,1
    8000562a:	00f76c63          	bltu	a4,a5,80005642 <create+0x86>
    panic("create: dirlink");

  iunlockput(dp);

  return ip;
}
    8000562e:	8526                	mv	a0,s1
    80005630:	60a6                	ld	ra,72(sp)
    80005632:	6406                	ld	s0,64(sp)
    80005634:	74e2                	ld	s1,56(sp)
    80005636:	7942                	ld	s2,48(sp)
    80005638:	79a2                	ld	s3,40(sp)
    8000563a:	7a02                	ld	s4,32(sp)
    8000563c:	6ae2                	ld	s5,24(sp)
    8000563e:	6161                	addi	sp,sp,80
    80005640:	8082                	ret
    iunlockput(ip);
    80005642:	8526                	mv	a0,s1
    80005644:	fffff097          	auipc	ra,0xfffff
    80005648:	870080e7          	jalr	-1936(ra) # 80003eb4 <iunlockput>
    return 0;
    8000564c:	4481                	li	s1,0
    8000564e:	b7c5                	j	8000562e <create+0x72>
  if((ip = ialloc(dp->dev, type)) == 0)
    80005650:	85ce                	mv	a1,s3
    80005652:	00092503          	lw	a0,0(s2)
    80005656:	ffffe097          	auipc	ra,0xffffe
    8000565a:	464080e7          	jalr	1124(ra) # 80003aba <ialloc>
    8000565e:	84aa                	mv	s1,a0
    80005660:	c521                	beqz	a0,800056a8 <create+0xec>
  ilock(ip);
    80005662:	ffffe097          	auipc	ra,0xffffe
    80005666:	5f0080e7          	jalr	1520(ra) # 80003c52 <ilock>
  ip->major = major;
    8000566a:	05549323          	sh	s5,70(s1)
  ip->minor = minor;
    8000566e:	05449423          	sh	s4,72(s1)
  ip->nlink = 1;
    80005672:	4a05                	li	s4,1
    80005674:	05449523          	sh	s4,74(s1)
  iupdate(ip);
    80005678:	8526                	mv	a0,s1
    8000567a:	ffffe097          	auipc	ra,0xffffe
    8000567e:	50e080e7          	jalr	1294(ra) # 80003b88 <iupdate>
  if(type == T_DIR){  // Create . and .. entries.
    80005682:	2981                	sext.w	s3,s3
    80005684:	03498a63          	beq	s3,s4,800056b8 <create+0xfc>
  if(dirlink(dp, name, ip->inum) < 0)
    80005688:	40d0                	lw	a2,4(s1)
    8000568a:	fb040593          	addi	a1,s0,-80
    8000568e:	854a                	mv	a0,s2
    80005690:	fffff097          	auipc	ra,0xfffff
    80005694:	cb0080e7          	jalr	-848(ra) # 80004340 <dirlink>
    80005698:	06054b63          	bltz	a0,8000570e <create+0x152>
  iunlockput(dp);
    8000569c:	854a                	mv	a0,s2
    8000569e:	fffff097          	auipc	ra,0xfffff
    800056a2:	816080e7          	jalr	-2026(ra) # 80003eb4 <iunlockput>
  return ip;
    800056a6:	b761                	j	8000562e <create+0x72>
    panic("create: ialloc");
    800056a8:	00003517          	auipc	a0,0x3
    800056ac:	12050513          	addi	a0,a0,288 # 800087c8 <syscalls+0x318>
    800056b0:	ffffb097          	auipc	ra,0xffffb
    800056b4:	f20080e7          	jalr	-224(ra) # 800005d0 <panic>
    dp->nlink++;  // for ".."
    800056b8:	04a95783          	lhu	a5,74(s2)
    800056bc:	2785                	addiw	a5,a5,1
    800056be:	04f91523          	sh	a5,74(s2)
    iupdate(dp);
    800056c2:	854a                	mv	a0,s2
    800056c4:	ffffe097          	auipc	ra,0xffffe
    800056c8:	4c4080e7          	jalr	1220(ra) # 80003b88 <iupdate>
    if(dirlink(ip, ".", ip->inum) < 0 || dirlink(ip, "..", dp->inum) < 0)
    800056cc:	40d0                	lw	a2,4(s1)
    800056ce:	00003597          	auipc	a1,0x3
    800056d2:	10a58593          	addi	a1,a1,266 # 800087d8 <syscalls+0x328>
    800056d6:	8526                	mv	a0,s1
    800056d8:	fffff097          	auipc	ra,0xfffff
    800056dc:	c68080e7          	jalr	-920(ra) # 80004340 <dirlink>
    800056e0:	00054f63          	bltz	a0,800056fe <create+0x142>
    800056e4:	00492603          	lw	a2,4(s2)
    800056e8:	00003597          	auipc	a1,0x3
    800056ec:	0f858593          	addi	a1,a1,248 # 800087e0 <syscalls+0x330>
    800056f0:	8526                	mv	a0,s1
    800056f2:	fffff097          	auipc	ra,0xfffff
    800056f6:	c4e080e7          	jalr	-946(ra) # 80004340 <dirlink>
    800056fa:	f80557e3          	bgez	a0,80005688 <create+0xcc>
      panic("create dots");
    800056fe:	00003517          	auipc	a0,0x3
    80005702:	0ea50513          	addi	a0,a0,234 # 800087e8 <syscalls+0x338>
    80005706:	ffffb097          	auipc	ra,0xffffb
    8000570a:	eca080e7          	jalr	-310(ra) # 800005d0 <panic>
    panic("create: dirlink");
    8000570e:	00003517          	auipc	a0,0x3
    80005712:	0ea50513          	addi	a0,a0,234 # 800087f8 <syscalls+0x348>
    80005716:	ffffb097          	auipc	ra,0xffffb
    8000571a:	eba080e7          	jalr	-326(ra) # 800005d0 <panic>
    return 0;
    8000571e:	84aa                	mv	s1,a0
    80005720:	b739                	j	8000562e <create+0x72>

0000000080005722 <sys_dup>:
{
    80005722:	7179                	addi	sp,sp,-48
    80005724:	f406                	sd	ra,40(sp)
    80005726:	f022                	sd	s0,32(sp)
    80005728:	ec26                	sd	s1,24(sp)
    8000572a:	1800                	addi	s0,sp,48
  if(argfd(0, 0, &f) < 0)
    8000572c:	fd840613          	addi	a2,s0,-40
    80005730:	4581                	li	a1,0
    80005732:	4501                	li	a0,0
    80005734:	00000097          	auipc	ra,0x0
    80005738:	dde080e7          	jalr	-546(ra) # 80005512 <argfd>
    return -1;
    8000573c:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0)
    8000573e:	02054363          	bltz	a0,80005764 <sys_dup+0x42>
  if((fd=fdalloc(f)) < 0)
    80005742:	fd843503          	ld	a0,-40(s0)
    80005746:	00000097          	auipc	ra,0x0
    8000574a:	e34080e7          	jalr	-460(ra) # 8000557a <fdalloc>
    8000574e:	84aa                	mv	s1,a0
    return -1;
    80005750:	57fd                	li	a5,-1
  if((fd=fdalloc(f)) < 0)
    80005752:	00054963          	bltz	a0,80005764 <sys_dup+0x42>
  filedup(f);
    80005756:	fd843503          	ld	a0,-40(s0)
    8000575a:	fffff097          	auipc	ra,0xfffff
    8000575e:	338080e7          	jalr	824(ra) # 80004a92 <filedup>
  return fd;
    80005762:	87a6                	mv	a5,s1
}
    80005764:	853e                	mv	a0,a5
    80005766:	70a2                	ld	ra,40(sp)
    80005768:	7402                	ld	s0,32(sp)
    8000576a:	64e2                	ld	s1,24(sp)
    8000576c:	6145                	addi	sp,sp,48
    8000576e:	8082                	ret

0000000080005770 <sys_read>:
{
    80005770:	7179                	addi	sp,sp,-48
    80005772:	f406                	sd	ra,40(sp)
    80005774:	f022                	sd	s0,32(sp)
    80005776:	1800                	addi	s0,sp,48
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    80005778:	fe840613          	addi	a2,s0,-24
    8000577c:	4581                	li	a1,0
    8000577e:	4501                	li	a0,0
    80005780:	00000097          	auipc	ra,0x0
    80005784:	d92080e7          	jalr	-622(ra) # 80005512 <argfd>
    return -1;
    80005788:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    8000578a:	04054163          	bltz	a0,800057cc <sys_read+0x5c>
    8000578e:	fe440593          	addi	a1,s0,-28
    80005792:	4509                	li	a0,2
    80005794:	ffffd097          	auipc	ra,0xffffd
    80005798:	7e2080e7          	jalr	2018(ra) # 80002f76 <argint>
    return -1;
    8000579c:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    8000579e:	02054763          	bltz	a0,800057cc <sys_read+0x5c>
    800057a2:	fd840593          	addi	a1,s0,-40
    800057a6:	4505                	li	a0,1
    800057a8:	ffffd097          	auipc	ra,0xffffd
    800057ac:	7f0080e7          	jalr	2032(ra) # 80002f98 <argaddr>
    return -1;
    800057b0:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    800057b2:	00054d63          	bltz	a0,800057cc <sys_read+0x5c>
  return fileread(f, p, n);
    800057b6:	fe442603          	lw	a2,-28(s0)
    800057ba:	fd843583          	ld	a1,-40(s0)
    800057be:	fe843503          	ld	a0,-24(s0)
    800057c2:	fffff097          	auipc	ra,0xfffff
    800057c6:	45c080e7          	jalr	1116(ra) # 80004c1e <fileread>
    800057ca:	87aa                	mv	a5,a0
}
    800057cc:	853e                	mv	a0,a5
    800057ce:	70a2                	ld	ra,40(sp)
    800057d0:	7402                	ld	s0,32(sp)
    800057d2:	6145                	addi	sp,sp,48
    800057d4:	8082                	ret

00000000800057d6 <sys_write>:
{
    800057d6:	7179                	addi	sp,sp,-48
    800057d8:	f406                	sd	ra,40(sp)
    800057da:	f022                	sd	s0,32(sp)
    800057dc:	1800                	addi	s0,sp,48
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    800057de:	fe840613          	addi	a2,s0,-24
    800057e2:	4581                	li	a1,0
    800057e4:	4501                	li	a0,0
    800057e6:	00000097          	auipc	ra,0x0
    800057ea:	d2c080e7          	jalr	-724(ra) # 80005512 <argfd>
    return -1;
    800057ee:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    800057f0:	04054163          	bltz	a0,80005832 <sys_write+0x5c>
    800057f4:	fe440593          	addi	a1,s0,-28
    800057f8:	4509                	li	a0,2
    800057fa:	ffffd097          	auipc	ra,0xffffd
    800057fe:	77c080e7          	jalr	1916(ra) # 80002f76 <argint>
    return -1;
    80005802:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    80005804:	02054763          	bltz	a0,80005832 <sys_write+0x5c>
    80005808:	fd840593          	addi	a1,s0,-40
    8000580c:	4505                	li	a0,1
    8000580e:	ffffd097          	auipc	ra,0xffffd
    80005812:	78a080e7          	jalr	1930(ra) # 80002f98 <argaddr>
    return -1;
    80005816:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argint(2, &n) < 0 || argaddr(1, &p) < 0)
    80005818:	00054d63          	bltz	a0,80005832 <sys_write+0x5c>
  return filewrite(f, p, n);
    8000581c:	fe442603          	lw	a2,-28(s0)
    80005820:	fd843583          	ld	a1,-40(s0)
    80005824:	fe843503          	ld	a0,-24(s0)
    80005828:	fffff097          	auipc	ra,0xfffff
    8000582c:	4b8080e7          	jalr	1208(ra) # 80004ce0 <filewrite>
    80005830:	87aa                	mv	a5,a0
}
    80005832:	853e                	mv	a0,a5
    80005834:	70a2                	ld	ra,40(sp)
    80005836:	7402                	ld	s0,32(sp)
    80005838:	6145                	addi	sp,sp,48
    8000583a:	8082                	ret

000000008000583c <sys_close>:
{
    8000583c:	1101                	addi	sp,sp,-32
    8000583e:	ec06                	sd	ra,24(sp)
    80005840:	e822                	sd	s0,16(sp)
    80005842:	1000                	addi	s0,sp,32
  if(argfd(0, &fd, &f) < 0)
    80005844:	fe040613          	addi	a2,s0,-32
    80005848:	fec40593          	addi	a1,s0,-20
    8000584c:	4501                	li	a0,0
    8000584e:	00000097          	auipc	ra,0x0
    80005852:	cc4080e7          	jalr	-828(ra) # 80005512 <argfd>
    return -1;
    80005856:	57fd                	li	a5,-1
  if(argfd(0, &fd, &f) < 0)
    80005858:	02054463          	bltz	a0,80005880 <sys_close+0x44>
  myproc()->ofile[fd] = 0;
    8000585c:	ffffc097          	auipc	ra,0xffffc
    80005860:	4ee080e7          	jalr	1262(ra) # 80001d4a <myproc>
    80005864:	fec42783          	lw	a5,-20(s0)
    80005868:	07e9                	addi	a5,a5,26
    8000586a:	078e                	slli	a5,a5,0x3
    8000586c:	97aa                	add	a5,a5,a0
    8000586e:	0007b023          	sd	zero,0(a5)
  fileclose(f);
    80005872:	fe043503          	ld	a0,-32(s0)
    80005876:	fffff097          	auipc	ra,0xfffff
    8000587a:	26e080e7          	jalr	622(ra) # 80004ae4 <fileclose>
  return 0;
    8000587e:	4781                	li	a5,0
}
    80005880:	853e                	mv	a0,a5
    80005882:	60e2                	ld	ra,24(sp)
    80005884:	6442                	ld	s0,16(sp)
    80005886:	6105                	addi	sp,sp,32
    80005888:	8082                	ret

000000008000588a <sys_fstat>:
{
    8000588a:	1101                	addi	sp,sp,-32
    8000588c:	ec06                	sd	ra,24(sp)
    8000588e:	e822                	sd	s0,16(sp)
    80005890:	1000                	addi	s0,sp,32
  if(argfd(0, 0, &f) < 0 || argaddr(1, &st) < 0)
    80005892:	fe840613          	addi	a2,s0,-24
    80005896:	4581                	li	a1,0
    80005898:	4501                	li	a0,0
    8000589a:	00000097          	auipc	ra,0x0
    8000589e:	c78080e7          	jalr	-904(ra) # 80005512 <argfd>
    return -1;
    800058a2:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argaddr(1, &st) < 0)
    800058a4:	02054563          	bltz	a0,800058ce <sys_fstat+0x44>
    800058a8:	fe040593          	addi	a1,s0,-32
    800058ac:	4505                	li	a0,1
    800058ae:	ffffd097          	auipc	ra,0xffffd
    800058b2:	6ea080e7          	jalr	1770(ra) # 80002f98 <argaddr>
    return -1;
    800058b6:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0 || argaddr(1, &st) < 0)
    800058b8:	00054b63          	bltz	a0,800058ce <sys_fstat+0x44>
  return filestat(f, st);
    800058bc:	fe043583          	ld	a1,-32(s0)
    800058c0:	fe843503          	ld	a0,-24(s0)
    800058c4:	fffff097          	auipc	ra,0xfffff
    800058c8:	2e8080e7          	jalr	744(ra) # 80004bac <filestat>
    800058cc:	87aa                	mv	a5,a0
}
    800058ce:	853e                	mv	a0,a5
    800058d0:	60e2                	ld	ra,24(sp)
    800058d2:	6442                	ld	s0,16(sp)
    800058d4:	6105                	addi	sp,sp,32
    800058d6:	8082                	ret

00000000800058d8 <sys_link>:
{
    800058d8:	7169                	addi	sp,sp,-304
    800058da:	f606                	sd	ra,296(sp)
    800058dc:	f222                	sd	s0,288(sp)
    800058de:	ee26                	sd	s1,280(sp)
    800058e0:	ea4a                	sd	s2,272(sp)
    800058e2:	1a00                	addi	s0,sp,304
  if(argstr(0, old, MAXPATH) < 0 || argstr(1, new, MAXPATH) < 0)
    800058e4:	08000613          	li	a2,128
    800058e8:	ed040593          	addi	a1,s0,-304
    800058ec:	4501                	li	a0,0
    800058ee:	ffffd097          	auipc	ra,0xffffd
    800058f2:	6cc080e7          	jalr	1740(ra) # 80002fba <argstr>
    return -1;
    800058f6:	57fd                	li	a5,-1
  if(argstr(0, old, MAXPATH) < 0 || argstr(1, new, MAXPATH) < 0)
    800058f8:	10054e63          	bltz	a0,80005a14 <sys_link+0x13c>
    800058fc:	08000613          	li	a2,128
    80005900:	f5040593          	addi	a1,s0,-176
    80005904:	4505                	li	a0,1
    80005906:	ffffd097          	auipc	ra,0xffffd
    8000590a:	6b4080e7          	jalr	1716(ra) # 80002fba <argstr>
    return -1;
    8000590e:	57fd                	li	a5,-1
  if(argstr(0, old, MAXPATH) < 0 || argstr(1, new, MAXPATH) < 0)
    80005910:	10054263          	bltz	a0,80005a14 <sys_link+0x13c>
  begin_op();
    80005914:	fffff097          	auipc	ra,0xfffff
    80005918:	cfe080e7          	jalr	-770(ra) # 80004612 <begin_op>
  if((ip = namei(old)) == 0){
    8000591c:	ed040513          	addi	a0,s0,-304
    80005920:	fffff097          	auipc	ra,0xfffff
    80005924:	ae2080e7          	jalr	-1310(ra) # 80004402 <namei>
    80005928:	84aa                	mv	s1,a0
    8000592a:	c551                	beqz	a0,800059b6 <sys_link+0xde>
  ilock(ip);
    8000592c:	ffffe097          	auipc	ra,0xffffe
    80005930:	326080e7          	jalr	806(ra) # 80003c52 <ilock>
  if(ip->type == T_DIR){
    80005934:	04449703          	lh	a4,68(s1)
    80005938:	4785                	li	a5,1
    8000593a:	08f70463          	beq	a4,a5,800059c2 <sys_link+0xea>
  ip->nlink++;
    8000593e:	04a4d783          	lhu	a5,74(s1)
    80005942:	2785                	addiw	a5,a5,1
    80005944:	04f49523          	sh	a5,74(s1)
  iupdate(ip);
    80005948:	8526                	mv	a0,s1
    8000594a:	ffffe097          	auipc	ra,0xffffe
    8000594e:	23e080e7          	jalr	574(ra) # 80003b88 <iupdate>
  iunlock(ip);
    80005952:	8526                	mv	a0,s1
    80005954:	ffffe097          	auipc	ra,0xffffe
    80005958:	3c0080e7          	jalr	960(ra) # 80003d14 <iunlock>
  if((dp = nameiparent(new, name)) == 0)
    8000595c:	fd040593          	addi	a1,s0,-48
    80005960:	f5040513          	addi	a0,s0,-176
    80005964:	fffff097          	auipc	ra,0xfffff
    80005968:	abc080e7          	jalr	-1348(ra) # 80004420 <nameiparent>
    8000596c:	892a                	mv	s2,a0
    8000596e:	c935                	beqz	a0,800059e2 <sys_link+0x10a>
  ilock(dp);
    80005970:	ffffe097          	auipc	ra,0xffffe
    80005974:	2e2080e7          	jalr	738(ra) # 80003c52 <ilock>
  if(dp->dev != ip->dev || dirlink(dp, name, ip->inum) < 0){
    80005978:	00092703          	lw	a4,0(s2)
    8000597c:	409c                	lw	a5,0(s1)
    8000597e:	04f71d63          	bne	a4,a5,800059d8 <sys_link+0x100>
    80005982:	40d0                	lw	a2,4(s1)
    80005984:	fd040593          	addi	a1,s0,-48
    80005988:	854a                	mv	a0,s2
    8000598a:	fffff097          	auipc	ra,0xfffff
    8000598e:	9b6080e7          	jalr	-1610(ra) # 80004340 <dirlink>
    80005992:	04054363          	bltz	a0,800059d8 <sys_link+0x100>
  iunlockput(dp);
    80005996:	854a                	mv	a0,s2
    80005998:	ffffe097          	auipc	ra,0xffffe
    8000599c:	51c080e7          	jalr	1308(ra) # 80003eb4 <iunlockput>
  iput(ip);
    800059a0:	8526                	mv	a0,s1
    800059a2:	ffffe097          	auipc	ra,0xffffe
    800059a6:	46a080e7          	jalr	1130(ra) # 80003e0c <iput>
  end_op();
    800059aa:	fffff097          	auipc	ra,0xfffff
    800059ae:	ce8080e7          	jalr	-792(ra) # 80004692 <end_op>
  return 0;
    800059b2:	4781                	li	a5,0
    800059b4:	a085                	j	80005a14 <sys_link+0x13c>
    end_op();
    800059b6:	fffff097          	auipc	ra,0xfffff
    800059ba:	cdc080e7          	jalr	-804(ra) # 80004692 <end_op>
    return -1;
    800059be:	57fd                	li	a5,-1
    800059c0:	a891                	j	80005a14 <sys_link+0x13c>
    iunlockput(ip);
    800059c2:	8526                	mv	a0,s1
    800059c4:	ffffe097          	auipc	ra,0xffffe
    800059c8:	4f0080e7          	jalr	1264(ra) # 80003eb4 <iunlockput>
    end_op();
    800059cc:	fffff097          	auipc	ra,0xfffff
    800059d0:	cc6080e7          	jalr	-826(ra) # 80004692 <end_op>
    return -1;
    800059d4:	57fd                	li	a5,-1
    800059d6:	a83d                	j	80005a14 <sys_link+0x13c>
    iunlockput(dp);
    800059d8:	854a                	mv	a0,s2
    800059da:	ffffe097          	auipc	ra,0xffffe
    800059de:	4da080e7          	jalr	1242(ra) # 80003eb4 <iunlockput>
  ilock(ip);
    800059e2:	8526                	mv	a0,s1
    800059e4:	ffffe097          	auipc	ra,0xffffe
    800059e8:	26e080e7          	jalr	622(ra) # 80003c52 <ilock>
  ip->nlink--;
    800059ec:	04a4d783          	lhu	a5,74(s1)
    800059f0:	37fd                	addiw	a5,a5,-1
    800059f2:	04f49523          	sh	a5,74(s1)
  iupdate(ip);
    800059f6:	8526                	mv	a0,s1
    800059f8:	ffffe097          	auipc	ra,0xffffe
    800059fc:	190080e7          	jalr	400(ra) # 80003b88 <iupdate>
  iunlockput(ip);
    80005a00:	8526                	mv	a0,s1
    80005a02:	ffffe097          	auipc	ra,0xffffe
    80005a06:	4b2080e7          	jalr	1202(ra) # 80003eb4 <iunlockput>
  end_op();
    80005a0a:	fffff097          	auipc	ra,0xfffff
    80005a0e:	c88080e7          	jalr	-888(ra) # 80004692 <end_op>
  return -1;
    80005a12:	57fd                	li	a5,-1
}
    80005a14:	853e                	mv	a0,a5
    80005a16:	70b2                	ld	ra,296(sp)
    80005a18:	7412                	ld	s0,288(sp)
    80005a1a:	64f2                	ld	s1,280(sp)
    80005a1c:	6952                	ld	s2,272(sp)
    80005a1e:	6155                	addi	sp,sp,304
    80005a20:	8082                	ret

0000000080005a22 <sys_unlink>:
{
    80005a22:	7151                	addi	sp,sp,-240
    80005a24:	f586                	sd	ra,232(sp)
    80005a26:	f1a2                	sd	s0,224(sp)
    80005a28:	eda6                	sd	s1,216(sp)
    80005a2a:	e9ca                	sd	s2,208(sp)
    80005a2c:	e5ce                	sd	s3,200(sp)
    80005a2e:	1980                	addi	s0,sp,240
  if(argstr(0, path, MAXPATH) < 0)
    80005a30:	08000613          	li	a2,128
    80005a34:	f3040593          	addi	a1,s0,-208
    80005a38:	4501                	li	a0,0
    80005a3a:	ffffd097          	auipc	ra,0xffffd
    80005a3e:	580080e7          	jalr	1408(ra) # 80002fba <argstr>
    80005a42:	18054163          	bltz	a0,80005bc4 <sys_unlink+0x1a2>
  begin_op();
    80005a46:	fffff097          	auipc	ra,0xfffff
    80005a4a:	bcc080e7          	jalr	-1076(ra) # 80004612 <begin_op>
  if((dp = nameiparent(path, name)) == 0){
    80005a4e:	fb040593          	addi	a1,s0,-80
    80005a52:	f3040513          	addi	a0,s0,-208
    80005a56:	fffff097          	auipc	ra,0xfffff
    80005a5a:	9ca080e7          	jalr	-1590(ra) # 80004420 <nameiparent>
    80005a5e:	84aa                	mv	s1,a0
    80005a60:	c979                	beqz	a0,80005b36 <sys_unlink+0x114>
  ilock(dp);
    80005a62:	ffffe097          	auipc	ra,0xffffe
    80005a66:	1f0080e7          	jalr	496(ra) # 80003c52 <ilock>
  if(namecmp(name, ".") == 0 || namecmp(name, "..") == 0)
    80005a6a:	00003597          	auipc	a1,0x3
    80005a6e:	d6e58593          	addi	a1,a1,-658 # 800087d8 <syscalls+0x328>
    80005a72:	fb040513          	addi	a0,s0,-80
    80005a76:	ffffe097          	auipc	ra,0xffffe
    80005a7a:	6a0080e7          	jalr	1696(ra) # 80004116 <namecmp>
    80005a7e:	14050a63          	beqz	a0,80005bd2 <sys_unlink+0x1b0>
    80005a82:	00003597          	auipc	a1,0x3
    80005a86:	d5e58593          	addi	a1,a1,-674 # 800087e0 <syscalls+0x330>
    80005a8a:	fb040513          	addi	a0,s0,-80
    80005a8e:	ffffe097          	auipc	ra,0xffffe
    80005a92:	688080e7          	jalr	1672(ra) # 80004116 <namecmp>
    80005a96:	12050e63          	beqz	a0,80005bd2 <sys_unlink+0x1b0>
  if((ip = dirlookup(dp, name, &off)) == 0)
    80005a9a:	f2c40613          	addi	a2,s0,-212
    80005a9e:	fb040593          	addi	a1,s0,-80
    80005aa2:	8526                	mv	a0,s1
    80005aa4:	ffffe097          	auipc	ra,0xffffe
    80005aa8:	68c080e7          	jalr	1676(ra) # 80004130 <dirlookup>
    80005aac:	892a                	mv	s2,a0
    80005aae:	12050263          	beqz	a0,80005bd2 <sys_unlink+0x1b0>
  ilock(ip);
    80005ab2:	ffffe097          	auipc	ra,0xffffe
    80005ab6:	1a0080e7          	jalr	416(ra) # 80003c52 <ilock>
  if(ip->nlink < 1)
    80005aba:	04a91783          	lh	a5,74(s2)
    80005abe:	08f05263          	blez	a5,80005b42 <sys_unlink+0x120>
  if(ip->type == T_DIR && !isdirempty(ip)){
    80005ac2:	04491703          	lh	a4,68(s2)
    80005ac6:	4785                	li	a5,1
    80005ac8:	08f70563          	beq	a4,a5,80005b52 <sys_unlink+0x130>
  memset(&de, 0, sizeof(de));
    80005acc:	4641                	li	a2,16
    80005ace:	4581                	li	a1,0
    80005ad0:	fc040513          	addi	a0,s0,-64
    80005ad4:	ffffb097          	auipc	ra,0xffffb
    80005ad8:	28a080e7          	jalr	650(ra) # 80000d5e <memset>
  if(writei(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    80005adc:	4741                	li	a4,16
    80005ade:	f2c42683          	lw	a3,-212(s0)
    80005ae2:	fc040613          	addi	a2,s0,-64
    80005ae6:	4581                	li	a1,0
    80005ae8:	8526                	mv	a0,s1
    80005aea:	ffffe097          	auipc	ra,0xffffe
    80005aee:	512080e7          	jalr	1298(ra) # 80003ffc <writei>
    80005af2:	47c1                	li	a5,16
    80005af4:	0af51563          	bne	a0,a5,80005b9e <sys_unlink+0x17c>
  if(ip->type == T_DIR){
    80005af8:	04491703          	lh	a4,68(s2)
    80005afc:	4785                	li	a5,1
    80005afe:	0af70863          	beq	a4,a5,80005bae <sys_unlink+0x18c>
  iunlockput(dp);
    80005b02:	8526                	mv	a0,s1
    80005b04:	ffffe097          	auipc	ra,0xffffe
    80005b08:	3b0080e7          	jalr	944(ra) # 80003eb4 <iunlockput>
  ip->nlink--;
    80005b0c:	04a95783          	lhu	a5,74(s2)
    80005b10:	37fd                	addiw	a5,a5,-1
    80005b12:	04f91523          	sh	a5,74(s2)
  iupdate(ip);
    80005b16:	854a                	mv	a0,s2
    80005b18:	ffffe097          	auipc	ra,0xffffe
    80005b1c:	070080e7          	jalr	112(ra) # 80003b88 <iupdate>
  iunlockput(ip);
    80005b20:	854a                	mv	a0,s2
    80005b22:	ffffe097          	auipc	ra,0xffffe
    80005b26:	392080e7          	jalr	914(ra) # 80003eb4 <iunlockput>
  end_op();
    80005b2a:	fffff097          	auipc	ra,0xfffff
    80005b2e:	b68080e7          	jalr	-1176(ra) # 80004692 <end_op>
  return 0;
    80005b32:	4501                	li	a0,0
    80005b34:	a84d                	j	80005be6 <sys_unlink+0x1c4>
    end_op();
    80005b36:	fffff097          	auipc	ra,0xfffff
    80005b3a:	b5c080e7          	jalr	-1188(ra) # 80004692 <end_op>
    return -1;
    80005b3e:	557d                	li	a0,-1
    80005b40:	a05d                	j	80005be6 <sys_unlink+0x1c4>
    panic("unlink: nlink < 1");
    80005b42:	00003517          	auipc	a0,0x3
    80005b46:	cc650513          	addi	a0,a0,-826 # 80008808 <syscalls+0x358>
    80005b4a:	ffffb097          	auipc	ra,0xffffb
    80005b4e:	a86080e7          	jalr	-1402(ra) # 800005d0 <panic>
  for(off=2*sizeof(de); off<dp->size; off+=sizeof(de)){
    80005b52:	04c92703          	lw	a4,76(s2)
    80005b56:	02000793          	li	a5,32
    80005b5a:	f6e7f9e3          	bgeu	a5,a4,80005acc <sys_unlink+0xaa>
    80005b5e:	02000993          	li	s3,32
    if(readi(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    80005b62:	4741                	li	a4,16
    80005b64:	86ce                	mv	a3,s3
    80005b66:	f1840613          	addi	a2,s0,-232
    80005b6a:	4581                	li	a1,0
    80005b6c:	854a                	mv	a0,s2
    80005b6e:	ffffe097          	auipc	ra,0xffffe
    80005b72:	398080e7          	jalr	920(ra) # 80003f06 <readi>
    80005b76:	47c1                	li	a5,16
    80005b78:	00f51b63          	bne	a0,a5,80005b8e <sys_unlink+0x16c>
    if(de.inum != 0)
    80005b7c:	f1845783          	lhu	a5,-232(s0)
    80005b80:	e7a1                	bnez	a5,80005bc8 <sys_unlink+0x1a6>
  for(off=2*sizeof(de); off<dp->size; off+=sizeof(de)){
    80005b82:	29c1                	addiw	s3,s3,16
    80005b84:	04c92783          	lw	a5,76(s2)
    80005b88:	fcf9ede3          	bltu	s3,a5,80005b62 <sys_unlink+0x140>
    80005b8c:	b781                	j	80005acc <sys_unlink+0xaa>
      panic("isdirempty: readi");
    80005b8e:	00003517          	auipc	a0,0x3
    80005b92:	c9250513          	addi	a0,a0,-878 # 80008820 <syscalls+0x370>
    80005b96:	ffffb097          	auipc	ra,0xffffb
    80005b9a:	a3a080e7          	jalr	-1478(ra) # 800005d0 <panic>
    panic("unlink: writei");
    80005b9e:	00003517          	auipc	a0,0x3
    80005ba2:	c9a50513          	addi	a0,a0,-870 # 80008838 <syscalls+0x388>
    80005ba6:	ffffb097          	auipc	ra,0xffffb
    80005baa:	a2a080e7          	jalr	-1494(ra) # 800005d0 <panic>
    dp->nlink--;
    80005bae:	04a4d783          	lhu	a5,74(s1)
    80005bb2:	37fd                	addiw	a5,a5,-1
    80005bb4:	04f49523          	sh	a5,74(s1)
    iupdate(dp);
    80005bb8:	8526                	mv	a0,s1
    80005bba:	ffffe097          	auipc	ra,0xffffe
    80005bbe:	fce080e7          	jalr	-50(ra) # 80003b88 <iupdate>
    80005bc2:	b781                	j	80005b02 <sys_unlink+0xe0>
    return -1;
    80005bc4:	557d                	li	a0,-1
    80005bc6:	a005                	j	80005be6 <sys_unlink+0x1c4>
    iunlockput(ip);
    80005bc8:	854a                	mv	a0,s2
    80005bca:	ffffe097          	auipc	ra,0xffffe
    80005bce:	2ea080e7          	jalr	746(ra) # 80003eb4 <iunlockput>
  iunlockput(dp);
    80005bd2:	8526                	mv	a0,s1
    80005bd4:	ffffe097          	auipc	ra,0xffffe
    80005bd8:	2e0080e7          	jalr	736(ra) # 80003eb4 <iunlockput>
  end_op();
    80005bdc:	fffff097          	auipc	ra,0xfffff
    80005be0:	ab6080e7          	jalr	-1354(ra) # 80004692 <end_op>
  return -1;
    80005be4:	557d                	li	a0,-1
}
    80005be6:	70ae                	ld	ra,232(sp)
    80005be8:	740e                	ld	s0,224(sp)
    80005bea:	64ee                	ld	s1,216(sp)
    80005bec:	694e                	ld	s2,208(sp)
    80005bee:	69ae                	ld	s3,200(sp)
    80005bf0:	616d                	addi	sp,sp,240
    80005bf2:	8082                	ret

0000000080005bf4 <sys_open>:

uint64
sys_open(void)
{
    80005bf4:	7131                	addi	sp,sp,-192
    80005bf6:	fd06                	sd	ra,184(sp)
    80005bf8:	f922                	sd	s0,176(sp)
    80005bfa:	f526                	sd	s1,168(sp)
    80005bfc:	f14a                	sd	s2,160(sp)
    80005bfe:	ed4e                	sd	s3,152(sp)
    80005c00:	0180                	addi	s0,sp,192
  int fd, omode;
  struct file *f;
  struct inode *ip;
  int n;

  if((n = argstr(0, path, MAXPATH)) < 0 || argint(1, &omode) < 0)
    80005c02:	08000613          	li	a2,128
    80005c06:	f5040593          	addi	a1,s0,-176
    80005c0a:	4501                	li	a0,0
    80005c0c:	ffffd097          	auipc	ra,0xffffd
    80005c10:	3ae080e7          	jalr	942(ra) # 80002fba <argstr>
    return -1;
    80005c14:	54fd                	li	s1,-1
  if((n = argstr(0, path, MAXPATH)) < 0 || argint(1, &omode) < 0)
    80005c16:	0c054163          	bltz	a0,80005cd8 <sys_open+0xe4>
    80005c1a:	f4c40593          	addi	a1,s0,-180
    80005c1e:	4505                	li	a0,1
    80005c20:	ffffd097          	auipc	ra,0xffffd
    80005c24:	356080e7          	jalr	854(ra) # 80002f76 <argint>
    80005c28:	0a054863          	bltz	a0,80005cd8 <sys_open+0xe4>

  begin_op();
    80005c2c:	fffff097          	auipc	ra,0xfffff
    80005c30:	9e6080e7          	jalr	-1562(ra) # 80004612 <begin_op>

  if(omode & O_CREATE){
    80005c34:	f4c42783          	lw	a5,-180(s0)
    80005c38:	2007f793          	andi	a5,a5,512
    80005c3c:	cbdd                	beqz	a5,80005cf2 <sys_open+0xfe>
    ip = create(path, T_FILE, 0, 0);
    80005c3e:	4681                	li	a3,0
    80005c40:	4601                	li	a2,0
    80005c42:	4589                	li	a1,2
    80005c44:	f5040513          	addi	a0,s0,-176
    80005c48:	00000097          	auipc	ra,0x0
    80005c4c:	974080e7          	jalr	-1676(ra) # 800055bc <create>
    80005c50:	892a                	mv	s2,a0
    if(ip == 0){
    80005c52:	c959                	beqz	a0,80005ce8 <sys_open+0xf4>
      end_op();
      return -1;
    }
  }

  if(ip->type == T_DEVICE && (ip->major < 0 || ip->major >= NDEV)){
    80005c54:	04491703          	lh	a4,68(s2)
    80005c58:	478d                	li	a5,3
    80005c5a:	00f71763          	bne	a4,a5,80005c68 <sys_open+0x74>
    80005c5e:	04695703          	lhu	a4,70(s2)
    80005c62:	47a5                	li	a5,9
    80005c64:	0ce7ec63          	bltu	a5,a4,80005d3c <sys_open+0x148>
    iunlockput(ip);
    end_op();
    return -1;
  }

  if((f = filealloc()) == 0 || (fd = fdalloc(f)) < 0){
    80005c68:	fffff097          	auipc	ra,0xfffff
    80005c6c:	dc0080e7          	jalr	-576(ra) # 80004a28 <filealloc>
    80005c70:	89aa                	mv	s3,a0
    80005c72:	10050263          	beqz	a0,80005d76 <sys_open+0x182>
    80005c76:	00000097          	auipc	ra,0x0
    80005c7a:	904080e7          	jalr	-1788(ra) # 8000557a <fdalloc>
    80005c7e:	84aa                	mv	s1,a0
    80005c80:	0e054663          	bltz	a0,80005d6c <sys_open+0x178>
    iunlockput(ip);
    end_op();
    return -1;
  }

  if(ip->type == T_DEVICE){
    80005c84:	04491703          	lh	a4,68(s2)
    80005c88:	478d                	li	a5,3
    80005c8a:	0cf70463          	beq	a4,a5,80005d52 <sys_open+0x15e>
    f->type = FD_DEVICE;
    f->major = ip->major;
  } else {
    f->type = FD_INODE;
    80005c8e:	4789                	li	a5,2
    80005c90:	00f9a023          	sw	a5,0(s3)
    f->off = 0;
    80005c94:	0209a023          	sw	zero,32(s3)
  }
  f->ip = ip;
    80005c98:	0129bc23          	sd	s2,24(s3)
  f->readable = !(omode & O_WRONLY);
    80005c9c:	f4c42783          	lw	a5,-180(s0)
    80005ca0:	0017c713          	xori	a4,a5,1
    80005ca4:	8b05                	andi	a4,a4,1
    80005ca6:	00e98423          	sb	a4,8(s3)
  f->writable = (omode & O_WRONLY) || (omode & O_RDWR);
    80005caa:	0037f713          	andi	a4,a5,3
    80005cae:	00e03733          	snez	a4,a4
    80005cb2:	00e984a3          	sb	a4,9(s3)

  if((omode & O_TRUNC) && ip->type == T_FILE){
    80005cb6:	4007f793          	andi	a5,a5,1024
    80005cba:	c791                	beqz	a5,80005cc6 <sys_open+0xd2>
    80005cbc:	04491703          	lh	a4,68(s2)
    80005cc0:	4789                	li	a5,2
    80005cc2:	08f70f63          	beq	a4,a5,80005d60 <sys_open+0x16c>
    itrunc(ip);
  }

  iunlock(ip);
    80005cc6:	854a                	mv	a0,s2
    80005cc8:	ffffe097          	auipc	ra,0xffffe
    80005ccc:	04c080e7          	jalr	76(ra) # 80003d14 <iunlock>
  end_op();
    80005cd0:	fffff097          	auipc	ra,0xfffff
    80005cd4:	9c2080e7          	jalr	-1598(ra) # 80004692 <end_op>

  return fd;
}
    80005cd8:	8526                	mv	a0,s1
    80005cda:	70ea                	ld	ra,184(sp)
    80005cdc:	744a                	ld	s0,176(sp)
    80005cde:	74aa                	ld	s1,168(sp)
    80005ce0:	790a                	ld	s2,160(sp)
    80005ce2:	69ea                	ld	s3,152(sp)
    80005ce4:	6129                	addi	sp,sp,192
    80005ce6:	8082                	ret
      end_op();
    80005ce8:	fffff097          	auipc	ra,0xfffff
    80005cec:	9aa080e7          	jalr	-1622(ra) # 80004692 <end_op>
      return -1;
    80005cf0:	b7e5                	j	80005cd8 <sys_open+0xe4>
    if((ip = namei(path)) == 0){
    80005cf2:	f5040513          	addi	a0,s0,-176
    80005cf6:	ffffe097          	auipc	ra,0xffffe
    80005cfa:	70c080e7          	jalr	1804(ra) # 80004402 <namei>
    80005cfe:	892a                	mv	s2,a0
    80005d00:	c905                	beqz	a0,80005d30 <sys_open+0x13c>
    ilock(ip);
    80005d02:	ffffe097          	auipc	ra,0xffffe
    80005d06:	f50080e7          	jalr	-176(ra) # 80003c52 <ilock>
    if(ip->type == T_DIR && omode != O_RDONLY){
    80005d0a:	04491703          	lh	a4,68(s2)
    80005d0e:	4785                	li	a5,1
    80005d10:	f4f712e3          	bne	a4,a5,80005c54 <sys_open+0x60>
    80005d14:	f4c42783          	lw	a5,-180(s0)
    80005d18:	dba1                	beqz	a5,80005c68 <sys_open+0x74>
      iunlockput(ip);
    80005d1a:	854a                	mv	a0,s2
    80005d1c:	ffffe097          	auipc	ra,0xffffe
    80005d20:	198080e7          	jalr	408(ra) # 80003eb4 <iunlockput>
      end_op();
    80005d24:	fffff097          	auipc	ra,0xfffff
    80005d28:	96e080e7          	jalr	-1682(ra) # 80004692 <end_op>
      return -1;
    80005d2c:	54fd                	li	s1,-1
    80005d2e:	b76d                	j	80005cd8 <sys_open+0xe4>
      end_op();
    80005d30:	fffff097          	auipc	ra,0xfffff
    80005d34:	962080e7          	jalr	-1694(ra) # 80004692 <end_op>
      return -1;
    80005d38:	54fd                	li	s1,-1
    80005d3a:	bf79                	j	80005cd8 <sys_open+0xe4>
    iunlockput(ip);
    80005d3c:	854a                	mv	a0,s2
    80005d3e:	ffffe097          	auipc	ra,0xffffe
    80005d42:	176080e7          	jalr	374(ra) # 80003eb4 <iunlockput>
    end_op();
    80005d46:	fffff097          	auipc	ra,0xfffff
    80005d4a:	94c080e7          	jalr	-1716(ra) # 80004692 <end_op>
    return -1;
    80005d4e:	54fd                	li	s1,-1
    80005d50:	b761                	j	80005cd8 <sys_open+0xe4>
    f->type = FD_DEVICE;
    80005d52:	00f9a023          	sw	a5,0(s3)
    f->major = ip->major;
    80005d56:	04691783          	lh	a5,70(s2)
    80005d5a:	02f99223          	sh	a5,36(s3)
    80005d5e:	bf2d                	j	80005c98 <sys_open+0xa4>
    itrunc(ip);
    80005d60:	854a                	mv	a0,s2
    80005d62:	ffffe097          	auipc	ra,0xffffe
    80005d66:	ffe080e7          	jalr	-2(ra) # 80003d60 <itrunc>
    80005d6a:	bfb1                	j	80005cc6 <sys_open+0xd2>
      fileclose(f);
    80005d6c:	854e                	mv	a0,s3
    80005d6e:	fffff097          	auipc	ra,0xfffff
    80005d72:	d76080e7          	jalr	-650(ra) # 80004ae4 <fileclose>
    iunlockput(ip);
    80005d76:	854a                	mv	a0,s2
    80005d78:	ffffe097          	auipc	ra,0xffffe
    80005d7c:	13c080e7          	jalr	316(ra) # 80003eb4 <iunlockput>
    end_op();
    80005d80:	fffff097          	auipc	ra,0xfffff
    80005d84:	912080e7          	jalr	-1774(ra) # 80004692 <end_op>
    return -1;
    80005d88:	54fd                	li	s1,-1
    80005d8a:	b7b9                	j	80005cd8 <sys_open+0xe4>

0000000080005d8c <sys_mkdir>:

uint64
sys_mkdir(void)
{
    80005d8c:	7175                	addi	sp,sp,-144
    80005d8e:	e506                	sd	ra,136(sp)
    80005d90:	e122                	sd	s0,128(sp)
    80005d92:	0900                	addi	s0,sp,144
  char path[MAXPATH];
  struct inode *ip;

  begin_op();
    80005d94:	fffff097          	auipc	ra,0xfffff
    80005d98:	87e080e7          	jalr	-1922(ra) # 80004612 <begin_op>
  if(argstr(0, path, MAXPATH) < 0 || (ip = create(path, T_DIR, 0, 0)) == 0){
    80005d9c:	08000613          	li	a2,128
    80005da0:	f7040593          	addi	a1,s0,-144
    80005da4:	4501                	li	a0,0
    80005da6:	ffffd097          	auipc	ra,0xffffd
    80005daa:	214080e7          	jalr	532(ra) # 80002fba <argstr>
    80005dae:	02054963          	bltz	a0,80005de0 <sys_mkdir+0x54>
    80005db2:	4681                	li	a3,0
    80005db4:	4601                	li	a2,0
    80005db6:	4585                	li	a1,1
    80005db8:	f7040513          	addi	a0,s0,-144
    80005dbc:	00000097          	auipc	ra,0x0
    80005dc0:	800080e7          	jalr	-2048(ra) # 800055bc <create>
    80005dc4:	cd11                	beqz	a0,80005de0 <sys_mkdir+0x54>
    end_op();
    return -1;
  }
  iunlockput(ip);
    80005dc6:	ffffe097          	auipc	ra,0xffffe
    80005dca:	0ee080e7          	jalr	238(ra) # 80003eb4 <iunlockput>
  end_op();
    80005dce:	fffff097          	auipc	ra,0xfffff
    80005dd2:	8c4080e7          	jalr	-1852(ra) # 80004692 <end_op>
  return 0;
    80005dd6:	4501                	li	a0,0
}
    80005dd8:	60aa                	ld	ra,136(sp)
    80005dda:	640a                	ld	s0,128(sp)
    80005ddc:	6149                	addi	sp,sp,144
    80005dde:	8082                	ret
    end_op();
    80005de0:	fffff097          	auipc	ra,0xfffff
    80005de4:	8b2080e7          	jalr	-1870(ra) # 80004692 <end_op>
    return -1;
    80005de8:	557d                	li	a0,-1
    80005dea:	b7fd                	j	80005dd8 <sys_mkdir+0x4c>

0000000080005dec <sys_mknod>:

uint64
sys_mknod(void)
{
    80005dec:	7135                	addi	sp,sp,-160
    80005dee:	ed06                	sd	ra,152(sp)
    80005df0:	e922                	sd	s0,144(sp)
    80005df2:	1100                	addi	s0,sp,160
  struct inode *ip;
  char path[MAXPATH];
  int major, minor;

  begin_op();
    80005df4:	fffff097          	auipc	ra,0xfffff
    80005df8:	81e080e7          	jalr	-2018(ra) # 80004612 <begin_op>
  if((argstr(0, path, MAXPATH)) < 0 ||
    80005dfc:	08000613          	li	a2,128
    80005e00:	f7040593          	addi	a1,s0,-144
    80005e04:	4501                	li	a0,0
    80005e06:	ffffd097          	auipc	ra,0xffffd
    80005e0a:	1b4080e7          	jalr	436(ra) # 80002fba <argstr>
    80005e0e:	04054a63          	bltz	a0,80005e62 <sys_mknod+0x76>
     argint(1, &major) < 0 ||
    80005e12:	f6c40593          	addi	a1,s0,-148
    80005e16:	4505                	li	a0,1
    80005e18:	ffffd097          	auipc	ra,0xffffd
    80005e1c:	15e080e7          	jalr	350(ra) # 80002f76 <argint>
  if((argstr(0, path, MAXPATH)) < 0 ||
    80005e20:	04054163          	bltz	a0,80005e62 <sys_mknod+0x76>
     argint(2, &minor) < 0 ||
    80005e24:	f6840593          	addi	a1,s0,-152
    80005e28:	4509                	li	a0,2
    80005e2a:	ffffd097          	auipc	ra,0xffffd
    80005e2e:	14c080e7          	jalr	332(ra) # 80002f76 <argint>
     argint(1, &major) < 0 ||
    80005e32:	02054863          	bltz	a0,80005e62 <sys_mknod+0x76>
     (ip = create(path, T_DEVICE, major, minor)) == 0){
    80005e36:	f6841683          	lh	a3,-152(s0)
    80005e3a:	f6c41603          	lh	a2,-148(s0)
    80005e3e:	458d                	li	a1,3
    80005e40:	f7040513          	addi	a0,s0,-144
    80005e44:	fffff097          	auipc	ra,0xfffff
    80005e48:	778080e7          	jalr	1912(ra) # 800055bc <create>
     argint(2, &minor) < 0 ||
    80005e4c:	c919                	beqz	a0,80005e62 <sys_mknod+0x76>
    end_op();
    return -1;
  }
  iunlockput(ip);
    80005e4e:	ffffe097          	auipc	ra,0xffffe
    80005e52:	066080e7          	jalr	102(ra) # 80003eb4 <iunlockput>
  end_op();
    80005e56:	fffff097          	auipc	ra,0xfffff
    80005e5a:	83c080e7          	jalr	-1988(ra) # 80004692 <end_op>
  return 0;
    80005e5e:	4501                	li	a0,0
    80005e60:	a031                	j	80005e6c <sys_mknod+0x80>
    end_op();
    80005e62:	fffff097          	auipc	ra,0xfffff
    80005e66:	830080e7          	jalr	-2000(ra) # 80004692 <end_op>
    return -1;
    80005e6a:	557d                	li	a0,-1
}
    80005e6c:	60ea                	ld	ra,152(sp)
    80005e6e:	644a                	ld	s0,144(sp)
    80005e70:	610d                	addi	sp,sp,160
    80005e72:	8082                	ret

0000000080005e74 <sys_chdir>:

uint64
sys_chdir(void)
{
    80005e74:	7135                	addi	sp,sp,-160
    80005e76:	ed06                	sd	ra,152(sp)
    80005e78:	e922                	sd	s0,144(sp)
    80005e7a:	e526                	sd	s1,136(sp)
    80005e7c:	e14a                	sd	s2,128(sp)
    80005e7e:	1100                	addi	s0,sp,160
  char path[MAXPATH];
  struct inode *ip;
  struct proc *p = myproc();
    80005e80:	ffffc097          	auipc	ra,0xffffc
    80005e84:	eca080e7          	jalr	-310(ra) # 80001d4a <myproc>
    80005e88:	892a                	mv	s2,a0
  
  begin_op();
    80005e8a:	ffffe097          	auipc	ra,0xffffe
    80005e8e:	788080e7          	jalr	1928(ra) # 80004612 <begin_op>
  if(argstr(0, path, MAXPATH) < 0 || (ip = namei(path)) == 0){
    80005e92:	08000613          	li	a2,128
    80005e96:	f6040593          	addi	a1,s0,-160
    80005e9a:	4501                	li	a0,0
    80005e9c:	ffffd097          	auipc	ra,0xffffd
    80005ea0:	11e080e7          	jalr	286(ra) # 80002fba <argstr>
    80005ea4:	04054b63          	bltz	a0,80005efa <sys_chdir+0x86>
    80005ea8:	f6040513          	addi	a0,s0,-160
    80005eac:	ffffe097          	auipc	ra,0xffffe
    80005eb0:	556080e7          	jalr	1366(ra) # 80004402 <namei>
    80005eb4:	84aa                	mv	s1,a0
    80005eb6:	c131                	beqz	a0,80005efa <sys_chdir+0x86>
    end_op();
    return -1;
  }
  ilock(ip);
    80005eb8:	ffffe097          	auipc	ra,0xffffe
    80005ebc:	d9a080e7          	jalr	-614(ra) # 80003c52 <ilock>
  if(ip->type != T_DIR){
    80005ec0:	04449703          	lh	a4,68(s1)
    80005ec4:	4785                	li	a5,1
    80005ec6:	04f71063          	bne	a4,a5,80005f06 <sys_chdir+0x92>
    iunlockput(ip);
    end_op();
    return -1;
  }
  iunlock(ip);
    80005eca:	8526                	mv	a0,s1
    80005ecc:	ffffe097          	auipc	ra,0xffffe
    80005ed0:	e48080e7          	jalr	-440(ra) # 80003d14 <iunlock>
  iput(p->cwd);
    80005ed4:	15093503          	ld	a0,336(s2)
    80005ed8:	ffffe097          	auipc	ra,0xffffe
    80005edc:	f34080e7          	jalr	-204(ra) # 80003e0c <iput>
  end_op();
    80005ee0:	ffffe097          	auipc	ra,0xffffe
    80005ee4:	7b2080e7          	jalr	1970(ra) # 80004692 <end_op>
  p->cwd = ip;
    80005ee8:	14993823          	sd	s1,336(s2)
  return 0;
    80005eec:	4501                	li	a0,0
}
    80005eee:	60ea                	ld	ra,152(sp)
    80005ef0:	644a                	ld	s0,144(sp)
    80005ef2:	64aa                	ld	s1,136(sp)
    80005ef4:	690a                	ld	s2,128(sp)
    80005ef6:	610d                	addi	sp,sp,160
    80005ef8:	8082                	ret
    end_op();
    80005efa:	ffffe097          	auipc	ra,0xffffe
    80005efe:	798080e7          	jalr	1944(ra) # 80004692 <end_op>
    return -1;
    80005f02:	557d                	li	a0,-1
    80005f04:	b7ed                	j	80005eee <sys_chdir+0x7a>
    iunlockput(ip);
    80005f06:	8526                	mv	a0,s1
    80005f08:	ffffe097          	auipc	ra,0xffffe
    80005f0c:	fac080e7          	jalr	-84(ra) # 80003eb4 <iunlockput>
    end_op();
    80005f10:	ffffe097          	auipc	ra,0xffffe
    80005f14:	782080e7          	jalr	1922(ra) # 80004692 <end_op>
    return -1;
    80005f18:	557d                	li	a0,-1
    80005f1a:	bfd1                	j	80005eee <sys_chdir+0x7a>

0000000080005f1c <sys_exec>:

uint64
sys_exec(void)
{
    80005f1c:	7145                	addi	sp,sp,-464
    80005f1e:	e786                	sd	ra,456(sp)
    80005f20:	e3a2                	sd	s0,448(sp)
    80005f22:	ff26                	sd	s1,440(sp)
    80005f24:	fb4a                	sd	s2,432(sp)
    80005f26:	f74e                	sd	s3,424(sp)
    80005f28:	f352                	sd	s4,416(sp)
    80005f2a:	ef56                	sd	s5,408(sp)
    80005f2c:	0b80                	addi	s0,sp,464
  char path[MAXPATH], *argv[MAXARG];
  int i;
  uint64 uargv, uarg;

  if(argstr(0, path, MAXPATH) < 0 || argaddr(1, &uargv) < 0){
    80005f2e:	08000613          	li	a2,128
    80005f32:	f4040593          	addi	a1,s0,-192
    80005f36:	4501                	li	a0,0
    80005f38:	ffffd097          	auipc	ra,0xffffd
    80005f3c:	082080e7          	jalr	130(ra) # 80002fba <argstr>
    return -1;
    80005f40:	597d                	li	s2,-1
  if(argstr(0, path, MAXPATH) < 0 || argaddr(1, &uargv) < 0){
    80005f42:	0c054a63          	bltz	a0,80006016 <sys_exec+0xfa>
    80005f46:	e3840593          	addi	a1,s0,-456
    80005f4a:	4505                	li	a0,1
    80005f4c:	ffffd097          	auipc	ra,0xffffd
    80005f50:	04c080e7          	jalr	76(ra) # 80002f98 <argaddr>
    80005f54:	0c054163          	bltz	a0,80006016 <sys_exec+0xfa>
  }
  memset(argv, 0, sizeof(argv));
    80005f58:	10000613          	li	a2,256
    80005f5c:	4581                	li	a1,0
    80005f5e:	e4040513          	addi	a0,s0,-448
    80005f62:	ffffb097          	auipc	ra,0xffffb
    80005f66:	dfc080e7          	jalr	-516(ra) # 80000d5e <memset>
  for(i=0;; i++){
    if(i >= NELEM(argv)){
    80005f6a:	e4040493          	addi	s1,s0,-448
  memset(argv, 0, sizeof(argv));
    80005f6e:	89a6                	mv	s3,s1
    80005f70:	4901                	li	s2,0
    if(i >= NELEM(argv)){
    80005f72:	02000a13          	li	s4,32
    80005f76:	00090a9b          	sext.w	s5,s2
      goto bad;
    }
    if(fetchaddr(uargv+sizeof(uint64)*i, (uint64*)&uarg) < 0){
    80005f7a:	00391793          	slli	a5,s2,0x3
    80005f7e:	e3040593          	addi	a1,s0,-464
    80005f82:	e3843503          	ld	a0,-456(s0)
    80005f86:	953e                	add	a0,a0,a5
    80005f88:	ffffd097          	auipc	ra,0xffffd
    80005f8c:	f54080e7          	jalr	-172(ra) # 80002edc <fetchaddr>
    80005f90:	02054a63          	bltz	a0,80005fc4 <sys_exec+0xa8>
      goto bad;
    }
    if(uarg == 0){
    80005f94:	e3043783          	ld	a5,-464(s0)
    80005f98:	c3b9                	beqz	a5,80005fde <sys_exec+0xc2>
      argv[i] = 0;
      break;
    }
    argv[i] = kalloc();
    80005f9a:	ffffb097          	auipc	ra,0xffffb
    80005f9e:	bd8080e7          	jalr	-1064(ra) # 80000b72 <kalloc>
    80005fa2:	85aa                	mv	a1,a0
    80005fa4:	00a9b023          	sd	a0,0(s3)
    if(argv[i] == 0)
    80005fa8:	cd11                	beqz	a0,80005fc4 <sys_exec+0xa8>
      goto bad;
    if(fetchstr(uarg, argv[i], PGSIZE) < 0)
    80005faa:	6605                	lui	a2,0x1
    80005fac:	e3043503          	ld	a0,-464(s0)
    80005fb0:	ffffd097          	auipc	ra,0xffffd
    80005fb4:	f7e080e7          	jalr	-130(ra) # 80002f2e <fetchstr>
    80005fb8:	00054663          	bltz	a0,80005fc4 <sys_exec+0xa8>
    if(i >= NELEM(argv)){
    80005fbc:	0905                	addi	s2,s2,1
    80005fbe:	09a1                	addi	s3,s3,8
    80005fc0:	fb491be3          	bne	s2,s4,80005f76 <sys_exec+0x5a>
    kfree(argv[i]);

  return ret;

 bad:
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005fc4:	10048913          	addi	s2,s1,256
    80005fc8:	6088                	ld	a0,0(s1)
    80005fca:	c529                	beqz	a0,80006014 <sys_exec+0xf8>
    kfree(argv[i]);
    80005fcc:	ffffb097          	auipc	ra,0xffffb
    80005fd0:	aaa080e7          	jalr	-1366(ra) # 80000a76 <kfree>
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005fd4:	04a1                	addi	s1,s1,8
    80005fd6:	ff2499e3          	bne	s1,s2,80005fc8 <sys_exec+0xac>
  return -1;
    80005fda:	597d                	li	s2,-1
    80005fdc:	a82d                	j	80006016 <sys_exec+0xfa>
      argv[i] = 0;
    80005fde:	0a8e                	slli	s5,s5,0x3
    80005fe0:	fc040793          	addi	a5,s0,-64
    80005fe4:	9abe                	add	s5,s5,a5
    80005fe6:	e80ab023          	sd	zero,-384(s5) # ffffffffffffee80 <end+0xffffffff7ffd2e80>
  int ret = exec(path, argv);
    80005fea:	e4040593          	addi	a1,s0,-448
    80005fee:	f4040513          	addi	a0,s0,-192
    80005ff2:	fffff097          	auipc	ra,0xfffff
    80005ff6:	178080e7          	jalr	376(ra) # 8000516a <exec>
    80005ffa:	892a                	mv	s2,a0
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005ffc:	10048993          	addi	s3,s1,256
    80006000:	6088                	ld	a0,0(s1)
    80006002:	c911                	beqz	a0,80006016 <sys_exec+0xfa>
    kfree(argv[i]);
    80006004:	ffffb097          	auipc	ra,0xffffb
    80006008:	a72080e7          	jalr	-1422(ra) # 80000a76 <kfree>
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    8000600c:	04a1                	addi	s1,s1,8
    8000600e:	ff3499e3          	bne	s1,s3,80006000 <sys_exec+0xe4>
    80006012:	a011                	j	80006016 <sys_exec+0xfa>
  return -1;
    80006014:	597d                	li	s2,-1
}
    80006016:	854a                	mv	a0,s2
    80006018:	60be                	ld	ra,456(sp)
    8000601a:	641e                	ld	s0,448(sp)
    8000601c:	74fa                	ld	s1,440(sp)
    8000601e:	795a                	ld	s2,432(sp)
    80006020:	79ba                	ld	s3,424(sp)
    80006022:	7a1a                	ld	s4,416(sp)
    80006024:	6afa                	ld	s5,408(sp)
    80006026:	6179                	addi	sp,sp,464
    80006028:	8082                	ret

000000008000602a <sys_pipe>:

uint64
sys_pipe(void)
{
    8000602a:	7139                	addi	sp,sp,-64
    8000602c:	fc06                	sd	ra,56(sp)
    8000602e:	f822                	sd	s0,48(sp)
    80006030:	f426                	sd	s1,40(sp)
    80006032:	0080                	addi	s0,sp,64
  uint64 fdarray; // user pointer to array of two integers
  struct file *rf, *wf;
  int fd0, fd1;
  struct proc *p = myproc();
    80006034:	ffffc097          	auipc	ra,0xffffc
    80006038:	d16080e7          	jalr	-746(ra) # 80001d4a <myproc>
    8000603c:	84aa                	mv	s1,a0

  if(argaddr(0, &fdarray) < 0)
    8000603e:	fd840593          	addi	a1,s0,-40
    80006042:	4501                	li	a0,0
    80006044:	ffffd097          	auipc	ra,0xffffd
    80006048:	f54080e7          	jalr	-172(ra) # 80002f98 <argaddr>
    return -1;
    8000604c:	57fd                	li	a5,-1
  if(argaddr(0, &fdarray) < 0)
    8000604e:	0e054063          	bltz	a0,8000612e <sys_pipe+0x104>
  if(pipealloc(&rf, &wf) < 0)
    80006052:	fc840593          	addi	a1,s0,-56
    80006056:	fd040513          	addi	a0,s0,-48
    8000605a:	fffff097          	auipc	ra,0xfffff
    8000605e:	de0080e7          	jalr	-544(ra) # 80004e3a <pipealloc>
    return -1;
    80006062:	57fd                	li	a5,-1
  if(pipealloc(&rf, &wf) < 0)
    80006064:	0c054563          	bltz	a0,8000612e <sys_pipe+0x104>
  fd0 = -1;
    80006068:	fcf42223          	sw	a5,-60(s0)
  if((fd0 = fdalloc(rf)) < 0 || (fd1 = fdalloc(wf)) < 0){
    8000606c:	fd043503          	ld	a0,-48(s0)
    80006070:	fffff097          	auipc	ra,0xfffff
    80006074:	50a080e7          	jalr	1290(ra) # 8000557a <fdalloc>
    80006078:	fca42223          	sw	a0,-60(s0)
    8000607c:	08054c63          	bltz	a0,80006114 <sys_pipe+0xea>
    80006080:	fc843503          	ld	a0,-56(s0)
    80006084:	fffff097          	auipc	ra,0xfffff
    80006088:	4f6080e7          	jalr	1270(ra) # 8000557a <fdalloc>
    8000608c:	fca42023          	sw	a0,-64(s0)
    80006090:	06054863          	bltz	a0,80006100 <sys_pipe+0xd6>
      p->ofile[fd0] = 0;
    fileclose(rf);
    fileclose(wf);
    return -1;
  }
  if(copyout(p->pagetable, fdarray, (char*)&fd0, sizeof(fd0)) < 0 ||
    80006094:	4691                	li	a3,4
    80006096:	fc440613          	addi	a2,s0,-60
    8000609a:	fd843583          	ld	a1,-40(s0)
    8000609e:	68a8                	ld	a0,80(s1)
    800060a0:	ffffb097          	auipc	ra,0xffffb
    800060a4:	688080e7          	jalr	1672(ra) # 80001728 <copyout>
    800060a8:	02054063          	bltz	a0,800060c8 <sys_pipe+0x9e>
     copyout(p->pagetable, fdarray+sizeof(fd0), (char *)&fd1, sizeof(fd1)) < 0){
    800060ac:	4691                	li	a3,4
    800060ae:	fc040613          	addi	a2,s0,-64
    800060b2:	fd843583          	ld	a1,-40(s0)
    800060b6:	0591                	addi	a1,a1,4
    800060b8:	68a8                	ld	a0,80(s1)
    800060ba:	ffffb097          	auipc	ra,0xffffb
    800060be:	66e080e7          	jalr	1646(ra) # 80001728 <copyout>
    p->ofile[fd1] = 0;
    fileclose(rf);
    fileclose(wf);
    return -1;
  }
  return 0;
    800060c2:	4781                	li	a5,0
  if(copyout(p->pagetable, fdarray, (char*)&fd0, sizeof(fd0)) < 0 ||
    800060c4:	06055563          	bgez	a0,8000612e <sys_pipe+0x104>
    p->ofile[fd0] = 0;
    800060c8:	fc442783          	lw	a5,-60(s0)
    800060cc:	07e9                	addi	a5,a5,26
    800060ce:	078e                	slli	a5,a5,0x3
    800060d0:	97a6                	add	a5,a5,s1
    800060d2:	0007b023          	sd	zero,0(a5)
    p->ofile[fd1] = 0;
    800060d6:	fc042503          	lw	a0,-64(s0)
    800060da:	0569                	addi	a0,a0,26
    800060dc:	050e                	slli	a0,a0,0x3
    800060de:	9526                	add	a0,a0,s1
    800060e0:	00053023          	sd	zero,0(a0)
    fileclose(rf);
    800060e4:	fd043503          	ld	a0,-48(s0)
    800060e8:	fffff097          	auipc	ra,0xfffff
    800060ec:	9fc080e7          	jalr	-1540(ra) # 80004ae4 <fileclose>
    fileclose(wf);
    800060f0:	fc843503          	ld	a0,-56(s0)
    800060f4:	fffff097          	auipc	ra,0xfffff
    800060f8:	9f0080e7          	jalr	-1552(ra) # 80004ae4 <fileclose>
    return -1;
    800060fc:	57fd                	li	a5,-1
    800060fe:	a805                	j	8000612e <sys_pipe+0x104>
    if(fd0 >= 0)
    80006100:	fc442783          	lw	a5,-60(s0)
    80006104:	0007c863          	bltz	a5,80006114 <sys_pipe+0xea>
      p->ofile[fd0] = 0;
    80006108:	01a78513          	addi	a0,a5,26
    8000610c:	050e                	slli	a0,a0,0x3
    8000610e:	9526                	add	a0,a0,s1
    80006110:	00053023          	sd	zero,0(a0)
    fileclose(rf);
    80006114:	fd043503          	ld	a0,-48(s0)
    80006118:	fffff097          	auipc	ra,0xfffff
    8000611c:	9cc080e7          	jalr	-1588(ra) # 80004ae4 <fileclose>
    fileclose(wf);
    80006120:	fc843503          	ld	a0,-56(s0)
    80006124:	fffff097          	auipc	ra,0xfffff
    80006128:	9c0080e7          	jalr	-1600(ra) # 80004ae4 <fileclose>
    return -1;
    8000612c:	57fd                	li	a5,-1
}
    8000612e:	853e                	mv	a0,a5
    80006130:	70e2                	ld	ra,56(sp)
    80006132:	7442                	ld	s0,48(sp)
    80006134:	74a2                	ld	s1,40(sp)
    80006136:	6121                	addi	sp,sp,64
    80006138:	8082                	ret
    8000613a:	0000                	unimp
    8000613c:	0000                	unimp
	...

0000000080006140 <kernelvec>:
    80006140:	7111                	addi	sp,sp,-256
    80006142:	e006                	sd	ra,0(sp)
    80006144:	e40a                	sd	sp,8(sp)
    80006146:	e80e                	sd	gp,16(sp)
    80006148:	ec12                	sd	tp,24(sp)
    8000614a:	f016                	sd	t0,32(sp)
    8000614c:	f41a                	sd	t1,40(sp)
    8000614e:	f81e                	sd	t2,48(sp)
    80006150:	fc22                	sd	s0,56(sp)
    80006152:	e0a6                	sd	s1,64(sp)
    80006154:	e4aa                	sd	a0,72(sp)
    80006156:	e8ae                	sd	a1,80(sp)
    80006158:	ecb2                	sd	a2,88(sp)
    8000615a:	f0b6                	sd	a3,96(sp)
    8000615c:	f4ba                	sd	a4,104(sp)
    8000615e:	f8be                	sd	a5,112(sp)
    80006160:	fcc2                	sd	a6,120(sp)
    80006162:	e146                	sd	a7,128(sp)
    80006164:	e54a                	sd	s2,136(sp)
    80006166:	e94e                	sd	s3,144(sp)
    80006168:	ed52                	sd	s4,152(sp)
    8000616a:	f156                	sd	s5,160(sp)
    8000616c:	f55a                	sd	s6,168(sp)
    8000616e:	f95e                	sd	s7,176(sp)
    80006170:	fd62                	sd	s8,184(sp)
    80006172:	e1e6                	sd	s9,192(sp)
    80006174:	e5ea                	sd	s10,200(sp)
    80006176:	e9ee                	sd	s11,208(sp)
    80006178:	edf2                	sd	t3,216(sp)
    8000617a:	f1f6                	sd	t4,224(sp)
    8000617c:	f5fa                	sd	t5,232(sp)
    8000617e:	f9fe                	sd	t6,240(sp)
    80006180:	c29fc0ef          	jal	ra,80002da8 <kerneltrap>
    80006184:	6082                	ld	ra,0(sp)
    80006186:	6122                	ld	sp,8(sp)
    80006188:	61c2                	ld	gp,16(sp)
    8000618a:	7282                	ld	t0,32(sp)
    8000618c:	7322                	ld	t1,40(sp)
    8000618e:	73c2                	ld	t2,48(sp)
    80006190:	7462                	ld	s0,56(sp)
    80006192:	6486                	ld	s1,64(sp)
    80006194:	6526                	ld	a0,72(sp)
    80006196:	65c6                	ld	a1,80(sp)
    80006198:	6666                	ld	a2,88(sp)
    8000619a:	7686                	ld	a3,96(sp)
    8000619c:	7726                	ld	a4,104(sp)
    8000619e:	77c6                	ld	a5,112(sp)
    800061a0:	7866                	ld	a6,120(sp)
    800061a2:	688a                	ld	a7,128(sp)
    800061a4:	692a                	ld	s2,136(sp)
    800061a6:	69ca                	ld	s3,144(sp)
    800061a8:	6a6a                	ld	s4,152(sp)
    800061aa:	7a8a                	ld	s5,160(sp)
    800061ac:	7b2a                	ld	s6,168(sp)
    800061ae:	7bca                	ld	s7,176(sp)
    800061b0:	7c6a                	ld	s8,184(sp)
    800061b2:	6c8e                	ld	s9,192(sp)
    800061b4:	6d2e                	ld	s10,200(sp)
    800061b6:	6dce                	ld	s11,208(sp)
    800061b8:	6e6e                	ld	t3,216(sp)
    800061ba:	7e8e                	ld	t4,224(sp)
    800061bc:	7f2e                	ld	t5,232(sp)
    800061be:	7fce                	ld	t6,240(sp)
    800061c0:	6111                	addi	sp,sp,256
    800061c2:	10200073          	sret
    800061c6:	00000013          	nop
    800061ca:	00000013          	nop
    800061ce:	0001                	nop

00000000800061d0 <timervec>:
    800061d0:	34051573          	csrrw	a0,mscratch,a0
    800061d4:	e10c                	sd	a1,0(a0)
    800061d6:	e510                	sd	a2,8(a0)
    800061d8:	e914                	sd	a3,16(a0)
    800061da:	710c                	ld	a1,32(a0)
    800061dc:	7510                	ld	a2,40(a0)
    800061de:	6194                	ld	a3,0(a1)
    800061e0:	96b2                	add	a3,a3,a2
    800061e2:	e194                	sd	a3,0(a1)
    800061e4:	4589                	li	a1,2
    800061e6:	14459073          	csrw	sip,a1
    800061ea:	6914                	ld	a3,16(a0)
    800061ec:	6510                	ld	a2,8(a0)
    800061ee:	610c                	ld	a1,0(a0)
    800061f0:	34051573          	csrrw	a0,mscratch,a0
    800061f4:	30200073          	mret
	...

00000000800061fa <plicinit>:
// the riscv Platform Level Interrupt Controller (PLIC).
//

void
plicinit(void)
{
    800061fa:	1141                	addi	sp,sp,-16
    800061fc:	e422                	sd	s0,8(sp)
    800061fe:	0800                	addi	s0,sp,16
  // set desired IRQ priorities non-zero (otherwise disabled).
  *(uint32*)(PLIC + UART0_IRQ*4) = 1;
    80006200:	0c0007b7          	lui	a5,0xc000
    80006204:	4705                	li	a4,1
    80006206:	d798                	sw	a4,40(a5)
  *(uint32*)(PLIC + VIRTIO0_IRQ*4) = 1;
    80006208:	c3d8                	sw	a4,4(a5)
}
    8000620a:	6422                	ld	s0,8(sp)
    8000620c:	0141                	addi	sp,sp,16
    8000620e:	8082                	ret

0000000080006210 <plicinithart>:

void
plicinithart(void)
{
    80006210:	1141                	addi	sp,sp,-16
    80006212:	e406                	sd	ra,8(sp)
    80006214:	e022                	sd	s0,0(sp)
    80006216:	0800                	addi	s0,sp,16
  int hart = cpuid();
    80006218:	ffffc097          	auipc	ra,0xffffc
    8000621c:	b06080e7          	jalr	-1274(ra) # 80001d1e <cpuid>
  
  // set uart's enable bit for this hart's S-mode. 
  *(uint32*)PLIC_SENABLE(hart)= (1 << UART0_IRQ) | (1 << VIRTIO0_IRQ);
    80006220:	0085171b          	slliw	a4,a0,0x8
    80006224:	0c0027b7          	lui	a5,0xc002
    80006228:	97ba                	add	a5,a5,a4
    8000622a:	40200713          	li	a4,1026
    8000622e:	08e7a023          	sw	a4,128(a5) # c002080 <_entry-0x73ffdf80>

  // set this hart's S-mode priority threshold to 0.
  *(uint32*)PLIC_SPRIORITY(hart) = 0;
    80006232:	00d5151b          	slliw	a0,a0,0xd
    80006236:	0c2017b7          	lui	a5,0xc201
    8000623a:	953e                	add	a0,a0,a5
    8000623c:	00052023          	sw	zero,0(a0)
}
    80006240:	60a2                	ld	ra,8(sp)
    80006242:	6402                	ld	s0,0(sp)
    80006244:	0141                	addi	sp,sp,16
    80006246:	8082                	ret

0000000080006248 <plic_claim>:

// ask the PLIC what interrupt we should serve.
int
plic_claim(void)
{
    80006248:	1141                	addi	sp,sp,-16
    8000624a:	e406                	sd	ra,8(sp)
    8000624c:	e022                	sd	s0,0(sp)
    8000624e:	0800                	addi	s0,sp,16
  int hart = cpuid();
    80006250:	ffffc097          	auipc	ra,0xffffc
    80006254:	ace080e7          	jalr	-1330(ra) # 80001d1e <cpuid>
  int irq = *(uint32*)PLIC_SCLAIM(hart);
    80006258:	00d5179b          	slliw	a5,a0,0xd
    8000625c:	0c201537          	lui	a0,0xc201
    80006260:	953e                	add	a0,a0,a5
  return irq;
}
    80006262:	4148                	lw	a0,4(a0)
    80006264:	60a2                	ld	ra,8(sp)
    80006266:	6402                	ld	s0,0(sp)
    80006268:	0141                	addi	sp,sp,16
    8000626a:	8082                	ret

000000008000626c <plic_complete>:

// tell the PLIC we've served this IRQ.
void
plic_complete(int irq)
{
    8000626c:	1101                	addi	sp,sp,-32
    8000626e:	ec06                	sd	ra,24(sp)
    80006270:	e822                	sd	s0,16(sp)
    80006272:	e426                	sd	s1,8(sp)
    80006274:	1000                	addi	s0,sp,32
    80006276:	84aa                	mv	s1,a0
  int hart = cpuid();
    80006278:	ffffc097          	auipc	ra,0xffffc
    8000627c:	aa6080e7          	jalr	-1370(ra) # 80001d1e <cpuid>
  *(uint32*)PLIC_SCLAIM(hart) = irq;
    80006280:	00d5151b          	slliw	a0,a0,0xd
    80006284:	0c2017b7          	lui	a5,0xc201
    80006288:	97aa                	add	a5,a5,a0
    8000628a:	c3c4                	sw	s1,4(a5)
}
    8000628c:	60e2                	ld	ra,24(sp)
    8000628e:	6442                	ld	s0,16(sp)
    80006290:	64a2                	ld	s1,8(sp)
    80006292:	6105                	addi	sp,sp,32
    80006294:	8082                	ret

0000000080006296 <free_desc>:
}

// mark a descriptor as free.
static void
free_desc(int i)
{
    80006296:	1141                	addi	sp,sp,-16
    80006298:	e406                	sd	ra,8(sp)
    8000629a:	e022                	sd	s0,0(sp)
    8000629c:	0800                	addi	s0,sp,16
  if(i >= NUM)
    8000629e:	479d                	li	a5,7
    800062a0:	04a7cc63          	blt	a5,a0,800062f8 <free_desc+0x62>
    panic("virtio_disk_intr 1");
  if(disk.free[i])
    800062a4:	00023797          	auipc	a5,0x23
    800062a8:	d5c78793          	addi	a5,a5,-676 # 80029000 <disk>
    800062ac:	00a78733          	add	a4,a5,a0
    800062b0:	6789                	lui	a5,0x2
    800062b2:	97ba                	add	a5,a5,a4
    800062b4:	0187c783          	lbu	a5,24(a5) # 2018 <_entry-0x7fffdfe8>
    800062b8:	eba1                	bnez	a5,80006308 <free_desc+0x72>
    panic("virtio_disk_intr 2");
  disk.desc[i].addr = 0;
    800062ba:	00451713          	slli	a4,a0,0x4
    800062be:	00025797          	auipc	a5,0x25
    800062c2:	d427b783          	ld	a5,-702(a5) # 8002b000 <disk+0x2000>
    800062c6:	97ba                	add	a5,a5,a4
    800062c8:	0007b023          	sd	zero,0(a5)
  disk.free[i] = 1;
    800062cc:	00023797          	auipc	a5,0x23
    800062d0:	d3478793          	addi	a5,a5,-716 # 80029000 <disk>
    800062d4:	97aa                	add	a5,a5,a0
    800062d6:	6509                	lui	a0,0x2
    800062d8:	953e                	add	a0,a0,a5
    800062da:	4785                	li	a5,1
    800062dc:	00f50c23          	sb	a5,24(a0) # 2018 <_entry-0x7fffdfe8>
  wakeup(&disk.free[0]);
    800062e0:	00025517          	auipc	a0,0x25
    800062e4:	d3850513          	addi	a0,a0,-712 # 8002b018 <disk+0x2018>
    800062e8:	ffffc097          	auipc	ra,0xffffc
    800062ec:	4a2080e7          	jalr	1186(ra) # 8000278a <wakeup>
}
    800062f0:	60a2                	ld	ra,8(sp)
    800062f2:	6402                	ld	s0,0(sp)
    800062f4:	0141                	addi	sp,sp,16
    800062f6:	8082                	ret
    panic("virtio_disk_intr 1");
    800062f8:	00002517          	auipc	a0,0x2
    800062fc:	55050513          	addi	a0,a0,1360 # 80008848 <syscalls+0x398>
    80006300:	ffffa097          	auipc	ra,0xffffa
    80006304:	2d0080e7          	jalr	720(ra) # 800005d0 <panic>
    panic("virtio_disk_intr 2");
    80006308:	00002517          	auipc	a0,0x2
    8000630c:	55850513          	addi	a0,a0,1368 # 80008860 <syscalls+0x3b0>
    80006310:	ffffa097          	auipc	ra,0xffffa
    80006314:	2c0080e7          	jalr	704(ra) # 800005d0 <panic>

0000000080006318 <virtio_disk_init>:
{
    80006318:	1101                	addi	sp,sp,-32
    8000631a:	ec06                	sd	ra,24(sp)
    8000631c:	e822                	sd	s0,16(sp)
    8000631e:	e426                	sd	s1,8(sp)
    80006320:	1000                	addi	s0,sp,32
  initlock(&disk.vdisk_lock, "virtio_disk");
    80006322:	00002597          	auipc	a1,0x2
    80006326:	55658593          	addi	a1,a1,1366 # 80008878 <syscalls+0x3c8>
    8000632a:	00025517          	auipc	a0,0x25
    8000632e:	d7e50513          	addi	a0,a0,-642 # 8002b0a8 <disk+0x20a8>
    80006332:	ffffb097          	auipc	ra,0xffffb
    80006336:	8a0080e7          	jalr	-1888(ra) # 80000bd2 <initlock>
  if(*R(VIRTIO_MMIO_MAGIC_VALUE) != 0x74726976 ||
    8000633a:	100017b7          	lui	a5,0x10001
    8000633e:	4398                	lw	a4,0(a5)
    80006340:	2701                	sext.w	a4,a4
    80006342:	747277b7          	lui	a5,0x74727
    80006346:	97678793          	addi	a5,a5,-1674 # 74726976 <_entry-0xb8d968a>
    8000634a:	0ef71163          	bne	a4,a5,8000642c <virtio_disk_init+0x114>
     *R(VIRTIO_MMIO_VERSION) != 1 ||
    8000634e:	100017b7          	lui	a5,0x10001
    80006352:	43dc                	lw	a5,4(a5)
    80006354:	2781                	sext.w	a5,a5
  if(*R(VIRTIO_MMIO_MAGIC_VALUE) != 0x74726976 ||
    80006356:	4705                	li	a4,1
    80006358:	0ce79a63          	bne	a5,a4,8000642c <virtio_disk_init+0x114>
     *R(VIRTIO_MMIO_DEVICE_ID) != 2 ||
    8000635c:	100017b7          	lui	a5,0x10001
    80006360:	479c                	lw	a5,8(a5)
    80006362:	2781                	sext.w	a5,a5
     *R(VIRTIO_MMIO_VERSION) != 1 ||
    80006364:	4709                	li	a4,2
    80006366:	0ce79363          	bne	a5,a4,8000642c <virtio_disk_init+0x114>
     *R(VIRTIO_MMIO_VENDOR_ID) != 0x554d4551){
    8000636a:	100017b7          	lui	a5,0x10001
    8000636e:	47d8                	lw	a4,12(a5)
    80006370:	2701                	sext.w	a4,a4
     *R(VIRTIO_MMIO_DEVICE_ID) != 2 ||
    80006372:	554d47b7          	lui	a5,0x554d4
    80006376:	55178793          	addi	a5,a5,1361 # 554d4551 <_entry-0x2ab2baaf>
    8000637a:	0af71963          	bne	a4,a5,8000642c <virtio_disk_init+0x114>
  *R(VIRTIO_MMIO_STATUS) = status;
    8000637e:	100017b7          	lui	a5,0x10001
    80006382:	4705                	li	a4,1
    80006384:	dbb8                	sw	a4,112(a5)
  *R(VIRTIO_MMIO_STATUS) = status;
    80006386:	470d                	li	a4,3
    80006388:	dbb8                	sw	a4,112(a5)
  uint64 features = *R(VIRTIO_MMIO_DEVICE_FEATURES);
    8000638a:	4b94                	lw	a3,16(a5)
  features &= ~(1 << VIRTIO_RING_F_INDIRECT_DESC);
    8000638c:	c7ffe737          	lui	a4,0xc7ffe
    80006390:	75f70713          	addi	a4,a4,1887 # ffffffffc7ffe75f <end+0xffffffff47fd275f>
    80006394:	8f75                	and	a4,a4,a3
  *R(VIRTIO_MMIO_DRIVER_FEATURES) = features;
    80006396:	2701                	sext.w	a4,a4
    80006398:	d398                	sw	a4,32(a5)
  *R(VIRTIO_MMIO_STATUS) = status;
    8000639a:	472d                	li	a4,11
    8000639c:	dbb8                	sw	a4,112(a5)
  *R(VIRTIO_MMIO_STATUS) = status;
    8000639e:	473d                	li	a4,15
    800063a0:	dbb8                	sw	a4,112(a5)
  *R(VIRTIO_MMIO_GUEST_PAGE_SIZE) = PGSIZE;
    800063a2:	6705                	lui	a4,0x1
    800063a4:	d798                	sw	a4,40(a5)
  *R(VIRTIO_MMIO_QUEUE_SEL) = 0;
    800063a6:	0207a823          	sw	zero,48(a5) # 10001030 <_entry-0x6fffefd0>
  uint32 max = *R(VIRTIO_MMIO_QUEUE_NUM_MAX);
    800063aa:	5bdc                	lw	a5,52(a5)
    800063ac:	2781                	sext.w	a5,a5
  if(max == 0)
    800063ae:	c7d9                	beqz	a5,8000643c <virtio_disk_init+0x124>
  if(max < NUM)
    800063b0:	471d                	li	a4,7
    800063b2:	08f77d63          	bgeu	a4,a5,8000644c <virtio_disk_init+0x134>
  *R(VIRTIO_MMIO_QUEUE_NUM) = NUM;
    800063b6:	100014b7          	lui	s1,0x10001
    800063ba:	47a1                	li	a5,8
    800063bc:	dc9c                	sw	a5,56(s1)
  memset(disk.pages, 0, sizeof(disk.pages));
    800063be:	6609                	lui	a2,0x2
    800063c0:	4581                	li	a1,0
    800063c2:	00023517          	auipc	a0,0x23
    800063c6:	c3e50513          	addi	a0,a0,-962 # 80029000 <disk>
    800063ca:	ffffb097          	auipc	ra,0xffffb
    800063ce:	994080e7          	jalr	-1644(ra) # 80000d5e <memset>
  *R(VIRTIO_MMIO_QUEUE_PFN) = ((uint64)disk.pages) >> PGSHIFT;
    800063d2:	00023717          	auipc	a4,0x23
    800063d6:	c2e70713          	addi	a4,a4,-978 # 80029000 <disk>
    800063da:	00c75793          	srli	a5,a4,0xc
    800063de:	2781                	sext.w	a5,a5
    800063e0:	c0bc                	sw	a5,64(s1)
  disk.desc = (struct VRingDesc *) disk.pages;
    800063e2:	00025797          	auipc	a5,0x25
    800063e6:	c1e78793          	addi	a5,a5,-994 # 8002b000 <disk+0x2000>
    800063ea:	e398                	sd	a4,0(a5)
  disk.avail = (uint16*)(((char*)disk.desc) + NUM*sizeof(struct VRingDesc));
    800063ec:	00023717          	auipc	a4,0x23
    800063f0:	c9470713          	addi	a4,a4,-876 # 80029080 <disk+0x80>
    800063f4:	e798                	sd	a4,8(a5)
  disk.used = (struct UsedArea *) (disk.pages + PGSIZE);
    800063f6:	00024717          	auipc	a4,0x24
    800063fa:	c0a70713          	addi	a4,a4,-1014 # 8002a000 <disk+0x1000>
    800063fe:	eb98                	sd	a4,16(a5)
    disk.free[i] = 1;
    80006400:	4705                	li	a4,1
    80006402:	00e78c23          	sb	a4,24(a5)
    80006406:	00e78ca3          	sb	a4,25(a5)
    8000640a:	00e78d23          	sb	a4,26(a5)
    8000640e:	00e78da3          	sb	a4,27(a5)
    80006412:	00e78e23          	sb	a4,28(a5)
    80006416:	00e78ea3          	sb	a4,29(a5)
    8000641a:	00e78f23          	sb	a4,30(a5)
    8000641e:	00e78fa3          	sb	a4,31(a5)
}
    80006422:	60e2                	ld	ra,24(sp)
    80006424:	6442                	ld	s0,16(sp)
    80006426:	64a2                	ld	s1,8(sp)
    80006428:	6105                	addi	sp,sp,32
    8000642a:	8082                	ret
    panic("could not find virtio disk");
    8000642c:	00002517          	auipc	a0,0x2
    80006430:	45c50513          	addi	a0,a0,1116 # 80008888 <syscalls+0x3d8>
    80006434:	ffffa097          	auipc	ra,0xffffa
    80006438:	19c080e7          	jalr	412(ra) # 800005d0 <panic>
    panic("virtio disk has no queue 0");
    8000643c:	00002517          	auipc	a0,0x2
    80006440:	46c50513          	addi	a0,a0,1132 # 800088a8 <syscalls+0x3f8>
    80006444:	ffffa097          	auipc	ra,0xffffa
    80006448:	18c080e7          	jalr	396(ra) # 800005d0 <panic>
    panic("virtio disk max queue too short");
    8000644c:	00002517          	auipc	a0,0x2
    80006450:	47c50513          	addi	a0,a0,1148 # 800088c8 <syscalls+0x418>
    80006454:	ffffa097          	auipc	ra,0xffffa
    80006458:	17c080e7          	jalr	380(ra) # 800005d0 <panic>

000000008000645c <virtio_disk_rw>:
  return 0;
}

void
virtio_disk_rw(struct buf *b, int write)
{
    8000645c:	7175                	addi	sp,sp,-144
    8000645e:	e506                	sd	ra,136(sp)
    80006460:	e122                	sd	s0,128(sp)
    80006462:	fca6                	sd	s1,120(sp)
    80006464:	f8ca                	sd	s2,112(sp)
    80006466:	f4ce                	sd	s3,104(sp)
    80006468:	f0d2                	sd	s4,96(sp)
    8000646a:	ecd6                	sd	s5,88(sp)
    8000646c:	e8da                	sd	s6,80(sp)
    8000646e:	e4de                	sd	s7,72(sp)
    80006470:	e0e2                	sd	s8,64(sp)
    80006472:	fc66                	sd	s9,56(sp)
    80006474:	f86a                	sd	s10,48(sp)
    80006476:	f46e                	sd	s11,40(sp)
    80006478:	0900                	addi	s0,sp,144
    8000647a:	8aaa                	mv	s5,a0
    8000647c:	8d2e                	mv	s10,a1
  uint64 sector = b->blockno * (BSIZE / 512);
    8000647e:	00c52c83          	lw	s9,12(a0)
    80006482:	001c9c9b          	slliw	s9,s9,0x1
    80006486:	1c82                	slli	s9,s9,0x20
    80006488:	020cdc93          	srli	s9,s9,0x20

  acquire(&disk.vdisk_lock);
    8000648c:	00025517          	auipc	a0,0x25
    80006490:	c1c50513          	addi	a0,a0,-996 # 8002b0a8 <disk+0x20a8>
    80006494:	ffffa097          	auipc	ra,0xffffa
    80006498:	7ce080e7          	jalr	1998(ra) # 80000c62 <acquire>
  for(int i = 0; i < 3; i++){
    8000649c:	4981                	li	s3,0
  for(int i = 0; i < NUM; i++){
    8000649e:	44a1                	li	s1,8
      disk.free[i] = 0;
    800064a0:	00023c17          	auipc	s8,0x23
    800064a4:	b60c0c13          	addi	s8,s8,-1184 # 80029000 <disk>
    800064a8:	6b89                	lui	s7,0x2
  for(int i = 0; i < 3; i++){
    800064aa:	4b0d                	li	s6,3
    800064ac:	a0ad                	j	80006516 <virtio_disk_rw+0xba>
      disk.free[i] = 0;
    800064ae:	00fc0733          	add	a4,s8,a5
    800064b2:	975e                	add	a4,a4,s7
    800064b4:	00070c23          	sb	zero,24(a4)
    idx[i] = alloc_desc();
    800064b8:	c19c                	sw	a5,0(a1)
    if(idx[i] < 0){
    800064ba:	0207c563          	bltz	a5,800064e4 <virtio_disk_rw+0x88>
  for(int i = 0; i < 3; i++){
    800064be:	2905                	addiw	s2,s2,1
    800064c0:	0611                	addi	a2,a2,4 # 2004 <_entry-0x7fffdffc>
    800064c2:	19690d63          	beq	s2,s6,8000665c <virtio_disk_rw+0x200>
    idx[i] = alloc_desc();
    800064c6:	85b2                	mv	a1,a2
  for(int i = 0; i < NUM; i++){
    800064c8:	00025717          	auipc	a4,0x25
    800064cc:	b5070713          	addi	a4,a4,-1200 # 8002b018 <disk+0x2018>
    800064d0:	87ce                	mv	a5,s3
    if(disk.free[i]){
    800064d2:	00074683          	lbu	a3,0(a4)
    800064d6:	fee1                	bnez	a3,800064ae <virtio_disk_rw+0x52>
  for(int i = 0; i < NUM; i++){
    800064d8:	2785                	addiw	a5,a5,1
    800064da:	0705                	addi	a4,a4,1
    800064dc:	fe979be3          	bne	a5,s1,800064d2 <virtio_disk_rw+0x76>
    idx[i] = alloc_desc();
    800064e0:	57fd                	li	a5,-1
    800064e2:	c19c                	sw	a5,0(a1)
      for(int j = 0; j < i; j++)
    800064e4:	01205d63          	blez	s2,800064fe <virtio_disk_rw+0xa2>
    800064e8:	8dce                	mv	s11,s3
        free_desc(idx[j]);
    800064ea:	000a2503          	lw	a0,0(s4)
    800064ee:	00000097          	auipc	ra,0x0
    800064f2:	da8080e7          	jalr	-600(ra) # 80006296 <free_desc>
      for(int j = 0; j < i; j++)
    800064f6:	2d85                	addiw	s11,s11,1
    800064f8:	0a11                	addi	s4,s4,4
    800064fa:	ffb918e3          	bne	s2,s11,800064ea <virtio_disk_rw+0x8e>
  int idx[3];
  while(1){
    if(alloc3_desc(idx) == 0) {
      break;
    }
    sleep(&disk.free[0], &disk.vdisk_lock);
    800064fe:	00025597          	auipc	a1,0x25
    80006502:	baa58593          	addi	a1,a1,-1110 # 8002b0a8 <disk+0x20a8>
    80006506:	00025517          	auipc	a0,0x25
    8000650a:	b1250513          	addi	a0,a0,-1262 # 8002b018 <disk+0x2018>
    8000650e:	ffffc097          	auipc	ra,0xffffc
    80006512:	0fc080e7          	jalr	252(ra) # 8000260a <sleep>
  for(int i = 0; i < 3; i++){
    80006516:	f8040a13          	addi	s4,s0,-128
{
    8000651a:	8652                	mv	a2,s4
  for(int i = 0; i < 3; i++){
    8000651c:	894e                	mv	s2,s3
    8000651e:	b765                	j	800064c6 <virtio_disk_rw+0x6a>
  disk.desc[idx[0]].next = idx[1];

  disk.desc[idx[1]].addr = (uint64) b->data;
  disk.desc[idx[1]].len = BSIZE;
  if(write)
    disk.desc[idx[1]].flags = 0; // device reads b->data
    80006520:	00025717          	auipc	a4,0x25
    80006524:	ae073703          	ld	a4,-1312(a4) # 8002b000 <disk+0x2000>
    80006528:	973e                	add	a4,a4,a5
    8000652a:	00071623          	sh	zero,12(a4)
  else
    disk.desc[idx[1]].flags = VRING_DESC_F_WRITE; // device writes b->data
  disk.desc[idx[1]].flags |= VRING_DESC_F_NEXT;
    8000652e:	00023517          	auipc	a0,0x23
    80006532:	ad250513          	addi	a0,a0,-1326 # 80029000 <disk>
    80006536:	00025717          	auipc	a4,0x25
    8000653a:	aca70713          	addi	a4,a4,-1334 # 8002b000 <disk+0x2000>
    8000653e:	6314                	ld	a3,0(a4)
    80006540:	96be                	add	a3,a3,a5
    80006542:	00c6d603          	lhu	a2,12(a3)
    80006546:	00166613          	ori	a2,a2,1
    8000654a:	00c69623          	sh	a2,12(a3)
  disk.desc[idx[1]].next = idx[2];
    8000654e:	f8842683          	lw	a3,-120(s0)
    80006552:	6310                	ld	a2,0(a4)
    80006554:	97b2                	add	a5,a5,a2
    80006556:	00d79723          	sh	a3,14(a5)

  disk.info[idx[0]].status = 0;
    8000655a:	20048613          	addi	a2,s1,512 # 10001200 <_entry-0x6fffee00>
    8000655e:	0612                	slli	a2,a2,0x4
    80006560:	962a                	add	a2,a2,a0
    80006562:	02060823          	sb	zero,48(a2)
  disk.desc[idx[2]].addr = (uint64) &disk.info[idx[0]].status;
    80006566:	00469793          	slli	a5,a3,0x4
    8000656a:	630c                	ld	a1,0(a4)
    8000656c:	95be                	add	a1,a1,a5
    8000656e:	6689                	lui	a3,0x2
    80006570:	03068693          	addi	a3,a3,48 # 2030 <_entry-0x7fffdfd0>
    80006574:	96ca                	add	a3,a3,s2
    80006576:	96aa                	add	a3,a3,a0
    80006578:	e194                	sd	a3,0(a1)
  disk.desc[idx[2]].len = 1;
    8000657a:	6314                	ld	a3,0(a4)
    8000657c:	96be                	add	a3,a3,a5
    8000657e:	4585                	li	a1,1
    80006580:	c68c                	sw	a1,8(a3)
  disk.desc[idx[2]].flags = VRING_DESC_F_WRITE; // device writes the status
    80006582:	6314                	ld	a3,0(a4)
    80006584:	96be                	add	a3,a3,a5
    80006586:	4509                	li	a0,2
    80006588:	00a69623          	sh	a0,12(a3)
  disk.desc[idx[2]].next = 0;
    8000658c:	6314                	ld	a3,0(a4)
    8000658e:	97b6                	add	a5,a5,a3
    80006590:	00079723          	sh	zero,14(a5)

  // record struct buf for virtio_disk_intr().
  b->disk = 1;
    80006594:	00baa223          	sw	a1,4(s5)
  disk.info[idx[0]].b = b;
    80006598:	03563423          	sd	s5,40(a2)

  // avail[0] is flags
  // avail[1] tells the device how far to look in avail[2...].
  // avail[2...] are desc[] indices the device should process.
  // we only tell device the first index in our chain of descriptors.
  disk.avail[2 + (disk.avail[1] % NUM)] = idx[0];
    8000659c:	6714                	ld	a3,8(a4)
    8000659e:	0026d783          	lhu	a5,2(a3)
    800065a2:	8b9d                	andi	a5,a5,7
    800065a4:	0789                	addi	a5,a5,2
    800065a6:	0786                	slli	a5,a5,0x1
    800065a8:	97b6                	add	a5,a5,a3
    800065aa:	00979023          	sh	s1,0(a5)
  __sync_synchronize();
    800065ae:	0ff0000f          	fence
  disk.avail[1] = disk.avail[1] + 1;
    800065b2:	6718                	ld	a4,8(a4)
    800065b4:	00275783          	lhu	a5,2(a4)
    800065b8:	2785                	addiw	a5,a5,1
    800065ba:	00f71123          	sh	a5,2(a4)

  *R(VIRTIO_MMIO_QUEUE_NOTIFY) = 0; // value is queue number
    800065be:	100017b7          	lui	a5,0x10001
    800065c2:	0407a823          	sw	zero,80(a5) # 10001050 <_entry-0x6fffefb0>

  // Wait for virtio_disk_intr() to say request has finished.
  while(b->disk == 1) {
    800065c6:	004aa783          	lw	a5,4(s5)
    800065ca:	02b79163          	bne	a5,a1,800065ec <virtio_disk_rw+0x190>
    sleep(b, &disk.vdisk_lock);
    800065ce:	00025917          	auipc	s2,0x25
    800065d2:	ada90913          	addi	s2,s2,-1318 # 8002b0a8 <disk+0x20a8>
  while(b->disk == 1) {
    800065d6:	4485                	li	s1,1
    sleep(b, &disk.vdisk_lock);
    800065d8:	85ca                	mv	a1,s2
    800065da:	8556                	mv	a0,s5
    800065dc:	ffffc097          	auipc	ra,0xffffc
    800065e0:	02e080e7          	jalr	46(ra) # 8000260a <sleep>
  while(b->disk == 1) {
    800065e4:	004aa783          	lw	a5,4(s5)
    800065e8:	fe9788e3          	beq	a5,s1,800065d8 <virtio_disk_rw+0x17c>
  }

  disk.info[idx[0]].b = 0;
    800065ec:	f8042483          	lw	s1,-128(s0)
    800065f0:	20048793          	addi	a5,s1,512
    800065f4:	00479713          	slli	a4,a5,0x4
    800065f8:	00023797          	auipc	a5,0x23
    800065fc:	a0878793          	addi	a5,a5,-1528 # 80029000 <disk>
    80006600:	97ba                	add	a5,a5,a4
    80006602:	0207b423          	sd	zero,40(a5)
    if(disk.desc[i].flags & VRING_DESC_F_NEXT)
    80006606:	00025917          	auipc	s2,0x25
    8000660a:	9fa90913          	addi	s2,s2,-1542 # 8002b000 <disk+0x2000>
    8000660e:	a019                	j	80006614 <virtio_disk_rw+0x1b8>
      i = disk.desc[i].next;
    80006610:	00e4d483          	lhu	s1,14(s1)
    free_desc(i);
    80006614:	8526                	mv	a0,s1
    80006616:	00000097          	auipc	ra,0x0
    8000661a:	c80080e7          	jalr	-896(ra) # 80006296 <free_desc>
    if(disk.desc[i].flags & VRING_DESC_F_NEXT)
    8000661e:	0492                	slli	s1,s1,0x4
    80006620:	00093783          	ld	a5,0(s2)
    80006624:	94be                	add	s1,s1,a5
    80006626:	00c4d783          	lhu	a5,12(s1)
    8000662a:	8b85                	andi	a5,a5,1
    8000662c:	f3f5                	bnez	a5,80006610 <virtio_disk_rw+0x1b4>
  free_chain(idx[0]);

  release(&disk.vdisk_lock);
    8000662e:	00025517          	auipc	a0,0x25
    80006632:	a7a50513          	addi	a0,a0,-1414 # 8002b0a8 <disk+0x20a8>
    80006636:	ffffa097          	auipc	ra,0xffffa
    8000663a:	6e0080e7          	jalr	1760(ra) # 80000d16 <release>
}
    8000663e:	60aa                	ld	ra,136(sp)
    80006640:	640a                	ld	s0,128(sp)
    80006642:	74e6                	ld	s1,120(sp)
    80006644:	7946                	ld	s2,112(sp)
    80006646:	79a6                	ld	s3,104(sp)
    80006648:	7a06                	ld	s4,96(sp)
    8000664a:	6ae6                	ld	s5,88(sp)
    8000664c:	6b46                	ld	s6,80(sp)
    8000664e:	6ba6                	ld	s7,72(sp)
    80006650:	6c06                	ld	s8,64(sp)
    80006652:	7ce2                	ld	s9,56(sp)
    80006654:	7d42                	ld	s10,48(sp)
    80006656:	7da2                	ld	s11,40(sp)
    80006658:	6149                	addi	sp,sp,144
    8000665a:	8082                	ret
  if(write)
    8000665c:	01a037b3          	snez	a5,s10
    80006660:	f6f42823          	sw	a5,-144(s0)
  buf0.reserved = 0;
    80006664:	f6042a23          	sw	zero,-140(s0)
  buf0.sector = sector;
    80006668:	f7943c23          	sd	s9,-136(s0)
  disk.desc[idx[0]].addr = (uint64) kvmpa((uint64) &buf0);
    8000666c:	f8042483          	lw	s1,-128(s0)
    80006670:	00449913          	slli	s2,s1,0x4
    80006674:	00025997          	auipc	s3,0x25
    80006678:	98c98993          	addi	s3,s3,-1652 # 8002b000 <disk+0x2000>
    8000667c:	0009ba03          	ld	s4,0(s3)
    80006680:	9a4a                	add	s4,s4,s2
    80006682:	f7040513          	addi	a0,s0,-144
    80006686:	ffffb097          	auipc	ra,0xffffb
    8000668a:	ab0080e7          	jalr	-1360(ra) # 80001136 <kvmpa>
    8000668e:	00aa3023          	sd	a0,0(s4)
  disk.desc[idx[0]].len = sizeof(buf0);
    80006692:	0009b783          	ld	a5,0(s3)
    80006696:	97ca                	add	a5,a5,s2
    80006698:	4741                	li	a4,16
    8000669a:	c798                	sw	a4,8(a5)
  disk.desc[idx[0]].flags = VRING_DESC_F_NEXT;
    8000669c:	0009b783          	ld	a5,0(s3)
    800066a0:	97ca                	add	a5,a5,s2
    800066a2:	4705                	li	a4,1
    800066a4:	00e79623          	sh	a4,12(a5)
  disk.desc[idx[0]].next = idx[1];
    800066a8:	f8442783          	lw	a5,-124(s0)
    800066ac:	0009b703          	ld	a4,0(s3)
    800066b0:	974a                	add	a4,a4,s2
    800066b2:	00f71723          	sh	a5,14(a4)
  disk.desc[idx[1]].addr = (uint64) b->data;
    800066b6:	0792                	slli	a5,a5,0x4
    800066b8:	0009b703          	ld	a4,0(s3)
    800066bc:	973e                	add	a4,a4,a5
    800066be:	058a8693          	addi	a3,s5,88
    800066c2:	e314                	sd	a3,0(a4)
  disk.desc[idx[1]].len = BSIZE;
    800066c4:	0009b703          	ld	a4,0(s3)
    800066c8:	973e                	add	a4,a4,a5
    800066ca:	40000693          	li	a3,1024
    800066ce:	c714                	sw	a3,8(a4)
  if(write)
    800066d0:	e40d18e3          	bnez	s10,80006520 <virtio_disk_rw+0xc4>
    disk.desc[idx[1]].flags = VRING_DESC_F_WRITE; // device writes b->data
    800066d4:	00025717          	auipc	a4,0x25
    800066d8:	92c73703          	ld	a4,-1748(a4) # 8002b000 <disk+0x2000>
    800066dc:	973e                	add	a4,a4,a5
    800066de:	4689                	li	a3,2
    800066e0:	00d71623          	sh	a3,12(a4)
    800066e4:	b5a9                	j	8000652e <virtio_disk_rw+0xd2>

00000000800066e6 <virtio_disk_intr>:

void
virtio_disk_intr()
{
    800066e6:	1101                	addi	sp,sp,-32
    800066e8:	ec06                	sd	ra,24(sp)
    800066ea:	e822                	sd	s0,16(sp)
    800066ec:	e426                	sd	s1,8(sp)
    800066ee:	e04a                	sd	s2,0(sp)
    800066f0:	1000                	addi	s0,sp,32
  acquire(&disk.vdisk_lock);
    800066f2:	00025517          	auipc	a0,0x25
    800066f6:	9b650513          	addi	a0,a0,-1610 # 8002b0a8 <disk+0x20a8>
    800066fa:	ffffa097          	auipc	ra,0xffffa
    800066fe:	568080e7          	jalr	1384(ra) # 80000c62 <acquire>

  while((disk.used_idx % NUM) != (disk.used->id % NUM)){
    80006702:	00025717          	auipc	a4,0x25
    80006706:	8fe70713          	addi	a4,a4,-1794 # 8002b000 <disk+0x2000>
    8000670a:	02075783          	lhu	a5,32(a4)
    8000670e:	6b18                	ld	a4,16(a4)
    80006710:	00275683          	lhu	a3,2(a4)
    80006714:	8ebd                	xor	a3,a3,a5
    80006716:	8a9d                	andi	a3,a3,7
    80006718:	cab9                	beqz	a3,8000676e <virtio_disk_intr+0x88>
    int id = disk.used->elems[disk.used_idx].id;

    if(disk.info[id].status != 0)
    8000671a:	00023917          	auipc	s2,0x23
    8000671e:	8e690913          	addi	s2,s2,-1818 # 80029000 <disk>
      panic("virtio_disk_intr status");
    
    disk.info[id].b->disk = 0;   // disk is done with buf
    wakeup(disk.info[id].b);

    disk.used_idx = (disk.used_idx + 1) % NUM;
    80006722:	00025497          	auipc	s1,0x25
    80006726:	8de48493          	addi	s1,s1,-1826 # 8002b000 <disk+0x2000>
    int id = disk.used->elems[disk.used_idx].id;
    8000672a:	078e                	slli	a5,a5,0x3
    8000672c:	97ba                	add	a5,a5,a4
    8000672e:	43dc                	lw	a5,4(a5)
    if(disk.info[id].status != 0)
    80006730:	20078713          	addi	a4,a5,512
    80006734:	0712                	slli	a4,a4,0x4
    80006736:	974a                	add	a4,a4,s2
    80006738:	03074703          	lbu	a4,48(a4)
    8000673c:	ef21                	bnez	a4,80006794 <virtio_disk_intr+0xae>
    disk.info[id].b->disk = 0;   // disk is done with buf
    8000673e:	20078793          	addi	a5,a5,512
    80006742:	0792                	slli	a5,a5,0x4
    80006744:	97ca                	add	a5,a5,s2
    80006746:	7798                	ld	a4,40(a5)
    80006748:	00072223          	sw	zero,4(a4)
    wakeup(disk.info[id].b);
    8000674c:	7788                	ld	a0,40(a5)
    8000674e:	ffffc097          	auipc	ra,0xffffc
    80006752:	03c080e7          	jalr	60(ra) # 8000278a <wakeup>
    disk.used_idx = (disk.used_idx + 1) % NUM;
    80006756:	0204d783          	lhu	a5,32(s1)
    8000675a:	2785                	addiw	a5,a5,1
    8000675c:	8b9d                	andi	a5,a5,7
    8000675e:	02f49023          	sh	a5,32(s1)
  while((disk.used_idx % NUM) != (disk.used->id % NUM)){
    80006762:	6898                	ld	a4,16(s1)
    80006764:	00275683          	lhu	a3,2(a4)
    80006768:	8a9d                	andi	a3,a3,7
    8000676a:	fcf690e3          	bne	a3,a5,8000672a <virtio_disk_intr+0x44>
  }
  *R(VIRTIO_MMIO_INTERRUPT_ACK) = *R(VIRTIO_MMIO_INTERRUPT_STATUS) & 0x3;
    8000676e:	10001737          	lui	a4,0x10001
    80006772:	533c                	lw	a5,96(a4)
    80006774:	8b8d                	andi	a5,a5,3
    80006776:	d37c                	sw	a5,100(a4)

  release(&disk.vdisk_lock);
    80006778:	00025517          	auipc	a0,0x25
    8000677c:	93050513          	addi	a0,a0,-1744 # 8002b0a8 <disk+0x20a8>
    80006780:	ffffa097          	auipc	ra,0xffffa
    80006784:	596080e7          	jalr	1430(ra) # 80000d16 <release>
}
    80006788:	60e2                	ld	ra,24(sp)
    8000678a:	6442                	ld	s0,16(sp)
    8000678c:	64a2                	ld	s1,8(sp)
    8000678e:	6902                	ld	s2,0(sp)
    80006790:	6105                	addi	sp,sp,32
    80006792:	8082                	ret
      panic("virtio_disk_intr status");
    80006794:	00002517          	auipc	a0,0x2
    80006798:	15450513          	addi	a0,a0,340 # 800088e8 <syscalls+0x438>
    8000679c:	ffffa097          	auipc	ra,0xffffa
    800067a0:	e34080e7          	jalr	-460(ra) # 800005d0 <panic>
	...

0000000080007000 <_trampoline>:
    80007000:	14051573          	csrrw	a0,sscratch,a0
    80007004:	02153423          	sd	ra,40(a0)
    80007008:	02253823          	sd	sp,48(a0)
    8000700c:	02353c23          	sd	gp,56(a0)
    80007010:	04453023          	sd	tp,64(a0)
    80007014:	04553423          	sd	t0,72(a0)
    80007018:	04653823          	sd	t1,80(a0)
    8000701c:	04753c23          	sd	t2,88(a0)
    80007020:	f120                	sd	s0,96(a0)
    80007022:	f524                	sd	s1,104(a0)
    80007024:	fd2c                	sd	a1,120(a0)
    80007026:	e150                	sd	a2,128(a0)
    80007028:	e554                	sd	a3,136(a0)
    8000702a:	e958                	sd	a4,144(a0)
    8000702c:	ed5c                	sd	a5,152(a0)
    8000702e:	0b053023          	sd	a6,160(a0)
    80007032:	0b153423          	sd	a7,168(a0)
    80007036:	0b253823          	sd	s2,176(a0)
    8000703a:	0b353c23          	sd	s3,184(a0)
    8000703e:	0d453023          	sd	s4,192(a0)
    80007042:	0d553423          	sd	s5,200(a0)
    80007046:	0d653823          	sd	s6,208(a0)
    8000704a:	0d753c23          	sd	s7,216(a0)
    8000704e:	0f853023          	sd	s8,224(a0)
    80007052:	0f953423          	sd	s9,232(a0)
    80007056:	0fa53823          	sd	s10,240(a0)
    8000705a:	0fb53c23          	sd	s11,248(a0)
    8000705e:	11c53023          	sd	t3,256(a0)
    80007062:	11d53423          	sd	t4,264(a0)
    80007066:	11e53823          	sd	t5,272(a0)
    8000706a:	11f53c23          	sd	t6,280(a0)
    8000706e:	140022f3          	csrr	t0,sscratch
    80007072:	06553823          	sd	t0,112(a0)
    80007076:	00853103          	ld	sp,8(a0)
    8000707a:	02053203          	ld	tp,32(a0)
    8000707e:	01053283          	ld	t0,16(a0)
    80007082:	00053303          	ld	t1,0(a0)
    80007086:	18031073          	csrw	satp,t1
    8000708a:	12000073          	sfence.vma
    8000708e:	8282                	jr	t0

0000000080007090 <userret>:
    80007090:	18059073          	csrw	satp,a1
    80007094:	12000073          	sfence.vma
    80007098:	07053283          	ld	t0,112(a0)
    8000709c:	14029073          	csrw	sscratch,t0
    800070a0:	02853083          	ld	ra,40(a0)
    800070a4:	03053103          	ld	sp,48(a0)
    800070a8:	03853183          	ld	gp,56(a0)
    800070ac:	04053203          	ld	tp,64(a0)
    800070b0:	04853283          	ld	t0,72(a0)
    800070b4:	05053303          	ld	t1,80(a0)
    800070b8:	05853383          	ld	t2,88(a0)
    800070bc:	7120                	ld	s0,96(a0)
    800070be:	7524                	ld	s1,104(a0)
    800070c0:	7d2c                	ld	a1,120(a0)
    800070c2:	6150                	ld	a2,128(a0)
    800070c4:	6554                	ld	a3,136(a0)
    800070c6:	6958                	ld	a4,144(a0)
    800070c8:	6d5c                	ld	a5,152(a0)
    800070ca:	0a053803          	ld	a6,160(a0)
    800070ce:	0a853883          	ld	a7,168(a0)
    800070d2:	0b053903          	ld	s2,176(a0)
    800070d6:	0b853983          	ld	s3,184(a0)
    800070da:	0c053a03          	ld	s4,192(a0)
    800070de:	0c853a83          	ld	s5,200(a0)
    800070e2:	0d053b03          	ld	s6,208(a0)
    800070e6:	0d853b83          	ld	s7,216(a0)
    800070ea:	0e053c03          	ld	s8,224(a0)
    800070ee:	0e853c83          	ld	s9,232(a0)
    800070f2:	0f053d03          	ld	s10,240(a0)
    800070f6:	0f853d83          	ld	s11,248(a0)
    800070fa:	10053e03          	ld	t3,256(a0)
    800070fe:	10853e83          	ld	t4,264(a0)
    80007102:	11053f03          	ld	t5,272(a0)
    80007106:	11853f83          	ld	t6,280(a0)
    8000710a:	14051573          	csrrw	a0,sscratch,a0
    8000710e:	10200073          	sret
	...
